package com.jln.ufc.web.action.enums;

import com.jln.common.enums.ResultCodeEnum;

public enum UfcResultCodeEnum implements ResultCodeInterface{


    ERPERROR30001(30001,"有员工没有组织信息！"),
    ERPERROR30002(30002,"请先维护完整的组织信息！"),
    ERPERROR30003(30003,"有员工没有部门信息！"),
    ERPERROR30004(30004,"请先维护完整的部门信息！"),
    ERPERROR30005(30005,"新增岗位信息失败！"),
    ERPERROR30006(30006,"保存员工信息失败！"),
    ERPERROR30007(30007,"保存用户信息失败！"),
    ERPERROR30008(30008,"保存用户主表信息失败！"),
    ERPERROR30009(30009,"保存员工关联岗位信息失败！"),
    ERPERROR30010(30010,"当前订单号已经不符合可以修改的状态"),
    ERPERROR30011(30011,"当前订单号已经不符合可以删除的状态"),
    ERPERROR30012(30012,"删除订单失败，请稍后再试!"),
    ;

    private int code;
    private String msg;

    UfcResultCodeEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    UfcResultCodeEnum(ResultCodeEnum ufcResultCodeEnum) {
        this.code = ufcResultCodeEnum.getCode();
        this.msg = ufcResultCodeEnum.getMsg();
    }



    @Override
    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    @Override
    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}
