package com.jln.ufc.web.action.exception;

import com.jln.common.utils.EmptyUtil;
import com.jln.ufc.web.action.enums.ResultCodeInterface;

/*
 * message
 *异常的描述信息，也就是在打印栈追踪信息时异常类名后面紧跟着的描述字符串
 *cause
 *导致此异常发生的父异常，即追踪信息里的caused by
 *enableSuppress
 *关于异常挂起的参数，这里我们永远设为false即可
 *writableStackTrace
 *表示是否生成栈追踪信息，只要将此参数设为false, 则在构造异常对象时就不会调用fillInStackTrace()
 * 生成”轻量级”异常，对性能的耗费从大到小依次为：输出到日志、获取异常堆栈、创建并 catch 异常
 * */
public class UfcCustomException extends RuntimeException {

    private int code;
    private String msg;

    public UfcCustomException(ResultCodeInterface resultCode) {
        super(EmptyUtil.isEmpty(resultCode.getMsg())?null: resultCode.toString(), (Throwable)null, false, false);
        String string = EmptyUtil.isEmpty(resultCode.getMsg())?null: resultCode.toString();
        this.code = resultCode.getCode();
        this.msg = string;
    }

    public UfcCustomException(int code, String msg) {
        super(msg, (Throwable)null, false, false);
        this.code = code;
        this.msg = msg;
    }

    public int getCode() {
        return this.code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMsg() {
        return this.msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }



}
