package com.jln.ufc.web.action.ufc.bm.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectCopyVo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectVo;
import com.jln.ufc.web.action.ufc.bm.service.UfcBMaterialService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author Aaron
 * @since 2020-02-12
 */
@Api(tags = "物料基础信息维护")
@RestController
@RequestMapping("/ufc/bm/bm04/bm0402")
public class UfcBMaterialController {

    @Autowired
    @Qualifier("UfcBMaterial")
    private UfcBMaterialService bMaterialService;

    @ApplyForPermission
    @ApiOperation(value = "物料信息下拉框查询", notes = "物料信息下拉框查询")
    @PostMapping("/selectList")
    public Result<Page<UfcBMaterialSelectVo>> select(@RequestBody PageParameter<UfcBMaterialSelectCopyVo> query) {
        return bMaterialService.selectList(query);
    }

}
