package com.jln.ufc.web.action.ufc.bm.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStandardprocess;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcStandardprocessInfo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcStandprocessQuery;
import com.jln.ufc.web.action.ufc.bm.service.UfcBStandardprocessService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "工序维护")
@RestController
@RequestMapping("/bm/ucfBp")
public class UfcBStandardprocessController {

    @Autowired
    private UfcBStandardprocessService ufcBStandardprocessService;

    @ApiOperation(value = "标准工序保存接口",notes="标准工序保存接口")
    @PostMapping("/saveerp")
    public Result saveerp(@RequestBody List<UfcBStandardprocess> bStandardprocess) {
        try {
            return ufcBStandardprocessService.saveerp(bStandardprocess);
        } catch (Exception e) {
            return new Result().toFailure(e.getMessage());
        }
    }
    @ApiOperation(value = "标准工序批量删除接口",notes="标准工序批量删除接口")
    @PostMapping("/deleteerp")
    public Result deleteerp(@RequestBody List<Long> bStandardprocessoids) {
        return ufcBStandardprocessService.deleteerp(bStandardprocessoids);
    }

    @ApiOperation(value = "工序列表",notes="工序列表")
    @PostMapping("/selectPage")
    public Result<Page<UfcStandardprocessInfo>> selectPage(@Validated @RequestBody PageParameter<UfcStandprocessQuery> page ) {
        return ufcBStandardprocessService.selectPage(page);
    }

}
