package com.jln.ufc.web.action.ufc.bm.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.bm.entity.dto.UfcBSupplierFl;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBSupplierInfo;
import com.jln.ufc.web.action.ufc.bm.service.UfcBSupplierService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author: Luca.Liu
 * @date: 2022/2/28
 */
@Api(tags = "供应商维护")
@RestController
@RequestMapping("/ufc/bm/bm06/bm0603")
public class UfcBSupplierController {
    
    @Autowired
    private UfcBSupplierService bSupplierService;

    @ApiOperation(value = "保存供应商设置信息接口",notes="保存供应商设置信息接口")
    @PostMapping("/save")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result save(@RequestBody UfcBSupplierInfo bSupplierInfo, @LoginUser User user )  {
        return bSupplierService.save(bSupplierInfo,user);
    }

    @ApiOperation(value = "获取供应商设置接口oid回显",notes="获取供应商设置接口oid回显")
    @GetMapping("/get")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result getbyoid(@RequestParam Long oid){
        return bSupplierService.getbyoid(oid);
    }

    @ApiOperation(value = "供应商设置列表",notes="供应商设置列表")
    @PostMapping("/selectPage")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result selectPage(@RequestBody PageParameter<UfcBSupplierFl> page) {
        return bSupplierService.selectPage(page);
    }
}
