package com.jln.ufc.web.action.ufc.bm.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.bm.entity.dto.UfcMaterialPageDto;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialInfo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectCopyVo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectInfoVo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectVo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialView;
import com.jln.ufc.web.action.ufc.bm.service.UfcJcBMaterialService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "物料基础信息维护")
@RestController
@RequestMapping("/ufc/bm/bm")
public class UfcJcBMaterialController {

    @Autowired
    private UfcJcBMaterialService bMaterialService;

    @ApiOperation(value = "物料信息下拉框查询", notes = "物料信息下拉框查询")
    @PostMapping("/queryList")
    public Result<Page<UfcBMaterialSelectVo>> queryList(@RequestBody PageParameter<UfcBMaterialSelectCopyVo> query) {
        return bMaterialService.queryList(query);
    }

    @ApiOperation(value = "根据工厂编码查询物料数据", notes = "根据工厂编码查询物料数据")
    @PostMapping("/queryByGcidList")
    public Result<Page<UfcBMaterialInfo>> queryByGcidList(@RequestBody PageParameter<UfcMaterialPageDto> query) {
        return bMaterialService.queryByGcidList(query);
    }

    @ApiOperation(value = "检验标准维护——获取物料列表", notes = "检验标准维护——获取物料列表")
    @PostMapping("/getBMaterialList")
    public Result<Page<UfcBMaterialView>> getBMaterialList(@RequestBody PageParameter<UfcBMaterialSelectInfoVo> bMaterialSelectInfo) {
        return bMaterialService.getBMaterialList(new Page<>(bMaterialSelectInfo.getPageNum(), bMaterialSelectInfo.getPageSize()), bMaterialSelectInfo.getData());
    }
    
}
