package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * <p>
 *
 * </p>
 *
 * @author
 * @since 2020-02-11
 */


@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel("工厂实体类")
@TableName("b_factory")
public class UfcBFactory extends Model<UfcBFactory> {

    private static final long serialVersionUID = 1L;

    /**
     * 工厂主键
     */
    @ApiModelProperty(example = "工厂主键", required = true,dataType = "String")
    @TableId(value = "B_FactoryOID", type = IdType.INPUT)
    private Long bFactoryoid;

    /**
     * 工厂编码
     */
    @Size(max = 4,message = "工厂编码最大长度为4个字节")
    @NotNull(message = "工厂编码不能为空")
    @ApiModelProperty(example = "工厂编码", required = true,dataType = "string")
    private String gcid;

    /**
     * 工厂名称
     */
    @Size(max = 24,message = "工厂名称最大长度为24个字节")
    @ApiModelProperty(example = "工厂名称", required = true,dataType = "string")
    private String gcmc;

    /**
     * 备注
     */
    @Size(max = 250,message = "备注最大长度为250个字节")
    @ApiModelProperty(example = " 备注", required = true,dataType = "string")
    private String bz;

    /**
     * 停用标志 0为未停用，1为停用
     */
    @ApiModelProperty(example = " 0：启用；1：停用", required = true,dataType = "boolean")
    private Boolean tybz;


    /**
     * 启用日期
     */
    @ApiModelProperty(example = "启用日期", required = true,dataType = "date")
    @DateTimeFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = LocalDateTimeConst.DATE_PATTERN)
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate qyrq;


    /**
     * 停用日期
     */
    @ApiModelProperty(example = "停用日期", required = true,dataType = "date")
    @DateTimeFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate tyrq;

    /**
     * 维护时间
     */
    @ApiModelProperty(example = "维护时间", required = true,dataType = "date")
    //@JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    /**
     * 维护人
     */
    @Size(max = 36,message = "维护人主键最大长度为36个字节")
    @ApiModelProperty(example = "维护人主键", required = true,dataType = "date")
    private Long sysLastUpdBy;

    /**
     * 是否删除，0为未删除，1为删除
     */
    private Integer del;


    @Override
    protected Serializable pkVal() {
        return this.bFactoryoid;
    }

}
