package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 物料属性组和物料属性项目关联表
 * </p>
 *
 * @author
 * @since 2021-05-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("b_material_group_item")
public class UfcBMaterialGroupItem extends Model<UfcBMaterialGroupItem> {

    private static final long serialVersionUID = 1L;

    @TableId
    private Long id;

    /**
     * 属性组外键
     */
    private Long groupId;

    /**
     * 属性项目外键
     */
    private Long itemId;

    /**
     * 是否在信息中显示（0：不显示，1：显示）
     */
    private Boolean whetherDisplay;

    /**
     * 显示格式（1：显示属性名称、2：不显示属性名称）
     */
    private Integer displayFormat;

    /**
     * 分隔符（1：空格、2：竖线、3：英文分号、4：中文分号）
     */
    @TableField("`separator`")
    private Integer separator;

    /**
     * 属性字段
     */
    private String attrField;

    /**
     * 长度
     */
    private Integer length;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
