package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.io.Serializable;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 物料属性组
 * </p>
 *
 * @author
 * @since 2021-05-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("b_material_property_group")
public class UfcBMaterialPropertyGroup extends Model<UfcBMaterialPropertyGroup> {

    private static final long serialVersionUID = 1L;

    /**
     * 物料属性组主键
     */
    @TableId
    private Long materialPropertyGroupOid;

    /**
     * 物料属性组编码
     */
    private String materialPropertyGroupCode;

    /**
     * 物料属性组名称
     */
    private String name;

    /**
     * 数量属性
     */
    private String numAttr;

    /**
     * 数量属性（辅）
     */
    private String numAttrSecondary;

    /**
     * 停用标志 0:已停用1：未停用
     */
    private Boolean tybz;

    /**
     * 启用日期
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private LocalDate qyrq;

    /**
     * 停用日期
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private LocalDate tyrq;

    /**
     * 维护人外键
     */
    private Long sysLastUpdBy;

    /**
     * 维护时间
     */
    private LocalDateTime sysLastUpd;

    /**
     * 删除标识（0.未删除1.已删除）
     */
    @TableLogic
    private Boolean del;


    @Override
    protected Serializable pkVal() {
        return this.materialPropertyGroupOid;
    }

}
