package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.io.Serializable;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 物料属性项目
 * </p>
 *
 * @author
 * @since 2021-05-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("b_material_property_item")
public class UfcBMaterialPropertyItem extends Model<UfcBMaterialPropertyItem> {

    private static final long serialVersionUID = 1L;

    /**
     * 物料属性项目主键
     */
    @TableId
    private Long materialPropertyItemOid;

    /**
     * 物料属性项目编码
     */
    private String materialPropertyItemCode;

    /**
     * 物料属性项目名称
     */
    private String name;

    /**
     * 属性值类型（F：分数值型，S：字符型，D：日期型）
     */
    private String propertyValueType;

    /**
     * 属性分类（G：公有，S：私有）
     */
    private String propertyType;

    /**
     * 辅助输入模块
     */
    private String auxiliaryInput;

    /**
     * 可空
     */
    private Boolean canEnpty;

    /**
     * 枚举类型
     */
    private Boolean enumType;

    /**
     * 枚举列表
     */
    private String enumList;

    /**
     * 唯一
     */
    private Boolean only;

    /**
     * 数值上限
     */
    private String numUpper;

    /**
     * 数值下限
     */
    private String nunLower;

    /**
     * 缺省值
     */
    private String defaultValue;

    /**
     * 属性字段
     */
    private String attrField;

    /**
     * 显示
     */
    private Boolean display;

    /**
     * 显示宽度
     */
    private Integer displayWidth;

    /**
     * 长度
     */
    private Integer length;

    /**
     * 备注
     */
    private String bz;

    /**
     * 停用标志 0:已停用1：未停用
     */
    private Boolean tybz;

    /**
     * 启用日期
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private LocalDate qyrq;

    /**
     * 停用日期
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private LocalDate tyrq;

    /**
     * 维护人外键
     */
    private Long sysLastUpdBy;

    /**
     * 维护时间
     */
    private LocalDateTime sysLastUpd;

    /**
     * 删除标识（0.未删除1.已删除）
     */
    @TableLogic
    private Boolean del;


    @Override
    protected Serializable pkVal() {
        return this.materialPropertyItemOid;
    }

}
