package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author 
 * @since 2020-02-21
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("b_productprocessdetail")
public class UfcBProductprocessdetail extends Model<UfcBProductprocessdetail> {

    private static final long serialVersionUID = 1L;
    @TableId
    private Long bProductprocessdetailoid;

    /**
     * 产品工艺路线编码
     */
    private String cpgyid;

    /**
     * 工序编码
     */
    private String gxid;

    /**
     * 序号
     */
    private Integer xh;

    /**
     * 工序名称
     */
    private String gxmc;

    /**
     * 工序类型
     */
    private String gxlx;

    /**
     * 关键工序
     */
    private Integer gjgx;

    /**
     * 上料
     */
    private Integer slgx;

    /**
     * 下料
     */
    private Integer xlgx;

    /**
     * 测试
     */
    private Integer csgx;

    /**
     * 工位机编码
     */
    private String gwjid;

    /**
     * 备注
     */
    private String bz;

    /**
     * 停用标志
     */
    private Boolean tybz;

    /**
     * 启用日期
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private LocalDate qyrq;

    /**
     * 停用日期
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private LocalDate tyrq;


    /**
     * 最后修改日期
     */
    private LocalDateTime sysLastUpd;

    /**
     * 最后修改用户
     */
    private Long sysLastUpdBy;

    /**
     * 产品工艺明细
     */
    private Long bProductprocessFk;

    /**
     * 删除标识
     */
    @TableLogic
    private Integer del;

    /**
     * 工位外键
     */
    private Long bWorkstationFk;

    /**
     * 工段外键
     */
    private Long bWorksectionFk;

    /**
     * 基础工序外键
     */
    private Long bStandardprocessFk;

    /**
     *
     */
    private BigDecimal rggs;

    /**
     *
     */
    private Float zbsj;

    /**
     *
     */
    private Float jgsj;

    /**
     *
     */
    private Float pdsj;

    private Float zysj;

    private Float ddsj;


    //------------------------新增字段----------------------------

    @ApiModelProperty(example = "作业方式 PC、PDA、DCT", required = true)
    private String zyfs;

    @ApiModelProperty(example = "采集内容 PD|产能、PD|产能和缺陷", required = true)
    private String cjnr;

    @ApiModelProperty(example = "是否批次上料 1是 0不是", required = true)
    private Boolean isPcsl;

    @ApiModelProperty(example = "是否经过本工序", required = true)
    private Boolean jgbgx;

    @ApiModelProperty(example = "关键物料校验", required = true)
    private Boolean gjwljy;

    @ApiModelProperty(example = "合格率预警", required = true)
    private Boolean hglyj;

    @ApiModelProperty(example = "合格率预警阀值 百分比", required = true)
    private BigDecimal hglyjfz;

    @ApiModelProperty(example = "产品工艺路线节点外键", value = "产品工艺路线节点外键")
    private Long technologicalProcessFk;

    //标准工艺路线明细带出

    @ApiModelProperty(example = "标准产量", value = "标准产量")
    private BigDecimal bzcl;

    @ApiModelProperty(example = "标准工时", value = "标准产量")
    private BigDecimal bzgs;

    @ApiModelProperty(example = "标准人数", value = "标准人数")
    private Integer bzrs;

    //------------------------新增字段----------------------------

    //----------------------新增字段 判断是否存在工位外键
    @ApiModelProperty(example = "是否维护", value = "是否维护")
    @TableField(exist = false)
    private Boolean sfwh;



    /**
     * 首检工序
     */
    @ApiModelProperty(value = "首检工序", example = "false", position = 107)
    private Boolean firstInspectionProcess;
    /**
     * 单件管理
     */
    @ApiModelProperty(value = "单件管理", example = "false", position = 107)
    private Boolean individualManagement;
    /**
     * 单件生成
     */
    @ApiModelProperty(value = "单件生成", example = "false", position = 107)
    private Boolean singleGenerating;
    /**
     * 特殊过程
     */
    @ApiModelProperty(value = "特殊过程", example = "false", position = 107)
    private Boolean specialProcess;

    /**
     * 是否允许入库
     */
    @ApiModelProperty(value = "是否允许入库", example = "false", position = 101)
    private Boolean sfyxrk;

    /**
     * 默认入库仓库
     */
    @ApiModelProperty(value = "默认入库仓库", example = "2000000", position = 102)
    private String mrrkck;

    /**
     * 是否允许变更产品
     */
    @ApiModelProperty(value = "是否允许变更产品", example = "false", position = 106)
    private Boolean sfyxbgcp;

    /**
     * 是否允许拆分流程卡
     */
    @ApiModelProperty(value = "是否允许拆分流程卡", example = "false", position = 105)
    private Boolean sfyxcslck;

    /**
     * 是否校验工序
     */
    @ApiModelProperty(value = "是否校验工序", example = "false", position = 100)
    private Boolean sfjygx;

    /**
     * 是否进行数量校验
     */
    @ApiModelProperty(value = "是否进行数量校验", example = "false", position = 107)
    private Boolean sfjxsljy;

    /**
     * 是否允许自动接收
     */
    @ApiModelProperty(value = "是否允许自动接收", example = "false", position = 104)
    private Boolean sfyxzdjs;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    /**
     * 文档附件名称
     */
    @ApiModelProperty(example = "文档附件名称",dataType = "string")
    private String cessoryName;

    /**
     * 文档地址
     */
    @ApiModelProperty(example = "文档地址",dataType = "string")
    private String accessoryUrl;

    @ApiModelProperty(example = "是否转包工序",dataType = "boolean")
    private Boolean zbgx;

    @Override
    protected Serializable pkVal() {
        return this.bProductprocessdetailoid;
    }

}
