package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@ApiModel("Ufc标准工序实体类")
@TableName(value = "b_standardprocess")
public class UfcBStandardprocess extends Model<UfcBStandardprocess> {

    private static final long serialVersionUID = 1L;
    @TableId(value = "b_standardprocessoid", type = IdType.UUID)
    private Long bStandardprocessoid;

    /**
     * 标准工序编码
     */
    @TableField("bzgxid")
    private String bzgxid;

    /**
     * 标准工序名称
     */
    @TableField("bzgxmc")
    private String bzgxmc;

    /**
     * 设备数
     */
    private Integer sbs;

    /**
     * 人数
     */
    private Integer rs;

    /**
     * 准备时间
     */
    private Float zbsj;

    /**
     * 排队时间
     */
    private Float pdsj;

    /**
     * 加工时间
     */
    private Float jgsj;

    /**
     * 等待时间
     */
    private Float ddsj;

    /**
     * 关键工序
     */
    private Boolean gjgx;

    /**
     * 上料
     */
    private Boolean slgx;

    /**
     * 下料
     */
    private Boolean xlgx;

    /**
     * 测试
     */
    private Boolean csgx;

    /**
     * 备注
     */
    private String bz;

    /**
     * 停用标志
     */
    private Boolean tybz;

    /**
     * 启用日期
     */
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    @ApiModelProperty(value = "启用日期",example = "2021-06-02")
    private LocalDate qyrq;

    /**
     * 停用日期
     */
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    @ApiModelProperty(value = "停用日期",example = "2021-06-02")
    private LocalDate tyrq;

    /**
     * 最后修改日期
     */
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    @ApiModelProperty(value = "最后修改日期",example = "2021-06-02 00:00:00")
    private LocalDateTime sysLastUpd;

    /**
     * 最后修改用户
     */
    private Long sysLastUpdBy;

    private Integer del;

    /**
     * 转移时间
     */
    private Float zysj;

    /* 2021-06-01 新增字段 */
    /**
     * 是否校验工序
     */
    private Boolean sfjygx;

    /**
     * 是否允许入库
     */
    private Boolean sfyxrk;

    /**
     * 默认入库仓库
     */
    private String mrrkck;

    /**
     * 是否允许自动接收
     */
    private Boolean sfyxzdjs;

    /**
     * 是否允许拆分流程卡
     */
    private Boolean sfyxcslck;

    /**
     * 是否允许变更产品
     */
    private Boolean sfyxbgcp;

    /**
     * 是否进行数量校验
     */
    private Boolean sfjxsljy;


    /**
     * 首检工序
     */
    @ApiModelProperty(value = "首检工序", example = "false", position = 107)
    private Boolean firstInspectionProcess;
    /**
     * 单件管理
     */
    @ApiModelProperty(value = "单件管理", example = "false", position = 107)
    private Boolean individualManagement;
    /**
     * 单件生成
     */
    @ApiModelProperty(value = "单件生成", example = "false", position = 107)
    private Boolean singleGenerating;
    /**
     * 特殊过程
     */
    @ApiModelProperty(value = "特殊过程", example = "false", position = 107)
    private Boolean specialProcess;



    @ApiModelProperty(example = "是否经过本工序", required = true)
    private Boolean jgbgx;

    @ApiModelProperty(example = "是否批次上料 1是 0不是", required = true)
    private Boolean isPcsl;

    @ApiModelProperty(example = "关键工序校验", required = true)
    private Boolean gjgxjy;

    @ApiModelProperty(example = "合格率预警", required = true)
    private Boolean hglyj;

    @ApiModelProperty(example = "合格率预警阀值 百分比", required = true)
    private BigDecimal hglyjfz;

    /**
     * 文档附件名称
     */
    @ApiModelProperty(example = "文档附件名称",dataType = "string")
    private String cessoryName;

    /**
     * 文档地址
     */
    @ApiModelProperty(example = "文档地址",dataType = "string")
    private String accessoryUrl;

    /**
     * 新增字段，erp组织主键
     */
    private String sszz;

    /**
     * 表示数据是新增还是修改的标识(MES不需要存储：1为新增，2为修改)
     */
    @TableField(exist = false)
    private Integer aebj;
    @Override
    protected Serializable pkVal() {
        return this.bStandardprocessoid;
    }

}
