package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@ApiModel("Ufc标准工艺路线实体类")
@TableName(value = "b_standardprocessflow")
public class UfcBStandardprocessflow extends Model<UfcBStandardprocessflow>{

    private static final long serialVersionUID = 1L;

    @TableId
    private Long bStandardprocessflowoid;

    private String bzgylxid;

    private String bzgymc;

    private String gylxlb;

    private String gcid;

    private String bz;

    private Boolean tybz;

    private LocalDate qyrq;
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate tyrq;

    private String zt;

    private Long sysLastUpdBy;

    private Integer del;

    private LocalDateTime sysLastUpd;

    private Long bFactoryFk;

    @ApiModelProperty(example = "版本号：BM001", required = true,dataType = "string")
    private String bbh;

    @ApiModelProperty(example = "是否发布", required = true,dataType = "boolean")
    private Boolean isFb;

    @ApiModelProperty(example = "是否缺省版本", required = true,dataType = "boolean")
    private Boolean isQsbb;

    @ApiModelProperty(example = "标准工艺路线目录外键", required = true,dataType = "long")
    private Long stdprocatFk;

    @ApiModelProperty(example = "物料外键", required = true,dataType = "long")
    private Long bMaterialFk;

    @Override
    protected Serializable pkVal() {
        return this.bStandardprocessflowoid;
    }


    /**
     * 新增字段
     * @return
     */
    @ApiModelProperty(value = "新增字段，erp组织主键")
    private String  sszz;
    @ApiModelProperty(value = "新增字段，序号 erp作业号")
    private Integer  xh;
    @ApiModelProperty(value = "组织编码")
    private String gcCode;
    @ApiModelProperty(value = "物料外键")
    @TableField(exist = false)
    private String cpCode;
    @ApiModelProperty(value = "表示数据是新增还是修改的标识(MES不需要存储：1为新增，2为修改)")
    @TableField(exist = false)
    private Integer aebj;
    @ApiModelProperty(value = "产品工艺路线明细")
    @TableField(exist = false)
    private List<UfcBStandardprocessflowdetail> gx;

}
