package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName(value = "b_standardprocessflowdetail")
public class UfcBStandardprocessflowdetail extends Model<UfcBStandardprocessflowdetail>{

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(example = "标准工序主键", value = "标准工序主键")
    @TableId
    private Long bStandardprocessflowdetailoid;

    @ApiModelProperty(example = "标准工序编码", value = "标准工序编码")
    private String bzgylxid;

    @ApiModelProperty(example = "序号", value = "序号")
    private Integer xh;

    @ApiModelProperty(example = "标准工序编码:GX01",value = "标准工序编码:GX01")
    private String bzgxid;

    @ApiModelProperty(example = "标准工序名称:测试", required = true,dataType = "string")
    private String bzgxmc;

    @ApiModelProperty(example = "工序类型：4", required = true,dataType = "string")
    private String gxlx;

    private Boolean gjgx;

    private Boolean slgx;

    private Boolean xlgx;

    private Boolean csgx;

    private String gdid;

    private Float zbsj;

    private Float jgsj;

    private Float pdsj;

    private Float zysj;

    private Float ddsj;

    private String bz;

    @TableLogic
    private Integer del;

    private Long sysLastUpdBy;

    private LocalDateTime sysLastUpd;

    @ApiModelProperty(example = "标准工序外键", value = "标准工序外键")
    private Long Standardprocessflowfk;

    @ApiModelProperty(example = "工位外键", value = "工位外键")
    private Long bWorksectionFk;

    @ApiModelProperty(example = "工艺节点编码", value = "工艺节点编码")
    private Long bStandardprocessflowFk;

    @ApiModelProperty(example = "工艺节点编码", value = "工艺节点编码")
    private String gyjdbm;

    @ApiModelProperty(example = "工艺节点名称", value = "工艺节点名称")
    private String gyjdmc;

    @ApiModelProperty(example = "流转方式   A|流转节点内所有工序、S|流转节点内某一道工序", value = "流转方式   A|流转节点内所有工序、S|流转节点内某一道工序")
    private String lzfs;

    @ApiModelProperty(example = "标准产量3位小数", value = "标准产量3位小数")
    private BigDecimal bzcl;

    @ApiModelProperty(example = "标准工时", value = "标准工时")
    private BigDecimal bzgs;

    @ApiModelProperty(example = "标准人数", value = "标准人数")
    private Integer bzrs;

    @ApiModelProperty(example = "作业方式 PC、PDA、DCT", value = "作业方式 PC、PDA、DCT")
    private String zyfs;

    @ApiModelProperty(example = "采集内容 PD|产能、PD|产能和缺陷", value = "采集内容 PD|产能、PD|产能和缺陷")
    private String cjnr;

    @ApiModelProperty(example = "是否批次上料 1是 0不是", value = "是否批次上料 1是 0不是")
    private Boolean isPcsl;

    @ApiModelProperty(example = "是否经过本工序", value = "是否经过本工序")
    private Boolean jgbgx;

    @ApiModelProperty(example = "关键物料校验", value = "关键物料校验")
    private Boolean gjwljy;

    @ApiModelProperty(example = "合格率预警", value = "合格率预警")
    private Boolean hglyj;

    @ApiModelProperty(example = "合格率预警阀值 百分比", value = "合格率预警阀值 百分比")
    private BigDecimal hglyjfz;


    @ApiModelProperty(example = "标准工序节点外键-新增字段", value = "标准工序节点外键-新增字段")
    private Long technologicalProcessFk;
    /**
     * 首检工序
     */
    @ApiModelProperty(value = "首检工序", example = "false", position = 107)
    private Boolean firstInspectionProcess;
    /**
     * 单件管理
     */
    @ApiModelProperty(value = "单件管理", example = "false", position = 107)
    private Boolean individualManagement;
    /**
     * 单件生成
     */
    @ApiModelProperty(value = "单件生成", example = "false", position = 107)
    private Boolean singleGenerating;
    /**
     * 特殊过程
     */
    @ApiModelProperty(value = "特殊过程", example = "false", position = 107)
    private Boolean specialProcess;



    /**
     * 是否允许入库
     */
    @ApiModelProperty(value = "是否允许入库", example = "false", position = 101)
    private Boolean sfyxrk;

    /**
     * 默认入库仓库
     */
    @ApiModelProperty(value = "默认入库仓库", example = "2000000", position = 102)
    private String mrrkck;

    /**
     * 是否允许变更产品
     */
    @ApiModelProperty(value = "是否允许变更产品", example = "false", position = 106)
    private Boolean sfyxbgcp;

    /**
     * 是否允许拆分流程卡
     */
    @ApiModelProperty(value = "是否允许拆分流程卡", example = "false", position = 105)
    private Boolean sfyxcslck;

    /**
     * 是否校验工序
     */
    @ApiModelProperty(value = "是否校验工序", example = "false", position = 100)
    private Boolean sfjygx;

    /**
     * 是否进行数量校验
     */
    @ApiModelProperty(value = "是否进行数量校验", example = "false", position = 107)
    private Boolean sfjxsljy;

    /**
     * 是否允许自动接收
     */
    @ApiModelProperty(value = "是否允许自动接收", example = "false", position = 104)
    private Boolean sfyxzdjs;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    @Override
    protected Serializable pkVal() {
        return this.bStandardprocessflowdetailoid;
    }



    /**
     * 新增字段
     */
    @ApiModelProperty(example = "是否批次上料 1是 0不是", value = "是否批次上料 1是 0不是")
    @TableField(exist = false)
    private Boolean is_pcsl;

    @ApiModelProperty(value = "首检工序")
    @TableField(exist = false)
    private Boolean first_inspection_process;

    @ApiModelProperty(value = "单件管理")
    @TableField(exist = false)
    private Boolean individual_management;

    @ApiModelProperty(value = "单件生成")
    @TableField(exist = false)
    private Boolean single_generating;

    @ApiModelProperty(value = "特殊过程")
    @TableField(exist = false)
    private Boolean special_process;

}
