package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 标准工艺路线目录
 * </p>
 *
 * @author
 * @since 2021-06-02
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="BStdprocat对象", description="标准工艺路线目录")
@TableName("b_stdprocat")
public class UfcBStdprocat extends Model<UfcBStdprocat> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "标准工艺路线目录主键")
    @TableId
    private Long bStdprocatoid;

    @ApiModelProperty(value = "标准工艺路线编码")
    private String bzgylxid;

    @ApiModelProperty(value = "标准工艺路线名称")
    private String bzgylxmc;

    @ApiModelProperty(value = "工艺路线类别")
    private String lbid;

    @ApiModelProperty(value = "工厂编码")
    private String gcid;

    @ApiModelProperty(value = "当前缺省版本号")
    private String qsver;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "停用标志")
    private Boolean tybz;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "维护时间")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "工艺路线类别外键")
    private Long fkBProcat;

    @ApiModelProperty(value = "工厂外键")
    private Long fkBFactory;

    @ApiModelProperty(value = "停用日期")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate tyrq;

    @ApiModelProperty(value = "启用日期")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate qyrq;

    @ApiModelProperty(value = "维护人名称")
    @TableField(exist = false)
    private String empName;

    @Override
    protected Serializable pkVal() {
        return this.bStdprocatoid;
    }

}
