package com.jln.ufc.web.action.ufc.bm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.io.Serializable;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 基础数据-标准工艺路线-记录工序节点数据
 * </p>
 *
 * @author
 * @since 2021-06-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "BTechnologicalStandard对象", description = "基础数据-标准工艺路线-记录工序节点数据")
@TableName("b_technological_standard")
public class UfcBTechnologicalStandard extends Model<UfcBTechnologicalStandard> {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(value = "标准工艺路线-工序节点数据-主键")
    private Long technologicalProcessOid;

    @TableField(exist = false)
    @ApiModelProperty(value = "旧主键")
    private Long oldOid;

    @ApiModelProperty(value = "节点名称")
    private String nodeName;

    @ApiModelProperty(value = "节点编码")
    private String nodeCode;

    @ApiModelProperty(value = "流转方式：A|流转节点内的所有工序,S|流转节点内的某一道工序")
    private String transferMode;

    @ApiModelProperty(value = "流转某一道工序:某一道工序的外键")
    private Long defaultProcess;

    @ApiModelProperty(value = "流程节点的父级主键-开始的pid为：100000000000000000")
    private Long technologicalProcessPid;

    @ApiModelProperty(value = "标准工艺路线主键")
    private Long processRouteFk;

    @ApiModelProperty(value = "工序节点的样式信息数据")
    private String textJson;

    @ApiModelProperty(value = "节点的类型：1|开始节点，2|中间节点，3|结束节点")
    private Integer nodeTypes;

    @ApiModelProperty(value = "流班组外键")
    private Long bGroupFk;
    @ApiModelProperty(value = "班组编码")
    @TableField(exist = false)
    private String BGroupCode;
    @TableField(exist = false)
    @ApiModelProperty(value = "班组名称")
    private String BGroupName;

    @ApiModelProperty(value = "排序")
    private Integer sort = 0;

    @Override
    protected Serializable pkVal() {
        return this.technologicalProcessOid;
    }

}
