package com.jln.ufc.web.action.ufc.bm.entity.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Size;
import java.time.LocalDateTime;

@Data
@ApiModel("供应商设置数据层")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcBSupplierInfo {
    private static final long serialVersionUID = 1L;
    @ApiModelProperty(example = "00000", value = "客户设置主键", required = true,dataType = "Long")
    @TableId(value = "b_supplieroid", type = IdType.INPUT)
    private Long bSupplieroid;

    /**
     * 供应商编码
     */
    @ApiModelProperty(example = "王五", value = "供应商编码", required = true,dataType = "string")
    private String gysid;

    /**
     * 供应商名称
     */
    @ApiModelProperty(example = "杰夫供应商", value = "供应商名称", required = true,dataType = "string")
    @Size(max = 120,message = "供应商名称最大长度为120个字节")
    private String mc;

    /**
     * 供应商简称
     */
    @ApiModelProperty(example = "杰夫", value = "供应商简称", required = true,dataType = "string")
    @Size(max = 60,message = "供应商简称最大长度为60个字节")
    private String jc;

    /**
     * 英文名称
     */
    @ApiModelProperty(example = "JieFU", value = "英文名称", required = true,dataType = "string")
    @Size(max = 100,message = "英文名称最大长度为100个字节")
    private String ywmc;

    /**
     * 地址
     */
    @ApiModelProperty(example = "无锡", value = "地址", required = true,dataType = "string")
    @Size(max = 100,message = "地址最大长度为100个字节")
    private String dz;

    /**
     * 电话
     */
    @ApiModelProperty(example = "18596586632", value = "电话", required = true,dataType = "string")
    @Size(max = 20,message = "电话最大长度为20个字节")
    private String tel;

    /**
     * 传真
     */
    @ApiModelProperty(example = "1516489988262625", value = "传真", required = true,dataType = "string")
    @Size(max = 20,message = "传真最大长度为20个字节")
    private String fax;

    /**
     * e-mail
     */
    @ApiModelProperty(example = "2985587456@qq.com", value = "e-mail", required = true,dataType = "string")
    @Size(max = 40,message = "e-mail最大长度为40个字节")
    private String email;

    /**
     * 开户行
     */
    @ApiModelProperty(example = "建设银行", value = "开户行", required = true,dataType = "string")
    @Size(max = 250,message = "开户行最大长度为250个字节")
    private String yh;

    /**
     * 银行账号
     */
    @ApiModelProperty(example = "121561652525295829", value = "银行账号", required = true,dataType = "string")
    @Size(max = 40,message = "银行账号最大长度为40个字节")
    private String yhzh;

    /**
     * 税号
     */
    @ApiModelProperty(example = "595985295298529", value = "税号", required = true,dataType = "string")
    @Size(max = 20,message = "税号最大长度为20个字节")
    private String sh;

    /**
     * 法人代表
     */
    @ApiModelProperty(example = "张三", value = "法人代表", required = true,dataType = "string")
    @Size(max = 30,message = "法人代表最大长度为30个字节")
    private String frdb;

    /**
     * 联系人
     */
    @ApiModelProperty(example = "李四", value = "联系人", required = true,dataType = "string")
    @Size(max = 20,message = "联系人最大长度为20个字节")
    private String lxr;

    /**
     * 货币
     */
    @ApiModelProperty(example = "CNY", value = "货币", required = true,dataType = "string")
    @Size(max = 10,message = "货币最大长度为10个字节")
    private String hbid;
    @ApiModelProperty(example = "CNY", value = "名称", dataType = "string")
    private String hbmc;

    /**
     * 地区
     */
    @ApiModelProperty(example = "福州", value = "地区编码", required = true,dataType = "string")
    @Size(max = 10,message = "地区最大长度为10个字节")
    private String dq;

    /**
     * 采购员
     */
    @ApiModelProperty(example = "李四", value = "采购员", required = true,dataType = "string")
    @Size(max = 30,message = "采购员最大长度为30个字节")
    private String cgy;

    /**
     * abc分类
     */
    @ApiModelProperty(example = "A", value = "abc分类", required = true,dataType = "string")
    @Size(max = 1,message = "abc分类最大长度为1个字节")
    private String abc;

    /**
     * 供应商分类
     */
    @ApiModelProperty(example = "FL01", value = "供应商分类", required = true,dataType = "string")
    @Size(max = 10,message = "供应商分类最大长度为10个字节")
    private String fl;

    /**
     * 供应商类型
     */
    @ApiModelProperty(example = "A", value = "供应商类型", required = true,dataType = "string")
    @Size(max = 1,message = "供应商类型最大长度为1个字节")
    private String gyslx;

    /**
     * 冻结
     */
    @ApiModelProperty(example = "false", value = "冻结", required = true,dataType = "boolean")
    private Boolean dj;

    /**
     * 状态
     */
    @ApiModelProperty(example = "I", value = "状态", required = true,dataType = "string")
    @Size(max = 1,message = "状态最大长度为1个字节")
    private String zt;

    /**
     * 维护人主键
     */
    @ApiModelProperty(example = "000000", value = "维护人主键", required = true,dataType = "Long")
    private Long sysLastUpdBy;

    /**
     * 维护时间
     */
    @ApiModelProperty(example = "2020-02-19 03:59:16", value = "维护时间", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    /**
     * 维护人姓名
     */
    @ApiModelProperty(example = "王五", value = "维护人姓名", required = true,dataType = "string")
    private String userName;


    /**
     * 供应商分类名称
     */
    @ApiModelProperty(example = "A1", value = "供应商分类名称", required = true,dataType = "string")
    private String flmc;

    /**
     * 供应商地区名称
     */
    @ApiModelProperty(example = "无锡", value = "供应商地区名称", required = true,dataType = "string")
    private String dqmc;

    /**
     * 是否检测试验供应商
     */
    @ApiModelProperty(example = "false", value = "是否检测试验供应商", required = true, dataType = "boolean")
    private Boolean jesygys;
    /**
     * 组织名称
     */
    @ApiModelProperty(example = "false", value = "组织名称")
    private String organizeName;
    /**
     * 组织编码
     */
    @ApiModelProperty(example = "false", value = "组织名称")
    private Long erpOrgId;
}
