package com.jln.ufc.web.action.ufc.bm.entity.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

@Data
@ApiModel("标准工序数据层")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcStandardprocessInfo {


    private static final long serialVersionUID = 1L;
    @ApiModelProperty(example = "标准工序主键", required = true, dataType = "string")
    @TableId(value = "bStandardprocessoid", type = IdType.INPUT)
    @JsonProperty(value = "bStandardprocessoid")
    private Long bStandardprocessoid;

    /**
     * 标准工序编码
     */
    @NotBlank(message = "标准工序编码不能为空")
    @ApiModelProperty(example = "标准工序编码：BZGX001", required = true, dataType = "string")
    private String bzgxid;

    /**
     * 标准工序名称
     */
    @NotBlank(message = "标准工序名称不能为空")
    @ApiModelProperty(example = "标准工序名称:测试工序", required = true, dataType = "string")
    @Size(max = 24, message = "标准工序名称最大长度为24个字节")
    private String bzgxmc;

    /**
     * 设备数
     */
    @ApiModelProperty(example = "设备数：10", required = true, dataType = "int")
    private Integer sbs;

    /**
     * 人数
     */
    @ApiModelProperty(example = "人数;5", required = true, dataType = "int")
    private Integer rs;

    /**
     * 准备时间
     */
    @ApiModelProperty(example = "准备时间:19", required = true, dataType = "float")
    private Float zbsj;

    /**
     * 排队时间
     */
    @ApiModelProperty(example = "排队时间:12", required = true, dataType = "float")
    private Float pdsj;

    /**
     * 加工时间
     */
    @ApiModelProperty(example = "加工时间:50", required = true, dataType = "float")
    private Float jgsj;

    /**
     * 等待时间
     */
    @ApiModelProperty(example = "等待时间:23", required = true, dataType = "float")
    private Float ddsj;

    /**
     * 关键工序
     */
    @ApiModelProperty(example = "关键工序:6", required = true, dataType = "int")
    private boolean gjgx;

    /**
     * 上料
     */
    @ApiModelProperty(example = "上料:4", required = true, dataType = "int")
    private boolean slgx;

    /**
     * 下料
     */
    @ApiModelProperty(example = "下料:1", required = true, dataType = "int")
    private boolean xlgx;

    /**
     * 测试
     */
    @ApiModelProperty(example = "测试:4", required = true, dataType = "int")
    private boolean csgx;

    /**
     * 备注
     */

    @ApiModelProperty(example = "备注:测试", required = true, dataType = "string")
    @Size(max = 250, message = "备注最大长度为250个字节")
    private String bz;

    /**
     * 停用标志
     */
    @ApiModelProperty(example = "停用标志", required = true, dataType = "int")
    private Boolean tybz;

    /**
     * 启用日期
     */
    @ApiModelProperty(example = "启用日期", required = true, dataType = "date")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private LocalDate qyrq;


    /**
     * 停用日期
     */
    @ApiModelProperty(example = "停用日期", required = true, dataType = "date")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private LocalDate tyrq;

    /**
     * 创建日期
     *//*
    @ApiModelProperty(example = "创建日期", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;*/

    /**
     * 最后修改日期
     */
    @ApiModelProperty(example = "最后修改日期", required = true, dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;


    /**
     * 创建用户
     */
    @ApiModelProperty(example = "创建用户", required = true, dataType = "string")
    private Long sysCreatedBy;


    /**
     * 维护人
     */
    @ApiModelProperty(example = "维护人", dataType = "string")
    private String userName;

    private Float zysj;


    /**
     * 是否校验工序
     */
    @ApiModelProperty(value = "是否校验工序", example = "false", position = 100)
    private Boolean sfjygx;

    /**
     * 是否允许入库
     */
    @ApiModelProperty(value = "是否允许入库", example = "false", position = 101)
    private Boolean sfyxrk;

    /**
     * 默认入库仓库
     */
    @ApiModelProperty(value = "默认入库仓库", example = "2000000", position = 102)
    private String mrrkck;

    /**
     * 默认入库仓库
     */
    @ApiModelProperty(value = "默认入库仓库名称", example = "第一仓库", position = 103)
    private String ckmc;

    /**
     * 是否允许自动接收
     */
    @ApiModelProperty(value = "是否允许自动接收", example = "false", position = 104)
    private Boolean sfyxzdjs;

    /**
     * 是否允许拆分流程卡
     */
    @ApiModelProperty(value = "是否允许拆分流程卡", example = "false", position = 105)
    private Boolean sfyxcslck;

    /**
     * 是否允许变更产品
     */
    @ApiModelProperty(value = "是否允许变更产品", example = "false", position = 106)
    private Boolean sfyxbgcp;

    /**
     * 是否进行数量校验
     */
    @ApiModelProperty(value = "是否进行数量校验", example = "false", position = 107)
    private Boolean sfjxsljy;
    /**
     * 是否进行数量校验
     */
    @ApiModelProperty(value = "工序是否存在", example = "false", position = 107)
    private Boolean whetherTheProcessExists;

    /**
     * 首检工序
     */
    @ApiModelProperty(value = "首检工序", example = "false", position = 107)
    private Boolean firstInspectionProcess;
    /**
     * 单件管理
     */
    @ApiModelProperty(value = "单件管理", example = "false", position = 107)
    private Boolean individualManagement;
    /**
     * 单件生成
     */
    @ApiModelProperty(value = "单件生成", example = "false", position = 107)
    private Boolean singleGenerating;
    /**
     * 特殊过程
     */
    @ApiModelProperty(value = "特殊过程", example = "false", position = 107)
    private Boolean specialProcess;



    @ApiModelProperty(example = "是否经过本工序", required = true)
    private Boolean jgbgx;

    @ApiModelProperty(example = "是否批次上料 1是 0不是", required = true)
    private Boolean isPcsl;

    @ApiModelProperty(example = "关键工序校验", required = true)
    private Boolean gjgxjy;

    @ApiModelProperty(example = "合格率预警", required = true)
    private Boolean hglyj;

    @ApiModelProperty(example = "合格率预警阀值 百分比", required = true)
    private BigDecimal hglyjfz;

    /**
     * 文档附件名称
     */
    @ApiModelProperty(example = "文档附件名称",dataType = "string")
    private String cessoryName;

    /**
     * 文档地址
     */
    @ApiModelProperty(example = "文档地址",dataType = "string")
    private String accessoryUrl;

    @ApiModelProperty(example = "是否转包工序",dataType = "boolean")
    private Boolean zbgx;

    @ApiModelProperty(example = "组织名称")
    private String organizeName;

    @ApiModelProperty(example = "组织名称")
    private String sszz;

}
