package com.jln.ufc.web.action.ufc.bm.entity.vo;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.utils.EmptyUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.List;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@Accessors(chain = true)
@ApiModel(value = "物料属性202108封装类")
public class UfcWoWlsxVo {

    @ApiModelProperty(example = "物料属性值字段")
    private List<UfcWoBindWlVo> wlsxzList;

    @ApiModelProperty(example = "生产订单属性组信息")
    private List<UfcWoBindWlVo> wosxzList;

    @ApiModelProperty(example = "物料属性组编码", required = true, dataType = "string")
    private String wlsxzbm;

    @ApiModelProperty(example = "物料属性组名称", required = true, dataType = "string")
    private String wlsxzmc;

    @ApiModelProperty(example = "物料批次组编码", required = true, dataType = "string")
    private String wlpcsxzbm;

    @ApiModelProperty(example = "物料批次组名称", required = true, dataType = "string")
    private String wlpcsxzmc;

    @ApiModelProperty(example = "物料批次属性组外键", required = true, dataType = "string")
    private Long wlpcsxzfk;

    @ApiModelProperty(example = "物料属性组外键", required = true, dataType = "string")
    private Long wlsxzfk;


    @ApiModelProperty(example = "物料属性字段", required = true, dataType = "string")
    private String wlsxJson;

    @ApiModelProperty(example = "物料批次字段", required = true, dataType = "string")
    private String wlpcJson;

    public String getWlsxJson() {
        if (EmptyUtil.isEmpty(wlsxzList)) {
            return "";
        }
        StringBuffer buffer = new StringBuffer();
        for (UfcWoBindWlVo itemVo : wlsxzList) {
            separatorItem(itemVo,buffer);
        }
        return buffer.toString();
    }

    public String getWlpcJson() {
        if (EmptyUtil.isEmpty(wosxzList)) {
            return "";
        }
        StringBuffer buffer = new StringBuffer();
        for (UfcWoBindWlVo itemVo : wosxzList) {
            separatorItem(itemVo,buffer);
        }
        return buffer.toString();
    }

    private void separatorItem(UfcWoBindWlVo itemVo, StringBuffer buffer) {
        if (itemVo.getWhetherDisplay() != null && itemVo.getWhetherDisplay()) {
            if (itemVo.getDisplayFormat() == 1) {
                buffer.append(itemVo.getSxxmmc());
                switch (itemVo.getSeparator()) {
                    case 1:
                        buffer.append(" ");
                        break;
                    case 2:
                        buffer.append("|");
                        break;
                    case 3:
                        buffer.append(";");
                        break;
                    case 4: //default暂时和4相同，代码规范所以4暂时不写
                    default:
                        buffer.append("；");
                        break;
                }
            }
            buffer.append(itemVo.getSxz());
            buffer.append(" ");
        }
    }
}
