package com.jln.ufc.web.action.ufc.bm.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBMaterial;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectCopyVo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcBMaterialSelectVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author
 * @since 2020-02-12
 */
@Component("UfcBMaterialMapper")
public interface UfcBMaterialMapper extends BaseMapper<UfcBMaterial> {

    Page<UfcBMaterialSelectVo> selectLists(Page<UfcBMaterialSelectVo> page, @Param("dto") UfcBMaterialSelectCopyVo bMaterialSelectVo);

    List<UfcBMaterial> getList(@Param(Constants.WRAPPER) Wrapper wrapper);

    /**
     * 统计物料信息的分页查询总条数
     * @param bMaterialSelectVo  物料分类信息
     * @return
     */
    Integer selectListCount(@Param("dto") UfcBMaterialSelectCopyVo bMaterialSelectVo);
}
