package com.jln.ufc.web.action.ufc.bm.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.PswlsxInfo;
import com.jln.common.entity.Result;
import com.jln.common.entity.WlsxInfo;
import com.jln.common.utils.EmptyUtil;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBMaterialPropertyGroup;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcWoBindWlVo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcWoWlsxVo;
import com.jln.ufc.web.action.ufc.bm.mapper.UfcBMaterialPropertyGroupMapper;
import com.jln.ufc.web.action.ufc.bm.service.UfcBMaterialPropertyGroupService;
import com.jln.ufc.web.action.ufc.bm.service.UfcJcBMaterialService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.lang.reflect.Field;
import java.util.List;

@Service
public class UfcBMaterialPropertyGroupServiceImpl extends ServiceImpl<UfcBMaterialPropertyGroupMapper, UfcBMaterialPropertyGroup> implements UfcBMaterialPropertyGroupService {

    private static Logger logger = LoggerFactory.getLogger(UfcBMaterialPropertyGroupServiceImpl.class);
    
    @Autowired
    private UfcJcBMaterialService bMaterialService;
    
    @Override
    public void packedAbsorber(Object o) {
        if (o instanceof Page) {
            for (Object record : ((Page) o).getRecords()) {
                packed1(record);
            }
        } else if (o instanceof List) {
            ((List) o).forEach(o1 -> {
                packed1(o1);
            });
        } else {
            packed1(o);
        }
    }

    private void packed1(Object o) {
        if (o instanceof PswlsxInfo) {

            try {
                Field field1 = o.getClass().getDeclaredField("bMaterialoid");
                if (field1 != null) {
                    field1.setAccessible(true);
                    Long wlfk = (Long) field1.get(o);
                    Result<WlsxInfo> wlsx = bMaterialService.getWlsx(wlfk);
                    if (wlsx.confirmSuccess()) {
                        if (!EmptyUtil.isEmpty(wlsx.getData())) {
                            BeanUtils.copyProperties(wlsx.getData(), o);
                        }
                    }
                }
            } catch (NoSuchFieldException e) {
                logger.warn("没有【bMaterialoid】字段");
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }
            try {
                Field field2 = o.getClass().getDeclaredField("wooid");

                if (field2 != null) {
                    field2.setAccessible(true);
                    Long oid = (Long) field2.get(o);
                    Result<UfcWoWlsxVo> wlsx = getWoWlsx(oid);
                    if (wlsx.confirmSuccess()) {
                        if (!EmptyUtil.isEmpty(wlsx.getData())) {
                            BeanUtils.copyProperties(wlsx.getData(), o);
                        }
                    }
                }
            } catch (NoSuchFieldException e) {
                logger.warn("没有【wooid】字段");
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }

        }
    }

    /**
     * 生产订单维护接口—获取生产订单绑定物料信息接口
     *
     * @param oid
     * @return
     */
    public Result<UfcWoWlsxVo> getWoWlsx(Long oid) {
        if (EmptyUtil.isEmpty(oid)) {
            return new Result().toFailure("没有生产订单信息");
        }
        //通过生产订单主键获取物料外键
        UfcWoWlsxVo woWlsx = new UfcWoWlsxVo();
        //获取的生产订单及物料外键不能为空
        woWlsx = this.baseMapper.getWoWlsx(oid);
        if (!EmptyUtil.isEmpty(woWlsx)) {
            //物料属性信息
            List<UfcWoBindWlVo> wlsxzList = this.baseMapper.getWoWlsxzList(oid, "0");
            //订单属性信息
            List<UfcWoBindWlVo> wosxzList = this.baseMapper.getWoWlsxzList(oid, "1");
            woWlsx.setWlsxzList(wlsxzList);
            woWlsx.setWosxzList(wosxzList);
        }

        return new Result<UfcWoWlsxVo>().toSuccess(woWlsx);
    }

    
}
