package com.jln.ufc.web.action.ufc.bm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBProductprocessdetail;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStandardprocess;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcStandardprocessInfo;
import com.jln.ufc.web.action.ufc.bm.entity.vo.UfcStandprocessQuery;
import com.jln.ufc.web.action.ufc.bm.mapper.UfcBStandardprocessMapper;
import com.jln.ufc.web.action.ufc.bm.service.UfcBStandardprocessService;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcBProductprocessdetailMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
public class UfcBStandardprocessServiceImpl extends ServiceImpl<UfcBStandardprocessMapper, UfcBStandardprocess> implements UfcBStandardprocessService {

    @Autowired
    private UfcBStandardprocessMapper ufcBStandardprocessMapper;

    @Autowired
    private UfcBStandardprocessService ufcBStandardprocessService;

    @Autowired
    private UfcBStandardprocessMapper bStandardprocessMapper;

    @Autowired
    private UfcBProductprocessdetailMapper ufcBProductprocessdetailMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result saveerp(List<UfcBStandardprocess> bStandardprocess) throws Exception {
        List<UfcBStandardprocess> insert = new ArrayList<>();
        List<UfcBStandardprocess> update = new ArrayList<>();
        for (UfcBStandardprocess standardprocess : bStandardprocess) {
            standardprocess.setDel(0);
            LambdaQueryWrapper<UfcBStandardprocess> wrapper = new LambdaQueryWrapper<>();
            wrapper.eq(UfcBStandardprocess::getBzgxid, standardprocess.getBzgxid());
            wrapper.eq(UfcBStandardprocess::getSszz, standardprocess.getSszz());
            wrapper.eq(UfcBStandardprocess::getDel, false);
            Integer checked = ufcBStandardprocessMapper.selectCount(wrapper);
            if (!EmptyUtil.isEmpty(checked) && checked > 0) {
                update.add(standardprocess);
            } else {
                insert.add(standardprocess);
            }
        }
        if (!EmptyUtil.isEmpty(insert)) {
            ufcBStandardprocessService.saveBatch(insert);
        }
        if (!EmptyUtil.isEmpty(update)) {
            ufcBStandardprocessService.updateBatchById(update);
        }
        return new Result().toSuccess();
    }

    @Override
    public Result deleteerp(List<Long> bStandardprocessoids) {
        int delete = bStandardprocessMapper.deleteBatchIds(bStandardprocessoids);
        if (delete > 0) {
            return new Result().toSuccess();
        } else {
            return new Result().toFailure("删除失败!");
        }
    }

    @Override
    public Result<Page<UfcStandardprocessInfo>> selectPage(PageParameter<UfcStandprocessQuery> page) {
        Page<UfcStandardprocessInfo> bStandardprocessInfoPage = bStandardprocessMapper.selectQueryPage(new Page<>(page.getPageNum(), page.getPageSize()), page.getData());
        if (!EmptyUtil.isEmpty(bStandardprocessInfoPage.getRecords())) {
            UfcStandprocessQuery data = page.getData();
            List<UfcStandardprocessInfo> records = bStandardprocessInfoPage.getRecords();
            if (!EmptyUtil.isEmpty(page.getData()) && !EmptyUtil.isEmpty(data.getNodePrimaryKey())) {
                Long nodePrimaryKey = data.getNodePrimaryKey();
                List<UfcBProductprocessdetail> bProductprocessdetailList = ufcBProductprocessdetailMapper.selectList(new LambdaQueryWrapper<UfcBProductprocessdetail>().eq(UfcBProductprocessdetail::getDel, false).eq(UfcBProductprocessdetail::getTechnologicalProcessFk, nodePrimaryKey));
                for (UfcStandardprocessInfo record : records) {
                    for (UfcBProductprocessdetail bProductprocessdetail : bProductprocessdetailList) {
                        if (record.getBStandardprocessoid().equals(bProductprocessdetail.getBStandardprocessFk())) {
                            record.setWhetherTheProcessExists(true);
                            break;
                        }
                        record.setWhetherTheProcessExists(false);
                    }
                }
            }


        }
        return new Result().toSuccess(bStandardprocessInfoPage);
    }

}
