package com.jln.ufc.web.action.ufc.bm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.JsonUtils;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBFactory;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStandardprocess;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStandardprocessflow;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStdprocat;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBTechnologicalStandard;
import com.jln.ufc.web.action.ufc.bm.mapper.UfcBStandardprocessMapper;
import com.jln.ufc.web.action.ufc.bm.mapper.UfcBStandardprocessflowMapper;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStandardprocessflowdetail;
import com.jln.ufc.web.action.ufc.bm.mapper.UfcBStandardprocessflowdetailMapper;
import com.jln.ufc.web.action.ufc.bm.service.UfcBFactoryService;
import com.jln.ufc.web.action.ufc.bm.service.UfcBStandardprocessflowService;
import com.jln.ufc.web.action.ufc.bm.service.UfcBStandardprocessflowdetailService;
import com.jln.ufc.web.action.ufc.bm.service.UfcBStdprocatService;
import com.jln.ufc.web.action.ufc.bm.service.UfcBTechnologicalStandardService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class UfcBStandardprocessflowServiceImpl extends ServiceImpl<UfcBStandardprocessflowMapper, UfcBStandardprocessflow> implements com.jln.ufc.web.action.ufc.bm.service.UfcBStandardprocessflowService {

    @Autowired
    private UfcBFactoryService bFactoryService;

    @Autowired
    private UfcBStandardprocessflowdetailMapper bStandardprocessflowdetailMapper;

    @Autowired
    private UfcBStandardprocessMapper bStandardprocessMapper;

    @Autowired
    private UfcBStdprocatService bStdprocatService;

    @Autowired
    private UfcBStandardprocessflowService UfcBStandardprocessflowService;

    @Autowired
    private UfcBStandardprocessflowdetailService bStandardprocessflowdetailService;

    @Autowired
    private UfcBTechnologicalStandardService bTechnologicalStandardService;

    @Autowired
    private UfcBStandardprocessflowMapper bStandardprocessflowMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result saveerp(List<UfcBStandardprocessflow> bStandardprocessflow, User user) {
        List<UfcBStandardprocessflow> insertFlow = new ArrayList<>();
        List<UfcBStandardprocessflowdetail> insertDetail = new ArrayList<>();
        List<UfcBStandardprocessflow> updateFlow = new ArrayList<>();
        List<UfcBStandardprocessflowdetail> updateDetail = new ArrayList<>();
        List<UfcBStdprocat> bStdprocatInsert = new ArrayList<>();
        List<UfcBStdprocat> bStdprocatUpdate = new ArrayList<>();
        List<UfcBTechnologicalStandard> bTechnologicalStandards = new ArrayList<>();

        if(!EmptyUtil.isEmpty(bStandardprocessflow)){
            for (UfcBStandardprocessflow standardprocessflow : bStandardprocessflow) {
                standardprocessflow.setSysLastUpd(LocalDateTime.now());
                if(!EmptyUtil.isEmpty(standardprocessflow.getCpCode())){
                    standardprocessflow.setBMaterialFk(Long.valueOf(standardprocessflow.getCpCode()));
                }
                UfcBFactory bFactory = null;
                if(!EmptyUtil.isEmpty(standardprocessflow.getSszz())){
                    LambdaQueryWrapper<UfcBFactory> wrapper = new LambdaQueryWrapper();
                    wrapper.eq(UfcBFactory::getGcid,standardprocessflow.getSszz());
                    wrapper.eq(UfcBFactory::getDel,false);
                    bFactory = bFactoryService.getBaseMapper().selectOne(wrapper);
                    if(!EmptyUtil.isEmpty(bFactory)){
                        standardprocessflow.setBFactoryFk(bFactory.getBFactoryoid());
                    }else{
                        //throw new Exception("组织机构不存在");
                        return new Result().toFailure("组织机构不存在");
                    }
                }else{
                    //throw new Exception("所属组织不能为空");
                    return new Result().toFailure("所属组织不能为空");
                }

                //存放nodes数组
                ArrayList<Map<String,Object>> nodesList = new ArrayList<>();
                ArrayList<Map<String,Object>> edgesList = new ArrayList<>();
                //按序号排序(Integer类型)
                List<UfcBStandardprocessflowdetail> gx2 = standardprocessflow.getGx().stream().sorted(Comparator.comparing(UfcBStandardprocessflowdetail::getXh)).collect(Collectors.toList());
                // 坐标
                int x=100 , y=100;
                for(int i=0;i<gx2.size();i++){
                    UfcBStandardprocessflowdetail bStandardprocessflowdetail = new UfcBStandardprocessflowdetail();
                    BeanUtils.copyProperties(gx2.get(i), bStandardprocessflowdetail);
                    bStandardprocessflowdetail.setBStandardprocessflowdetailoid(SnowflakeIdUtils.generate());
                    bStandardprocessflowdetail.setIsPcsl(standardprocessflow.getGx().get(i).getIs_pcsl());
                    bStandardprocessflowdetail.setFirstInspectionProcess(gx2.get(i).getFirst_inspection_process());
                    bStandardprocessflowdetail.setIndividualManagement(gx2.get(i).getIndividual_management());
                    bStandardprocessflowdetail.setSingleGenerating(gx2.get(i).getSingle_generating());
                    bStandardprocessflowdetail.setSpecialProcess(gx2.get(i).getSpecial_process());
                    bStandardprocessflowdetail.setSysLastUpd(LocalDateTime.now());
                    bStandardprocessflowdetail.setSysLastUpdBy(user.getUserId());
                    bStandardprocessflowdetail.setBzgxid(gx2.get(i).getBzgxid());
                    bStandardprocessflowdetail.setBzgxmc(gx2.get(i).getBzgxmc());
                    //流转方式,默认为A 流转节点内所有工序
                    bStandardprocessflowdetail.setLzfs("A");
                    //标准产品工艺路线编码 和 工序号 查询工艺路线详情    标准工艺路线详情序号不可重复
                    LambdaQueryWrapper<UfcBStandardprocessflowdetail> wrapper = new LambdaQueryWrapper<>();
                    wrapper.eq(UfcBStandardprocessflowdetail::getBzgylxid,gx2.get(i).getBzgylxid());
                    wrapper.eq(UfcBStandardprocessflowdetail::getXh,gx2.get(i).getXh());
                    wrapper.eq(UfcBStandardprocessflowdetail::getDel,false);
                    UfcBStandardprocessflowdetail checkedXh = bStandardprocessflowdetailMapper.selectOne(wrapper);



                    Map<String,Object> opacity = new LinkedHashMap<>();
                    opacity.put("opacity",0.9);

                    Map<String,Object> style = new LinkedHashMap<>();
                    style.put("nodeState:default",opacity);
                    style.put("nodeState:hover",opacity);
                    style.put("nodeState:selected",opacity);
                    style.put("radius",10);

                    Map<String,Object> labelCfg = new LinkedHashMap<>();
                    labelCfg.put("fontSize",20);


                    //第一个节点
                    if(i==0){
                        //开始节点oid
                        UfcBTechnologicalStandard startBTechnologicalStandard = new UfcBTechnologicalStandard();
                        startBTechnologicalStandard.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                        startBTechnologicalStandard.setNodeName("开始节点");
                        startBTechnologicalStandard.setNodeCode("start");
                        startBTechnologicalStandard.setSort(0);
                        startBTechnologicalStandard.setTransferMode("A");
                        startBTechnologicalStandard.setTechnologicalProcessPid(100000000000000000L);
                        startBTechnologicalStandard.setProcessRouteFk(standardprocessflow.getBStandardprocessflowoid());
                        startBTechnologicalStandard.setNodeTypes(1);

                        Map<String,Object> startArray = new LinkedHashMap<>();
                        startArray.put("text","node");
                        startArray.put("label","开始");
                        startArray.put("nodeCode","start");
                        startArray.put("nodeName","开始节点");
                        startArray.put("transferMode","A");
                        startArray.put("bgroupCode","");
                        startArray.put("bgroupFk","");
                        startArray.put("bgroupName","");
                        startArray.put("processRouteFk",String.valueOf(standardprocessflow.getBStandardprocessflowoid()));
                        startArray.put("technologicalProcessPid","");
                        startArray.put("nodeTypes","1");
                        startArray.put("id",String.valueOf(startBTechnologicalStandard.getTechnologicalProcessOid()));
                        startArray.put("technologicalProcessOid",String.valueOf(startBTechnologicalStandard.getTechnologicalProcessOid()));
                        startArray.put("type","circle-node");
                        startArray.put("x",x);
                        startArray.put("y",y);
                        startArray.put("style",style);
                        startArray.put("labelCfg",labelCfg);


                        nodesList.add(startArray);



                        UfcBTechnologicalStandard node1 = new UfcBTechnologicalStandard();
                        node1.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                        node1.setNodeName(gx2.get(i).getBzgxmc());
                        node1.setSort(gx2.get(i).getXh());
                        node1.setNodeCode(gx2.get(i).getBzgxid());
                        node1.setTransferMode("A");
                        node1.setTechnologicalProcessPid(startBTechnologicalStandard.getTechnologicalProcessOid());
                        node1.setProcessRouteFk(standardprocessflow.getBStandardprocessflowoid());
                        node1.setNodeTypes(3);

                        //明细表中存储节点外键
                        bStandardprocessflowdetail.setTechnologicalProcessFk(node1.getTechnologicalProcessOid());

                        Map<String,Object> node1Array = new LinkedHashMap<>();
                        node1Array.put("text","node");
                        node1Array.put("label",gx2.get(i).getBzgxmc());
                        node1Array.put("nodeCode",gx2.get(i).getBzgxid());
                        node1Array.put("nodeName",gx2.get(i).getBzgxmc());
                        node1Array.put("transferMode","A");
                        node1Array.put("bgroupCode","");
                        node1Array.put("bgroupFk","");
                        node1Array.put("bgroupName","");
                        node1Array.put("technologicalProcessPid","");
                        node1Array.put("processRouteFk",String.valueOf(standardprocessflow.getBStandardprocessflowoid()));
                        node1Array.put("nodeTypes","2");
                        node1Array.put("id",String.valueOf(node1.getTechnologicalProcessOid()));
                        node1Array.put("technologicalProcessOid",String.valueOf(node1.getTechnologicalProcessOid()));
                        node1Array.put("type","rect-node");
                        node1Array.put("x",x+(i+1)*100);
                        node1Array.put("y",y+(i+1)*100);
                        style.put("width",96);
                        node1Array.put("style",style);
                        node1Array.put("labelCfg",labelCfg);

                        //第一个节点线条
                        Map<String,Object> edges = new LinkedHashMap<>();
                        edges.put("id",String.valueOf(System.currentTimeMillis()));
                        edges.put("source",String.valueOf(startBTechnologicalStandard.getTechnologicalProcessOid()));
                        edges.put("target",String.valueOf(node1.getTechnologicalProcessOid()));
                        edges.put("sourceAnchor",1);
                        edges.put("targetAnchor",3);
                        edges.put("type","polyline-edge");

                        edgesList.add(edges);
                        nodesList.add(node1Array);
                        bTechnologicalStandards.add(startBTechnologicalStandard);

                        bTechnologicalStandards.add(node1);
                    }else {
                        UfcBTechnologicalStandard node = new UfcBTechnologicalStandard();
                        node.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                        node.setNodeName(gx2.get(i).getBzgxmc());
                        node.setNodeCode(gx2.get(i).getBzgxid());
                        node.setSort(gx2.get(i).getXh());
                        node.setTransferMode("A");
                        node.setTechnologicalProcessPid(bTechnologicalStandards.get(i).getTechnologicalProcessOid());
                        node.setProcessRouteFk(standardprocessflow.getBStandardprocessflowoid());
                        node.setNodeTypes(3);

                        //明细表中存储节点外键
                        bStandardprocessflowdetail.setTechnologicalProcessFk(node.getTechnologicalProcessOid());

                        Map<String,Object> nodeArray = new LinkedHashMap<>();
                        nodeArray.put("text","node");
                        nodeArray.put("label",gx2.get(i).getBzgxmc());
                        nodeArray.put("nodeCode",gx2.get(i).getBzgxid());
                        nodeArray.put("nodeName",gx2.get(i).getBzgxmc());
                        nodeArray.put("transferMode","A");
                        nodeArray.put("bgroupCode","");
                        nodeArray.put("bgroupFk","");
                        nodeArray.put("bgroupName","");
                        nodeArray.put("technologicalProcessPid","");
                        nodeArray.put("processRouteFk",String.valueOf(standardprocessflow.getBStandardprocessflowoid()));
                        nodeArray.put("nodeTypes","2");
                        nodeArray.put("id",String.valueOf(node.getTechnologicalProcessOid()));
                        nodeArray.put("technologicalProcessOid",String.valueOf(node.getTechnologicalProcessOid()));
                        nodeArray.put("type","rect-node");
                        nodeArray.put("x",x+(i+1)*100);
                        nodeArray.put("y",y+(i+1)*100);
                        style.put("width",96);
                        nodeArray.put("style",style);
                        nodeArray.put("labelCfg",labelCfg);

                        nodesList.add(nodeArray);
                        bTechnologicalStandards.add(node);
                        //节点线条
                        Map<String,Object> edges = new LinkedHashMap<>();
                        edges.put("id",String.valueOf(System.currentTimeMillis()));
                        edges.put("source",String.valueOf(bTechnologicalStandards.get(i).getTechnologicalProcessOid()));
                        edges.put("target",String.valueOf(node.getTechnologicalProcessOid()));
                        edges.put("sourceAnchor",1);
                        edges.put("targetAnchor",3);
                        edges.put("type","polyline-edge");

                        edgesList.add(edges);

                        //最后一个节点,生成结束节点
                        if(i==gx2.size()-1){
                            UfcBTechnologicalStandard endBTechnologicalStandard = new UfcBTechnologicalStandard();
                            endBTechnologicalStandard.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                            endBTechnologicalStandard.setNodeName("结束节点");
                            endBTechnologicalStandard.setNodeCode("end");
                            endBTechnologicalStandard.setSort(gx2.get(gx2.size()-1).getXh()+1);
                            endBTechnologicalStandard.setTransferMode("A");
                            endBTechnologicalStandard.setTechnologicalProcessPid(200000000000000000L);
                            endBTechnologicalStandard.setProcessRouteFk(standardprocessflow.getBStandardprocessflowoid());
                            endBTechnologicalStandard.setNodeTypes(3);

                            Map<String,Object> endArray = new LinkedHashMap<>();
                            endArray.put("text","node");
                            endArray.put("label","结束");
                            endArray.put("nodeCode","end");
                            endArray.put("nodeName","结束节点");
                            endArray.put("transferMode","A");
                            endArray.put("bgroupCode","");
                            endArray.put("bgroupFk","");
                            endArray.put("bgroupName","");
                            endArray.put("processRouteFk",String.valueOf(standardprocessflow.getBStandardprocessflowoid()));
                            endArray.put("technologicalProcessPid","");
                            endArray.put("nodeTypes","3");
                            endArray.put("id",String.valueOf(endBTechnologicalStandard.getTechnologicalProcessOid()));
                            endArray.put("technologicalProcessOid",String.valueOf(endBTechnologicalStandard.getTechnologicalProcessOid()));
                            endArray.put("type","ellipse-node");
                            endArray.put("x",x+(gx2.size()+1)*100);
                            endArray.put("y",y+(gx2.size()+1)*100);
                            endArray.put("style",style);
                            endArray.put("labelCfg",labelCfg);

                            nodesList.add(endArray);
                            bTechnologicalStandards.add(endBTechnologicalStandard);

                            //结束线条
                            Map<String,Object> endEdges = new LinkedHashMap<>();
                            endEdges.put("id",String.valueOf(System.currentTimeMillis()));
                            endEdges.put("source",String.valueOf(node.getTechnologicalProcessOid()));
                            endEdges.put("target",String.valueOf(endBTechnologicalStandard.getTechnologicalProcessOid()));
                            endEdges.put("sourceAnchor",1);
                            endEdges.put("targetAnchor",3);
                            endEdges.put("type","polyline-edge");
                            edgesList.add(endEdges);
                        }


                    }











                    insertDetail.add(bStandardprocessflowdetail);
                    updateDetail.add(bStandardprocessflowdetail);


                }
                Map<String,Object> nodes = new LinkedHashMap<>();
                nodes.put("nodes",nodesList);
                nodes.put("edges",edgesList);
                String textJson = JsonUtils.toJson(nodes);
                for (UfcBTechnologicalStandard bTechnologicalStandard : bTechnologicalStandards) {
                    bTechnologicalStandard.setTextJson(textJson);
                }

                // 保存工艺路线目录数据
                UfcBStdprocat bStdprocat = new UfcBStdprocat();
                bStdprocat.setBzgylxid(standardprocessflow.getBzgylxid());
                bStdprocat.setBzgylxmc(standardprocessflow.getBzgymc());
                bStdprocat.setLbid(standardprocessflow.getGylxlb());
                bStdprocat.setTybz(standardprocessflow.getTybz());
                bStdprocat.setTyrq(standardprocessflow.getTyrq());
                bStdprocat.setQyrq(standardprocessflow.getQyrq());
                bStdprocat.setBz(standardprocessflow.getBz());
                bStdprocat.setGcid(bFactory.getBFactoryoid() + "");

                //新增
                if(standardprocessflow.getAebj()==1){
                    bStdprocat.setBStdprocatoid(SnowflakeIdUtils.generate());
                    bStdprocatInsert.add(bStdprocat);
                    if (EmptyUtil.isEmpty(standardprocessflow.getStdprocatFk())) {
                        standardprocessflow.setStdprocatFk(bStdprocat.getBStdprocatoid());
                    }
                    insertFlow.add(standardprocessflow);
                }
                if(standardprocessflow.getAebj()==2){
                    updateFlow.add(standardprocessflow);
                    // 不存在标准工序进行数据回滚并给出对应提示
                    List<UfcBStandardprocessflowdetail> gx = standardprocessflow.getGx();
                    if (!EmptyUtil.isEmpty(gx)) {
                        List<String> gzgxidList = gx.stream().map(UfcBStandardprocessflowdetail::getBzgxid).collect(Collectors.toList());
                        List<UfcBStandardprocess> bStandardprocesses = bStandardprocessMapper.selectList(new LambdaQueryWrapper<UfcBStandardprocess>().in(UfcBStandardprocess::getBzgxid, gzgxidList));
                        if (EmptyUtil.isEmpty(bStandardprocesses) ) {
                            //throw new Exception("工序编码" + gzgxidList.stream().collect(Collectors.joining(",")) + "不存在");
                            return new Result().toFailure("工序编码" + gzgxidList.stream().collect(Collectors.joining(",")) + "不存在");
                        }
                        List<String> gzgxidList2 = bStandardprocesses.stream().map(UfcBStandardprocess::getBzgxid).collect(Collectors.toList());
                        List<String> list = gzgxidList.stream().filter(item -> !gzgxidList2.contains(item)).collect(Collectors.toList());
                        if (!EmptyUtil.isEmpty(list)) {
                            //throw new Exception("工序编码" + list.stream().collect(Collectors.joining(",")) + "不存在");
                            return new Result().toFailure("工序编码" + list.stream().collect(Collectors.joining(",")) + "不存在");
                        }
                    }
                    UfcBStdprocat one = bStdprocatService.getOne(new LambdaQueryWrapper<UfcBStdprocat>().eq(UfcBStdprocat::getBzgylxid, standardprocessflow.getBzgylxid()));
                    bStdprocat.setBStdprocatoid(one.getBStdprocatoid());
                    bStdprocatUpdate.add(bStdprocat);
                }
            }

        }
        if(!EmptyUtil.isEmpty(insertFlow)){
            boolean insert1 = UfcBStandardprocessflowService.saveBatch(insertFlow);
        }
        if(!EmptyUtil.isEmpty(insertDetail)){
            boolean insert2 = bStandardprocessflowdetailService.saveBatch(insertDetail);
        }
        if(!EmptyUtil.isEmpty(updateFlow)){
            boolean update1 = UfcBStandardprocessflowService.updateBatchById(updateFlow);
        }
        if(!EmptyUtil.isEmpty(updateDetail)){
            boolean update2 = bStandardprocessflowdetailService.updateBatchById(updateDetail);
        }
        if (!EmptyUtil.isEmpty(bStdprocatInsert)) {
            boolean b = bStdprocatService.saveBatch(bStdprocatInsert);
        }
        if (!EmptyUtil.isEmpty(bStdprocatUpdate)) {
            boolean b = bStdprocatService.updateBatchById(bStdprocatUpdate);
        }
        if(!EmptyUtil.isEmpty(bTechnologicalStandards)){
            boolean b = bTechnologicalStandardService.saveBatch(bTechnologicalStandards);
        }
        return new Result().toSuccess();
    }

    @Override
    public Result deleteerp(List<Long> bStandardprocessflowoids) {
        LambdaQueryWrapper<UfcBStandardprocessflowdetail> wrapper = new LambdaQueryWrapper();
        wrapper.in(UfcBStandardprocessflowdetail::getBStandardprocessflowFk,bStandardprocessflowoids);
        bStandardprocessflowdetailMapper.delete(wrapper);
        int delete = bStandardprocessflowMapper.deleteBatchIds(bStandardprocessflowoids);
        if(delete>0){
            return new Result().toSuccess();
        }
        return new Result().toFailure("删除失败!");
    }

}
