package com.jln.ufc.web.action.ufc.em.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.BusinessAn;
import com.jln.common.annotation.BusinessValue;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.em.entity.vo.EmEquinfVo;
import com.jln.ufc.web.action.ufc.em.entity.vo.QueryParamVo;
import com.jln.ufc.web.action.ufc.em.service.UfcEmEquinfService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(value = "设备基本信息",tags = "设备基本信息")
@RestController
@RequestMapping("/ufc/em/em01/em0108")
public class UfcEmEquinfController {
    
    @Autowired
    private UfcEmEquinfService ufcEmEquinfService;

    @ApiOperation(value = "获取设备基本信息列表数据", notes = "获取设备基本信息列表数据 ")
    @PostMapping("/getlist")
    @BusinessAn(value = "BMS1009")
    public Result<Page<EmEquinfVo>> getList(@RequestBody PageParameter<QueryParamVo> parameter , @BusinessValue List<Long> list, @LoginUser User user) {
        return ufcEmEquinfService.getList(parameter,list,user);
    }
    
    
}
