package com.jln.ufc.web.action.ufc.em.entity.vo;

import com.baomidou.mybatisplus.annotation.TableId;
import com.jln.common.entity.PswlsxInfo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @author: Luca.Liu
 * @date: 2022/3/11
 */
@Data
public class EmEquinfVo extends PswlsxInfo {

    /**
     * 主键
     */
    @TableId("em_equinfoid")
    private Long emEquinfoid;

    /**
     * 设备编码
     */
    private String sbbm;

    /**
     * 设备号
     */
    private String sbid;

    /**
     * 设备名称
     */
    private String sbmc;

    /**
     * 英文名称
     */

    private String ywmc;

    /**
     * 供货厂家
     */
    private String ghcj;

    /**
     * 制造厂家
     */
    private String zzcj;

    /**
     * 制造日期
     */
    private LocalDate zzrq;

    /**
     * 出厂编码
     */
    private String ccbh;

    /**
     * 出厂日期
     */
    private LocalDate ccrq;

    /**
     * 投产日期
     */
    private LocalDate tcrq;

    /**
     * 设备原值
     */
    private String ysjg;

    /**
     * 资产编号
     */
    private String zcid;

    /**
     * 责任人
     */
    @ApiModelProperty(value = "责任人")
    private String zzrname;
    /**
     * 责任人
     */
    @ApiModelProperty(value = "责任人工号")
    private String zzrgh;

    /**
     * 使用年限
     */
    private String synx;

    /**
     * 使用部门
     */
    @ApiModelProperty(value = "使用部门")
    private String sybm;
    /**
     * 使用部门
     */
    @ApiModelProperty(value = "使用部门名称")
    private String sybmmc;

    /**
     * 设备分类编码
     */
    @ApiModelProperty(value = "设备分类编码")
    private String lbid;

    /**
     * 设备分类名称
     */
    @ApiModelProperty(value = "设备分类名称")
    private String lbmc;
    /**
     * 设备状态编码
     */
    private String ztid;
    @ApiModelProperty(value = "设备状态编码")
    private String ztCode;
    /**
     * 设备状态名称
     */
    @ApiModelProperty(value = "设备状态名称")
    private String ztmc;

    /**
     * 物料编码
     */
    private String wlid;
    /**
     * 图号
     */
    private String tz;
    /**
     * 规格型号
     */
    private String gg;

    /**
     * 名称
     */
    private String mc;

    /**
     * 变动日期
     */
    private LocalDate bdrq;

    /**
     * 生产能力
     */
    private String scnl;

    /**
     * 设备寿命
     */
    private String sbsm;

    /**
     * 保修结束日期
     */
    private LocalDate bxjsq;

    /**
     * 设备净重
     */
    private String sbjz;

    /**
     * 电气复制系数
     */
    private String dqfzxs;

    /**
     * 机械复杂系数
     */
    private String jxfzxs;

    /**
     * 重要程度
     */
    private String zycd;

    /**
     * 安全级别
     */
    private String aqjb;

    /**
     * 特种设备
     */
    private Boolean tzsb;

    /**
     * 资料信息
     */
    private String zlxx;

    /**
     * 放置地点
     */
    private String fzdd;

    /**
     * 月标准使用时间
     */
    private String ybzsysj;

    /**
     * 安装日期
     */
    private LocalDate azrq;

    /**
     * 使用证编号
     */
    private String syzbh;

    /**
     * 备注
     */
    private String bz;

    /**
     * 启用日期
     */
    private LocalDate qyrq;

    /**
     * 停用日期
     */
    private LocalDate tyrq;

    /**
     * 停用标志
     */
    private Boolean tybz;

    /**
     * 删除标记
     */
    private Integer del;

    /**
     * 设备编码外键
     */
    private Long emEqucodFk;

    /**
     * 设备分类外键
     */
    private Long emEqucatFk;

    /**
     * 设备状态外键
     */
    private Long emEqustaFk;

    /**
     * 物料外键
     */
    private Long bMaterialFk;

    /**
     * 维护时间
     */
    private LocalDateTime sysLastUpd;

    /**
     * 创建人
     */
    private String employeeName ;

    /**
     * 所属工厂外键
     */
    private Long bFactoryFk;


    /**
     * 设备型号
     */
    private String unitType;

    @ApiModelProperty( value = "预留字段1")
    private String reserved1;
    @ApiModelProperty( value = "预留字段2")
    private String reserved2;
    @ApiModelProperty( value = "预留字段3")
    private String reserved3;
    @ApiModelProperty( value = "预留字段4")
    private String reserved4;
    @ApiModelProperty( value = "预留字段5")
    private LocalDate reserved5;
    @ApiModelProperty( value = "预留字段6")
    private LocalDate reserved6;
    @ApiModelProperty( value = "预留字段7")
    private Long reserved7;
    @ApiModelProperty( value = "预留字段8")
    private Long reserved8;

    @ApiModelProperty( value = "设备编码维护主键")
    private Long emEqucodoid;
    
    
}
