package com.jln.ufc.web.action.ufc.lm.controller;


import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmBusinessTypeVO;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmBusinessTypeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author 
 * @since 2022-01-10
 * 
 * 业务分类
 */
@RestController
@RequestMapping("/ufc/lm/lm01/lm0108")
@Api(tags = "业务分类")
public class UfcLmBusinessTypeController {
    
    @Autowired
    private UfcLmBusinessTypeService ufcLmBusinessTypeService;

    @PostMapping("getPage")
    @ApiOperation(value = "分页列表", notes = "分页列表 ")
    public Result getPage(@RequestBody PageParameter<UfcLmBusinessTypeVO> pageParameter){
        return ufcLmBusinessTypeService.getPage(pageParameter);
    }
    
    @ApplyForPermission
    @GetMapping("getList")
    @ApiOperation(value = "全部列表", notes = "全部列表")
    public Result getList(LaboratoryPermissions laboratoryPermissions){
        return ufcLmBusinessTypeService.getList(laboratoryPermissions);
    }
    
    @GetMapping("get")
    @ApiOperation(value = "根据id获取详情", notes = "根据id获取详情")
    public Result get(@RequestParam Long id){
        return ufcLmBusinessTypeService.get(id);
    }
    
    @PostMapping("save")
    @ApiOperation(value = "保存", notes = "保存")
    public Result save(@RequestBody UfcLmBusinessTypeVO ufcLmBusinessTypeVO, @LoginUser User user){
        return ufcLmBusinessTypeService.savePojo(ufcLmBusinessTypeVO, user);
    }
    
    @PostMapping("del")
    @ApiOperation(value = "删除", notes = "删除")
    public Result del(@RequestBody List<Long> ids, @LoginUser User user){
        return ufcLmBusinessTypeService.del(ids, user);
    }


}
