package com.jln.ufc.web.action.ufc.lm.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmOrdersDetail;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcOrdersDetailQueryDTO;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmOrdersDetailService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import java.util.List;

/**
 * <p>
 * 委托单明细 前端控制器
 * </p>
 *
 * @author
 * @since 2022-01-05
 */
@Api(tags = "委托单明细")
@RestController
@RequestMapping("/ufc/erp/orders/detail")
public class UfcLmOrdersDetailController {
    @Autowired
    private UfcLmOrdersDetailService ordersDetailService;

    @ApiOperation(value = "委托单明细分页查询", notes = "委托单明细分页查询")
    @PostMapping("/getDetailPage")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result<Page<UfcLmOrdersDetail>> getDetailPage(@RequestBody @Valid PageParameter<UfcOrdersDetailQueryDTO> queryDTO) {
        return ordersDetailService.getDetailPage(queryDTO);
    }

    @ApiOperation(value = "委托单明细查询", notes = "委托单明细查询")
    @PostMapping("/getDetail")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result<List<UfcLmOrdersDetail>> getDetail(@RequestBody @Valid UfcOrdersDetailQueryDTO queryDTO) {
        return ordersDetailService.getDetail(queryDTO);
    }

    @ApiOperation(value = "委托单明细保存", notes = "委托单明细保存")
    @PostMapping("/saveDetail")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result<Long> saveDetail(@RequestBody @Valid UfcLmOrdersDetail detail) {
        return ordersDetailService.saveDetail(detail);
    }

    @ApiOperation(value = "委托单明细删除", notes = "委托单明细删除")
    @PostMapping("/delDetail")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result<String> delDetail(@RequestBody List<Long> oids) {
        return ordersDetailService.delDetail(oids);
    }

    @ApiOperation(value = "委托单明细导入", notes = "委托单明细导入")
    @PostMapping("/importDetail")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result<String> importDetail(@RequestParam(value = "file", required = false) MultipartFile file, @RequestParam Long ufcLmOrdersFk, @LoginUser User user) {
        return ordersDetailService.importDetail(file, ufcLmOrdersFk,user);
    }

    @ApiOperation(value = "获取送试单号", notes = "获取送试单号")
    @GetMapping("/getCode")
    public Result<String> getCode(@RequestParam Long oid) {
        return ordersDetailService.getCode();
    }
}
