package com.jln.ufc.web.action.ufc.lm.controller;


import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsSaveDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTdsVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTdsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * <p>
 * 实验室(LM02)-送试单 前端控制器
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@RestController
@RequestMapping("/ufc/lm/lm0201")
@Api(tags = "送试单--定制接口")
public class UfcLmTdsController {
    @Autowired
    private UfcLmTdsService lmTdsService;

    @ApplyForPermission
    @ApiOperation(value = "送试单分页查询", notes = "送试单分页查询 ")
    @PostMapping("/pageTdsist")
    public Result pageSsList(@RequestBody PageParameter<UfcLmTdsDto> lmtdsDto, LaboratoryPermissions laboratoryPermissions) {
        return lmTdsService.pageSsList(lmtdsDto, laboratoryPermissions);
    }


    @ApiOperation(value = "外协转移弹窗", notes = "外协转移弹窗 ")
    @GetMapping("/getDefault")
    public Result getDefault(@RequestParam Long wboid){
        return lmTdsService.getDefault(wboid);
    }


    @ApiOperation(value = "外协转移弹窗", notes = "外协转移弹窗 ")
    @PostMapping("/gwjSave")
    public Result gwjSave(@RequestBody UfcLmTdsSaveDto ufcLmTdsSaveDto, @LoginUser User user){
        return lmTdsService.gwjSave(ufcLmTdsSaveDto, user);
    }

    @ApiOperation(value = "送试单-保存按钮", notes = "送试单-保存按钮")
    @PostMapping("/save")
    public Result<UfcLmTdsSaveDto> save(@RequestBody UfcLmTdsSaveDto lmTdsSaveDto, @LoginUser User user) {
        return lmTdsService.save(lmTdsSaveDto,user);
    }


    @ApiOperation(value = "根据主键查询-送试单明细", notes = "根据主键查询-送试单明细")
    @GetMapping("/getTdsByOid")
    public Result<UfcLmTdsVo> getTdsByOid(@RequestParam String tdsOid) {
        return lmTdsService.getTdsByOid(tdsOid);
    }


}
