package com.jln.ufc.web.action.ufc.lm.controller;


import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTestCategoryDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTestCategoryVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTestCategoryService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;


/**
 * <p>
 * 实验室-试验分类 前端控制器
 * </p>
 *
 * @author 
 * @since 2021-08-08
 */
@Api(tags = "实验分类--定制")
@RestController
@RequestMapping("/ufc/lm/lm0101/")
public class UfcLmTestCategoryController {

    @Autowired
    private UfcLmTestCategoryService lmTestCategoryService;

    @ApiOperation(value = "添加或编辑实验分类接口-定制",notes="添加或编辑实验分类接口--定制")
    @PostMapping("/saveOrUpdateLmTestCategry")
    public Result saveOrUpdateLmTestCategry(@Validated @RequestBody UfcLmTestCategoryDto lmTestCategoryDto, @LoginUser User user)
    {
        return lmTestCategoryService.saveOrUpdateLmTestCategry(lmTestCategoryDto,user);
    }

    @ApplyForPermission
    @ApiOperation(value = "分页查询实验分类接口-定制",notes="分页查询实验分类接口-定制")
    @PostMapping("/pageLmTestCategry")
    public Result pageLmTestCategry(@RequestBody PageParameter parameter, LaboratoryPermissions laboratoryPermissions)
    {
        return lmTestCategoryService.pageLmTestCategry(parameter, laboratoryPermissions);
    }

    @ApplyForPermission
    @ApiOperation(value = "实验分类下拉框-定制",notes="实验分类下拉框-定制")
    @GetMapping("/selLmTCategoryList")
    public Result selLmTCategoryList(@RequestParam(required = false) String syflbm,
                                     @RequestParam(required = false) String syflmc, LaboratoryPermissions laboratoryPermissions) {
        UfcLmTestCategoryVo ufcLmTestCategoryVo = new UfcLmTestCategoryVo();
        ufcLmTestCategoryVo.setSyflbm(syflbm);
        ufcLmTestCategoryVo.setSyflmc(syflmc);
        return lmTestCategoryService.selLmTCategoryList(ufcLmTestCategoryVo, laboratoryPermissions);
    }


}
