package com.jln.ufc.web.action.ufc.lm.controller;

import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTestItemsDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTestItemsQueryDto;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTestItemsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 实验室-试验项目维护 前端控制器
 * </p>
 *
 * @author
 * @since 2021-08-08
 */
@Api(tags = "试验项目维护--定制接口")
@RestController
@RequestMapping("/ufc/lm/lm0102")
public  class UfcLmTestItemsController {
    @Autowired
    private UfcLmTestItemsService lmTestItemsService;

    @ApiOperation(value = "添加或编辑试验项目维护接口--定制接口",notes="添加或编辑试验项目维护接口----定制接口")
    @PostMapping("/saveOrUpdateLmTestItems")
    public Result saveOrUpdateLmTestItems(@Validated @RequestBody UfcLmTestItemsDto lmTestItemsDto, @LoginUser User user)
    {
        return lmTestItemsService.saveOrUpdateLmTestItems(lmTestItemsDto,user);
    }


    @ApplyForPermission
    @ApiOperation(value = "分页查询试验项目维护接口",notes="分页查询试验项目维护接口")
    @PostMapping("/pageLmTestItems")
    public Result pageLmTestItems(@RequestBody PageParameter<UfcLmTestItemsQueryDto> parameter)
    {
        return lmTestItemsService.pageLmTestItems(parameter);
    }

    @ApiOperation(value = "根据主键查询试验项目维护接口",notes="根据主键查询试验项目维护接口")
    @PostMapping("/selLmTestItemsByoid")
    public Result selLmTestItemsByoid(@RequestParam(required = true) String lmTestItemsoid)
    {
        return lmTestItemsService.selLmTestItemsByoid(lmTestItemsoid);
    }



}
