package com.jln.ufc.web.action.ufc.lm.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcJccsDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcJccsVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTestParameterService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * <p>
 * 实验室-检测参数维护 前端控制器
 * </p>
 *
 * @author gushang
 * @since 2021-08-08
 */
@RestController
@RequestMapping("/ufc/lm/lm0106")
@Api(tags = "检测参数--定制类容")
public class UfcLmTestParameterController {

    @Autowired
    private UfcLmTestParameterService lmTestParameterService;

    @ApplyForPermission
    @ApiOperation(value = "获取检测参数列表", notes = "获取检测参数列表 ")
    @PostMapping("/getlist")
    public Result<Page<UfcJccsVo>> getjccsList(@RequestBody PageParameter<UfcJccsDto> parameter ) {
        return lmTestParameterService.getjccsList(parameter);
    }

   
    @ApiOperation(value = "检测测试--保存", notes = "检测测试--保存")
    @PostMapping("/save")
    public Result saveorupdatejccs(@Valid @RequestBody UfcJccsDto jccsDto, @LoginUser User user) {
        return lmTestParameterService.saveorupdatejccs(jccsDto,user);
    }



}
