package com.jln.ufc.web.action.ufc.lm.controller;


import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTestStandardDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTestStandard;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTestStandardVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTestStandardService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * <p>
 * 实验室-试验标准 前端控制器
 * </p>
 *
 * @author
 * @since 2021-08-09
 */
@Api(tags = "试验标准--定制")
@RestController
@RequestMapping("/ufc/lm/lm0104")
public class UfcLmTestStandardController {
    @Autowired
    private UfcLmTestStandardService lmTestStandardService;


    @ApiOperation(value = "保存或修改试验标准数据--定制", notes = "保存或修改试验标准数据-定制")
    @PostMapping("/saveOrUpdateLmTs")
    public Result<Long> saveOrUpdateLmTs(@Valid @RequestBody UfcLmTestStandardDto lmTestStandardDto, @LoginUser User user) {
        return lmTestStandardService.saveOrUpdate(lmTestStandardDto,user);
    }

    @ApplyForPermission
    @ApiOperation(value = "获取试验标准列表数据", notes = "获取试验标准列表数据 ")
    @PostMapping("/getLmTsList")
    public Result<PageParameter<UfcLmTestStandardVo>> getLmTsList(@RequestBody PageParameter<UfcLmTestStandardDto> parameter) {
        return lmTestStandardService.getList(parameter);
    }

  


    @ApiOperation(value = "获取试验标准编辑数据", notes = "获取试验标准编辑数据")
    @GetMapping("/getLmTsByOid")
    public Result<UfcLmTestStandardVo> getLmTsByOid(@RequestParam(value = "oid",required = true) Long oid) {
        return lmTestStandardService.getByOid(oid);
    }

}
