package com.jln.ufc.web.action.ufc.lm.controller;

import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcEmEquinfDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTtDto;
import com.jln.ufc.web.action.ufc.lm.service.UfcSingleTaskService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * <p>
 * 实验室-实验任务执行-单任务 前端控制器
 * </p>
 *
 * @author
 * @since 2021-09-01
 */
@Api(tags = "实验任务执行-单任务--定制接口")
@RestController
@RequestMapping("/ufc/lm/lm0203")

public class UfcSingleTaskController {

    @Autowired
    private UfcSingleTaskService singleTaskService;

    @ApplyForPermission
    @ApiOperation(value = "实验任务执行-单任务列表信息",notes="实验任务执行-单任务列表信息")
    @PostMapping("/getSingleTaskLsit")
    public Result getSingleTaskLsit(@RequestBody PageParameter<UfcLmTtDto> pageParameter)
    {
        return singleTaskService.getSingleTaskLsit(pageParameter);
    }

    @ApiOperation(value = "实验任务执行-单任务-设备选择列表",notes="实验任务执行-单任务-设备选择列表")
    @PostMapping("/getChooseEmEquinfList")
    public Result getChooseEmEquinfList(@RequestBody PageParameter<UfcEmEquinfDto> pageParameter) {
        return singleTaskService.getChooseEmEquinfList(pageParameter);
    }

   
}
