package com.jln.ufc.web.action.ufc.lm.controller;

import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcChangeOrderDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsDto;
import com.jln.ufc.web.action.ufc.lm.service.UfcTestRecheckService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/ufc/lm/lm0205")
@Api(tags = "试验管理-试验复核--定制接口")
public class UfcTestRecheckController {
    @Autowired
    private UfcTestRecheckService testRecheckService;

  

    @ApplyForPermission
    @ApiOperation(value = "试验复核列表分页查询", notes = "试验复核列表分页查询 ")
    @PostMapping("/pageFhList")
    public Result pageFhList(@RequestBody PageParameter<UfcLmTdsDto> lmtdsDto, LaboratoryPermissions laboratoryPermissions) {
        return testRecheckService.pageFhList(lmtdsDto, laboratoryPermissions);
    }


    @ApiOperation(value = "试验复核-转销售", notes = "试验复核-转销售")
    @PostMapping("/changeOrder")
    public Result changeOrder(@RequestBody UfcChangeOrderDto changeOrderDto) {
        return testRecheckService.changeOrder(changeOrderDto);
    }

}
