package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;

/**
 * <p>
 * 委托单
 * </p>
 *
 * @author 
 * @since 2022-01-06
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class UfcLmOrders extends Model<UfcLmOrders> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @ApiModelProperty(value = "主键")
    @TableId
    private Long ufcLmOrdersOid;

    /**
     * 单据编号
     */
    @ApiModelProperty(value = "单据编号")
    private String ufcLmOrdersNumber;

    /**
     * 单据类型
     */
    @ApiModelProperty(value = "单据类型")
    private String ufcLmOrdersType;

    /**
     * 检验类别
     */
    @ApiModelProperty(value = "检验类别")
    private String ufcLmOrdersInspectionType;

    /**
     * 销售类型
     */
    @ApiModelProperty(value = "销售类型")
    private String ufcLmOrdersSalesType;

    /**
     * 合同类型
     */
    @ApiModelProperty(value = "合同类型")
    private String ufcLmOrdersConsigneeType;

    /**
     * 合同号
     */
    @ApiModelProperty(value = "合同号")
    private String ufcLmOrdersContract;

    /**
     * 销售部门
     */
    @ApiModelProperty(value = "销售部门")
    private String ufcLmOrdersDepartment;

    /**
     * 销售员
     */
    @ApiModelProperty(value = "销售员")
    private String ufcLmOrdersSalesman;

    /**
     * 送试人
     */
    @ApiModelProperty(value = "送试人")
    private String ufcLmOrdersSendPeople;

    /**
     * 收货方
     */
    @ApiModelProperty(value = "收货方")
    private String ufcLmOrdersConsignee;

    /**
     * 日期
     */
    @ApiModelProperty(value = "日期")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate ufcLmOrdersDate;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String ufcLmOrdersRemarks;

    /**
     * 客户外键
     */
    @ApiModelProperty(value = "客户编码")
    private String bCustomeCode;
    /**
     * 客户外键
     */
    @ApiModelProperty(value = "客户名称")
    private String bCustomeName;

    /**
     * 状态(I:初始 F:确认)
     */
    @ApiModelProperty(value = "状态(I:初始 F:确认)")
    private String ufcLmOrdersState;
    /**
     * 状态(I:初始 F:确认)
     */
    @ApiModelProperty(value = "创建人")
    private String ufcLmOrdersCreate;

    @Override
    protected Serializable pkVal() {
        return this.ufcLmOrdersOid;
    }

}
