package com.jln.ufc.web.action.ufc.lm.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 委托单明细
 * </p>
 *
 * @author
 * @since 2022-01-05
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class UfcLmOrdersDetail extends Model<UfcLmOrdersDetail> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId
    @ApiModelProperty(value = "主键")
    private Long ufcLmOrdersDetaiOid;

    /**
     * 送试单号
     */
    @ApiModelProperty(value = "送试单号")
    private String ufcLmOrdersDetailSsdh;

    /**
     * 生产批号
     */
    @ApiModelProperty(value = "生产批号")
    @ExcelProperty("生产批号")
    private String ufcLmOrdersDetailScph;

    /**
     * 物料编码
     */
    @ApiModelProperty(value = "物料编码外键")
    private Long ufcLmOrdersDetailWlFk;
    /**
     * 物料编码
     */
    @ApiModelProperty(value = "物料编码")
    @ExcelProperty("物料编码")
    private String ufcLmOrdersDetailWlbm;

    /**
     * 物料名称
     */
    @ApiModelProperty(value = "物料名称")
    @ExcelProperty("物料名称")
    private String ufcLmOrdersDetailWlmc;

    /**
     * 规格型号
     */
    @ExcelProperty("规格型号")
    @ApiModelProperty(value = "规格型号")
    private String ufcLmOrdersDetailGgxh;

    /**
     * 图号
     */
    @ExcelProperty("图号")
    @ApiModelProperty(value = "图号")
    private String ufcLmOrdersDetailTh;
    /**
     * 图号
     */
    @ExcelProperty("物料材质")
    @ApiModelProperty(value = "物料材质")
    private String ufcLmOrdersDetailWlcz;

    /**
     * 计量单位
     */
    @ExcelProperty("计量单位")
    @ApiModelProperty(value = "计量单位")
    private String ufcLmOrdersDetailJldw;

    /**
     * 送试数量
     */
    @ExcelProperty("送试数量")
    @ApiModelProperty(value = "送试数量")
    private Integer ufcLmOrdersDetailSssl;
    /**
     * 送试数量
     */
    @ExcelProperty(value = "送试时间", format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "送试时间")
    private LocalDateTime ufcLmOrdersDetailSssj;

    /**
     * 单价
     */
    @ExcelProperty("单价")
    @ApiModelProperty(value = "单价")
    private BigDecimal ufcLmOrdersDetailDj;

    /**
     * 含税单价
     */
    @ExcelProperty("含税单价")
    @ApiModelProperty(value = "含税单价")
    private BigDecimal ufcLmOrdersDetailHsdj;

    /**
     * 执行试验标准
     */
    @ApiModelProperty(value = "执行试验标准外键")
    private Long ufcLmOrdersDetailZxsybzFk;
    /**
     * 执行试验标准
     */
    @ExcelProperty("执行试验标准")
    @ApiModelProperty(value = "执行试验标准")
    @TableField(exist = false)
    private String ufcLmOrdersDetailZxsybz;
    /**
     * 执行试验标准
     */
    @ApiModelProperty(value = "执行试验标准名称")
    @TableField(exist = false)
    private String ufcLmOrdersDetailZxsybzName;

    /**
     * 检测中心试验标准
     */
    @ApiModelProperty(value = "检测中心试验标准外键")
    private Long ufcLmOrdersDetailJczxsybzFk;
    /**
     * 检测中心试验标准
     */
    @ExcelProperty("检测中心试验标准")
    @ApiModelProperty(value = "检测中心试验标准")
    @TableField(exist = false)
    private String ufcLmOrdersDetailJczxsybz;
    /**
     * 检测中心试验标准
     */
    @ApiModelProperty(value = "检测中心试验标准名称")
    @TableField(exist = false)
    private String ufcLmOrdersDetailJczxsybzName;

    /**
     * 客户合同号
     */
    @ExcelProperty("客户合同号")
    @ApiModelProperty(value = "客户合同号")
    private String ufcLmOrdersDetailKhhth;

    /**
     * 第三方客户单号
     */
    @ExcelProperty("第三方客户单号")
    @ApiModelProperty(value = "第三方客户单号")
    private String ufcLmOrdersDetailDsfkhdh;

    /**
     * 要求完成时间
     */
    @ExcelProperty(value = "要求完成时间", format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "要求完成时间")
    private LocalDateTime ufcLmOrdersDetailYqwcsj;

    @ApiModelProperty(value = "生产厂商")
    private String ufcLmOrdersDetailSccs;

    @ApiModelProperty(value = "生产日期")
    private LocalDate ufcLmOrdersDetailScrq;

    /**
     * 备注
     */
    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String ufcLmOrdersDetailBz;

    /**
     * 批次数量/送试数量
     */
    @ExcelProperty("批次数量/送试数量")
    @ApiModelProperty(value = "批次数量/送试数量")
    private String ufcLmOrdersDetailsl;

    /**
     * 主表外键
     */
    @ApiModelProperty(value = "主表外键")
    private Long ufcLmOrdersFk;
    /**
     * 实验分类外键
     */
    @ApiModelProperty(value = "实验分类外键")
    @NotNull(message = "实验分类不能为空")
    private Long lmTestCategoryFk;

    /**
     * 实验分类
     */
    @ExcelProperty("实验分类")
    @ApiModelProperty(value = "实验分类编码")
    @TableField(exist = false)
    private String lmTestCategory;
    /**
     * 实验分类
     */
    @ApiModelProperty(value = "实验分类")
    @TableField(exist = false)
    private String lmTestCategoryName;

    /**
     * 送试人
     */
    @ApiModelProperty(value = "送试人")
    private String ufcLmOrdersSendPeople;
    /**
     * 2022-3-17 新增字段
     * 报告编号 同一个单据编号下：按列表顺序，依次在合同号后面加“流水号”，001、002、003、004
     */
    @ApiModelProperty(value = "报告编号")
    private String ufcLmOrdersBgbh;


    @Override
    protected Serializable pkVal() {
        return this.ufcLmOrdersDetaiOid;
    }

}
