package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 实验室-试验产品参数
 * </p>
 *
 * @author
 * @since 2021-08-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmParameter对象", description="实验室-试验产品参数")
@TableName("lm_parameter")
public class UfcLmParameter extends Model<UfcLmParameter> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "试验产品参数主键")
    @TableId
    private Long lmParameteroid;

    @ApiModelProperty(value = "试验标准外键")
    @TableField("lm_test_standard_fk")
    private Long lmTestStandardFk;

    @ApiModelProperty(value = "试验标准明细外键")
    @TableField("lm_test_standardDetail_fk")
    private Long lmTestStandarddetailFk;

    @ApiModelProperty(value = "检测参数编码")
    private String jccsbm;

    @ApiModelProperty(value = "检测参数名称")
    private String jccsmc;

    @ApiModelProperty(value = "检测参数外键")
    @TableField("lm_test_parameter_fk")
    private Long lmTestParameterFk;

    @ApiModelProperty(value = "数据类型（Z|字符型，S|数值型）")
    private String sjlx;

    @ApiModelProperty(value = "上限值")
    private String sxz;

    @ApiModelProperty(value = "下限值")
    private String xxz;

    @ApiModelProperty(value = "标准值")
    private String bzz;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;
    @ApiModelProperty(value = "单位名称")
    @TableField("dwmc")
    private String dwmc;
    @ApiModelProperty(value = "单位编码")
    @TableField("dwid")
    private String dwid;
    @ApiModelProperty(value = "测试条件")
    @TableField("cstj")
    private String cstj;
    @ApiModelProperty(value = "技术要求")
    @TableField("jsyq")
    private String jsyq;
    @ApiModelProperty(value = "序号")
    @TableField("xh")
    private Long xh;
    @Override
    protected Serializable pkVal() {
        return this.lmParameteroid;
    }

}
