package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 实验室(LM02)-送试单
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "LmTds对象", description = "实验室(LM02)-送试单")
@TableName("lm_tds")
public class UfcLmTds extends Model<UfcLmTds> {

    private static final long serialVersionUID = 1L;

    @TableId("lm_tdsoid")
    @ApiModelProperty(value = "送试单主键")
    private Long lmTdsoid;

    @ApiModelProperty(value = "送试单号")
    private String ssdh;

    @ApiModelProperty(value = "试验分类外键（试验分类选择）")
    private Long syflFk;

    @ApiModelProperty(value = "试验分类名称（试验分类选择）")
    private String syflmc;

    @ApiModelProperty(value = "试验分类编码（试验分类选择）")
    private String syflbm;

    @ApiModelProperty(value = "物料外键")
    private Long wlFk;

    @ApiModelProperty(value = "物料编码（物料表选择）")
    private String wlbm;

    @ApiModelProperty(value = "物料名称")
    private String wlmc;

    @ApiModelProperty(value = "物料规格")
    private String wlgg;

    @ApiModelProperty(value = "物料图号")
    private String wlth;
    @ApiModelProperty(value = "物料材质")
    private String wlcz;
    @ApiModelProperty(value = "物料计量单位")
    private String jldw;

    @ApiModelProperty(value = "试验标准主键（根据物料+试验分类自动匹配）")
    @TableField(value = "sybz_fk", updateStrategy = FieldStrategy.IGNORED)
    private Long sybzFk;

    @ApiModelProperty(value = "试验标准名称")
    private String sybzmc;

    @ApiModelProperty(value = "试验标准编码")
    private String sybzbm;

    @ApiModelProperty(value = "送试部门")
    private Long ssbmFk;

    @ApiModelProperty(value = "送试名称")
    private String ssbmmc;

    @ApiModelProperty(value = "送试编码")
    private String ssbmbm;

    @ApiModelProperty(value = "送试人外键")
    private Long ssrFk;

    @ApiModelProperty(value = "送试人名称")
    private String ssrmc;

    @ApiModelProperty(value = "送试时间")
    private LocalDateTime sssj;

    @ApiModelProperty(value = "送试数量")
    private Integer sssl;

    @ApiModelProperty(value = "试验员外键")
    private Long syyFk;

    @ApiModelProperty(value = "试验员工号")
    private String syygh;

    @ApiModelProperty(value = "试验员名称")
    private String syymc;

    @ApiModelProperty(value = "生成方式（Z|直接维护 P|工艺流程卡）")
    private String scfs;

    @ApiModelProperty(value = "复核结论（Y|合格 N|不合格）")
    private String fhjl;

    @ApiModelProperty(value = "总合格率（%）")
    private BigDecimal zhgl;

    @ApiModelProperty(value = "复核意见")
    private String fhyj;

    @ApiModelProperty(value = "复核人外键")
    private Long fhrFk;

    @ApiModelProperty(value = "复核人名称")
    private String fhrmc;

    @ApiModelProperty(value = "复核人时间")
    private LocalDateTime fhsj;

    @ApiModelProperty(value = "状态（I|初始 F|已提交）")
    private String zt;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;

    //20211101新增字段
    @ApiModelProperty(value = "送试单位名称")
    private String ssdwmc;
    @ApiModelProperty(value = "送试单位编码")
    private String ssdwbm;
    @ApiModelProperty(value = "产品等级名称")
    private String cpdjmc;
    @ApiModelProperty(value = "产品等级编码")
    private String cpdjbm;
    @ApiModelProperty(value = "产品等级名称")
    private String syzbmc;
    @ApiModelProperty(value = "产品等级编码")
    private String syzbbm;
    @ApiModelProperty(value = "合同号")
    private String hth;
    @ApiModelProperty(value = "要求完成时间")
    private LocalDateTime yqwcsj;
    @ApiModelProperty(value = "计划完成时间")
    @TableField("jhwcsj")
    private LocalDateTime jhwcsj;

    @TableField("xwl")
    @ApiModelProperty(value = "新物料")
    private Boolean xwl;

    @TableField("jszrr_fk")
    @ApiModelProperty(value = "技术责任人外键")
    private Long jszrrfk;
    @TableField("jszrrmc")
    @ApiModelProperty(value = "技术责任人名称")
    private String jszrrmc;

    @ApiModelProperty(value = "业务分类id")
    @TableField("ufc_ywfl_fk")
    private Long ufcYwflFk;

    @ApiModelProperty(value = "测试样品描述")
    private String csypms;

    @ApiModelProperty(value = "检测结果")
    @TableField("jcjg")
    private String jcjg;

    @ApiModelProperty(value = "批次数量/送试数量")
    private String pcsl;

    @ApiModelProperty(value = "总体要求")
    private String ztyq;

    @Override
    protected Serializable pkVal() {
        return this.lmTdsoid;
    }

}
