package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 送试单转销售订单表
 * </p>
 *
 * @author
 * @since 2021-11-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTdsSo对象", description="送试单转销售订单表")
public class UfcLmTdsSo extends Model<UfcLmTdsSo> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "送试单转销售订单表")
    @TableId("lm_tds_so_oid")
    private Long lmTdsSoOid;

    @ApiModelProperty(value = "送试单主键")
    private Long lmTdsFk;

    @ApiModelProperty(value = "送试单号")
    private String ssdh;

    @ApiModelProperty(value = "客户名称")
    private String khmc;

    @ApiModelProperty(value = "客户编码")
    private String khbm;

    @ApiModelProperty(value = "客户合同号")
    private String khhth;

    @ApiModelProperty(value = "车间编码")
    private String cjbm;

    @ApiModelProperty(value = "车间名称")
    private String cjmc;

    @ApiModelProperty(value = "合同号")
    private String hth;

    @ApiModelProperty(value = "日期")
    private LocalDate rq;

    @ApiModelProperty(value = "交货时间")
    private LocalDateTime jhsj;

    @ApiModelProperty(value = "产品名称/物料名称")
    private String wlmc;

    @ApiModelProperty(value = "规格/物料规格")
    private String wlgg;

    @ApiModelProperty(value = "数量/送试数量")
    private Integer sl;

    @ApiModelProperty(value = "销售类型")
    private String xslx;

    @ApiModelProperty(value = "检验类别")
    private String jylb;

    @ApiModelProperty(value = "销售部门")
    private String xsbm;
    @ApiModelProperty(value = "销售组织")
    private String xszz;

    @ApiModelProperty(value = "销售员")
    private String xsy;

    @ApiModelProperty(value = "销售金额")
    private BigDecimal xsje;


    @Override
    protected Serializable pkVal() {
        return this.lmTdsSoOid;
    }

}
