package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.io.Serializable;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 实验室(LM02)-送试单来源
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTdssl对象", description="实验室(LM02)-送试单来源")
@TableName("lm_tdssl")
public class UfcLmTdssl extends Model<UfcLmTdssl> {

    private static final long serialVersionUID = 1L;

    @TableId("lm_tdssloid")
    @ApiModelProperty(value = " 送试单来源主键")
    private Long lmTdssloid;

    @ApiModelProperty(value = "送试单外键（关联送试单）")
    private Long lmTdsFk;

    @ApiModelProperty(value = "送试单名称")
    private String ssdmc;

    @ApiModelProperty(value = "送试单号")
    private String ssdh;

    @ApiModelProperty(value = "流程卡号")
    private String lckh;

    @ApiModelProperty(value = "物料外键")
    private Long wlFk;

    @ApiModelProperty(value = "物料编码（从物料表选择）")
    private String wlbm;

    @ApiModelProperty(value = "物料名称")
    private String wlmc;

    @ApiModelProperty(value = "物料规格")
    private String wlgg;

    @ApiModelProperty(value = "物料图号")
    private String wlth;
    @ApiModelProperty(value = "物料材质")
    private String wlcz;
    @ApiModelProperty(value = "物料计量单位")
    private String jldw;

    @ApiModelProperty(value = "单据类型（Z|直接维护 P|工艺流程卡）")
    private String djlx;

    @ApiModelProperty(value = "源单号")
    private String ydh;

    @ApiModelProperty(value = "批号")
    private String ph;

    @ApiModelProperty(value = "送试数量")
    private Integer sssl;

    @ApiModelProperty(value = "状态（I|初始 F|已提交）")
    private String zt;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;

    @ApiModelProperty(value = "客户合同号")
    @TableField("khhth")
    private String khhth;


    @Override
    protected Serializable pkVal() {
        return this.lmTdssloid;
    }

}
