package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * <p>
 * 实验室-试验分类
 * </p>
 *
 * @author
 * @since 2021-08-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTestCategory对象", description="实验室-试验分类")
@TableName("lm_test_category")
public class UfcLmTestCategory extends Model<UfcLmTestCategory> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "试验分类主键")
    @TableId(type = IdType.INPUT)
    private Long lmTestCategoryoid;

    @ApiModelProperty(value = "试验分类编码", required = true,dataType = "string")
    @NotBlank(message = "试验分类编码不得为空")
    @Size(max = 8,message = "试验分类编码最大长度为8个字节")
    private String syflbm;

    @ApiModelProperty(value = "试验分类名称", required = true,dataType = "string")
    @NotBlank(message = "试验分类名称不得为空")
    @Size(max = 40,message = "试验分类名称最大长度为40个字节")
    private String syflmc;

    @ApiModelProperty(value = "是否检测（默认打勾）",example = "true",dataType = "bool")
    private Boolean sfjc;

    @ApiModelProperty(value = "备注",dataType = "string")
    @Size(max = 250,message = "备注最大长度为250个字节")
    private String bz;

    @ApiModelProperty(example = "维护时间", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人外键")
    @Size(message = "维护人外键")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志",example = "true",dataType = "bool")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    @Size(message = "创建人外键")
    private Long sysCreatedBy;


    @Override
    protected Serializable pkVal() {
        return this.lmTestCategoryoid;
    }

}
