package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * <p>
 * 实验室-试验项目维护
 * </p>
 *
 * @author
 * @since 2021-08-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTestItems对象", description="实验室-试验项目维护")
@TableName(value = "lm_test_items")
public class UfcLmTestItems extends Model<UfcLmTestItems> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "试验项目维护主键")
    @TableId(type = IdType.INPUT)
    private Long lmTestItemsoid;

    @ApiModelProperty(value = "试验项目编码", required = true,dataType = "string")
    @NotBlank(message = "试验项目编码不得为空")
    @Size(max = 12,message = "试验项目编码最大长度为12个字节")
    private String syxmbm;

    @ApiModelProperty(value = "试验项目名称", required = true,dataType = "string")
    @NotBlank(message = "试验项目名称不得为空")
    @Size(max = 40,message = "试验项目名称最大长度为40个字节")
    private String syxmmc;

    @ApiModelProperty(value = "分组", required = true,dataType = "string")
    @Size(max = 40,message = "分组最大长度为40个字节")
    private String fz;

    @ApiModelProperty(value = "抽样方式（全抽,样抽）", required = true,dataType = "string")
    @Size(max = 255,message = "抽样方式（全抽,样抽）最大长度为255个字节")
    private String cyfs;

    @ApiModelProperty(value = "抽样标准", required = true,dataType = "string")
    @Size(max = 255,message = "抽样标准最大长度为255个字节")
    private String cybz;

    @ApiModelProperty(value = "备注", required = true,dataType = "string")
    @Size(max = 255,message = "备注最大长度为255个字节")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志", required = true,dataType = "bool")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;

    @ApiModelProperty(value = "试验分类外键")
    @Size(message = "试验分类外键")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private Long lmTcfk;


    @Override
    protected Serializable pkVal() {
        return this.lmTestItemsoid;
    }

}
