package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 实验室-检测参数维护
 * </p>
 *
 * @author gushang
 * @since 2021-08-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTestParameter对象", description="实验室-检测参数维护")
@JsonIgnoreProperties(ignoreUnknown = true)
@TableName("lm_test_parameter")
public class UfcLmTestParameter extends Model<UfcLmTestParameter> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "检测参数维护主键")
    @TableId
    private Long lmTestParameteroid;

    @ApiModelProperty(value = "检测参数编码")
    private String jccsbm;

    @ApiModelProperty(value = "检测参数名称")
    private String jccsmc;

    @ApiModelProperty(value = "数据类型（Z | 字符型；S | 数值型）")
    private String sjlx;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;

    @ApiModelProperty(value = "检测参数分类外键")
    private Long jccsflfk;

    @Override
    protected Serializable pkVal() {
        return this.lmTestParameteroid;
    }

}
