package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 实验室-试验标准明细
 * </p>
 *
 * @author
 * @since 2021-08-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTestStandardDetail对象", description="实验室-试验标准明细")
@TableName("lm_test_standard_detail")
public class UfcLmTestStandardDetail extends Model<UfcLmTestStandardDetail> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "试验标准明细主键")
    @TableId
    private Long lmTestStandardDetailoid;

    @ApiModelProperty(value = "试验标准外键（关联主表）")
    @TableField("lm_test_standard_fk")
    private Long lmTestStandardFk;

    @ApiModelProperty(value = "试验标准编码(关联主表)")
    private String lmTestStandardBm;

    @ApiModelProperty(value = "序号")
    private Long xh;

    @ApiModelProperty(value = "试验项目编码（选取）")
    private String lmTestItemsBm;

    @ApiModelProperty(value = "试验项目外键（选取）")
    private String lmTestItemsFk;

    @ApiModelProperty(value = "组别")
    private String zb;

    @ApiModelProperty(value = "分组")
    private String fz;

    @ApiModelProperty(value = "技术要求")
    private String jsyq;

    @ApiModelProperty(value = "方法标准外键（选取）")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private Long lmTestMethodStandardFk;

    @ApiModelProperty(value = "方法标准名称（选取）")
    private String lmTestMethodStandardMc;

    @ApiModelProperty(value = "方法外键（选取）")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private Long lmTestMethodFk;

    @ApiModelProperty(value = "方法名称（选取）")
    private String lmTestMethodMc;

    @ApiModelProperty(value = "试验条件外键（选取）")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private Long lmTestConditionFk;

    @ApiModelProperty(value = "试验条件名称（选取）")
    private String lmTestConditionMc;

    @ApiModelProperty(value = "抽样数")
    private Long cys;

    @ApiModelProperty(value = "接收数")
    private Long jss;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;

    @ApiModelProperty(value = "试验时间")
    private Long sysj;

    @ApiModelProperty(value = "恢复时间")
    @TableField("hfsj")
    private Long hfsj;
    @ApiModelProperty(value = "样品编码")
    @TableField("ypbh")
    private String ypbh;
    @ApiModelProperty(value = "单位总量")
    @TableField("dwzl")
    private String dwzl;

    @ApiModelProperty(value = "前置条件")
    private String qztj;
    @ApiModelProperty(value = "抽样方式 A|固定抽样 B|百分比抽样")
    private String cyfs;
    @ApiModelProperty(value = "抽样百分比")
    private Float cybfb;
    @ApiModelProperty(value = "合格率")
    private Float hgl;

    @ApiModelProperty(value = "预留字段1")
    @TableField("ylzd1")
    private String ylzd1;
    @ApiModelProperty(value = "预留字段2")
    @TableField("ylzd2")
    private String ylzd2;
    @Override
    protected Serializable pkVal() {
        return this.lmTestStandardDetailoid;
    }

}
