package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 实验室(LM02)-试验任务
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTt对象", description="实验室(LM02)-试验任务")
@TableName("lm_tt")
public class UfcLmTt extends Model<UfcLmTt> {

    private static final long serialVersionUID = 1L;

    @TableId("lm_ttoid")
    @ApiModelProperty(value = "试验任务主键")
    private Long lmTtoid;

    @ApiModelProperty(value = "送试单外键（关联送试单）")
    private Long lmTdsFk;

    @ApiModelProperty(value = "送试单名称")
    private String ssdmc;

    @ApiModelProperty(value = "送试单号")
    private String ssdh;

    @ApiModelProperty(value = "任务单号（送试单号+“-”+序号）")
    private String rwdh;

    @ApiModelProperty(value = "试验项目编码（根据试验标准自动生成）")
    private String syxmbm;

    @ApiModelProperty(value = "试验项目名称")
    private String syxmmc;

    @ApiModelProperty(value = "组别")
    private String zb;
    @ApiModelProperty(value = "分组")
    private String fz;

    @ApiModelProperty(value = "技术要求")
    private String jsyq;

    @ApiModelProperty(value = "方法标准编码")
    private String ffbzbm;

    @ApiModelProperty(value = "方法标准外键")
    @TableField(value = "ffbz_fk" ,updateStrategy= FieldStrategy.IGNORED)

    private Long ffbzFk;

    @ApiModelProperty(value = "方法标准名称")
    private String ffbzmc;

    @ApiModelProperty(value = "方法外键")
    @TableField(value = "ff_fk",updateStrategy= FieldStrategy.IGNORED)
    private Long ffFk;
    @ApiModelProperty(value = "方法编码")
    private String ffbm;

    @ApiModelProperty(value = "方法名称")
    private String ffmc;

    @ApiModelProperty(value = "试验条件外键")
    @TableField(value = "sytj_fk",updateStrategy= FieldStrategy.IGNORED)
    private Long sytjFk;
    @ApiModelProperty(value = "试验条件编码")
    private String sytjbm;

    @ApiModelProperty(value = "试验条件名称")
    private String sytjmc;

    @ApiModelProperty(value = "抽样数")
    private Long cys;

    @ApiModelProperty(value = "接收数")
    private Long jss;

    @ApiModelProperty(value = "样品数（默认为标准中抽样数，可修改）")
    private Long yps;

    @ApiModelProperty(value = "失效数")
    private Long sxs;

    @ApiModelProperty(value = "合格数")
    private Long hgs;

    @ApiModelProperty(value = "不合格数")
    private Long bhgs;

    @ApiModelProperty(value = "试验员工号")
    private String syygh;

    @ApiModelProperty(value = "试验员名称")
    private String syymc;

    @ApiModelProperty(value = "试验员外键")
    private Long syyFk;

    @ApiModelProperty(value = "计划开始时间")
    private LocalDateTime jhkssj;

    @ApiModelProperty(value = "计划结束时间")
    private LocalDateTime jhjssj;

    @ApiModelProperty(value = "实际开始时间")
    private LocalDateTime sjkssj;

    @ApiModelProperty(value = "实际结束时间")
    private LocalDateTime sjjssj;

    @ApiModelProperty(value = "复核结果（Y|合格 N|不合格）")
    private String fhjg;

    @ApiModelProperty(value = "状态（I|初始 D|待分配 B|试验前 T|试验中 A|试验后 E|审核）")
    private String zt;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;

    @ApiModelProperty(value = "试验标准明细外键")
    @TableField("sybzmxfk")
    private Long sybzmxfk;
    @ApiModelProperty(value = "序号")
    @TableField("xh")
    private Long xh;
    @ApiModelProperty(value = "试验进度外键")
    @TableField("syjdfk")
    private Long syjdfk;
    @ApiModelProperty(value = "试验进度编码")
    @TableField("syjdbm")
    private String syjdbm;
    @ApiModelProperty(value = "试验进度名称")
    @TableField("syjdmc")
    private String syjdmc;
    @ApiModelProperty(value = "试验时间")
    @TableField("sysj")
    private Long sysj;
    @ApiModelProperty(value = "延期时间")
    @TableField("yqsj")
    private Long yqsj;
    @ApiModelProperty(value = "位置")
    @TableField("wz")
    private String wz;
    @ApiModelProperty(value = "前置条件")
    private String qztj;
    @ApiModelProperty(value = "抽样方式 A|固定抽样 B|百分比抽样")
    private String cyfs;
    @ApiModelProperty(value = "抽样百分比")
    private Float cybfb;
    @ApiModelProperty(value = "合格率")
    private Float hgl;

    @ApiModelProperty(value = "恢复时间")
    @TableField("hfsj")
    private Long hfsj;
    @ApiModelProperty(value = "样品编码")
    @TableField("ypbh")
    private String ypbh;
    @ApiModelProperty(value = "单位总量")
    @TableField("dwzl")
    private String dwzl;

    @ApiModelProperty(value = "检测结果")
    private String jcjg;

    @ApiModelProperty(value = "是否登记设备")
    private String djsb;
    
    @Override
    protected Serializable pkVal() {
        return this.lmTtoid;
    }

}
