package com.jln.ufc.web.action.ufc.lm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 实验室(LM02)-试验任务检测参数
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="LmTttp对象", description="实验室(LM02)-试验任务检测参数")
@TableName("lm_tttp")
public class UfcLmTttp extends Model<UfcLmTttp> {

    private static final long serialVersionUID = 1L;

    @TableId("lm_tttpoid")
    @ApiModelProperty(value = "试验任务检测参数主键")
    private Long lmTttpoid;

    @ApiModelProperty(value = "试验任务外键")
    private Long lmTtFk;

    @ApiModelProperty(value = "送试单外键")
    private Long lmTdsFk;

    @ApiModelProperty(value = "送试单单号")
    private String ssdh;

    @ApiModelProperty(value = "试验任务编码")
    private String syrwbm;

    @ApiModelProperty(value = "试验任务名称")
    private String syrwmc;

    @ApiModelProperty(value = "序号")
    private Integer xh;

    @ApiModelProperty(value = "参数编码")
    private String csbm;

    @ApiModelProperty(value = "参数名称")
    private String csmc;

    @ApiModelProperty(value = "数据类型（Z|字符型，S|数值型）")
    private String sjlx;

    @ApiModelProperty(value = "上限值")
    private String sxz;

    @ApiModelProperty(value = "下限值")
    private String xxz;

    @ApiModelProperty(value = "标准值")
    private String bzz;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "删除标志")
    private Boolean del;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "创建人")
    private Long sysCreatedBy;
    @ApiModelProperty(value = "单位名称")
    @TableField("dwmc")
    private String dwmc;
    @ApiModelProperty(value = "单位编码")
    @TableField("dwid")
    private String dwid;
    @ApiModelProperty(value = "测试条件")
    @TableField("cstj")
    private String cstj;
    @ApiModelProperty(value = "技术要求")
    @TableField("jsyq")
    private String jsyq;

    @Override
    protected Serializable pkVal() {
        return this.lmTttpoid;
    }

}
