package com.jln.ufc.web.action.ufc.lm.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTds;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcPsWbDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTdsVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * <p>
 * 实验室(LM02)-送试单 Mapper 接口
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Repository
public interface UfcLmTdsMapper extends BaseMapper<UfcLmTds> {

    Page<UfcLmTdsVo> selectPageTdsList(@Param("page") Page<UfcLmTdsVo> page, @Param("entity") UfcLmTdsDto data,
                                    @Param("itcIds") List<Long> itcIds);

    /**
     * 根据可以查看的业务分类查询试验标准
     * @param list
     * @return
     */
    List<Long> selectStandardoids(List<Long> list);

    /**
     * 根据可以查看的业务分类查询试验分类
     * @param list
     * @return
     */
    List<Long> selectItcIds(List<Long> list);


    UfcPsWbDto selectUfcPsWbDto(Long id);


    String selectDwmc(String khid);

    UfcLmTdsVo selectPageTdsOne(@Param("oid") String tdsOid);

    String selectMxHth(Long psWbFk);
}
