package com.jln.ufc.web.action.ufc.lm.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UfcLmTdsSaveDto {
    @ApiModelProperty(value = "送试单主键")
    private Long lmTdsoid;

    @ApiModelProperty(value = "送试单号")
    private String ssdh;

    @ApiModelProperty(value = "试验分类外键（试验分类选择）")
    private Long syflFk;

    @ApiModelProperty(value = "试验分类名称（试验分类选择）")
    private String syflmc;

    @ApiModelProperty(value = "试验分类编码（试验分类选择）")
    private String syflbm;

    @ApiModelProperty(value = "物料外键")
    private Long wlFk;

    @ApiModelProperty(value = "物料编码（物料表选择）")
    private String wlbm;

    @ApiModelProperty(value = "物料名称")
    private String wlmc;

    @ApiModelProperty(value = "物料规格")
    private String wlgg;
    @ApiModelProperty(value = "物料图号")
    private String wlth;
    @ApiModelProperty(value = "物料材质")
    private String wlcz;
    @ApiModelProperty(value = "物料计量单位")
    private String jldw;


    @ApiModelProperty(value = "试验标准主键（根据物料+试验分类自动匹配）")
    private Long sybzFk;

    @ApiModelProperty(value = "试验标准名称")
    private String sybzmc;

    @ApiModelProperty(value = "试验标准编码")
    private String sybzbm;

    @ApiModelProperty(value = "送试部门")
    private Long ssbmFk;

    @ApiModelProperty(value = "送试部门名称")
    private String ssbmmc;

    @ApiModelProperty(value = "送试部门编码")
    private String ssbmbm;

    @ApiModelProperty(value = "送试人外键")
    private Long ssrFk;

    @ApiModelProperty(value = "送试人名称")
    private String ssrmc;

    @ApiModelProperty(value = "送试时间",example = "2021-09-03 10:00:00")
    private LocalDateTime sssj;

    @ApiModelProperty(value = "送试数量")
    private Integer sssl;

    @ApiModelProperty(value = "生成方式（Z|直接维护 P|工艺流程卡）")
    private String scfs;

    @ApiModelProperty(value = "状态（I|初始 F|已提交）")
    private String zt;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "送试单位名称")
    private String ssdwmc;
    @ApiModelProperty(value = "送试单位编码")
    private String ssdwbm;
    @ApiModelProperty(value = "产品等级名称")
    private String cpdjmc;
    @ApiModelProperty(value = "产品等级编码")
    private String cpdjbm;
    @ApiModelProperty(value = "产品等级名称")
    private String syzbmc;
    @ApiModelProperty(value = "产品等级编码")
    private String syzbbm;
    @ApiModelProperty(value = "合同号")
    private String hth;
    @ApiModelProperty(value = "要求完成时间",example = "2021-11-01 11:00:00")
    private LocalDateTime yqwcsj;
    @ApiModelProperty(value = "计划完成时间",example = "2021-11-01 11:00:00")
    private LocalDateTime jhwcsj;
    @ApiModelProperty(value = "新物料")
    private Boolean xwl;
    @ApiModelProperty(value = "技术责任人外键")
    private Long jszrrfk;
    @ApiModelProperty(value = "技术责任人名称")
    private String jszrrmc;
    @ApiModelProperty(value = "送试单来源对象集合")
    List<UfcLmTdsslSaveDto> lmTdsslSaveDtoList = new ArrayList<>();

    @ApiModelProperty(value = "试验任务对象集合")
    List<UfcLmTtSaveDto> lmTtSaveDtoList = new ArrayList<>();

    @ApiModelProperty(value = "批次数量/送试数量")
    private String pcsl;

    @ApiModelProperty(value = "总体要求")
    private String ztyq;

    @ApiModelProperty(value = "业务分类id")
    private Long ywflFk;

    @ApiModelProperty(value = "工厂id")
    @JsonProperty(value = "bFactoryFk")
    private Long bFactoryFk;

    @ApiModelProperty(value = "测试样品描述")
    private String csypms;

    @ApiModelProperty(value = "检测结果")
    private String jcjg;

    @ApiModelProperty(value = "工单主键")
    private Long psWbFk;
}
