package com.jln.ufc.web.action.ufc.lm.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/1/21 13:50
 * Version:1.0
 **/
@ApiModel(value = "实验室-试验分类数据接收层", discriminator = "实验室-试验分类数据接收层")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UfcLmTestCategoryDto {

    @ApiModelProperty(value = "试验分类主键",example = "")
    private Long lmTestCategoryoid;

    @ApiModelProperty(value = "试验分类编码", required = true,dataType = "string")
    @NotBlank(message = "试验分类编码不得为空")
    @Size(max = 8,message = "试验分类编码最大长度为8个字节")
    private String syflbm;

    @ApiModelProperty(value = "试验分类名称", required = true,dataType = "string")
    @NotBlank(message = "试验分类名称不得为空")
    @Size(max = 40,message = "试验分类名称最大长度为40个字节")
    private String syflmc;

    @ApiModelProperty(value = "是否检测（默认打勾）",example = "true",dataType = "bool")
    private Boolean sfjc;

    @ApiModelProperty(value = "备注",dataType = "string")
    @Size(max = 250,message = "备注最大长度为250个字节")
    private String bz;

    @ApiModelProperty(value = "删除标志",example = "true",dataType = "bool")
    private Boolean del;
    
    @ApiModelProperty(value = "业务分类外键")
    private Long ufcLmBusinessTypeFk;
}
