package com.jln.ufc.web.action.ufc.lm.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * <p>
 * 实验室-试验项目维护
 * </p>
 *
 * @author
 * @since 2021-08-08
 */
@Data
@ApiModel(value = "实验室-试验项目维护数据接收层",discriminator = "实验室-试验项目维护数据接收层")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcLmTestItemsQueryDto extends LaboratoryPermissions {


    @ApiModelProperty(value = "试验项目编码", required = true,dataType = "string")
    @NotBlank(message = "试验项目编码不得为空")
    @Size(max = 12,message = "试验项目编码最大长度为12个字节")
    private String syxmbm;

    @ApiModelProperty(value = "试验项目名称", required = true,dataType = "string")
    @NotBlank(message = "试验项目名称不得为空")
    @Size(max = 40,message = "试验项目名称最大长度为40个字节")
    private String syxmmc;


    @ApiModelProperty(value = "备注", required = true,dataType = "string")
    @Size(max = 255,message = "备注最大长度为255个字节")
    private String bz;

    @ApiModelProperty(value = "试验分类外键",example = "")
    private Long syflFk;

    @ApiModelProperty(value = "业务分类")
    private String businessClass;

}
