package com.jln.ufc.web.action.ufc.lm.pojo.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDate;

@Data
@ApiModel("委托单分页查询条件")
public class UfcOrdersQueryDTO {

    @ApiModelProperty(value = "合同号")
    private String ufcLmOrdersContract;

    @ApiModelProperty(value = "客户名称")
    private String mc;

    @ApiModelProperty(value = "销售部门")
    private String ufcLmOrdersDepartment;

    @ApiModelProperty(value = "送试人")
    private Long ufcLmOrdersSendPeopleFk;

    @ApiModelProperty(value = "日期-起")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate ufcLmOrdersDateStart;

    @ApiModelProperty(value = "日期-止")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate ufcLmOrdersDateEnd;

    @ApiModelProperty(value = "检验类别")
    private String ufcLmOrdersInspectionType;

    @ApiModelProperty(value = "销售类型")
    private String ufcLmOrdersSalesType;

    @ApiModelProperty(value = "状态(I:初始 F:确认)")
    private String ufcLmOrdersState;

}
