package com.jln.ufc.web.action.ufc.lm.pojo.vo;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * <p>
 * 实验室-试验分类
 * </p>
 *
 * @author 
 * @since 2021-08-08
 */
@Data
@ApiModel(value = "实验室-试验分类数据显示层",discriminator = "实验室-试验分类数据显示层")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcLmTestCategoryVo {

    @ApiModelProperty(value = "试验分类主键")
    private String lmTestCategoryoid;

    @ApiModelProperty(value = "试验分类编码", required = true,dataType = "string")
    @NotBlank(message = "试验分类编码不得为空")
    @Size(max = 8,message = "试验分类编码最大长度为8个字节")
    private String syflbm;

    @ApiModelProperty(value = "试验分类名称", required = true,dataType = "string")
    @NotBlank(message = "试验分类名称不得为空")
    @Size(max = 40,message = "试验分类名称最大长度为40个字节")
    private String syflmc;

    @ApiModelProperty(value = "是否检测（默认打勾）",example = "true",dataType = "bool")
    private Boolean sfjc;

    @ApiModelProperty(value = "备注",dataType = "string")
    @Size(max = 250,message = "备注最大长度为250个字节")
    private String bz;


    @ApiModelProperty(example = "维护时间", required = true,dataType = "date")
    private String sysLastUpd;

    @ApiModelProperty(value = "维护人外键")
    @Size(message = "维护人外键")
    private String sysLastUpdBy;
    
    @ApiModelProperty(value = "业务分类名称")
    private String ufcLmBusinessName;
    
    @ApiModelProperty(value = "业务分类id")
    private Long ufcLmBusinessTypeOid;
    



}
