package com.jln.ufc.web.action.ufc.lm.pojo.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;

/**
 * <p>
 * 实验室-试验项目维护
 * </p>
 *
 * @author 
 * @since 2021-08-08
 */
@Data
@ApiModel(value = "实验室-试验项目维护数据显示层",discriminator = "实验室-试验项目维护数据显示层")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcLmTestItemsVo {

    @ApiModelProperty(value = "试验项目维护主键")
    private String lmTestItemsoid;

    @ApiModelProperty(value = "试验项目编码", required = true,dataType = "string")
    @NotBlank(message = "试验项目编码不得为空")
    @Size(max = 12,message = "试验项目编码最大长度为12个字节")
    private String syxmbm;

    @ApiModelProperty(value = "试验项目名称", required = true,dataType = "string")
    @NotBlank(message = "试验项目名称不得为空")
    @Size(max = 40,message = "试验项目名称最大长度为40个字节")
    private String syxmmc;

    @ApiModelProperty(value = "分组", required = true,dataType = "string")
    @Size(max = 40,message = "分组最大长度为40个字节")
    private String fz;

    @ApiModelProperty(value = "抽样方式（全抽,样抽）", required = true,dataType = "string")
    @Size(max = 255,message = "抽样方式（全抽,样抽）最大长度为255个字节")
    private String cyfs;

    @ApiModelProperty(value = "抽样标准", required = true,dataType = "string")
    @Size(max = 255,message = "抽样标准最大长度为255个字节")
    private String cybz;

    @ApiModelProperty(value = "备注", required = true,dataType = "string")
    @Size(max = 255,message = "备注最大长度为255个字节")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private String sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private String sysLastUpdBy;

    @ApiModelProperty(value = "试验分类外键")
    @Size(message = "试验分类外键")
    private String lmTcfk;

    @ApiModelProperty(value = "试验分类名称")
    @Size(message = "试验分类名称")
    private String lmTcMc;
    @ApiModelProperty(value = "试验分类名称")
    @Size(message = "试验分类编码")
    private String lmTcCode;

    @ApiModelProperty(value = "业务分类")
    private String businessClass;

    @ApiModelProperty(value = "业务分类名称")
    private String ufcLmBusinessName;

    @ApiModelProperty(value = "业务分类id")
    private Long ufcLmBusinessTypeOid;

}
