package com.jln.ufc.web.action.ufc.lm.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmBusinessType;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmBusinessTypeVO;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author 
 * @since 2022-01-10
 */
public interface UfcLmBusinessTypeService extends IService<UfcLmBusinessType> {


    /**
     * 分页获取业务分类
     * @param pageParameter
     * @return
     */
    Result getPage(PageParameter<UfcLmBusinessTypeVO> pageParameter);

    /**
     * 获取全部业务分类
     * @return
     */
    Result getList(LaboratoryPermissions laboratoryPermissions);

    /**
     * 根据id获取详情
     * @param id
     * @return
     */
    Result get(Long id);

    /**
     * 保存
     * @param ufcLmBusinessTypeVO
     * @param user
     * @return
     */
    Result savePojo(UfcLmBusinessTypeVO ufcLmBusinessTypeVO, User user);

    /**
     * 批量删除
     * @param ids
     * @param user
     * @return
     */
    Result del(List<Long> ids, User user);
    
    
    

}
