package com.jln.ufc.web.action.ufc.lm.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmOrdersDetail;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcOrdersDetailQueryDTO;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * <p>
 * 委托单明细 服务类
 * </p>
 *
 * @author
 * @since 2022-01-05
 */
public interface UfcLmOrdersDetailService extends IService<UfcLmOrdersDetail> {
    /**
     * 委托单明细分页查询
     *
     * @param queryDTO
     * @return
     */
    Result<Page<UfcLmOrdersDetail>> getDetailPage(PageParameter<UfcOrdersDetailQueryDTO> queryDTO);

    /**
     * 委托单明细保存
     *
     * @param detail
     * @return
     */
    Result<Long> saveDetail(UfcLmOrdersDetail detail);

    /**
     * 委托单明细删除
     *
     * @param oids
     * @return
     */
    Result<String> delDetail(List<Long> oids);

    /**
     * 委托单明细导入
     *
     * @param file
     * @param user
     * @return
     */
    Result<String> importDetail(MultipartFile file, Long ufcLmOrdersFk, User user);

    /**
     * 委托单明细查询
     * @param queryDTO
     * @return
     */
    Result<List<UfcLmOrdersDetail>> getDetail(UfcOrdersDetailQueryDTO queryDTO);

    /**
     * 获取送试单号
     * @return
     */
    Result<String> getCode();
}
