package com.jln.ufc.web.action.ufc.lm.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmOrders;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcOrdersQueryDTO;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcOrdersVO;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * <p>
 * 委托单 服务类
 * </p>
 *
 * @author
 * @since 2022-01-06
 */
public interface UfcLmOrdersService extends IService<UfcLmOrders> {

    /**
     * 委托单分页查询
     *
     * @param queryDTO
     * @return
     */
    Result<Page<UfcOrdersVO>> getUfcLmOrdersPage(PageParameter<UfcOrdersQueryDTO> queryDTO);

    /**
     * 委托单详情
     *
     * @param oid
     * @return
     */
    Result<UfcOrdersVO> getUfcLmOrders(Long oid);

    /**
     * 委托单保存
     *
     * @param detail
     * @return
     */
    Result<Long> saveUfcLmOrders(UfcLmOrders detail);

    /**
     * 委托单删除
     *
     * @param oids
     * @return
     */
    Result<String> delUfcLmOrders(List<Long> oids);

    /**
     * 委托单提交
     *
     * @param oids
     * @return
     */
    Result<String> submitUfcLmOrders(List<Long> oids, User user);

    /**
     * 委托单导入
     *
     * @param file
     * @param user
     * @return
     */
    Result<String> importInfo(MultipartFile file, User user);

    Result<String> withdraw(List<Long> oids, User user);
}
