package com.jln.ufc.web.action.ufc.lm.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTestStandard;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTestStandardDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTestStandardVo;


/**
 * <p>
 * 实验室-试验标准 服务类
 * </p>
 *
 * @author
 * @since 2021-08-09
 */
public interface UfcLmTestStandardService extends IService<UfcLmTestStandard> {

    /**
     * 保存或修改试验标准数据
     * @param lmTestStandardDto
     * @param user
     * @return
     */
    Result<Long> saveOrUpdate(UfcLmTestStandardDto lmTestStandardDto, User user);

    /**
     * 获取试验标准列表数据
     * @param parameter
     * @return
     */
    Result<PageParameter<UfcLmTestStandardVo>> getList(PageParameter<UfcLmTestStandardDto> parameter);



    /**
     * 获取试验标准编辑数据
     * @param oid
     * @return
     */
    Result<UfcLmTestStandardVo> getByOid(Long oid);

  
}
