package com.jln.ufc.web.action.ufc.lm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmBusinessTypeMiddel;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcLmBusinessTypeMiddelMapper;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmBusinessTypeMiddelService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * <p>
 * 业务类型和业务中间表 服务实现类
 * </p>
 *
 * @author 
 * @since 2022-01-10
 */
@Service
public class UfcLmBusinessTypeMiddelServiceImpl extends ServiceImpl<UfcLmBusinessTypeMiddelMapper, UfcLmBusinessTypeMiddel> implements UfcLmBusinessTypeMiddelService {

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result savePojo(Long ywFk, Long oid) {
        if (EmptyUtil.isEmpty(ywFk) || EmptyUtil.isEmpty(oid)) {
            return new Result().toFailure("检查参数!");
        }
        
        this.baseMapper.delete(new LambdaQueryWrapper<UfcLmBusinessTypeMiddel>()
                .eq(UfcLmBusinessTypeMiddel::getYwFk, ywFk));

        UfcLmBusinessTypeMiddel ufcLmBusinessTypeMiddel = new UfcLmBusinessTypeMiddel();
        ufcLmBusinessTypeMiddel.setUfcLmBusinessTypeMiddelOid(SnowflakeIdUtils.generate());
        ufcLmBusinessTypeMiddel.setYwFk(ywFk);
        ufcLmBusinessTypeMiddel.setUfcLmBusinessTypeFk(oid);
        boolean save = this.save(ufcLmBusinessTypeMiddel);
        if (save) {
            return new Result().toSuccess();
        }
        return new Result().toFailure("保存失败");
    }
}
