package com.jln.ufc.web.action.ufc.lm.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcLmTdsMapper;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmSampleReceiveDto;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcLmSampleReceiveMapper;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmSampleReceiveVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmSampleReceiveService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 实验室(LM02)样品接收 服务实现类
 * </p>
 *
 * @author
 * @since 2021-11-01
 */
@Service
public class UfcLmSampleReceiveServiceImpl implements UfcLmSampleReceiveService {
    @Autowired
    private UfcLmSampleReceiveMapper lmSampleReceiveMapper;
    @Autowired
    private UfcLmTdsMapper lmTdsMapper;

    @Override
    public Result getYpjsPage(PageParameter<UfcLmSampleReceiveDto> pageParameter) {
        List<Long> itcIds = null;
        if (!EmptyUtil.isEmpty(pageParameter.getData()) && !EmptyUtil.isEmpty(pageParameter.getData().getUfcLmBusinessTypeIds())) {
            itcIds = lmTdsMapper.selectItcIds(pageParameter.getData().getUfcLmBusinessTypeIds());
        }
        Page<UfcLmSampleReceiveVo> page = new Page<>(pageParameter.getPageNum(), pageParameter.getPageSize());
        IPage<UfcLmSampleReceiveVo> lmSampleReceiveVoIPage = this.lmSampleReceiveMapper.getYpjsPage(page, pageParameter.getData(), itcIds);
        return new Result().toSuccess(lmSampleReceiveVoIPage);
    }



}
