package com.jln.ufc.web.action.ufc.lm.service.impl;

import com.alibaba.excel.util.CollectionUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.common.utils.StringUtils;
import com.jln.ufc.web.action.entity.LaboratoryPermissions;
import com.jln.ufc.web.action.ufc.bm.entity.UfcJcBMaterial;
import com.jln.ufc.web.action.ufc.bm.service.UfcJcBMaterialService;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmParameter;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTds;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTdssl;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTestStandardDetail;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTt;
import com.jln.ufc.web.action.ufc.lm.entity.UfcLmTttp;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcLmTdsMapper;

import com.jln.ufc.web.action.ufc.lm.mapper.UfcLmTtMapper;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsSaveDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTdsslSaveDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTtSaveDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcPsWbDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcSybzSaveDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTdsVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmParameterService;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTdsService;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTdsslService;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTestStandardDetailService;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTtService;
import com.jln.ufc.web.action.ufc.lm.service.UfcLmTttpService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.util.*;
import java.util.stream.Collectors;


/**
 * <p>
 * 实验室(LM02)-送试单 服务实现类
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Service
@Transactional
public class UfcLmTdsServiceImpl extends ServiceImpl<UfcLmTdsMapper, UfcLmTds> implements UfcLmTdsService {

    @Autowired
    private UfcLmTdsMapper lmTdsMapper;

    @Autowired
    private UfcLmTdsslService lmTdsslService;

    @Autowired
    private UfcLmTtService lmTtService;

    @Autowired
    private UfcLmTtMapper lmTtMapper;

    @Autowired
    private UfcLmTttpService lmTttpService;

    @Autowired
    private UfcLmTestStandardDetailService lmTestStandardDetailService;

    @Autowired
    private UfcLmParameterService lmParameterService;
    
    @Autowired
    private UfcJcBMaterialService ufcJcBMaterialService;


    private UfcSybzSaveDto oldSybzSaveDto;

    public static UfcLmTdsVo LmVO;

    /**
     * 送试单分页查询
     *
     * @param lmtdsDto
     * @return
     */
    @Override
    public Result pageSsList(PageParameter<UfcLmTdsDto> lmtdsDto, LaboratoryPermissions laboratoryPermissions) {
        List<Long> itcIds = null;
        // 查询可以查看的试验标准
        if (!EmptyUtil.isEmpty(laboratoryPermissions) && !EmptyUtil.isEmpty(laboratoryPermissions.getUfcLmBusinessTypeIds())) {
            itcIds = lmTdsMapper.selectStandardoids(laboratoryPermissions.getUfcLmBusinessTypeIds());
        }
        Page<UfcLmTdsVo> page = new Page<>(lmtdsDto.getPageNum(), lmtdsDto.getPageSize());
        Page<UfcLmTdsVo> resList = lmTdsMapper.selectPageTdsList(page, lmtdsDto.getData(), itcIds);
        //报表存储数据
        Page<UfcLmTdsVo> resLists = lmTdsMapper.selectPageTdsList(page, lmtdsDto.getData(), itcIds);
//        LmTdsServiceImpl.LmList = resLists.getRecords();
        return new Result().toSuccess(resList);
    }

    /**
     * 送试单-保存按钮
     *
     * @param lmTdsSaveDto
     * @param user
     * @return
     */
    @Override
    @Transactional
    public Result save(UfcLmTdsSaveDto lmTdsSaveDto, User user) {
        //查询订单明细.合同号
        String mxHth = lmTdsMapper.selectMxHth(lmTdsSaveDto.getPsWbFk());
        if (EmptyUtil.isEmpty(lmTdsSaveDto)) {
            return new Result<>().toFailure(ResultCodeEnum.Valid_PARAM);
        }
        //1.保存送试单
        Long lmTdsOid = SnowflakeIdUtils.generate();
        UfcLmTds lmTds = new UfcLmTds();
        BeanUtils.copyProperties(lmTdsSaveDto, lmTds);
        lmTds.setUfcYwflFk(lmTdsSaveDto.getYwflFk());
        if (EmptyUtil.isEmpty(lmTdsSaveDto.getLmTdsoid())) {
            lmTds.setLmTdsoid(lmTdsOid);
            lmTds.setSysCreated(LocalDateTime.now());
            lmTds.setSysCreatedBy(user.getEmployeeOid());
            lmTds.setZt("I");
//            int count = this.count(new LambdaQueryWrapper<LmTds>()
//                    .eq(LmTds::getSsdh, lmTds.getSsdh()).eq(LmTds::getDel, false));
//            if (count>0){
//                lmTds.setSsdh(psWtCode());
//            }
        }
        lmTds.setSysLastUpd(LocalDateTime.now());
        lmTds.setSysLastUpdBy(user.getEmployeeOid());
        boolean saveOrUpdateTds = this.saveOrUpdate(lmTds);
        if (!saveOrUpdateTds) {
            throw new CustomException(ResultCodeEnum.LMERROR20001);
        }

        //2.保存送试单来源数据
        if (!EmptyUtil.isEmpty(lmTdsSaveDto.getLmTdsslSaveDtoList())) {
            List<UfcLmTdssl> lmTdsslList = new ArrayList<>();
            List<UfcLmTdsslSaveDto> lmTdsslSaveDtoList = lmTdsSaveDto.getLmTdsslSaveDtoList();

            List<String> lckhList = lmTdsslSaveDtoList.stream().map(UfcLmTdsslSaveDto::getLckh)
                    .collect(Collectors.toList());
            List<String> lckhcollect = lckhList.stream().filter(string -> !EmptyUtil.isEmpty(string)).collect(Collectors.toList());
            HashSet<String> lckhSet = new HashSet<>(lckhcollect);
            Boolean lckhResult = lckhSet.size() == lckhcollect.size() ? true : false;
            if (!lckhResult) {
                throw new CustomException(ResultCodeEnum.LMERROR20009);
            }
            List<String> phList = lmTdsslSaveDtoList.stream().map(UfcLmTdsslSaveDto::getPh)
                    .collect(Collectors.toList());
            List<String> collect = phList.stream().filter(string -> !EmptyUtil.isEmpty(string)).collect(Collectors.toList());
            HashSet<String> phSet = new HashSet<>(collect);
            Boolean phResult = phSet.size() == collect.size() ? true : false;
            if (!phResult) {
                throw new CustomException(ResultCodeEnum.LMERROR20010);
            }
            for (UfcLmTdsslSaveDto lmTdsslSaveDto : lmTdsSaveDto.getLmTdsslSaveDtoList()) {
                UfcLmTdssl lmTdssl = new UfcLmTdssl();
                BeanUtils.copyProperties(lmTdsslSaveDto, lmTdssl);
                if (EmptyUtil.isEmpty(lmTdsslSaveDto.getLmTdssloid())) {
                    lmTdssl.setLmTdssloid(SnowflakeIdUtils.generate());
                    lmTdssl.setSysCreated(LocalDateTime.now());
                    lmTdssl.setSysCreatedBy(user.getEmployeeOid());
                    lmTdssl.setZt("I");
                }
                lmTdssl.setLmTdsFk(lmTds.getLmTdsoid());
                lmTdssl.setSsdh(lmTds.getSsdh());
                lmTdssl.setSysLastUpd(LocalDateTime.now());
                lmTdssl.setSysLastUpdBy(user.getEmployeeOid());
                lmTdssl.setKhhth(mxHth);
                lmTdsslList.add(lmTdssl);
            }
            boolean updateBatchLmTdssl = this.lmTdsslService.saveOrUpdateBatch(lmTdsslList);
            if (!updateBatchLmTdssl) {
                throw new CustomException(ResultCodeEnum.LMERROR20001);
            }
        }

        //3.保存试验任务数据
        if (!EmptyUtil.isEmpty(lmTdsSaveDto.getLmTtSaveDtoList())) {
            for (UfcLmTtSaveDto lmTtSaveDto : lmTdsSaveDto.getLmTtSaveDtoList()) {
                UfcLmTt lmTt = new UfcLmTt();
                BeanUtils.copyProperties(lmTtSaveDto, lmTt);
                if (EmptyUtil.isEmpty(lmTtSaveDto.getLmTtoid())) {
                    lmTt.setLmTtoid(SnowflakeIdUtils.generate());
                    lmTt.setSysCreated(LocalDateTime.now());
                    lmTt.setSysCreatedBy(user.getEmployeeOid());
                    lmTt.setZt("I");
                    //
                    Long maxXh = lmTtMapper.getMaxXh(lmTds.getSsdh());
                    if (null == maxXh || maxXh == 0L) {
                        lmTt.setXh(10L);
                    } else {
                        maxXh = maxXh + 10;
                        if (maxXh.toString().length() == 2) {
                            maxXh = Long.valueOf(maxXh.toString().substring(0, 1) + "0");
                        } else if (maxXh.toString().length() == 3) {
                            maxXh = Long.valueOf(maxXh.toString().substring(0, 2) + "0");
                        } else if (maxXh.toString().length() == 4) {
                            maxXh = Long.valueOf(maxXh.toString().substring(0, 3) + "0");
                        } else if (maxXh.toString().length() == 5) {
                            maxXh = Long.valueOf(maxXh.toString().substring(0, 4) + "0");
                        }
                        lmTt.setXh(maxXh);
                    }

                }
                lmTt.setFfFk(EmptyUtil.isEmpty(lmTtSaveDto.getFfFk()) ? null : Long.valueOf(lmTtSaveDto.getFfFk()));
                lmTt.setFfbzFk(EmptyUtil.isEmpty(lmTtSaveDto.getFfbzFk()) ? null : Long.valueOf(lmTtSaveDto.getFfbzFk()));
                lmTt.setSytjFk(EmptyUtil.isEmpty(lmTtSaveDto.getSytjFk()) ? null : Long.valueOf(lmTtSaveDto.getSytjFk()));
                lmTt.setLmTdsFk(lmTds.getLmTdsoid());
                lmTt.setSsdh(lmTds.getSsdh());
                lmTt.setSysLastUpd(LocalDateTime.now());
                lmTt.setSysLastUpdBy(user.getEmployeeOid());
                lmTt.setDjsb(lmTtSaveDto.getDjsb());
                boolean saveOrUpdatelLmTt = this.lmTtService.saveOrUpdate(lmTt);
                if (!saveOrUpdatelLmTt) {
                    throw new CustomException(ResultCodeEnum.LMERROR20001);
                }
                // 4.保存检测参数数据
                int count = lmTttpService.count(new LambdaQueryWrapper<UfcLmTttp>().eq(UfcLmTttp::getSyrwbm, lmTt.getRwdh()));
                if (count > 0) {
                    this.lmTttpService.update(new LambdaUpdateWrapper<UfcLmTttp>()
                            .eq(UfcLmTttp::getSyrwbm, lmTt.getRwdh())
                            .set(UfcLmTttp::getLmTtFk, lmTt.getLmTtoid())
                            .set(UfcLmTttp::getSsdh, lmTds.getSsdh())
                            .set(UfcLmTttp::getLmTdsFk, lmTt.getLmTdsFk())
                            .set(UfcLmTttp::getSysLastUpd, LocalDateTime.now())
                            .set(UfcLmTttp::getSysLastUpdBy, user.getEmployeeOid())
                    );
                }
            }
            //4.送试单中生成试验任务，自动计算样品数（根据排序第一个）
            UfcLmTt lmttTop =new UfcLmTt();
            List<UfcLmTt> lmTtList=  lmTtService.list(new LambdaQueryWrapper<UfcLmTt>()
                    .eq(UfcLmTt::getSsdh, lmTdsSaveDto.getSsdh()).eq(UfcLmTt::getDel, false)
                    .orderByAsc(UfcLmTt::getXh) );
            if(!CollectionUtils.isEmpty(lmTtList)){
                lmttTop=lmTtList.get(0);
            }

            if (!ObjectUtils.isEmpty(lmttTop) && "B".equals(lmttTop.getCyfs())) {
                float sssl = Float.valueOf(lmTdsSaveDto.getSssl());//送试单数量
                float cybfb = ObjectUtils.isEmpty(lmttTop.getCybfb()) ? 0f : lmttTop.getCybfb(); //抽样百分比
                float hgl = ObjectUtils.isEmpty(lmttTop.getHgl()) ? 0f : lmttTop.getHgl(); //合格率
                //接受数=送试单得送试数量*（1-合格率）
                int yps = Math.round(sssl * (cybfb / 100)); //样品数=送试单的送试数量*该项目的抽样百分比
                int jss = Math.round(sssl * (1f - hgl / 100)); //接受数=送试单得送试数量*（1-合格率）
                lmttTop.setYps(Long.valueOf(yps));
                lmttTop.setJss(Long.valueOf(jss));
                lmTtService.updateById(lmttTop);
            }
        }
        return new Result().toSuccess(lmTds.getLmTdsoid());
    }
    /**
     * 送试单-试验标准保存试验任务和检测参数
     *
     * @param sybzSaveDto
     * @param user
     * @return
     */
    @Override
    @Transactional
    public Result saveSyrwAndJccs(UfcSybzSaveDto sybzSaveDto, User user) {
        if (EmptyUtil.isEmpty(sybzSaveDto)) {
            return new Result<>().toFailure(ResultCodeEnum.Valid_PARAM);
        }

//            BeanUtils.copyProperties(sybzSaveDto,oldSybzSaveDto);
        String ssdh = sybzSaveDto.getSsdh();
        UfcLmTds one = this.getOne(new LambdaQueryWrapper<UfcLmTds>().eq(UfcLmTds::getSsdh, ssdh).eq(UfcLmTds::getDel, false));
        Long sybzfk = sybzSaveDto.getSybzFk() == null ? 0 : sybzSaveDto.getSybzFk();
        String oldSsdh = sybzSaveDto.getSsdh() == null ? "" : sybzSaveDto.getSsdh();
//            if (ObjectUtils.isEmpty(oldSybzSaveDto)) {
        oldSybzSaveDto = new UfcSybzSaveDto();
        if (!ObjectUtils.isEmpty(one)){
            oldSybzSaveDto.setSsdh(one.getSsdh() == null ? "" :one.getSsdh());
            oldSybzSaveDto.setSybzFk(one.getSybzFk() == null ? 0 :one.getSybzFk());
        }

//            }
        if (!(sybzfk.equals(oldSybzSaveDto.getSybzFk()) && ssdh.equals(oldSsdh))) {
            this.lmTtService.remove(new LambdaUpdateWrapper<UfcLmTt>().eq(UfcLmTt::getSsdh, sybzSaveDto.getSsdh()));
            this.lmTttpService.remove(new LambdaUpdateWrapper<UfcLmTttp>().eq(UfcLmTttp::getSsdh, sybzSaveDto.getSsdh()));
            //2.根据试验标准主键保存试验任务及检测参数
            List<UfcLmTestStandardDetail> lmTestStandardDetailList = this.lmTestStandardDetailService.list(new LambdaQueryWrapper<UfcLmTestStandardDetail>()
                    .eq(UfcLmTestStandardDetail::getLmTestStandardFk, sybzSaveDto.getSybzFk())
                    .eq(UfcLmTestStandardDetail::getDel, false));
            if (!EmptyUtil.isEmpty(lmTestStandardDetailList)) {
                for (int i = 0; i < lmTestStandardDetailList.size(); i++) {
                    UfcLmTt lmTt = new UfcLmTt();
                    BeanUtils.copyProperties(lmTestStandardDetailList.get(i),lmTt);
                    lmTt.setRwdh(sybzSaveDto.getSsdh() + "-" + (i + 1));
                    lmTt.setZt("I");
                    lmTt.setSsdh(sybzSaveDto.getSsdh());
                    lmTt.setLmTtoid(SnowflakeIdUtils.generate());
                    lmTt.setSysCreated(LocalDateTime.now());
                    lmTt.setSysCreatedBy(user.getEmployeeOid());
                    lmTt.setSysLastUpdBy(user.getEmployeeOid());
                    lmTt.setSysLastUpd(LocalDateTime.now());
//                    lmTt.setXh(lmTestStandardDetailList.get(i).getXh());
                    lmTt.setSyxmbm(lmTestStandardDetailList.get(i).getLmTestItemsBm());
//                    lmTt.setFz(lmTestStandardDetailList.get(i).getFz());
//                    lmTt.setZb(lmTestStandardDetailList.get(i).getZb());
//                    lmTt.setJsyq(lmTestStandardDetailList.get(i).getJsyq());
                    lmTt.setYps(lmTestStandardDetailList.get(i).getCys());
//                    lmTt.setJss(lmTestStandardDetailList.get(i).getJss());
                    lmTt.setSybzmxfk(lmTestStandardDetailList.get(i).getLmTestStandardDetailoid());
                    lmTt.setFfbzFk(null == lmTestStandardDetailList.get(i).getLmTestMethodStandardFk() ? null : lmTestStandardDetailList.get(i).getLmTestMethodStandardFk());
                    lmTt.setFfbzmc(null == lmTestStandardDetailList.get(i).getLmTestMethodStandardMc() ? null : lmTestStandardDetailList.get(i).getLmTestMethodStandardMc());
                    lmTt.setFfFk(null == lmTestStandardDetailList.get(i).getLmTestMethodFk() ? null : lmTestStandardDetailList.get(i).getLmTestMethodFk());
                    lmTt.setFfmc(null == lmTestStandardDetailList.get(i).getLmTestMethodMc() ? null : lmTestStandardDetailList.get(i).getLmTestMethodMc());
                    lmTt.setSytjFk(null == lmTestStandardDetailList.get(i).getLmTestConditionFk() ? null : lmTestStandardDetailList.get(i).getLmTestConditionFk());
                    lmTt.setSytjmc(null == lmTestStandardDetailList.get(i).getLmTestConditionMc() ? null : lmTestStandardDetailList.get(i).getLmTestConditionMc());
                    //保存试验任务
                    boolean saveOrUpdateLmTt = this.lmTtService.saveOrUpdate(lmTt);
                    if (!saveOrUpdateLmTt) {
                        throw new CustomException(ResultCodeEnum.LMERROR20001);
                    }
                    //查询检测参数
                    List<UfcLmParameter> lmParameterList = this.lmParameterService.list(new LambdaQueryWrapper<UfcLmParameter>()
                            .eq(UfcLmParameter::getLmTestStandarddetailFk, lmTestStandardDetailList.get(i).getLmTestStandardDetailoid())
                            .eq(UfcLmParameter::getDel, false));
                    if (!EmptyUtil.isEmpty(lmParameterList)) {
                        for (UfcLmParameter lmParameter : lmParameterList) {
                            UfcLmTttp lmTttp = new UfcLmTttp();
                            BeanUtils.copyProperties(lmParameter, lmTttp);
                            lmTttp.setLmTtFk(lmTt.getLmTtoid());  //关联试验任务外键
                            lmTttp.setSyrwbm(lmTt.getRwdh());//关联试验任务单号
                            lmTttp.setSsdh(sybzSaveDto.getSsdh()); //关联送试单
                            lmTttp.setCsbm(lmParameter.getJccsbm());
                            lmTttp.setCsmc(lmParameter.getJccsmc());
                            lmTttp.setSysCreated(LocalDateTime.now());
                            lmTttp.setSysCreatedBy(user.getEmployeeOid());
                            lmTttp.setSysLastUpdBy(user.getEmployeeOid());
                            lmTttp.setSysLastUpd(LocalDateTime.now());
                            this.lmTttpService.saveOrUpdate(lmTttp);
                        }
                    }
                }
            }
        }
        oldSybzSaveDto.setSsdh(sybzSaveDto.getSsdh());
        oldSybzSaveDto.setSybzFk(sybzSaveDto.getSybzFk());

        return new Result<>().toSuccess();
    }

    @Override
    public Result getDefault(Long wboid) {
        UfcPsWbDto ufcPsWbDto = lmTdsMapper.selectUfcPsWbDto(wboid);
        String khmc = null;
        String khid = null;
        if(!EmptyUtil.isEmpty(ufcPsWbDto) && !EmptyUtil.isEmpty(ufcPsWbDto.getGcid()) && "100016".equals(ufcPsWbDto.getGcid())){
            khmc = lmTdsMapper.selectDwmc("0010003");
            khid = "0010003";
        }
        if(!EmptyUtil.isEmpty(ufcPsWbDto) && !EmptyUtil.isEmpty(ufcPsWbDto.getGcid()) && "100017".equals(ufcPsWbDto.getGcid())){
            khmc = lmTdsMapper.selectDwmc("0010004");
            khid = "0010004";
        }
        if(!EmptyUtil.isEmpty(ufcPsWbDto) && !EmptyUtil.isEmpty(ufcPsWbDto.getGcid()) && "100018".equals(ufcPsWbDto.getGcid())){
            khmc = lmTdsMapper.selectDwmc("0010005");
            khid = "0010005";
        }
        ufcPsWbDto.setKhmc(khmc);
        ufcPsWbDto.setKhid(khid);
        // 送试单号
        ufcPsWbDto.setSsdh(psWtCode());
        return new Result().toSuccess(ufcPsWbDto);
    }

    /**
     * 外协转移 生成送试单
     * @param ufcLmTdsSaveDto
     * @param user
     * @return
     */
    @Override
    public Result gwjSave(UfcLmTdsSaveDto ufcLmTdsSaveDto, User user) {
        List<UfcJcBMaterial> list = ufcJcBMaterialService.list(new LambdaQueryWrapper<UfcJcBMaterial>()
                .eq(UfcJcBMaterial::getWlid, ufcLmTdsSaveDto.getWlbm())
                .eq(UfcJcBMaterial::getDefaultFactoryFk, ufcLmTdsSaveDto.getBFactoryFk()));
        if (EmptyUtil.isEmpty(list)) {
            return new Result().toFailure("物料不存在!");
        }
        if (list.size() > 1) {
            return new Result().toFailure("物料查询出多个!");
        }
        UfcJcBMaterial bMaterial = list.get(0);
        
        // 物料fk
        ufcLmTdsSaveDto.setWlFk(bMaterial.getBMaterialoid());
        ufcLmTdsSaveDto.setWlcz(bMaterial.getCl());
        ufcLmTdsSaveDto.setWlth(bMaterial.getTz());
        ufcLmTdsSaveDto.setJldw(bMaterial.getJldw());
        ufcLmTdsSaveDto.getLmTdsslSaveDtoList().stream().forEach(o -> {
            o.setWlFk(bMaterial.getBMaterialoid());
            o.setWlcz(bMaterial.getCl());
            o.setWlth(bMaterial.getTz());
            o.setJldw(bMaterial.getJldw());
        });
        return save(ufcLmTdsSaveDto, user);
    }

    @Override
    public Result<UfcLmTdsVo> getTdsByOid(String tdsOid) {
        if (StringUtils.isEmpty(tdsOid)) {
            return new Result().toFailure(ResultCodeEnum.BMERROR1016);
        }
        UfcLmTdsVo res = lmTdsMapper.selectPageTdsOne(tdsOid);
        //存储数据给报表用
        UfcLmTdsServiceImpl.LmVO = res;
        return new Result().toSuccess(res);
    }


    public String psWtCode() {
        String start = "G";
        String orderCode;
        //查出数据库中最大的订单号
        UfcLmTds res = this.getOne(new LambdaQueryWrapper<UfcLmTds>().select(UfcLmTds::getSsdh)
                .eq(UfcLmTds::getDel, false)
                .likeRight(UfcLmTds::getSsdh, "G")
                .orderByDesc(UfcLmTds::getSsdh)
                .last("limit 1"), false);
        if (EmptyUtil.isEmpty(res)) {
            orderCode = start + new SimpleDateFormat("yyyyMMdd", Locale.CHINESE).format(new Date()) + "00001";
        } else {
            String ssdh = res.getSsdh();
            String str = ssdh.substring(9);
            int num = Integer.parseInt(str);
            num++;
            orderCode = start + new SimpleDateFormat("yyyyMMdd", Locale.CHINESE).format(new Date()) + String.format("%05d", num);
        }
        return orderCode;
    }
    

  
}
