package com.jln.ufc.web.action.ufc.lm.service.impl;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcLmTdsMapper;
import com.jln.ufc.web.action.ufc.lm.mapper.UfcSingleTaskMapper;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcEmEquinfDto;
import com.jln.ufc.web.action.ufc.lm.pojo.dto.UfcLmTtDto;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcEmEquinfVo;
import com.jln.ufc.web.action.ufc.lm.pojo.vo.UfcLmTtVo;
import com.jln.ufc.web.action.ufc.lm.service.UfcSingleTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class UfcSingleTaskServiceImpl implements UfcSingleTaskService {


    @Autowired
    private UfcSingleTaskMapper singleTaskMapper;

    @Autowired
    private UfcLmTdsMapper lmTdsMapper;

    /**
     * 获取实验任务列表信息
     *
     * @param pageParameter 分页参数及条件
     * @return
     */
    @Override
    public Result getSingleTaskLsit(PageParameter<UfcLmTtDto> pageParameter) {
        List<Long> itcIds = null;
        if (!EmptyUtil.isEmpty(pageParameter.getData()) && !EmptyUtil.isEmpty(pageParameter.getData().getUfcLmBusinessTypeIds())) {
            itcIds = lmTdsMapper.selectItcIds(pageParameter.getData().getUfcLmBusinessTypeIds());
        }
        Page<UfcLmTtVo> singleTaskLsit = singleTaskMapper.getSingleTaskLsit(new Page(pageParameter.getPageNum(), pageParameter.getPageSize()), pageParameter.getData(), itcIds);
        return new Result().toSuccess(singleTaskLsit);
    }

    /**
     * 获取设备选择列表
     *
     * @param pageParameter 分页信息/查询条件
     * @return
     */
    @Override
    public Result getChooseEmEquinfList(PageParameter<UfcEmEquinfDto> pageParameter) {
        Page<UfcEmEquinfVo> chooseEmEquinfList = singleTaskMapper.getChooseEmEquinfList(new Page(pageParameter.getPageNum(), pageParameter.getPageSize()), pageParameter.getData());
        return new Result().toSuccess(chooseEmEquinfList);
    }

    
}
