package com.jln.ufc.web.action.ufc.pp.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcErpQueryVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoQueryVo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/1/18 17:42
 * Version:1.0
 **/
@Api(tags = "生产计划管理-定制接口", value = "生产计划管理-定制接口")
@RestController
@RequestMapping("/ufc/pp/wo")
public class UfcWoController {

    @Autowired
    private UfcWoService ufcWoService;

    
    @ApplyForPermission
    @ApiOperation(value = "生产订单工艺路线|物料清单菜单只查询下达和确认的订单数据", notes = "生产订单工艺路线|物料清单菜单只查询下达和确认的订单数据")
    @PostMapping("/getUfcWoListRandF")
    public Result<Page<UfcWoVo>> getUfcWoListRandF(@RequestBody PageParameter<UfcWoQueryVo> productQueryInfo){
        return ufcWoService.getWoListRandFUfc(productQueryInfo);
    }

    @ApplyForPermission
    @ApiOperation(value = "生产订单暂停接口——生产订单暂停列表查询", notes = "生产订单暂停接口——生产订暂停列表查询")
    @PostMapping("/getUfcWoSuspendList")
    public Result<UfcWoVo> getUfcWoSuspendList(@RequestBody PageParameter<UfcWoQueryVo> woQueryInfo) {
        return ufcWoService.getWoSuspendList(new Page<>(woQueryInfo.getPageNum(),woQueryInfo.getPageSize()),woQueryInfo.getData());
    }

    @ApplyForPermission
    @ApiOperation(value = "生产订单维护接口——生产订单维护、关闭、变更列表查询", notes = "生产订单维护接口——生产订单维护、关闭、变更列表查询")
    @PostMapping("/getUfcWoList")
    public Result<Page<UfcWoVo>> getUfcWoList(@RequestBody PageParameter<UfcWoQueryVo> woQueryDto) {
        return ufcWoService.getWoList(new Page<>(woQueryDto.getPageNum(), woQueryDto.getPageSize()), woQueryDto.getData());
    }

    @ApplyForPermission
    @ApiOperation(value = "生产订单维护接口——生产订单确认列表查询", notes = "生产订单维护接口——生产订单确认列表查询")
    @PostMapping("/getUfcWoConfirmList")
    public Result<UfcWoVo> getUfcWoConfirmList(@RequestBody PageParameter<UfcWoQueryVo> woQueryInfo) {
        return ufcWoService.getUfcWoConfirmList(new Page<>(woQueryInfo.getPageNum(), woQueryInfo.getPageSize()), woQueryInfo.getData());
    }

    @ApiOperation(value = "生产订单维护接口——生产订单详情", notes = "生产订单维护接口——生产订单详情")
    @GetMapping("/getUfcWoInfo")
    public Result<UfcWoVo> getUfcWoInfo(@RequestParam("wooid") Long wooid) {
        return ufcWoService.getUfcWoInfo(wooid);
    }

    @ApplyForPermission
    @ApiOperation(value = "生产订单下达接口——生产订单下达列表查询", notes = "生产订单下达接口——生产订单下达列表查询")
    @PostMapping("/getUfcWoReleaseList")
    public Result<UfcWoVo> getUfcWoReleaseList(@RequestBody PageParameter<UfcWoQueryVo> woQueryInfo) {
        return ufcWoService.getUfcWoReleaseList(new Page<>(woQueryInfo.getPageNum(),woQueryInfo.getPageSize()),woQueryInfo.getData());
    }

    @ApplyForPermission
    @ApiOperation(value = "生产订单维护接口——生产订单维护、关闭、变更列表查询", notes = "生产订单维护接口——生产订单维护、关闭、变更列表查询")
    @PostMapping("/getUfcErpWoList")
    public Result getUfcErpWoList(@RequestBody UfcErpQueryVo woQueryDto) {
        return ufcWoService.getErpWoList(woQueryDto);
    }
    

}
