package com.jln.ufc.web.action.ufc.pp.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.pp.pojo.dto.UfcWoSelectDto;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWogylxVo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWogylxService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 生产订单工艺路线 前端控制器
 * </p>
 *
 * @author 
 * @since 2020-02-19
 */
@Api(tags = "生产订单工艺路线接口",value = "生产订单工艺路线接口")
@RestController
@RequestMapping("/ufc/pp/wogylx")
@Validated
public class UfcWogylxController {
    @Autowired
    private UfcWogylxService wogylxService;


    @ApplyForPermission
    @ApiOperation(value = "生产订单工艺路线接口——生产订单工艺路线列表查询", notes = "生产订单工艺路线接口——生产订单工艺路线列表查询")
    @PostMapping("/getWogylxList")
    public Result<UfcWogylxVo> getWogylxList(@RequestBody PageParameter<UfcWoSelectDto> woSelectInfo) {
      return wogylxService.getWogylxList(new Page<>(woSelectInfo.getPageNum(), woSelectInfo.getPageSize()),woSelectInfo.getData());
    }

}
