package com.jln.ufc.web.action.ufc.pp.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.ufc.web.action.ufc.pp.pojo.UfcWo;
import com.jln.ufc.web.action.ufc.pp.pojo.UfcWogylx;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcErpQueryVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoQueryVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: 定制部分-订单查询接口
 * @Description:
 * @Author:三刀 Date:2022/1/18 17:36
 * Version:1.0
 **/
@Repository
public interface UfcWoMapper extends BaseMapper<UfcWo> {

    /**
     * 定制处理:生产调度查询订单列表：新增合同号等字段
     * 方法新增了 订单状态的查询传参：ztList
     *
     * @param page             分页条
     * @param productQueryInfo 查询条件：没有新增的内容
     * @return
     */
    Page<UfcWoVo> getWoReleaseList(@Param("page") Page<UfcWoVo> page, @Param("productQueryInfo") UfcWoQueryVo productQueryInfo);


    /**
     * 定制: 生产订单暂停处理列表,新增源单号等字段
     *
     * @param page
     * @param productQueryInfo
     * @return
     */
    List<UfcWoVo> getWoSuspendList(Page<UfcWoVo> page, @Param("productQueryInfo") UfcWoQueryVo productQueryInfo);

    /**
     * 定制: 生产订单完工处理列表,新增源单号等字段
     *
     * @param page
     * @param productQueryInfo
     * @return
     */
    List<UfcWoVo> getWoList(Page<UfcWoVo> page, @Param("productQueryInfo") UfcWoQueryVo productQueryInfo);

    /**
     * 生产订单确认
     *
     * @param page
     * @param productQueryInfo
     * @return
     */
    List<UfcWoVo> getWoConfirmList(Page<UfcWoVo> page, @Param("productQueryInfo") UfcWoQueryVo productQueryInfo);

    /**
     * 详情
     *
     * @param wooid
     * @return
     */
    UfcWoVo getWoInfo(Long wooid);

    /**
     * 生产订单下达接口
     *
     * @param page
     * @param productQueryInfo
     * @return
     */
    Page<UfcWoVo> getUfcWoReleaseList(@Param("page") Page<UfcWoVo> page, @Param("productQueryInfo") UfcWoQueryVo productQueryInfo);

    /**
     * 查询当前订单已经排产过的数量
     *
     * @param woId 订单外键
     * @return
     */
    BigDecimal numberSchedules(@Param("woId") Long woId);

    List<UfcWoVo> getErpWoList(@Param("productQueryInfo") UfcErpQueryVo productQueryInfo);

    Map<String, BigDecimal> selectWoHgsl(@Param("wooid") Long wooid, @Param("flag") boolean flag);

    BigDecimal getBhgsl(@Param("wooid") Long wooid);

    BigDecimal selectHgsl(@Param("psWsoid") Long psWsoid);

    BigDecimal seletBhgsl(@Param("psWsoid") Long psWsoid);
}
