package com.jln.ufc.web.action.ufc.pp.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.jurisdictionAnnotation.ParametersLoading;
import com.jln.common.entity.AuthorityEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcWoQueryDto {

    @ApiModelProperty(example = "生产订单号")
    private String woid;

    @ApiModelProperty(example = "物料编码")
    private String wlid;

    @ApiModelProperty(example = "物料名称")
    private String wlmc;

    @ApiModelProperty(example = "规格型号")
    private String gg;

    @ApiModelProperty(example = "图号")
    private String th;

    @ApiModelProperty(example = "计划开工日期起")
    private String jhkgrqstart;

    @ApiModelProperty(example = "计划开工日期至")
    private String jhkgrqend;

    @ApiModelProperty(example = "计划完工日期起")
    private String jhwgrqstart;

    @ApiModelProperty(example = "计划完工日期至")
    private String jhwgrqend;

    @ApiModelProperty(example = "工厂编号")
    private String gcid;

    @ApiModelProperty(example = "车间部门编号")
    private String cjid;

    @ApiModelProperty(example = "制令号")
    private String zlh;

    @ApiModelProperty(example = "类型")
    private String lx;

    @ApiModelProperty(example = "状态")
    private String zt;

    @ApiModelProperty(example = "物料类别编号")
    private String piid;

    @ApiModelProperty(example = "物料外键", required = true,dataType = "string")
    private Long bMaterialFk;

    @ApiModelProperty(example = "工厂外键", required = true,dataType = "string")
    private Long bFactoryFk;

    @ApiModelProperty(example = "车间外键", required = true,dataType = "string")
    private Long bWorkshopFk;

    @ApiModelProperty(example = "物料类别主键", required = true,dataType = "string")
    private Long bMaterialclassoid;

    @ApiModelProperty(example = "无工艺路线查询条件", required = true,dataType = "Boolean")
    private Boolean wgylx;

    @ApiModelProperty(value = "状态限定集合-接口隐藏参数",hidden = true)
    private List<String> ztList;

    @ApiModelProperty(value = "投料控制方式：1|生产订单投料控制、2|作业计划投料控制、3|作业工序投料控制、4|投料不控制")
    private String releaseControlType;
    @ApiModelProperty(value = "投料控制方式")
    private String feedingControlMode;
    /**
     * 投料控制转换为JSON之后的值
     */
    private List<String> feedingControlModeList;


    /**
     * 车间主键存放List
     */
    @ParametersLoading(value = "BMS003",describe = "当前角色支持的工厂数据")
    private List<Long> factoryList;


    /**
     * 车间主键存放List
     */
    @ParametersLoading(value = "BMS004",describe = "当前角色支持的车间数据")
    private List<Long> workshopList;

    public List<Long> getFactoryList() {
        return factoryList;
    }

    public void setFactoryList(List<Long> factoryList) {
        this.factoryList = factoryList;
    }

    public List<Long> getWorkshopList() {
        return workshopList;
    }

    public void setWorkshopList(List<Long> workshopList) {
        this.workshopList = workshopList;
    }

}
