package com.jln.ufc.web.action.ufc.pp.pojo.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import com.jln.common.entity.AuthorityEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDate;
import java.util.List;

/**
 * @author: Luca.Liu
 * @date: 2022/2/17
 */
@Data
@ApiModel(value = "GdpcQueryVo", description = "工单排程查询条件--辽晶")
public class UfcGdpcQueryVo extends AuthorityEntity {

    @ApiModelProperty(example = "合同号")
    private String hth;

    @ApiModelProperty(example = "源单id")
    private String ydid;

    @ApiModelProperty(value = "订单外键", example = "订单外键")
    private Long woFk;

    @ApiModelProperty(value = "类型", example = "类型")
    private String type;
    @ApiModelProperty(value = "工厂外键", example = "工厂外键")
    private Long gcFk;
    @ApiModelProperty(value = "排程程度", example = "排程程度")
    private String pccd;
    @ApiModelProperty(value = "生产订单号", example = "生产订单号")
    private String scddh;

    @ApiModelProperty(value = "车间外键", example = "车间外键")
    private Long bWorkshopFk;

    @ApiModelProperty(value = "作业流程卡号", example = "作业流程卡号")
    private String lckh;

    @ApiModelProperty(value = "物料编码", example = "物料编码")
    private String wlid;

    @ApiModelProperty(value = "物料名称", example = "物料名称")
    private String wlmc;

    @ApiModelProperty(value = "图号", example = "图号")
    private String tz;

    @ApiModelProperty(value = "生产线外键", example = "生产线外键")
    private Long scxFk;

    @ApiModelProperty(value = "工段外键", example = "工段外键")
    private Long gdFk;

    @ApiModelProperty(value = "工位外键", example = "工位外键")
    private Long gwFk;

    @ApiModelProperty(value = "制令号", example = "制令号")
    private String zlh;

    @ApiModelProperty(example = "计划开工日期 起")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate jhkgrqq;

    @ApiModelProperty(example = "计划完工日期 起")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate jhwgrqq;

    @ApiModelProperty(example = "计划开工日期 末")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate jhkgrqm;

    @ApiModelProperty(example = "计划完工日期 末")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate jhwgrqm;

    @ApiModelProperty(example = "排程计划能查询出来的状态", hidden = true)
    private List<String> ztList;

    @ApiModelProperty(example = "类型：1 排程计划，2 排程调度，3 排程关闭", hidden = true)
    private Integer paramType;

    @ApiModelProperty(value = "物料类别外键", example = "物料类别外键")
    private Long wllbFk;

    @ApiModelProperty(value = "规格型号", example = "规格型号")
    private String gg;
    @ApiModelProperty(value = "订单类型")
    private String orderType;
    @ApiModelProperty(value = "明细ID")
    private String mxId;
}
