package com.jln.ufc.web.action.ufc.pp.pojo.vo;

import com.jln.common.entity.PswlsxInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @ClassName:  定制处理：WoVo
 *               处理位置：生产调度-排程计划信息查询接口
 *               产品上新增字段返回如下： 源单号，行号，执行标准，订单金额，需求数量，合同号
 * @Description:
 * @Author:三刀 Date:2022/1/18 17:13
 * Version:1.0
 **/
@Data
@ApiModel(value = "ufcWoVo",description = "生产调度-排程计划信息查询接口")
public class UfcWoVo extends PswlsxInfo {

    @ApiModelProperty(example = "源单号", hidden = true)
    private String ydid;

    @ApiModelProperty(example = "行号", hidden = true)
    private String ydhh;

    @ApiModelProperty(example = "执行标准", hidden = true)
    private String zxbz;

    @ApiModelProperty(example = "订单金额", hidden = true)
    private BigDecimal ddje;

    @ApiModelProperty(example = "需求数量", hidden = true)
    private BigDecimal erpXqsl;

    @ApiModelProperty(example = "合同号")
    private String hth;

    @ApiModelProperty(example = "创建时间")
    private LocalDateTime createDate;
    @ApiModelProperty(example = "单据头.单据日期")
    private LocalDateTime djtDjrq;
    @ApiModelProperty(example = "单据头.审核人")
    private Integer djtShr;
    @ApiModelProperty(example = "单据头.审核人名称")
    private String djtShrMc;
    @ApiModelProperty(example = "单据头.审核日期")
    private LocalDateTime djtShrq;
    @ApiModelProperty(example = "单据头.客户名称")
    private String djtKhmc;
    @ApiModelProperty(example = "明细.辅助属性名称（质量等级）")
    private String mxFzsxmcZldj;
    @ApiModelProperty(example = "明细.辅助属性名称（精度）")
    private String mxFzsxmcJd;
    @ApiModelProperty(example = "明细.温度系数组别")
    private String mxWdxszb;
    @ApiModelProperty(example = "明细.合同号")
    private String mxHth;
    @ApiModelProperty(example = "军检类型名称")
    private String mxJjmc;
    @ApiModelProperty(example = "明细.是否下场验收")
    private String mxSfxcys;
    @ApiModelProperty(example = "明细.HM执行标准编码")
    private String mxHnzxbzId;
    @ApiModelProperty(example = "明细.HM项目编码")
    private String mxHmxmbmId;
    @ApiModelProperty(example = "Erp计划数量")
    private BigDecimal erpjh;
    @ApiModelProperty(example = "erp工艺路线编码")
    private String cpgyCode;

    @ApiModelProperty(example = "主键id")
    private Long wooid;

    @ApiModelProperty(example = "生产订单号")
    private String woid;

    @ApiModelProperty(example = "物料编码")
    private String wlid;

    @ApiModelProperty(example = "物料名称")
    private String wlmc;

    @ApiModelProperty(example = "规格型号")
    private String gg;

    @ApiModelProperty(example = "图号")
    private String th;

    @ApiModelProperty(example = "材质")
    private String cz;

    @ApiModelProperty(example = "计量单位")
    private String jldw;

    @ApiModelProperty(example = "订单数量")
    private String xqsl;

    @ApiModelProperty(example = "已排程数量")
    private String ypcsl;

    @ApiModelProperty(example = "剩余数量")
    private String sysl;

    @ApiModelProperty(example = "完成数量")
    private String wcsl;

    @ApiModelProperty(example = "入库数量")
    private String rksl;

    @ApiModelProperty(example = "计划开工日期")
    private LocalDate jhkgrq;

    @ApiModelProperty(example = "计划完工日期")
    private LocalDate jhwgrq;

    @ApiModelProperty(example = "确认人")
    private Long qrr;
    @ApiModelProperty(example = "确认人名称")
    private String qrrname;

    @ApiModelProperty(example = "确认日期")
    private LocalDate qrrq;

    @ApiModelProperty(example = "下达人")
    private Long xdr;
    @ApiModelProperty(example = "下达人名称")
    private String xdrname;
    @ApiModelProperty(example = "下达日期")
    private LocalDate xdrq;

    @ApiModelProperty(example = "关闭人")
    private Long gbr;
    @ApiModelProperty(example = "关闭人名称")
    private String gbrname;

    @ApiModelProperty(example = "关闭日期")
    private LocalDate gbrq;

    @ApiModelProperty(example = "工厂编号")
    private String gcid;

    @ApiModelProperty(example = "工厂名称")
    private String gcmc;

    @ApiModelProperty(example = "车间部门编号")
    private String cjid;

    @ApiModelProperty(example = "车间部门名称")
    private String cjmc;

    @ApiModelProperty(example = "制令号")
    private String zlh;

    @ApiModelProperty(example = "排产方式")
    private String pcfs;

    @ApiModelProperty(example = "生成方式")
    private String scfs;

    @ApiModelProperty(example = "类型")
    private String lx;

    @ApiModelProperty(example = "状态")
    private String zt;

    @ApiModelProperty(example = "备注")
    private String bz;

    @ApiModelProperty(example = "维护人编号")
    private String whrid;

    @ApiModelProperty(example = "维护人")
    private String whr;

    @ApiModelProperty(example = "维护时间")
    private LocalDateTime whrq;

    @ApiModelProperty(example = "物料类别编号")
    private String piid;

    @ApiModelProperty(example = "物料类别名称")
    private String pimc;

    @ApiModelProperty(example = "物料类别主键")
    private Long bMaterialclassoid;

    @ApiModelProperty(example = "排产优先级")
    private String pcyxj;

    @ApiModelProperty(example = "废品扣减计划数")
    private String fp;

    @ApiModelProperty(example = "工艺路线号")
    private String cpgyid;
    @ApiModelProperty(example = "工艺路线名称")
    private String cpgymc;

    @ApiModelProperty(example = "产品结构号")
    private String bomid;

    @ApiModelProperty(example = "产线排程程度")
    private String pccd;

    @ApiModelProperty(example = "排程到设备")
    private Boolean gdsfsb;
    @ApiModelProperty(example = "排程到人员")
    private Boolean gdsfry;

    @ApiModelProperty(example = "物料外键", required = true, dataType = "string")
    private Long bMaterialFk;

    @ApiModelProperty(example = "工厂外键", required = true, dataType = "string")
    private Long bFactoryFk;

    @ApiModelProperty(example = "车间外键", required = true, dataType = "string")
    private Long bWorkshopFk;

    @ApiModelProperty(example = "产品工艺流程外键", required = true, dataType = "string")
    private Long bProductprocessFk;

    @ApiModelProperty(example = "产品结构外键", required = true, dataType = "string")
    private Long bBomFk;

    @ApiModelProperty(example = "技术参数", value = "技术参数", required = true, dataType = "string")
    private String jscs;
    @ApiModelProperty(example = "物料属性值", value = "物料属性值", required = true, dataType = "string")
    private String wlsxz;
    @ApiModelProperty(example = "批次属性值", value = "批次属性值", required = true, dataType = "string")
    private String pcsxz;

    @ApiModelProperty(example = "物料属性值拼接后", value = "物料属性值拼接后", required = true, dataType = "string")
    private String wlsxzSeparator;
    @ApiModelProperty(example = "批次属性值拼接后", value = "批次属性值拼接后", required = true, dataType = "string")
    private String pcsxzSeparator;

    @ApiModelProperty(example = "原订单保留数量", required = true)
    private BigDecimal keepTheNumberOf=BigDecimal.valueOf(0);

    @ApiModelProperty(example = "紧急程度等级编码", hidden = true)
    private String udid;

    @ApiModelProperty(example = "紧急程度等级外键", hidden = true)
    private Long budFk;

    @ApiModelProperty(example = "紧急程度等级说明", hidden = true)
    private String udmc;
    @ApiModelProperty(example = "排序号", hidden = true)
    private Integer sortNumber;
    @ApiModelProperty(value = "投料控制规则：1|生产订单投料控制、2|作业计划投料控制、3|作业工序投料控制、4|投料不控制")
    private String releaseControlType;
    @ApiModelProperty(value = "投料控制方式:1|直接投料、2|扫码投料、3|线边仓投料")
    private String feedingControlMode;
    /**
     * 投料控制转换为JSON之后的值
     */
    private List<String> feedingControlModeList;

    @ApiModelProperty(value = "明细.阶段（技术状态）")
    private String mxJd;
    @ApiModelProperty(value = "质量等级名称")
    private String mxZldjMc;
    @ApiModelProperty(value = "精度名称")
    private String mxJdMc;
    @ApiModelProperty(value = "温度系数组别名称")
    private String mxWdxsMc;
    @ApiModelProperty(value = "执行标准名称")
    private String mxZxbzMc;

    @ApiModelProperty(value = "明细.客户物料名称")
    private String mxKhwlmc;

    @ApiModelProperty(value = "合格数量")
    private BigDecimal hgsl;

    @ApiModelProperty(value = "不合格数量")
    private BigDecimal bhgsl;
    
    @ApiModelProperty(value = "明细.销售订单要货日期")
    private LocalDateTime mxXsddyhrq;
    
    @ApiModelProperty(value = "明细.ID号")
    private String mxId;
    
    @ApiModelProperty(value = "是否满足erp订单")
    private Boolean erpOrder;
    

}
