package com.jln.ufc.web.action.ufc.pp.pojo.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.time.LocalDate;

@Data
public class UfcWogylxVo {

    @ApiModelProperty(example = "生产订单工艺路线主键", required = true, dataType = "string")
    private Long wogylxoid;

    @ApiModelProperty(example = "生产订单号", required = true, dataType = "string")
    private String woid;

    @ApiModelProperty(example = "工序号", required = true, dataType = "string")
    private String gxid;

    @ApiModelProperty(example = "工序名称", required = true, dataType = "string")
    private String gxmc;

    @ApiModelProperty(example = "标准工序号", required = true, dataType = "string")
    private String bzgxid;

    @ApiModelProperty(example = "标准工序名称", required = true, dataType = "string")
    private String bzgxmc;

    @ApiModelProperty(example = "工序类型", required = true, dataType = "string")
    private String gxlx;

    @ApiModelProperty(example = "关键工序", required = true, dataType = "string")
    private String gjgx;

    @ApiModelProperty(example = "上料", required = true, dataType = "string")
    private String slgx;

    @ApiModelProperty(example = "下料", required = true, dataType = "string")
    private String xlgx;

    @ApiModelProperty(example = "测试", required = true, dataType = "string")
    private String csgx;

    @ApiModelProperty(example = "设备数", required = true, dataType = "string")
    private String sbs;

    @ApiModelProperty(example = "人数", required = true, dataType = "string")
    private String rs;

    @ApiModelProperty(example = "生产线编码", required = true, dataType = "string")
    private String scxid;

    @ApiModelProperty(example = "生产线名称", required = true, dataType = "string")
    private String scxmc;

    @ApiModelProperty(example = "工段编码", required = true, dataType = "string")
    private String gdid;

    @ApiModelProperty(example = "工段名称", required = true, dataType = "string")
    private String gdmc;

    @ApiModelProperty(example = "工位编码", required = true, dataType = "string")
    private String gwid;

    @ApiModelProperty(example = "工位名称", required = true, dataType = "string")
    private String gwmc;

    @ApiModelProperty(example = "工位机编码", required = true, dataType = "string")
    private String gwjid;

    @ApiModelProperty(example = "排产优先级", required = true, dataType = "int")
    private String pcyxj;

    @ApiModelProperty(example = "计划开工日期", required = true, dataType = "string")
    private LocalDate jhkgrq;

    @ApiModelProperty(example = "计划完工日期", required = true, dataType = "string")
    private LocalDate jhwgrq;

    @ApiModelProperty(example = "需求数量", required = true, dataType = "string")
    private String xqsl;

    @ApiModelProperty(example = "交接批量", required = true, dataType = "string")
    private String jjpl;

    @ApiModelProperty(example = "排产倍数", required = true, dataType = "string")
    private String pcbs;

    @ApiModelProperty(example = "转包工序", required = true, dataType = "string")
    private String zbgx;

    @ApiModelProperty(example = "转包供应商编码", required = true, dataType = "string")
    private String zbgysid;

    @ApiModelProperty(example = "转包供应商名称", required = true, dataType = "string")
    private String zbgysmc;

    @ApiModelProperty(example = "转包提前期", required = true, dataType = "string")
    private String zblt;

    @ApiModelProperty(example = "转包成本", required = true, dataType = "string")
    private String zbcb;

    @ApiModelProperty(example = "标准准备时间(m)", required = true, dataType = "string")
    private String bzzbsj;


    @ApiModelProperty(example = "单件人工费用", required = true, dataType = "string")
    private String djrg;

    @ApiModelProperty(example = "单件人工工时(h)", required = true, dataType = "string")
    private String rgsj;

    @ApiModelProperty(example = "备注", required = true, dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态", required = true, dataType = "string")
    private String zt;

    @ApiModelProperty(example = "维护人", required = true, dataType = "string")
    private String whr;

    @ApiModelProperty(example = "最后修改时间", required = true, dataType = "string")
    private String whrq;

    @ApiModelProperty(example = "生产订单外键", required = true, dataType = "string")
    @NotNull(message = "生产订单不能为空")
    private Long woFk;

    @ApiModelProperty(example = "产品工艺路线明细外键", required = true, dataType = "string")
    @NotNull(message = "产品工艺路线明细不能为空")
    private Long bProductprocessdetailFk;

    @ApiModelProperty(example = "生产线外键", required = true, dataType = "string")
    @NotNull(message = "生产线不能为空")
    private Long bProductionlineFk;

    @ApiModelProperty(example = "工段外键", required = true, dataType = "string")
    @NotNull(message = "工段不能为空")
    private Long bWorksectionFk;

    @ApiModelProperty(example = "工站外键", required = true, dataType = "string")
    @NotNull(message = "工站不能为空")
    private Long bWorkstationFk;

    @ApiModelProperty(example = "供应商外键", required = true, dataType = "string")
    @NotNull(message = "供应商不能为空")
    private Long bSupplierFk;

    @ApiModelProperty(example = "标准工序外键", required = true, dataType = "string")
    @NotNull(message = "标准工序不能为空")
    private Long bStandardprocessFk;

    //------------------------增加字段----------------------------------------------

    @ApiModelProperty(example = "订单工序节点外键", value = "订单工序外键")
    private Long technologicalProcessFk;

    //-----------------------以下数据来源：产品工艺路线明细（B_productprocess_detail）------------------------------

    @ApiModelProperty(example = "作业方式 PC、PDA、DCT", required = true)
    private String zyfs;

    @ApiModelProperty(example = "采集内容 PD|产能、PD|产能和缺陷", required = true)
    private String cjnr;

    @ApiModelProperty(example = "是否批次上料 1是 0不是", required = true)
    private Boolean isPcsl;

    @ApiModelProperty(example = "是否经过本工序", required = true)
    private Boolean jgbgx;

    @ApiModelProperty(example = "关键物料校验", required = true)
    private Boolean gjwljy;

    @ApiModelProperty(example = "合格率预警", required = true)
    private Boolean hglyj;

    @ApiModelProperty(example = "合格率预警阀值 百分比", required = true)
    private BigDecimal hglyjfz;

    //标准工艺路线明细带出

    @ApiModelProperty(example = "标准产量", value = "标准产量")
    private BigDecimal bzcl;

    @ApiModelProperty(example = "标准工时", value = "标准产量")
    private BigDecimal bzgs;

    @ApiModelProperty(example = "标准人数", value = "标准人数")
    private Integer bzrs;

    @ApiModelProperty(value = "节点名称")
    private String nodeName;

    @ApiModelProperty(value = "节点编码")
    private String nodeCode;

    @ApiModelProperty(value = "流转方式：A|流转节点内的所有工序,S|流转节点内的某一道工序")
    private String transferMode;

    //------------------------增加字段----------------------------------------------

    @ApiModelProperty(example = "标准加工时间(m):10", required = true)
    private BigDecimal bzjgsj;

    @ApiModelProperty(example = "实际加工时间(m):100", required = true)
    private BigDecimal sjjgsj;

    @ApiModelProperty(example = "原订单保留数量", required = true)
    private BigDecimal keepTheNumberOf;

    @ApiModelProperty(example = "拆分数量", required = true)
    private BigDecimal breakUpTheNumber;

    /**
     * ,,,,,,,,,,,,,
     */
    @ApiModelProperty(value = "默认仓库")
    private String mrrkck;
    @ApiModelProperty(value = "下料")
    private Boolean sfxlgx;
    @ApiModelProperty(value = "允许变更产品")
    private Boolean sfyxbgcp;
    @ApiModelProperty(value = "允许拆分流程卡")
    private Boolean sfyxcslck;
    @ApiModelProperty(value = "单件生产")
    private Boolean singleGenerating;
    @ApiModelProperty(value = "关键工序")
    private Boolean sfgjgx;
    @ApiModelProperty(value = "检验工序")
    private Boolean sfjygx;
    @ApiModelProperty(value = "数量校验")
    private Boolean sfjxsljy;
    @ApiModelProperty(value = "首检工序")
    private Boolean firstInspectionProcess;
    @ApiModelProperty(value = "特殊过程")
    private Boolean specialProcess;
    @ApiModelProperty(value = "上料")
    private Boolean sfslgx;
    @ApiModelProperty(value = "允许入库")
    private Boolean sfyxrk;
    @ApiModelProperty(value = "允许自动接收")
    private Boolean sfyxzdjs;
    @ApiModelProperty(value = "单件管理")
    private Boolean individualManagement;
    @ApiModelProperty(example = "标准排队时间(h):10", required = true)
    private BigDecimal bzpdsj;

    @ApiModelProperty(example = "标准转移时间(h):10", required = true)
    private BigDecimal bzzysj;

    @ApiModelProperty(example = "标准等待时间(h):10", required = true)
    private BigDecimal bzddsj;

    @ApiModelProperty(value = "产品工艺路线编码")
    private String cpgylxid;

    @ApiModelProperty(value = "产品工艺路线名称")
    private String cpgylxmc;
    
    @ApiModelProperty(value = "排序")
    private Integer sort;
}
