package com.jln.ufc.web.action.ufc.pp.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcErpQueryVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoQueryVo;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/1/18 17:41
 * Version:1.0
 **/
public interface UfcWoService {

    /**
     * 查询生产订单
     * @param productQueryInfo
     * @return
     */
    Result<Page<UfcWoVo>> getWoReleaseList(PageParameter<UfcWoQueryVo> productQueryInfo);

    /**
     * 查询计划变更
     * @param productQueryInfo
     * @return
     */
    Result<Page<UfcWoVo>> getWoListRandFUfc(PageParameter<UfcWoQueryVo>productQueryInfo);

    /**
     * 生产订单暂停列表查询
     * @param page
     * @param productQueryInfo
     * @return
     */
    Result<UfcWoVo> getWoSuspendList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo);

    /**
     * 获取订单列表
     * @param page
     * @param productQueryInfo
     * @return
     */
    Result<Page<UfcWoVo>> getWoList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo);

    /**
     * 生产订单确认列表查询
     * @param page
     * @param productQueryInfo
     * @return
     */
    Result<UfcWoVo> getUfcWoConfirmList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo);

    /**
     * 获取订单详情
     * @param wooid
     * @return
     */
    Result<UfcWoVo> getUfcWoInfo(Long wooid);

    /**
     * 生产订单下达列表查询
     * @param page
     * @param productQueryInfo
     * @return
     */
    Result<UfcWoVo> getUfcWoReleaseList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo);

    /**
     * 根据生产订单号批量查询
     * @param productQueryInfo
     * @return
     */
    Result getErpWoList(UfcErpQueryVo productQueryInfo);

}
