package com.jln.ufc.web.action.ufc.pp.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.Result;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.enums.WorkOderEnum;
import com.jln.common.pojo.FeedingTheDetailsVO;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.FeedingTheDetailsProcessingUtil;
import com.jln.common.utils.MyBaoBUtil;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.bm.service.UfcBMaterialPropertyGroupService;
import com.jln.ufc.web.action.ufc.pp.mapper.UfcWoMapper;
import com.jln.ufc.web.action.ufc.pp.pojo.dto.UfcWoBgNumberInfo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcErpQueryVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoQueryVo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWoService;
import com.jln.ufc.web.action.ufc.pp.service.UfcWobgCheckService;
import com.jln.ufc.web.action.ufc.pp.utilCl.Constant;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/1/18 17:41
 * Version:1.0
 **/
@Service
public class UfcWoServiceImpl implements UfcWoService {

    @Autowired
    private UfcWoMapper ufcWoMapper;

    @Autowired
    private UfcBMaterialPropertyGroupService ufcBMaterialPropertyGroupService;

    @Autowired
    private UfcWobgCheckService ufcWobgCheckService;


    @Override
    public Result<Page<UfcWoVo>> getWoReleaseList(PageParameter<UfcWoQueryVo> productQueryInfo) {
        Page<UfcWoVo> woQueryView = this.ufcWoMapper.getWoReleaseList(new Page<>(productQueryInfo.getPageNum(), productQueryInfo.getPageSize()), productQueryInfo.getData());
        for (UfcWoVo record : woQueryView.getRecords()) {
            FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(record.getFeedingControlMode());
            record.setFeedingControlMode(vo.getFeedingControlMode());
            record.setFeedingControlModeList(vo.getFeedingControlModeList());
            //处理已排产数量接口
            BigDecimal decimal = ufcWoMapper.numberSchedules(record.getWooid());
            decimal = EmptyUtil.isEmpty(decimal) ? BigDecimal.ZERO : decimal;
            BigDecimal xqsl = EmptyUtil.isEmpty(record.getXqsl()) ? BigDecimal.ZERO : new BigDecimal(record.getXqsl());
            record.setYpcsl(decimal.toString());
            record.setScfs((xqsl.subtract(decimal)).toString());

        }
        ufcBMaterialPropertyGroupService.packedAbsorber(woQueryView);
        //报表存储数据用
        Page<UfcWoVo> woQueryViews = this.ufcWoMapper.getWoReleaseList(new Page<>(1, 9999999), productQueryInfo.getData());
        Constant.woVoBBList = woQueryViews.getRecords();
        for (int i = 0; i < Constant.woVoBBList.size(); i++) {
            Constant.woVoBBList.get(i).setWlsxJson(null);
            Constant.woVoBBList.get(i).setWlpcJson(null);
            Constant.woVoBBList.get(i).setPcsxz(null);
            Constant.woVoBBList.get(i).setFeedingControlMode(null);
            Constant.woVoBBList.get(i).setFeedingControlModeList(null);
            Constant.woVoBBList.get(i).setWlsxz(null);
        }
        return new Result().toSuccess(woQueryView);
    }

    @Override
    public Result<Page<UfcWoVo>> getWoListRandFUfc(PageParameter<UfcWoQueryVo> productQueryInfo) {
        if (EmptyUtil.isEmpty(productQueryInfo.getData())) {
            productQueryInfo.setData(new UfcWoQueryVo());
        }
        List<String> ztList = new ArrayList<>();
        ztList.add(WorkOderEnum.CONFIRM.getValue());
        ztList.add(WorkOderEnum.ISSUED.getValue());
        productQueryInfo.getData().setZtList(ztList);
        Page<UfcWoVo> page = new Page<>(productQueryInfo.getPageNum(), productQueryInfo.getPageSize());
        return getWoList(page, productQueryInfo.getData());
    }

    @Override
    public Result<UfcWoVo> getWoSuspendList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo) {
        Page<UfcWoVo> woQueryView = page.setRecords(this.ufcWoMapper.getWoSuspendList(page, productQueryInfo));
        for (UfcWoVo record : woQueryView.getRecords()) {
            FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(record.getFeedingControlMode());
            record.setFeedingControlMode(vo.getFeedingControlMode());
            record.setFeedingControlModeList(vo.getFeedingControlModeList());
        }
        ufcBMaterialPropertyGroupService.packedAbsorber(woQueryView);
        return new Result().toSuccess(woQueryView);
    }

    @Override
    public Result<Page<UfcWoVo>> getWoList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo) {
        Page<UfcWoVo> woQueryView = page.setRecords(this.ufcWoMapper.getWoList(page, productQueryInfo));
        List<UfcWoVo> list = woQueryView.getRecords();
        for (UfcWoVo woVo : list) {
            FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(woVo.getFeedingControlMode());
            woVo.setFeedingControlMode(vo.getFeedingControlMode());
            woVo.setFeedingControlModeList(vo.getFeedingControlModeList());

            //查询订单合格数量和不合格数量
            Map<String,BigDecimal> count = ufcWoMapper.selectWoHgsl(woVo.getWooid(), true);
            if(!EmptyUtil.isEmpty(count)){
                BigDecimal qualified = count.get("hgsl") == null ? new BigDecimal(0) : count.get("hgsl");
                woVo.setHgsl(qualified);
                BigDecimal bhgsl = ufcWoMapper.getBhgsl(woVo.getWooid());
//                woVo.setBhgsl(count.get("bhgsl") == null ? new BigDecimal(0) : count.get("bhgsl"));
                woVo.setBhgsl(bhgsl);

                BigDecimal erpjh = woVo.getErpjh();
                // 合格数量 >= 订单数量 true
                if (qualified.compareTo(erpjh) > -1) {
                    woVo.setErpOrder(true);
                } else {
                    // 合格数量 < 订单数量 false
                    woVo.setErpOrder(false);
                }
            } else {
                woVo.setErpOrder(false);
            }
        }
        ufcBMaterialPropertyGroupService.packedAbsorber(page);
        //报表存储数据
        List<UfcWoVo> listVo = this.ufcWoMapper.getWoList(new Page<>(1, 9999999), productQueryInfo);
        for (int i = 0; i < listVo.size(); i++) {
            listVo.get(i).setWlpcJson(null);
            listVo.get(i).setFeedingControlMode(null);
            listVo.get(i).setPcsxz(null);
            listVo.get(i).setWlsxJson(null);
            listVo.get(i).setWlsxz(null);
        }
        MyBaoBUtil.map.put("PP0401", listVo);
        MyBaoBUtil.map.put("PP0101", listVo);
        MyBaoBUtil.map.put("PP0501", listVo);
        return new Result().toSuccess(woQueryView);
    }

    @Override
    public Result<UfcWoVo> getUfcWoConfirmList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo) {
        Page<UfcWoVo> woQueryView = page.setRecords(this.ufcWoMapper.getWoConfirmList(page, productQueryInfo));
        List<UfcWoVo> list = woQueryView.getRecords();
        for (UfcWoVo woVo : list) {
            FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(woVo.getFeedingControlMode());
            woVo.setFeedingControlMode(vo.getFeedingControlMode());
            woVo.setFeedingControlModeList(vo.getFeedingControlModeList());
        }
        ufcBMaterialPropertyGroupService.packedAbsorber(woQueryView);
        return new Result().toSuccess(woQueryView);
    }

    @Override
    public Result<UfcWoVo> getUfcWoInfo(Long wooid) {
        if (EmptyUtil.isEmpty(wooid)) {
            return new Result().toFailure(ResultCodeEnum.PPERROR10000);
        }
        UfcWoVo woView = this.ufcWoMapper.getWoInfo(wooid);
        FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(woView.getFeedingControlMode());
        woView.setFeedingControlMode(vo.getFeedingControlMode());
        woView.setFeedingControlModeList(vo.getFeedingControlModeList());
        if (!EmptyUtil.isEmpty(woView)) {
            wlsxggjkmx(woView);
            Result<UfcWoBgNumberInfo> info = ufcWobgCheckService.getWoBgNumberInfo(wooid);
            if (info.confirmSuccess()) {
                woView.setKeepTheNumberOf(info.getData().getKeepTheNumberOf());
            }
        }
        //存储报表数据
        List<UfcWoVo> listVo = new ArrayList<>();
        listVo.add(woView);
        MyBaoBUtil.map.put("PP0401-1", listVo);
        MyBaoBUtil.map.put("PP0101-1", listVo);
        MyBaoBUtil.map.put("PP0501-1", listVo);
        return new Result().toSuccess(woView);
    }

    @Override
    public Result<UfcWoVo> getUfcWoReleaseList(Page<UfcWoVo> page, UfcWoQueryVo productQueryInfo) {
        Page<UfcWoVo> woQueryView = this.ufcWoMapper.getUfcWoReleaseList(page, productQueryInfo);
        for (UfcWoVo record : woQueryView.getRecords()) {
            FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(record.getFeedingControlMode());
            record.setFeedingControlMode(vo.getFeedingControlMode());
            record.setFeedingControlModeList(vo.getFeedingControlModeList());
            //处理已排产数量接口
            BigDecimal decimal = ufcWoMapper.numberSchedules(record.getWooid());
            decimal = EmptyUtil.isEmpty(decimal) ? BigDecimal.ZERO : decimal;
            BigDecimal xqsl = EmptyUtil.isEmpty(record.getXqsl()) ? BigDecimal.ZERO : new BigDecimal(record.getXqsl());
            record.setYpcsl(decimal.toString());
            record.setScfs((xqsl.subtract(decimal)).toString());

        }
        ufcBMaterialPropertyGroupService.packedAbsorber(woQueryView);
        //报表存储数据用
        Page<UfcWoVo> woQueryViews = ufcWoMapper.getWoReleaseList(new Page<>(1, 9999999), productQueryInfo);
        Constant.woVoBBList = woQueryViews.getRecords();
        for (int i = 0; i < Constant.woVoBBList.size(); i++) {
            Constant.woVoBBList.get(i).setWlsxJson(null);
            Constant.woVoBBList.get(i).setWlpcJson(null);
            Constant.woVoBBList.get(i).setPcsxz(null);
            Constant.woVoBBList.get(i).setFeedingControlMode(null);
            Constant.woVoBBList.get(i).setFeedingControlModeList(null);
            Constant.woVoBBList.get(i).setWlsxz(null);
        }
        return new Result().toSuccess(woQueryView);
    }

    @Override
    public Result<Page<UfcWoVo>> getErpWoList(UfcErpQueryVo productQueryInfo) {
        List<UfcWoVo> erpWoList = this.ufcWoMapper.getErpWoList(productQueryInfo);
        for (UfcWoVo woVo : erpWoList) {
            FeedingTheDetailsVO vo = FeedingTheDetailsProcessingUtil.processingData(woVo.getFeedingControlMode());
            woVo.setFeedingControlMode(vo.getFeedingControlMode());
            woVo.setFeedingControlModeList(vo.getFeedingControlModeList());
        }
        ufcBMaterialPropertyGroupService.packedAbsorber(erpWoList);
        return new Result().toSuccess(erpWoList);
    }

    private void wlsxggjkmx(UfcWoVo woVo) {
        ufcBMaterialPropertyGroupService.packedAbsorber(woVo);
    }

}
