package com.jln.ufc.web.action.ufc.pp.service.impl;

import com.jln.common.entity.Result;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.utils.EmptyUtil;
import com.jln.ufc.web.action.ufc.pp.mapper.UfcWobgCheckMapper;
import com.jln.ufc.web.action.ufc.pp.pojo.dto.UfcWoBgNumberInfo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWobgCheckService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;

@Service
public class UfcWobgCheckServiceImpl implements UfcWobgCheckService {
    @Autowired
    private UfcWobgCheckMapper ufcWobgCheckMapper;

    @Override
    public Result<UfcWoBgNumberInfo> getWoBgNumberInfo(Long woOid) {
        UfcWoBgNumberInfo info = this.ufcWobgCheckMapper.getWoBgNumberInfo(woOid);
        if (EmptyUtil.isEmpty(info)) {
            return new Result<>().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        BigDecimal theNumber = info.getBreakUpTheNumber();
        info.setBreakUpTheNumber(null);
        if (!EmptyUtil.isEmpty(info.getSpit())) {
            if (info.getSpit()) {
                info.setBreakUpTheNumber(theNumber);
            }
        }
        return new Result<UfcWoBgNumberInfo>().toSuccess(info);
    }
}
