package com.jln.ufc.web.action.ufc.pp.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.ufc.web.action.ufc.pp.pojo.dto.UfcWoBgNumberInfo;
import com.jln.ufc.web.action.ufc.pp.pojo.dto.UfcWoSelectDto;
import com.jln.ufc.web.action.ufc.pp.service.UfcWobgCheckService;
import com.jln.ufc.web.action.ufc.pp.mapper.UfcWogylxMapper;
import com.jln.ufc.web.action.ufc.pp.pojo.UfcWogylx;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWogylxVo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWogylxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 生产订单工艺路线 服务实现类
 * </p>
 *
 * @author
 * @since 2020-02-19
 */
@Service
public class UfcWogylxServiceImpl extends ServiceImpl<UfcWogylxMapper, UfcWogylx> implements UfcWogylxService {

    @Autowired
    private UfcWobgCheckService wobgCheckService;
    
    /**
     * 生产订单工艺路线列表查询
     *
     * @param page
     * @param woSelectDto
     * @return
     */
    @Override
    public Result<UfcWogylxVo> getWogylxList(Page<UfcWogylxVo> page, UfcWoSelectDto woSelectDto) {
        Page<UfcWogylxVo> wogylx = page.setRecords(this.baseMapper.getWogylxList(page, woSelectDto));
        //TODO  处理源订单信息数据
        if (0 != wogylx.getRecords().size()) {
            Result<UfcWoBgNumberInfo> info = wobgCheckService.getWoBgNumberInfo(page.getRecords().get(0).getWoFk());
            if (info.confirmSuccess()) {
                for (UfcWogylxVo record : wogylx.getRecords()) {
                    record.setKeepTheNumberOf(info.getData().getKeepTheNumberOf());
                    record.setBreakUpTheNumber(info.getData().getBreakUpTheNumber());
                }
            }
        }
        return new Result().toSuccess(wogylx);
    }
}
