package com.jln.ufc.web.action.ufc.ps.controller;

import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPswSVoData;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsWsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

/**
 * @author: Luca.Liu
 * @date: 2022/3/18
 */
@Api(tags = "工单排程", value = "工单排程")
@RestController
@RequestMapping("/ufc/ps/PS01/PS0101")
public class UfcGdpcController {
    
    @Autowired
    private UfcPsWsService psWsService;

    /**
     * 生产订单排程接口——生产订单排程添加
     * @param pswSVoData
     * @return
     */
    @ApiOperation(value = "生产订单排程接口——生产订单排程添加----------辽晶", notes = "生产订单排程接口——生产订单排程添加----------辽晶")
    @PostMapping("/addpswsLj")
    public Result addpswsLj(@Valid @RequestBody UfcPswSVoData pswSVoData, @LoginUser User user) {
        return psWsService.addpswsLj(pswSVoData, user);
    }

    @ApiOperation(value = "批量修改 生产订单排程接口——生产订单排程确认", notes = "批量修改 生产订单排程接口——生产订单排程确认")
    @PostMapping("/getpswsYesBatch")
    public Result getpswsYesBatch(@RequestBody List<Long> list) {
        return psWsService.getpswsYesBatch(list);
    }

}
