package com.jln.ufc.web.action.ufc.ps.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.LoginUser;
import com.jln.common.annotation.jurisdictionAnnotation.PermissionStatement;
import com.jln.common.entity.PermissionsOnTheEntity;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcCjheckQcSampleStdDto;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcInspectionDto;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcInspectionSaveVo;
import com.jln.ufc.web.action.ufc.ps.service.UfcInspectionService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/ufc/ps/gwj/inspectoin")
@Api(tags = "首件检验队列")
public class UfcInspectionController {

    @Autowired
    private UfcInspectionService ufcInspectionService;


    @PermissionStatement(value = "PSK0507")
    @ApiOperation(notes = "获取首件、专检检验队列列表信息", value = "获取首件检验队列列表信息")
    @PostMapping("getInspectionList")
    public Result getInspectionList(@RequestBody PageParameter<UfcInspectionDto> inspectionDtoPageParameter, @LoginUser User user, PermissionsOnTheEntity permissionsOnTheEntity) {
        return ufcInspectionService.getInspectionList(inspectionDtoPageParameter,user,permissionsOnTheEntity);
    }

    @ApiOperation(notes = "获取首件检验检验结果提交", value = "获取首件检验检验结果提交")
    @PostMapping("updateQcSampletionStdData")
    public Result updateQcSampletionStdData(@RequestBody UfcInspectionSaveVo inspectionSaveVo, @LoginUser User user) {
        return ufcInspectionService.updateQcSampletionStdData(inspectionSaveVo,user);
    }

}
