package com.jln.ufc.web.action.ufc.ps.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcGdpcQueryVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoQueryVo;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWoService;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWsList;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsWsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/1/17 21:47
 * Version:1.0
 **/
@Api(tags = "生产调度-作业计划-定制接口", value = "生产调度-作业计划调度-定制接口")
@RestController
@RequestMapping("/ucf/ps/PS01/PS0101")
public class UfcPsWsController {

    @Autowired
    private UfcPsWsService psWsService;

    @Autowired
    private UfcWoService ufcWoService;


    /**
     * 生产订单排程接口——生产订单排程列表
     * @param page
     * @return
     */
    @ApplyForPermission
    @ApiOperation(value = "生产订单排程接口——生产订单排程列表--定制接口", notes = "生产订单排程接口——生产订单排程列表--定制接口")
    @PostMapping("/getPsWsList")
    public Result<Page<UfcPsWsList>> getPsWsList(@RequestBody PageParameter<UfcGdpcQueryVo> page) {
        if(EmptyUtil.isEmpty(page.getData())){
            page.setData(new UfcGdpcQueryVo());
        }
        page.getData().setParamType(1);
        return psWsService.getPsWsList(page);
    }

    /**
     * 生产调度---调取生产计划-生产订单工艺路线接口
     * 生产订单工艺路线接口——生产订单列表查询
     *
     * @param woQueryInfo
     * @return
     */
    @ApplyForPermission
    @ApiOperation(value = "生产订单工艺路线接口——生产订单列表查询-定制接口", notes = "生产订单工艺路线接口——生产订单列表查询-定制接口")
    @PostMapping("/getWoList")
    public Result<Page<UfcWoVo>> getWoList(@RequestBody PageParameter<UfcWoQueryVo> woQueryInfo) {
        return ufcWoService.getWoReleaseList(woQueryInfo);
    }

    /**
     * 生产订单排程接口——生产订单排程列表
     * @param page
     * @return
     */
    @ApplyForPermission
    @ApiOperation(value = "生产订单排程接口——生产调度列表---定制接口", notes = "生产订单排程接口——生产调度列表--定制接口")
    @PostMapping("/getPsWsDispatchList")
    public Result<Page<UfcPsWsList>> getPsWsDispatchList(@RequestBody PageParameter<UfcGdpcQueryVo> page) {
        if(EmptyUtil.isEmpty(page.getData())){
            page.setData(new UfcGdpcQueryVo());
        }
        page.getData().setParamType(2);
        return psWsService.getPsWsList(page);
    }

    /**
     * 生产订单排程接口——生产订单排程列表
     * @param page
     * @return
     */
    @ApplyForPermission
    @ApiOperation(value = "生产订单排程接口——生产关闭--定制接口", notes = "生产订单排程接口——生产关闭--定制接口")
    @PostMapping("/getPsWsCloseList")
    public Result<Page<UfcPsWsList>> getPsWsCloseList(@RequestBody PageParameter<UfcGdpcQueryVo> page) {
        if(EmptyUtil.isEmpty(page.getData())){
            page.setData(new UfcGdpcQueryVo());
        }
        page.getData().setParamType(3);
        return psWsService.getPsWsList(page);
    }

    @ApiOperation(value = "生产订单排程接口——生产订单排程详情查看OID", notes = "生产订单排程接口——生产订单排程详情查看OID")
    @GetMapping("/getpswsoid")
    public Result getpswslistoid(@RequestParam("pswsoid") Long pswsoid) {
        return psWsService.getpswslistoid(pswsoid);
    }

    /**
     * 查询流转卡产品批号
     */
    @ApiOperation(value = "生产订单排程接口——生产订单排程详情查看OID", notes = "生产订单排程接口——生产订单排程详情查看OID")
    @GetMapping("/getCpph")
    public Result getCpph(@RequestParam("pswboid") Long pswboid) {
        return psWsService.getCpph(pswboid);
    }
}
