package com.jln.ufc.web.action.ufc.ps.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.jurisdictionAnnotation.PermissionStatement;
import com.jln.common.entity.PermissionsOnTheEntity;
import com.jln.common.entity.Result;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcWoQuery;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcWoView;
import com.jln.ufc.web.action.ufc.ps.service.UfcZytlService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@RestController
@RequestMapping("ufc/ps/scdd")
@Api(tags = "生产订单查询")
public class UfcWosController {

    @Autowired
    private UfcZytlService ufcZytlService;

    @PermissionStatement(value = "PSK0503")
    @ApiOperation(value = "生产订单查询-----根据条件查询生产订单",notes = "生产订单查询-----根据条件查询生产订单")
    @PostMapping("getWoPageList")
    public Result<Page<UfcWoView>> getWoPageList(@Valid @RequestBody PageParameter<UfcWoQuery> pageParameter, PermissionsOnTheEntity permissionsOnTheEntity){
        return ufcZytlService.getWoPageList(pageParameter,permissionsOnTheEntity);
    }

}
