package com.jln.ufc.web.action.ufc.ps.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWb;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcWbOutVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.util.List;


/**
 * @ClassName:   定制工单部分查询mapper-数据
 * @Description:
 * @Author:三刀 Date:2022/2/24 14:56
 * Version:1.0
 **/
@Repository
public interface UfcPsWbMapper extends BaseMapper<UfcPsWb> {


    /**
     * 查询工单定制部分的数据：工序号  工序编码  合格数量 主键
     * @param psWsFk  工单外键
     * @param zt   状态
     * @return
     */
    List<UfcPsWb> getUfcPsWbList(@Param("psWsFk") Long psWsFk, @Param("zt") String zt);

    /**
     * 工单反馈详情统计合格数量
     * @param psWbId
     * @return
     */
    BigDecimal getGxFkVO(@Param("psWbId") Long psWbId);

    UfcPsWb selectNextGx(@Param("psWbFk") Long pswboid);

    Integer selectNextHgsl(@Param("psWbFk") Long psWboid);

    UfcWbOutVo getWbMaterialInfo(@Param("id")Long id);

    int updateNumber(UfcPsWb psWb);
}
