package com.jln.ufc.web.action.ufc.ps.pojo;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.io.Serializable;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * <p>
 * 紧急程度等级表
 * </p>
 *
 * @author
 * @since 2021-08-31
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("b_ud")
public class UfcBUd extends Model<UfcBUd> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId
    private Long bUdoid;

    /**
     * 紧急程度等级
     */
    @NotNull(message = "缺少必要参数：紧急程度等级")
    @Size(max = 4,message = "紧急程度等级最大长度为4个单位")
    private String udid;

    /**
     * 紧急程度说明
     */
    private String udmc;

    /**
     * 启用日期
     */
    @ApiModelProperty(example = "2021-08-31 15:44:21", required = true,dataType = "date")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime qyrq;

    /**
     * 停用日期
     */
    @ApiModelProperty(example = "2021-08-31 15:44:21", required = true,dataType = "date")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime tyrq;

    /**
     * 停用标志
     */
    private Boolean tybz;

    /**
     * 备注
     */
    private String bz;

    /**
     * 维护人
     */
    @ApiModelProperty(value="维护人", hidden = true)
    private Long sysLastUpdBy;

    /**
     * 维护日期
     */
    @ApiModelProperty(value="维护日期", hidden = true)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value="是否删除", hidden = true)
    private Boolean del;

    /**
     * 排序号
     */
    private Integer sortNumber;


    @Override
    protected Serializable pkVal() {
        return this.bUdoid;
    }

}
