package com.jln.ufc.web.action.ufc.ps.pojo;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 生产工单工艺路线数据记录表
 * </p>
 *
 * @author
 * @since 2021-06-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="PsTechnologicalProcess对象", description="生产工单工艺路线数据记录表")
@TableName("ps_technological_process")
public class UfcPsTechnologicalProcess extends Model<UfcPsTechnologicalProcess> {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(value = "产品工艺路线-流程节点相关数据")
    private Long psTechnologicalProcessOid;

    @ApiModelProperty(value = "节点名称")
    private String nodeName;

    @ApiModelProperty(value = "节点编码")
    private String nodeCode;

    @ApiModelProperty(value = "流转方式：A|流转节点内的所有工序,S|流转节点内的某一道工序")
    private String transferMode;

    @ApiModelProperty(value = "流转某一道工序:某一道工序的外键")
    private Long defaultProcess;

    @ApiModelProperty(value = "流程节点的父级主键-开始的pid为：100000000000000000")
    private Long technologicalProcessPid;

    @ApiModelProperty(value = "产品工艺路线外键")
    private Long processRouteFk;

    @ApiModelProperty(value = "工序节点的样式信息数据")
    private String textJson;

    @ApiModelProperty(value = "节点的类型：1|开始节点，2|中间节点，3|结束节点")
    private Integer nodeTypes;

    @ApiModelProperty(value = "排序")
    private Integer sort;


    @Override
    protected Serializable pkVal() {
        return this.psTechnologicalProcessOid;
    }

}
