package com.jln.ufc.web.action.ufc.ps.pojo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotEmpty;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author 
 * @since 2020-02-10
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel("工单产出物料实体")
@TableName("ps_wbout")
public class UfcPsWbout extends Model<UfcPsWbout> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(example = "单件信息主键", hidden = true,dataType = "string")
    @TableId(value = "ps_mout", type = IdType.INPUT)
    private Long psMout;


    @ApiModelProperty(example = "产出物料二维码", hidden = true,dataType = "string")
    private String ccewm;



    @NotEmpty(message = "产出序列号不能为空")
    @ApiModelProperty(example = "产出序列号", required = true,dataType = "string")
    private String ccsn;


    @ApiModelProperty(example = "打印次数", hidden = true,dataType = "string")
    private Integer dycs;


    @ApiModelProperty(example = "开工时间", hidden = true,dataType = "string")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime kgsj;


    @ApiModelProperty(example = "完工时间", hidden = true,dataType = "string")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime wgsj;

    @ApiModelProperty(example = "单件工时,毫秒值", hidden = true,dataType = "int")
    private Integer djgs;


    @ApiModelProperty(example = "物料绑定方式:sn|序列号,bt|批次号", required = true,dataType = "enum")
    private String bdfs;


    @ApiModelProperty(example = "绑定时间", hidden = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime bdsj;


    @ApiModelProperty(example = "解绑时间", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime jbsjj;


    @NotEmpty(message ="是否绑定不能为空")
    @ApiModelProperty(example = "是否绑定:0否，1是", required = true,dataType = "enum")
    private Long sfbd;


    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;


    @ApiModelProperty(example = "创建人oid", hidden = true,dataType = "string")
    private Long sysCreatedBy;


    @ApiModelProperty(example = "最后修改人oid", hidden = true,dataType = "string")
    private Long sysLastUpdBy;


    @ApiModelProperty(example = "创建日期", hidden = true,dataType = "string")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "生产工单外键", required = true,dataType = "string")
    private Long psWbFk;


    @ApiModelProperty(example = "物料外键:当前产出的物料", required = true,dataType = "string")
    private Long bMaterialFk;

    @TableLogic
    @ApiModelProperty(example = "是否删除：0未删除，1已删除", hidden = true,dataType = "string")
    private Integer del;

    @ApiModelProperty(example = "投料状态:I|初始，F|开工，Q|投料，C|完成，K|反馈")
    private String zt;

    @ApiModelProperty(value = "产出物料是否合格",example = "标记产出物料是否合格")
    private Boolean qualified;

    @ApiModelProperty(value = "产出物料数量",example = "产出物料数量")
    private BigDecimal ccsl;

    @Override
    protected Serializable pkVal() {
        return this.psMout;
    }

}
