package com.jln.ufc.web.action.ufc.ps.pojo;

import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 *
 * </p>
 *
 * @author
 * @since 2020-02-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("ps_ws")
public class UfcPsWs extends Model<UfcPsWs> {

    private static final long serialVersionUID = 1L;

    /**
     * 生产订单排程主键
     */
    @TableId(type = IdType.INPUT)
    private Long psWsoid;

    /**
     * c|产品，l|零星
     */
    private String lx;

    /**
     * 工单排程到人员
     */
    private Boolean gdsfry;

    /**
     * 工单排程到设备
     */
    private Boolean gdsfsb;

    /**
     * 排程程度：cx|排程至产线gd|排程至工段
     * gw|排程至工位
     */
    private String pccd;

    /**
     * 订单序号:对应订单排产次数，从1递增
     */
    private Integer woxh;

    /**
     * 排程计划号
     */
    private String jhid;

    /**
     * 制订计划日期
     */
    private LocalDate jhrq;

    /**
     * 计划开工日期
     */
    private LocalDate jhkgrq;

    /**
     * 计划完工日期
     */
    private LocalDate jhwgrq;

    /**
     * 实际开工日期，为空说明还没有开工
     */
    private LocalDate sjkgrq;

    /**
     * 当拆分的工单都完工时，才算完工（完工日期）
     */
    private LocalDate sjwgrq;

    /**
     * 制订计划人外键(外键关联员表）
     */
    private Long jhryId;
    /**
     * 制订计划人外键(外键关联员表）
     */
    private Long jhrFk;


    /**
     * 下达人id（外键关联员工表）
     */
    private Long xdrId;

    /**
     * 关闭日期
     */
    private LocalDate gbrq;

    /**
     * 关闭说明，限定字数50
     */
    private String gbsm;

    /**
     * 原状态：i|初始、f|确认、r|下达、s|暂停、c|完成
     */
    private String yzt;

    /**
     * 生成二维码路径
     */
    private String ewm;

    /**
     * 制令号
     */
    private String zlh;

    /**
     * 排产数量
     */
    private BigDecimal pcsl;

    /**
     * 合格数量
     */
    private BigDecimal hgsl;

    /**
     * 回用数量
     */
    private BigDecimal hysl;

    /**
     * 返工数量
     */
    private BigDecimal fgsl;

    /**
     * 废品数量
     */
    private BigDecimal fpsl;

    /**
     * 废料数量
     */
    private BigDecimal lfsl;

    /**
     * 入库单数量
     */
    private BigDecimal rkdsl;

    /**
     * 入库数量
     */
    private BigDecimal rksl;

    /**
     * 备注
     */
    private String bz;

    /**
     * 状态：i|初始、f|确认、r|下达、s|暂停、c|完成
     */
    private String zt;

    /**
     * 创建人oid
     */
    private Long sysCreatedBy;

    /**
     * 最后修改人oid
     */
    private Long sysLastUpdBy;

    /**
     * 维护时间
     */
    private LocalDateTime sysCreated;

    /**
     * 生产订单外键
     */
    private Long woFk;

    /**
     * 排产到具体外键，根据排产程度状态确定当前字段是那张表的外键
     */
    private Long prodScheFk;

    /**
     * 确定产出物料是什么
     */
    private Long bMaterialFk;

    /**
     * 工段外键
     */
    private Long bWorksectionFk;

    /**
     * 车间外键
     */
    private Long bWorkshopFk;

    /**
     * 工厂外键
     */
    private Long bFactoryFk;

    /**
     * 工位外键
     */
    private Long bWorkstationFk;

    /**
     * 生产线外建
     */
    private Long bProductionlineFk;

    private String gwjid;

    /**
     * 班组
     */
    private String bzid;

    /**
     * 班次
     */
    private String bcid;

    private LocalDate xdrq;

    /**
     * 是否删除：0未删除，1删除
     */
    private Integer del;

    @ApiModelProperty(example = "备注类型", required = true, dataType = "String")
    private String bzlx;

    @ApiModelProperty(example = "流程卡外键", required = true, dataType = "String")
    private Long processCardFk;

    private Integer ywcsl;
    /**
     * 生产批次
     */
    @ApiModelProperty(value = "生产批次")
    private String productionBatch;

    //--2021.10.27-新增物料投料字段-----------------

    @ApiModelProperty(value = "投料控制方式：1|生产订单投料控制、2|作业计划投料控制、3|作业工序投料控制、4|投料不控制")
    private String releaseControlType;

    @ApiModelProperty(value = "投料方式控制:1|直接投料、2|扫码投料、3|线边仓投料")
    private String feedingControlMode;
    //--2021.10.27-新增物料投料字段-----------------
    /**
     * 投料控制转换为JSON之后的值
     */
    @TableField(exist = false)
    private List<String> feedingControlModeList;

    @Override
    protected Serializable pkVal() {
        return this.psWsoid;
    }

}
