package com.jln.ufc.web.action.ufc.ps.pojo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 工票表
 * </p>
 *
 * @author 
 * @since 2021-08-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="PsWt对象", description="工票表")
@TableName("ps_wt")
public class UfcPsWt extends Model<UfcPsWt> {

    private static final long serialVersionUID = 1L;

    @TableId
    private Long psWtoid;

    @TableField(exist = false)
    private String xh;

    @ApiModelProperty(value = "工票号（来源工单）")
    private String gpid;

    @ApiModelProperty(value = "工单号")
    private String wbid;

    @ApiModelProperty(value = "排程计划号（来源工单）")
    private String jhid;

    @ApiModelProperty(value = "工序编码-来源工单")
    private String gxid;

    @ApiModelProperty(value = "工序名称-工单表")
    private String gxmc;

    @ApiModelProperty(value = "标准工序号")
    private String bzgxid;

    @ApiModelProperty(value = "实际开工日期")
    private LocalDate sjkgrq;

    @ApiModelProperty(value = "实际完工日期")
    private LocalDate sjwgrq;

    @ApiModelProperty(value = "下达人-名称")
    private String xdr;

    @ApiModelProperty(value = "下达日期")
    private LocalDate xdrq;

    @ApiModelProperty(value = "班次编码")
    private String bcid;

    @ApiModelProperty(value = "班组编码")
    private String bzid;

    @ApiModelProperty(value = "设备list")
    private String sblist;

    @ApiModelProperty(value = "生产设备编码")
    private String sbid;

    @ApiModelProperty(value = "人员编码")
    private String ryid;

    @ApiModelProperty(value = "人员工号")
    private String rygh;

    @ApiModelProperty(value = "人员名称")
    private String rymc;

    @ApiModelProperty(value = "人员list")
    private String sylist;

    @ApiModelProperty(value = "物料编码")
    private String wlid;

    @ApiModelProperty(value = "二维码")
    private String erm;

    @ApiModelProperty(value = "指令号")
    private String zlh;

    @ApiModelProperty(value = "排产数量")
    private BigDecimal pcsl;

    @ApiModelProperty(value = "合格数量")
    private BigDecimal hgsl;

    @ApiModelProperty(value = "回用数量")
    private BigDecimal hysl;

    @ApiModelProperty(value = "返工数量")
    private BigDecimal fgsl;

    @ApiModelProperty(value = "废品数量")
    private BigDecimal  fpsl;

    @ApiModelProperty(value = "料废数量")
    private BigDecimal lfsl;

    @ApiModelProperty(value = "入库数量")
    private BigDecimal rksl;

    @ApiModelProperty(value = "入库单数量")
    private BigDecimal rkdsl;

    @ApiModelProperty(value = "派工时间")
    private LocalDateTime pgsj;

    @ApiModelProperty(value = "报工时间")
    private LocalDateTime bgsj;

    @ApiModelProperty(value = "提交首检时间")
    private LocalDateTime tjsjsj;

    @ApiModelProperty(value = "完成首检时间")
    private LocalDateTime wcsjsj;

    @ApiModelProperty(value = "提交专检时间")
    private LocalDateTime tjzjsl;

    @ApiModelProperty(value = "完成专检时间")
    private LocalDateTime wczjsl;

    @ApiModelProperty(value = "提交审核时间")
    private LocalDateTime tjshsj;

    @ApiModelProperty(value = "完成审核时间")
    private LocalDateTime wcshsj;

    @ApiModelProperty(value = "是否派工标志")
    private Boolean sfpg;

    @ApiModelProperty(value = "是否报工标致")
    private Boolean sfbg;

    @ApiModelProperty(value = "是否提交首检")
    private Boolean sftjsj;

    @ApiModelProperty(value = "首检完成标志")
    private Boolean sjwc;

    @ApiModelProperty(value = "是否提交专检")
    private Boolean sftjzj;

    @ApiModelProperty(value = "专检完成标志")
    private Boolean zjwc;

    @ApiModelProperty(value = "是否提交审核")
    private Boolean sftjsh;

    @ApiModelProperty(value = "审核完成标志")
    private Boolean shwc;

    @ApiModelProperty(value = "首检人员编码")
    private String sjyrid;

    @ApiModelProperty(value = "首检人员工号")
    private String sjyrgh;

    @ApiModelProperty(value = "首检人员姓名")
    private String sjyrmc;

    @ApiModelProperty(value = "首检合格标志")
    private Boolean sjhg;

    private String zjyj;

    @ApiModelProperty(value = "首检不合格分类(GF|工废LF|料废FG|返工)")
    private String sjbhgfl;

    @ApiModelProperty(value = "首检不合格现象编码(可关联QC_UQ)")
    private String sjbhgxxid;

    @ApiModelProperty(value = "首检不合格现象说明")
    private String sjbhgxxmc;

    @ApiModelProperty(value = "首检不合格原因编码(可关联QC_UQREASON)")
    private String sjbhgyyid;

    @ApiModelProperty(value = "首检不合格原因说明")
    private String sjbhgyysm;

    @ApiModelProperty(value = "专检人员编码")
    private String zjyrid;

    @ApiModelProperty(value = "专检人员工号")
    private String zjyrgh;

    @ApiModelProperty(value = "专检人员名称")
    private String zjrymc;

    @ApiModelProperty(value = "专检合格标志")
    private Boolean zjhg;

    @ApiModelProperty(value = "首检意见")
    private String sjyj;

    @ApiModelProperty(value = "专检不合格分类(GF|工废LF|料废FG|返工)")
    private String zjbhgfl;

    @ApiModelProperty(value = "专检不合格现象编码")
    private String zjbhgxxid;

    @ApiModelProperty(value = "专检不合格现象说明")
    private String zjbhgxxmc;

    @ApiModelProperty(value = "专检不合格原因编码")
    private String zjbhgyyid;

    @ApiModelProperty(value = "专检不合格原因说明")
    private String zjbhgyymc;

    @ApiModelProperty(value = "审核人编码")
    private String shyid;

    @ApiModelProperty(value = "审核人员工号")
    private String shrygh;

    @ApiModelProperty(value = "审核人员名称")
    private String shrymc;

    @ApiModelProperty(value = "审核通过标志")
    private Boolean shtgbz;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "状态（I|初始、R|执行、P|审核、S|暂停、C|完成）")
    private String zt;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "作业计划排程外键")
    private Long psWsFk;

    @ApiModelProperty(value = "工单外键")
    private Long psWbFk;

    @ApiModelProperty(value = "工厂外键")
    private Long bFactoryFk;

    @ApiModelProperty(value = "车间外键")
    private Long bWorkshopFk;

    @ApiModelProperty(value = "生产线外键")
    private Long bWorklineFk;

    @ApiModelProperty(value = "工段外键")
    private Long bWorksectionFk;

    @ApiModelProperty(value = "工位外键，方便排产到工位")
    private Long bWorkstationFk;

    @ApiModelProperty(value = "标准工序外键")
    private Long bStandardprocessFk;

    @ApiModelProperty(value = "产品工序外键")
    private Long bProductprocessFk;

    @ApiModelProperty(value = "生产订单工艺路线外键")
    private Long wogylxFk;

    @ApiModelProperty(value = "物料外键")
    private Long bMaterialFk;

    @ApiModelProperty(value = "工单外键")
    private Long woFk;

    @ApiModelProperty(value = "工位机ID")
    private String gwjid;

    @ApiModelProperty(value = "工位名称")
    private String gwmc;

    @ApiModelProperty(value = "工位编码")
    private String gwid;

    @ApiModelProperty(value = "工段编码")
    private String gdid;

    @ApiModelProperty(value = "生产线编码")
    private String scxid;

    @ApiModelProperty(value = "原状态(I|初始、R|执行、P|审核、S|暂停、C|完成）")
    private String yzt;

    @ApiModelProperty(value = "关闭说明")
    private String gbsm;

    @ApiModelProperty(value = "关闭日期")
    private LocalDate gbrq;

    @ApiModelProperty(value = "关闭人")
    private String gbr;

    @ApiModelProperty(value = "计划开工日期")
    private LocalDate jhkgrq;

    @ApiModelProperty(value = "计划完工日期")
    private LocalDate jhwgrq;

    @ApiModelProperty(value = "是否单件管理")
    private Boolean sfdj;

    @ApiModelProperty(value = "是否专检")
    private Boolean sfzj;

    @ApiModelProperty(value = "是否首检")
    private Boolean sfsj;

    @ApiModelProperty(value = "是否关键")
    private Boolean sfgj;

    @ApiModelProperty(value = "作业计划序号")
    private Integer jhxh;

    @ApiModelProperty(value = "订单序号")
    private Integer woxh;

    @ApiModelProperty(value = "订单号")
    private String woid;

    @ApiModelProperty(value = "车间编码")
    private String cjid;

    @ApiModelProperty(value = "工厂编码")
    private String gcid;

    @ApiModelProperty(value = "产线人员外键")
    private String psPlwmFk;

    @ApiModelProperty(value = "排序号-工单维度")
    private Integer sortNumber;


    @Override
    protected Serializable pkVal() {
        return this.psWtoid;
    }

}
