package com.jln.ufc.web.action.ufc.ps.pojo.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcQcSampleStdVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
@Data
@ApiModel("保存检验结果")
public class UfcQcSampleDto {

    /**
     * 检验样本主键
     */
    @TableId(value = "qc_sample_oid", type = IdType.INPUT)
    @ApiModelProperty(value="检验样本主键")
    private Long qcSampleOid;

    /**
     * 检验单号-来着qc_bill
     */
    @TableField(value = "jydid")
    @ApiModelProperty(value="检验单号-来着qc_bill")
    private String jydid;

    /**
     * 样本编号-自动生成的数据
     */
    @TableField(value = "ybbh")
    @ApiModelProperty(value="样本编号-自动生成的数据")
    private String ybbh;

    /**
     * 是否合格
     */
    @TableField(value = "sjsfhg")
    @ApiModelProperty(value="是否合格")
    private Boolean sjsfhg;

    /**
     * 不合格原因编码-来自QC_UQREASON
     */
    @TableField(value = "bhgyyid")
    @ApiModelProperty(value="不合格原因编码-来自QC_UQREASON")
    private String bhgyyid;

    /**
     * 不合格原因说明-来自QC_UQREASON
     */
    @TableField(value = "bhgyymc")
    @ApiModelProperty(value="不合格原因说明-来自QC_UQREASON")
    private String bhgyymc;

    /**
     * 检验单外键
     */
    @TableField(value = "qc_bill_fk")
    @ApiModelProperty(value="检验单外键")
    private Long qcBillFk;

    /**
     * 检验标准外键--来自检验单-冗余字段
     */
    @TableField(value = "qc_std_fk")
    @ApiModelProperty(value="检验标准外键--来自检验单-冗余字段")
    private Long qcStdFk;

    private List<UfcQcSampleStdVo> qcSampleStdVoList;

}
