package com.jln.ufc.web.action.ufc.ps.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;
import java.util.List;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2021/6/17 10:28
 * Version:1.0
 **/
@Data
@ApiModel(value = "WbRptJobAddDto",description = "工单反馈的数据在工位机上面的添加对象")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcWbRptJobAddDto {


    @ApiModelProperty(example = "0.000", value = "合格数量",required = true,dataType = "BigDecimal")
    private BigDecimal hgsl;

    @Length(max =250,message = "备注不能超过250字")
    @ApiModelProperty(example = "反馈说明：250字", value = "反馈说明",required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "0", value = "生产工单外键",required = true,dataType = "Long")
    private Long psWbFk;

    @ApiModelProperty(value = "物料信息-后端没处理给前端用的")
    private String wlInfo;

    @ApiModelProperty(value = "物料信息批次号-后端没处理给前端用的")
    private String wlInfoPh;

    @ApiModelProperty(value = "工单产出物料外键")
    private Long psWbOutFk;

    @ApiModelProperty(value = "是否不合格汇报：不合格汇报 true，合格汇报 false")
    private Boolean qualified;

    @DecimalMin(value = "0",message = "数量不能小于零")
    @ApiModelProperty(example = "0.000", value = "人工工时：保留三位小数")
    private BigDecimal rggs;

    @ApiModelProperty(value = "生产工单汇报主键")
    private Long psWbrptoid;


    /**
     * 不合格数据说明
     */
    private List<UfcWbUpDto> wbUpDtoList;

    @NotBlank(message = "请指定绑定方式")
    @ApiModelProperty(example = "物料绑定方式:sn|序列号,bt|批次号", required = true,dataType = "string")
    private String bdfs;

    /**
     * 产品批号
     */
    private String cpph;
}
