package com.jln.ufc.web.action.ufc.ps.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotEmpty;
import java.math.BigDecimal;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2021/6/17 10:58
 * Version:1.0
 **/
@Data
@ApiModel(value = "WbUpDto",description = "工单不合格明细对象")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcWbUpDto {

    @NotEmpty(message = "分类不能空")
    @ApiModelProperty(value = "分类:gf|工废lf|料废fg|返工", required = true,dataType = "string")
    private String fl;

    @Length(max =18,message = "不合格现象编码不能超过12位")
    @ApiModelProperty(value = "不合格现象编码，12位", required = true,dataType = "string")
    private String bhgxxid;

    @Length(max =100,message = "不合格现象说明不能超过100字")
    @ApiModelProperty(value = "不合格现象说明，字数限制100", required = true,dataType = "string")
    private String bhgxxmc;


    @ApiModelProperty(value = "报废物料外键，工废或料废的产品物料主键，缺省为生产订单的物料主键。", required = true,dataType = "string")
    private Long bfwlFk;

    @ApiModelProperty(value = "报废物料批号")
    private String bfwlph;

    @ApiModelProperty(value = "不合格数量")
    private BigDecimal unqualifiedQuantity;

    @ApiModelProperty(value = "生产工单不合格明细主键")
    private Long psWbuqoid;

    @ApiModelProperty(value = "物料信息-后端没处理给前端用的")
    private String wlInfo;
}
