package com.jln.ufc.web.action.ufc.ps.pojo.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.time.LocalDate;

@ApiModel(value="com-jln-system-web-action-ps-gwj-entity-Inspection")
@Data
public class UfcInspectionVo {


    /**
     * 送检单主键
     */
    @ApiModelProperty(value="送检单主键,")
    private Long  qcBilloid;



    /**
     * 检验对象编码

     */
    @ApiModelProperty(value="检验对象编码,")
    private String jydxid;

    /**
     * 排程计划号（来源工单）
     */
    @ApiModelProperty(value="排程计划号（来源工单）")
    private String jhid;

    /**
     * 工票号
     */
    @ApiModelProperty(value="工票号")
    private String gpid;

    /**
     * 物料编码
     */
    @ApiModelProperty(value="物料编码")
    private String wlid;

    /**
     * 送检数量
     */
    @TableField(value = "sjsl")
    @ApiModelProperty(value="送检数量")
    private BigDecimal sjsl;

    /**
     * 物料名称
     */
    @ApiModelProperty(value="物料名称")
    private String mc;

    /**
     * 规格型号
     */
    @ApiModelProperty(value="规格型号")
    private String gg;

    /**
     * 材质
     */
    @TableField(value = "cl")
    @ApiModelProperty(value="材质")
    private String cl;

    /**
     * 计量单位
     */
    @ApiModelProperty(value="计量单位")
    private String jldw;

    /**
     * 批次属性值
     */
    @ApiModelProperty(value="批次属性值")
    private String pcsxz;


    /**
     * 检验对象编码

     */
    @ApiModelProperty(value="工序编码,")
    private String gxid;

    /**
     * 检验对象编码

     */
    @ApiModelProperty(value="工序名称,")
    private String gxmc;


    /**
     *工票外键
     */
    @ApiModelProperty(value="工票外键")
    private Long psWtoid;


    /**
     *工票外键
     */
    @ApiModelProperty(value="检验对象外键")
    private Long qcObjoid;

    /**
     *车间编码
     */
    @ApiModelProperty(value="车间编码")
    private String cjid;


    /**
     *车间编码
     */
    @ApiModelProperty(value="车间名称")
    private String cjmc;

    /**
     *车间编码
     */
    @ApiModelProperty(value="生产线编码")
    private String scxid;

    /**
     *车间编码
     */
    @ApiModelProperty(value="车间名称")
    private String scxmc;

    /**
     * 不合格原因编码
     */
    private Boolean hg;

    /**
     * 不合格原因编码
     */
    private String bhgyyid;
    /**
     * 不合格原因说明
     */
    private String bhgyy;

    /**
     * 检验单编码
     */
    private String jydid;

    /**
     *
     */
    private Long qcStdFk;

    /**
     * 下达日期
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate xdrq;



    /**
     * 检验日期
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jyrq;
    /**
     * 检验人id
     */
    private String jyrid;

    /**
     * 检验人名称
     */
    private String jyr;

}