package com.jln.ufc.web.action.ufc.ps.pojo.vo;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Size;
import java.math.BigDecimal;

/**
 * @ClassName:  工单投入物料展示层
 *                1.投入物料的时候，通过这个添加
 *                2.查询投入物料的时候显示这个信息
 *
 * @Description:
 * @Author:三刀 Date:2020/12/26 22:14
 * Version:1.0
 **/
@Data
@ApiModel(value = "psMfeedShow",discriminator = "工单投入物料展示层")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcPsMfeedShow {


    @ApiModelProperty(value = "投入物料外键",example = "")
    private Long bMaterialFk;

    @ApiModelProperty(value = "投入物料编码",example = "")
    private String materialCode;

    @ApiModelProperty(value = "投入物料名称",example = "")
    private String materialName;

    @ApiModelProperty(value = "投入物料规格",example = "")
    private String materialSpecification;

    @ApiModelProperty(value = "序列号",example = "")
    private String tlxlh;

    @ApiModelProperty(value = "批次号",example = "")
    private String tlwlph;

    @ApiModelProperty(value = "数量",example = "")
    private BigDecimal tlsl;

    @ApiModelProperty(value = "工单投入物料主键",example = "")
    private Long psMfeedoid;

    @ApiModelProperty(value = "工单产出物料关联外键", example = "")
    private Long psWboutFk;

    @ApiModelProperty(value = "工单产出物料关联外键", example = "")
    private Long psMout;

    @ApiModelProperty(value = "生产工单外键",example = "")
    private Long psWbFk;

    @ApiModelProperty(value = "批次控制",example = "",hidden = true)
    private Boolean phkz;

    @ApiModelProperty(value = "单件控制",example = "",hidden = true)
    private Boolean djgl;

    @ApiModelProperty(value = "序列号--冗余（前端不判断）",example = "",hidden = true)
    private String sn;

    @ApiModelProperty(value = "是否批次控制-冗余(前端不判断)",example = "",hidden = true)
    private Boolean batch;

    /**
     * 计量单位
     */
    @ApiModelProperty(example = "计量单位 吨", required = true, dataType = "string")
    @Size(max = 8, message = "计量单位最大长度为8个字节")
    private String jldw;

    /**
     * 图号
     */
    @ApiModelProperty(example = "图号 TH01", required = true, dataType = "string")
    @Size(max = 50, message = "图号最大长度为50个字节")
    private String tz;

    /**
     * 材质
     */
    @ApiModelProperty(example = "材料 CL01", required = true, dataType = "string")
    @Size(max = 30, message = "材质最大长度为30个字节")
    private String cl;
}
