package com.jln.ufc.web.action.ufc.ps.pojo.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotEmpty;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/2/24 14:55
 * Version:1.0
 **/
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel("生产工单实体类")
@TableName("ps_wb")
public class UfcPsWb {

    @ApiModelProperty(example = "工序号", hidden = true,dataType = "int")
    private String gxid;

    @ApiModelProperty(example = "工序名称", hidden = true,dataType = "String")
    private String gxmc;

    @ApiModelProperty(example = "合格数量", required = true,dataType = "string")
    private BigDecimal hgsl;

    @ApiModelProperty(example = "生产工单主键", hidden = true,dataType = "string")
    @TableId(value = "ps_wboid", type = IdType.INPUT)
    private Long psWboid;


    @NotEmpty(message = "订单序号不能为空")
    @ApiModelProperty(example = "订单序号", required = true,dataType = "int")
    private Integer woxh;

    /**
     * 排程计划序号，对应排程计划分解明细，从1递增
     */
    @NotEmpty(message = "排程计划序号不能为空")
    @ApiModelProperty(example = "排程计划序号不能为空:对应排程计划分解明细，从1递增", required = true,dataType = "int")
    private Integer jhxh;


    @NotEmpty(message = "工单编号不能为空")
    @ApiModelProperty(example = "工单编号：按照工单编号的规则生成", required = true,dataType = "string")
    private String wbid;


    @NotEmpty(message = "工票号不能为空")
    @ApiModelProperty(example = "工票号:按照工票编号的规则生成", required = true,dataType = "string")
    private String gpid;


    @ApiModelProperty(example = "生成的二维维码位置", required = true,dataType = "string")
    private String ewm;

    @NotEmpty(message = "计划开工日期不能为空")
    @ApiModelProperty(example = "计划开工日期", required = true,dataType = "date")
    private LocalDate jhkgrq;

    @NotEmpty(message = "计划完工日期不能为空")
    @ApiModelProperty(example = "计划完工日期", required = true,dataType = "date")
    private LocalDate jhwgrq;


    @ApiModelProperty(example = "实际开工日期", required = true,dataType = "date")
    private LocalDate sjkgrq;


    @ApiModelProperty(example = "实际完工日期", required = true,dataType = "date")
    private LocalDate sjwgrq;


    @ApiModelProperty(example = "下达人id，外键关联用户表", hidden = true,dataType = "string")
    private Long xdrId;


    @ApiModelProperty(example = "下达日期", hidden = true,dataType = "date")
    private LocalDate xdrq;


    @ApiModelProperty(example = "关闭人外键，外键关联用户表", hidden = true,dataType = "string")
    private Long gbrId;


    @ApiModelProperty(example = "关闭日期", hidden = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDate gbrq;


    @ApiModelProperty(example = "关闭说明，500字节", required = true,dataType = "string")
    private String gbsm;


    @ApiModelProperty(example = "原状态：i|初始、f|确认、r|下达、s|暂停、c|完成", required = true,dataType = "string")
    private String yzt;


    @ApiModelProperty(example = "班次编码", required = true,dataType = "string")
    private String bcid;


    @ApiModelProperty(example = "班组编码", required = true,dataType = "string")
    private String bzid;


    @ApiModelProperty(example = "生产设备list:如有多个，用逗号隔开（设备表主键）", required = true,dataType = "string")
    private Long sblist;


    @ApiModelProperty(example = "人员list:如有多个，用逗号隔开(员工表主键)", required = true,dataType = "string")
    private Long rylist;


    @ApiModelProperty(example = "制令号", required = true,dataType = "string")
    private String zlh;

    @NotEmpty(message = "排产数量不能为空")
    @ApiModelProperty(example = "排产数量", required = true,dataType = "string")
    private BigDecimal pcsl;

    @ApiModelProperty(example = "回用数量", required = true,dataType = "string")
    private BigDecimal hysl;


    @ApiModelProperty(example = "返工数量", required = true,dataType = "string")
    private BigDecimal fgsl;


    @ApiModelProperty(example = "废品数量", required = true,dataType = "string")
    private BigDecimal fpsl;


    @ApiModelProperty(example = "料废数量", required = true,dataType = "string")
    private BigDecimal lfsl;


    @ApiModelProperty(example = "入库单数量", required = true,dataType = "string")
    private BigDecimal rkdsl;


    @ApiModelProperty(example = "入库数量", required = true,dataType = "string")
    private BigDecimal rksl;


    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;


    @ApiModelProperty(example = "状态：i|初始、f|确认、r|下达、s|暂停、c|完成", required = true,dataType = "string")
    private String zt;


    @ApiModelProperty(example = "创建人", hidden = true,dataType = "string")
    private Long sysCreatedBy;


    @ApiModelProperty(example = "创建日期", hidden = true,dataType = "string")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "生产订单排程外键", required = true,dataType = "string")
    private Long psWsFk;


    @ApiModelProperty(example = "工位外键", required = true,dataType = "string")
    private Long bWorkstationFk;


    @ApiModelProperty(example = "标准工序外键", required = true,dataType = "string")
    private Long bStandardprocessFk;


    @ApiModelProperty(example = "产品工序外键", required = true,dataType = "string")
    private Long bProductprocessFk;

    @ApiModelProperty(example = "生产订单工艺路线外键", required = true,dataType = "string")
    private Long wogylxFk;

    @ApiModelProperty(example = "物料外键", required = true,dataType = "string")
    private Long bMaterialFk;

    @ApiModelProperty(example = "工段外键，排产到工段是必须有值", required = true,dataType = "string")
    private Long bWorksectionFk;

    @TableLogic
    @ApiModelProperty(example = "是否删除：0.未删除1.已删除（后端控制）", hidden = true,dataType = "string")
    private Integer del;

    @ApiModelProperty(example = "工厂外键", hidden = true,dataType = "string")
    private Long bFactoryFk;

    @ApiModelProperty(example = "车间外键", hidden = true,dataType = "string")
    private Long bWorkshopFk;

    @ApiModelProperty(example = "生产线外键", hidden = true,dataType = "string")
    private Long bWorklineFk;

    @ApiModelProperty(example = "生产订单外键", hidden = true,dataType = "string")
    private Long woFk;

    @ApiModelProperty(example = "工单工艺路线外键", hidden = true,dataType = "String")
    private Long psGylxFk;

    @ApiModelProperty(example = "流程卡外键", hidden = true,dataType = "String")
    private Long processCardFk;

    @ApiModelProperty(example = "生产节点记录外键", hidden = true,dataType = "String")
    private Long psTechnologicalProcessFk;

    @ApiModelProperty(example = "开工人外键", hidden = true,dataType = "String")
    private Long kgrId;

    @ApiModelProperty(example = "开工人", hidden = true,dataType = "String")
    private Long completionPeopleFk;

    @ApiModelProperty(value = "是否关键工序")
    private Boolean sfgj;

    @ApiModelProperty(value = "是否需要首检")
    private Boolean sfsj;

    @ApiModelProperty(value = "是否需要专检")
    private Boolean sfzl;

    @ApiModelProperty(value = "是否单件管理")
    private Boolean sfdl;

    @ApiModelProperty(value = "允许生成单件")
    private Boolean sfscdj;

    @ApiModelProperty(value = "排序")
    private Integer sort;
}
