package com.jln.ufc.web.action.ufc.ps.pojo.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.jln.common.constant.LocalDateTimeConst;
import com.jln.common.entity.PswlsxInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @ClassName:  定制工单详情返回对象:在有的基础上增加工序名称，工序编码
 * @Description:
 * @Author:三刀 Date:2022/1/17 21:54
 * Version:1.0
 **/
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@ApiModel("工单排程（生产工单）")
public class UfcPsWsList  extends PswlsxInfo {

    @ApiModelProperty(example = "源单号")
    private String ydid;

    @ApiModelProperty(example = "行号")
    private String ydhh;

    @ApiModelProperty(example = "执行标准")
    private String zxbz;

    @ApiModelProperty(example = "订单金额")
    private BigDecimal ddje;

    @ApiModelProperty(example = "需求数量")
    private BigDecimal erpXqsl;

    @ApiModelProperty(example = "合同号")
    private String hth;

    @ApiModelProperty(example = "创建时间")
    private LocalDateTime createDate;
    @ApiModelProperty(example = "单据头.单据日期")
    private LocalDateTime djtDjrq;
    @ApiModelProperty(example = "单据头.审核人")
    private Integer djtShr;
    @ApiModelProperty(example = "单据头.审核人名称")
    private String djtShrMc;
    @ApiModelProperty(example = "单据头.审核日期")
    private LocalDateTime djtShrq;
    @ApiModelProperty(example = "单据头.客户名称")
    private String djtKhmc;
    @ApiModelProperty(example = "明细.辅助属性名称（质量等级）")
    private String mxFzsxmcZldj;
    @ApiModelProperty(example = "明细.辅助属性名称（精度）")
    private String mxFzsxmcJd;
    @ApiModelProperty(example = "明细.温度系数组别")
    private String mxWdxszb;
    @ApiModelProperty(example = "明细.合同号")
    private String mxHth;
    @ApiModelProperty(example = "军检类型名称")
    private String mxJjmc;
    @ApiModelProperty(example = "明细.是否下场验收")
    private String mxSfxcys;
    @ApiModelProperty(example = "明细.HM执行标准编码")
    private String mxHnzxbzId;
    @ApiModelProperty(example = "明细.HM项目编码")
    private String mxHmxmbmId;
    @ApiModelProperty(example = "Erp计划数量")
    private BigDecimal erpjh;
    @ApiModelProperty(example = "erp工艺路线编码")
    private String cpgyCode;

    @ApiModelProperty(example = "主键")
    private Long psWsoid;
    @ApiModelProperty(example = "c|产品，l|零星")
    private String lx;

    @ApiModelProperty(example = "工单排程到人员")
    private Boolean gdsfry;

    @ApiModelProperty(example = "工单排程到设备")
    private Boolean gdsfsb;

    @ApiModelProperty(example = "排程程度：cx|排程至产线gd|排程至工段 gw|排程至工位")
    private String pccd;

    @ApiModelProperty(example = "订单序号:对应订单排产次数，从1递增")
    private Integer woxh;

    @ApiModelProperty(example = "排程计划号")
    private String jhid;

    @ApiModelProperty(example = "制订计划日期")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime jhrq;

    @ApiModelProperty(example = "计划开工日期")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate jhkgrq;

    @ApiModelProperty(example = "计划完工日期")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate jhwgrq;

    @ApiModelProperty(example = "制令号")
    private String zlh;

    @ApiModelProperty(example = "排产数量")
    private BigDecimal pcsl;

    @ApiModelProperty(example = "合格数量")
    private BigDecimal hgsl;

    @ApiModelProperty(example = "备注")
    private String bz;

    @ApiModelProperty(example = "状态：i|初始、f|确认、r|下达、s|暂停、c|完成")
    private String zt;

    @ApiModelProperty(example = "最后修改人oid")
    private String whr;

    @ApiModelProperty(example = "维护时间")
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "班组")
    private String bzid;

    @ApiModelProperty(example = "班次")
    private String bcid;

    @ApiModelProperty(example = "班次名称")
    private String bcmc;

    @ApiModelProperty(example = "生产订单号")
    private String woid;

    @ApiModelProperty(example = "物料编码")
    private String wlid;

    @ApiModelProperty(example = "物料名称")
    private String mc;

    @ApiModelProperty(example = "规格型号")
    private String gg;

    @ApiModelProperty(example = "图号")
    private String tz;

    @ApiModelProperty(example = "材质")
    private String cl;

    @ApiModelProperty(example = "计量单位")
    private String jldw;

    @ApiModelProperty(example = "工厂编号")
    private String gcid;

    @ApiModelProperty(example = "工厂名称")
    private String gcmc;

    @ApiModelProperty(example = "车间部门编号")
    private String cjid;

    @ApiModelProperty(example = "车间部门名称")
    private String cjmc;

    @ApiModelProperty(example = "生产线编号")
    private String scxid;

    @ApiModelProperty(example = "生产线名称")
    private String scxmc;

    @ApiModelProperty(example = "人员编码")
    private String codeing;

    @ApiModelProperty(example = "人员工号")
    private String jobNumber;

    @ApiModelProperty(example = "人员名称")
    private String employeeName;

    @ApiModelProperty(value = "工段名称")
    private String gdmc;

    @ApiModelProperty(value = "工段编码")
    private String gdcode;


    @ApiModelProperty(value = "工位名称")
    private String gwmc;

    @ApiModelProperty(value = "工位编码")
    private String gwcode;

    @ApiModelProperty(value = "订单数量")
    private BigDecimal xqsl;

    /**
     * 工段外键
     */
    private Long bWorksectionFk;

    /**
     * 工位外键
     */
    private Long bWorkstationFk;

    /**
     * 生产线外建
     */
    private Long bProductionlineFk;

    @ApiModelProperty(example = "产线人员编码", required = true,dataType = "string")
    private String cxryid;

    @ApiModelProperty(example = "产线人员名称", required = true,dataType = "string")
    private String cxrymc;

    @ApiModelProperty(example = "产线人员工号", required = true,dataType = "string")
    private String cxrygh;

    @ApiModelProperty(example = "工位机ID", required = true,dataType = "string")
    private String gwjid;

    @ApiModelProperty(example = "作业流程卡号", required = true,dataType = "string")
    private String processId;

    @ApiModelProperty(example = "前置流程卡号", required = true,dataType = "string")
    private String beforeProcess;

    @ApiModelProperty(example = "下达日期")
    private LocalDate xdrq;

    @ApiModelProperty(example = "下达人")
    private String xdrName;

    @ApiModelProperty(example = "张三",value="入库单数量", required = false,dataType = "Long")
    private BigDecimal rkdsl;

    @ApiModelProperty(example = "张三",value="入库数量", required = false,dataType = "Long")
    private BigDecimal rksl;

    @ApiModelProperty(example = "张三",value="已完成数量", required = false,dataType = "Long")
    private Integer ywcsl;

    @ApiModelProperty(example = "张三",value="已完成数量", required = false,dataType = "Long")
    private BigDecimal wwcsl;

    /**
     * 工厂外键
     */
    @ApiModelProperty(value = "工厂外键")
    private Long bFactoryFk;

    @ApiModelProperty(value = "物料外键")
    private Long bMaterialFk;
    /**
     * 物料属性用-物料主键
     */
    @ApiModelProperty(value = "物料属性用-物料主键", example = "000000", hidden = true)
    @JsonProperty("bMaterialoid")
    private Long bMaterialoid;

    @ApiModelProperty(value = "紧急程度等级编码")
    private String udid;

    @ApiModelProperty(value = "紧急程度等级外键")
    private Long budFk;

    @ApiModelProperty(value = "紧急程度等级说明")
    private String udmc;
    @ApiModelProperty(value = "排序号")
    private Integer sortNumber;
    @ApiModelProperty(value = "生产批号")
    private String productionBatch;

    //----2021.10.27.生产投料专项控制增加值---------

    @ApiModelProperty(value = "投料控制方式：1|生产订单投料控制、2|作业计划投料控制、3|作业工序投料控制、4|投料不控制")
    private String releaseControlType;

    @ApiModelProperty(value = "投料方式控制:1|直接投料、2|扫码投料、3|线边仓投料")
    private String feedingControlMode;

    /**
     * 投料控制转换为JSON之后的值
     */
    private List<String> feedingControlModeList;
    //----2021.10.27.生产投料专项控制增加值---------

    @ApiModelProperty(value = "订单主键")
    private Long wooid;

    /**
     * 当前执行工序：下达状态和完成状态的才可能存在，其余状态理论上是不会存在的
     */
    @ApiModelProperty(value = "当前执行工序")
    private String currentExecutionProcedure;

    /**
     * 当前执行工序：下达状态和完成状态的才可能存在，其余状态理论上是不会存在的
     */
    @ApiModelProperty(value = "完成工序")
    private String completedProcess;

    @ApiModelProperty(value = "明细.阶段（技术状态）")
    private String mxJd;
    @ApiModelProperty(value = "质量等级名称")
    private String mxZldjMc;
    @ApiModelProperty(value = "精度名称")
    private String mxJdMc;
    @ApiModelProperty(value = "温度系数组别名称")
    private String mxWdxsMc;
    @ApiModelProperty(value = "执行标准名称")
    private String mxZxbzMc;

    @ApiModelProperty(value = "明细.客户物料名称")
    private String mxKhwlmc;

    @ApiModelProperty(value = "不合格数量")
    private BigDecimal bhgsl;

    @ApiModelProperty(value = "调度状态：A|已调度、B|未调度、C|部分调度")
    private String dispatchStatus;

    @ApiModelProperty(value = "明细.销售订单要货日期")
    private LocalDateTime mxXsddyhrq;

    @ApiModelProperty(value = "明细.ID号")
    private String mxId;
    @ApiModelProperty(value = "订单类型")
    private String orderType;
}
