package com.jln.ufc.web.action.ufc.ps.pojo.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;

/**
 * @author: Luca.Liu
 * @date: 2022/3/18
 */
@Data
public class UfcPsWsVo {

    /**
     * 工单排程到人员
     */
    @ApiModelProperty(example = "工单排程到人员")
    private Boolean gdsfry;

    /**
     * 工单排程到设备

     */
    @ApiModelProperty(example = "工单排程到设备")
    private Boolean gdsfsb;

    /**
     * 排程程度：cx|排程至产线gd|排程至工段
     gw|排程至工位

     */
    @ApiModelProperty(example = "排程至工位", required = true,dataType = "string")
    private String pccd;


    /**
     * 计划开工日期
     */
    @ApiModelProperty(example = "计划开工日期", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jhkgrq;

    /**
     * 计划完工日期
     */
    @ApiModelProperty(example = "计划完工日期", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jhwgrq;



    /**
     * 排产数量
     */
    @ApiModelProperty(example = "排产数量", required = true)
    private BigDecimal pcsl;

    /**
     * 生产订单外键
     */
    @ApiModelProperty(example = "生产订单外键", required = true,dataType = "string")
    private Long woFk;
    /**
     * 紧急程度外键
     */
    @ApiModelProperty(example = "紧急程度外键", required = true)
    private Long budFk;
    /**
     * 排序号
     */
    @ApiModelProperty(example = "排序号", required = true)
    private Integer sortNumber;
    @ApiModelProperty(example = "紧急程度编码", required = true)
    private String udid;

    /**
     * 排产到具体外键，根据排产程度状态确定当前字段是那张表的外键
     */
    @ApiModelProperty(example = "排产到具体外键", required = true,dataType = "string")
    private Long prodScheFk;

    /**
     * 物料外键
     */
    @ApiModelProperty(example = "物料外键", required = true,dataType = "Long")
    private Long bMaterialFk;

    /**
     * 工段外键
     */
    @ApiModelProperty(example = "工段外键", dataType = "string")
    private Long bWorksectionFk;
    /**
     * 车间外键
     */
    @ApiModelProperty(example = "车间外键", dataType = "Long")
    private Long bWorkshopFk;


    /**
     * 工厂外键
     */
    @ApiModelProperty(example = "工厂外键", required = true,dataType = "Long")
    private Long bFactoryFk;

    /**
     * 工位外键
     */
    @ApiModelProperty(example = "工位外键",dataType = "Long")
    private Long bWorkstationFk;

    /**
     * 生产线外建
     */
    @ApiModelProperty(example = "生产线外建", required = true,dataType = "Long")
    private Long bProductionlineFk;

    @ApiModelProperty(example = "备注类型", required = true,dataType = "String")
    private String bzlx;
    
}
