package com.jln.ufc.web.action.ufc.ps.pojo.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 生产工单工艺路线
 * </p>
 *
 * @author 
 * @since 2021-06-10
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="Psgylx对象", description="生产工单工艺路线")
@TableName("psgylx")
public class UfcPsgylx extends Model<UfcPsgylx> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "生产工单工艺路线主键----由生产订单工艺路线复制过来")
    @TableId
    private Long psGylxOid;

    @ApiModelProperty(value = "生产计划外键")
    private Long psWsFk;

    @ApiModelProperty(value = "标准工序编码")
    private String bzgxid;

    @ApiModelProperty(value = "标准工序名称")
    private String bzgxmc;

    @ApiModelProperty(value = "设备数")
    private Integer sbs;

    @ApiModelProperty(value = "人数")
    private Integer rs;

    @ApiModelProperty(value = "准备时间")
    private Float zbsj;

    @ApiModelProperty(value = "排队时间")
    private Float pdsj;

    @ApiModelProperty(value = "加工时间")
    private Float jgsj;

    @ApiModelProperty(value = "等待时间")
    private Float ddsj;

    @ApiModelProperty(value = "关键工序")
    private Integer gjgx;

    @ApiModelProperty(value = "上料")
    private Integer slgx;

    @ApiModelProperty(value = "下料")
    private Integer xlgx;

    @ApiModelProperty(value = "测试")
    private Integer csgx;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "维护时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "维护人")
    private Long sysLastUpdBy;

    @TableLogic
    private Boolean del;

    @ApiModelProperty(value = "转移时间")
    private Float zysj;

    @ApiModelProperty(value = "是否校验工序")
    private Boolean sfjygx;

    @ApiModelProperty(value = "是否允许入库")
    private Boolean sfyxrk;

    @ApiModelProperty(value = "默认入库仓库")
    private String mrrkck;

    @TableField(exist = false)
    @ApiModelProperty(value = "默认入库仓库名称")
    private String ckmc;

    @ApiModelProperty(value = "是否允许自动接收")
    private Boolean sfyxzdjs;

    @ApiModelProperty(value = "是否允许拆分流程卡")
    private Boolean sfyxcslck;

    @ApiModelProperty(value = "是否允许变更产品")
    private Boolean sfyxbgcp;

    @ApiModelProperty(value = "是否进行数量校验")
    private Boolean sfjxsljy;

    @ApiModelProperty(value = "工单工序节点主键")
    private Long technologicalProcessFk;

    @ApiModelProperty(value = "流转方式   A|流转节点内所有工序、S|流转节点内某一道工序")
    private String lzfs;

    @ApiModelProperty(value = "标准产量3位小数")
    private BigDecimal bzcl;

    @ApiModelProperty(value = "标准工时")
    private BigDecimal bzgs;

    @ApiModelProperty(value = "标准人数")
    private Integer bzrs;

    @ApiModelProperty(value = "作业方式 PC、PDA、DCT")
    private String zyfs;

    @ApiModelProperty(value = "采集内容 PD|产能、PD|产能和缺陷")
    private String cjnr;

    @ApiModelProperty(value = "是否批次上料 1是 0不是")
    private Boolean isPcsl;

    @ApiModelProperty(value = "是否经过本工序")
    private Boolean jgbgx;

    @ApiModelProperty(value = "关键物料校验")
    private Boolean gjwljy;

    @ApiModelProperty(value = "合格率预警")
    private Boolean hglyj;

    @ApiModelProperty(value = "合格率预警阀值 百分比")
    private BigDecimal hglyjfz;

    @ApiModelProperty(value = "工序号")
    private String gxid;

    @ApiModelProperty(value = "状态")
    private String zt;

    @ApiModelProperty(value = "工序类型")
    private String gxlx;

    @ApiModelProperty(value = "生产线外键")
    private Long bProductionlineFk;

    @ApiModelProperty(value = "工段外键")
    private Long bWorksectionFk;

    @ApiModelProperty(value = "工站外键")
    private Long bWorkstationFk;

    @ApiModelProperty(value = "排产优先级")
    private BigDecimal pcyxj;

    @ApiModelProperty(value = "工位机编码")
    private String gwjid;

    @ApiModelProperty(value = "计划开工日期")
    private LocalDate jhkgrq;

    @ApiModelProperty(value = "计划完工日期")
    private LocalDate jhwgrq;

    @ApiModelProperty(value = "需求数量")
    private BigDecimal xqsl;

    @ApiModelProperty(value = "交接批量")
    private BigDecimal jjpl;

    @ApiModelProperty(value = "排产倍数")
    private BigDecimal pcbs;

    @ApiModelProperty(value = "转包工序")
    private Integer zbgx;

    @ApiModelProperty(value = "转包提前期")
    private BigDecimal zblt;

    @ApiModelProperty(value = "转包成本")
    private BigDecimal zbcb;

    @ApiModelProperty(value = "供应商外键")
    private Long bSupplierFk;

    @ApiModelProperty(value = "单件人工费用")
    private BigDecimal djrg;

    @ApiModelProperty(value = "单件人工工时(h)")
    private BigDecimal rgsj;

    @ApiModelProperty(value = "标准工艺路线")
    private Long bStandardprocessFk;

    @ApiModelProperty(value = "订单工艺路线")
    private Long wogylxFk;

    @ApiModelProperty(value = "排序]")
    private Integer sort;


    @Override
    protected Serializable pkVal() {
        return this.psGylxOid;
    }

}
