package com.jln.ufc.web.action.ufc.ps.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.entity.PermissionsOnTheEntity;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.utils.BMaterialValueJsonUtils;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.ufc.web.action.ufc.ps.mapper.UfcInspectionMapper;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsWt;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcQcBilldata;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcInspectionDto;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcQcSampleDto;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcInspectionSaveVo;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcInspectionVo;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcQcSampleStdVo;
import com.jln.ufc.web.action.ufc.ps.service.UfcInspectionService;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsWtService;
import com.jln.ufc.web.action.ufc.ps.service.UfcQcBilldataService;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcBill;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcSample;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcSampleStd;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcBillService;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcSampleService;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcSampleStdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

@Service
public class UfcInspectionServiceImpl implements UfcInspectionService {

    @Autowired
    private UfcInspectionMapper ufcInspectionMapper;
    @Autowired
    private UfcQcSampleService ufcQcSampleService;
    @Autowired
    private UfcQcSampleStdService ufcQcSampleStdService;
    @Autowired
    private UfcQcBillService ufcQcBillService;
    @Autowired
    private UfcQcBilldataService qcBilldataService;
    @Autowired
    private UfcPsWtService psWtService;
    @Override
    public Result getInspectionList(PageParameter<UfcInspectionDto> query, User user, PermissionsOnTheEntity permissionsOnTheEntity) {
        if(EmptyUtil.isEmpty(query.getData())){
            query.setData(new UfcInspectionDto());
        }
        query.getData().setThisRygh(user.getEmployeeCode());
        Page page = new Page(query.getPageNum(), query.getPageSize());
        page.setOptimizeCountSql(false);
        page.setSearchCount(false);
        Integer listCunt = ufcInspectionMapper.getInspectionListCunt(query.getData(), permissionsOnTheEntity);
        if(EmptyUtil.isEmpty(listCunt)||0==listCunt){
            return new Result().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        page.setTotal(listCunt);
        Page<UfcInspectionVo> inspectionList = ufcInspectionMapper.getInspectionList(page,query.getData(),permissionsOnTheEntity);
        if(0!=inspectionList.getRecords().size()){
            BMaterialValueJsonUtils jsonUtils=new BMaterialValueJsonUtils();
            for (UfcInspectionVo record : inspectionList.getRecords()) {
                Result<String> value = jsonUtils.getBMaterialValueJsonValue(record.getPcsxz());
                record.setPcsxz(value.getData());
            }

        }

        return new Result().toSuccess(inspectionList);
    }

    @Override
    public Result updateQcSampletionStdData(UfcInspectionSaveVo inspectionSaveVo, User user) {
        List<UfcQcSampleStd> qcSampleStdsList = new ArrayList<>();


        List<UfcQcSampleDto> qcSampleDtosList = inspectionSaveVo.getQcSampleDtosList();
        if(qcSampleDtosList != null || qcSampleDtosList.size()>0){
            qcSampleDtosList.forEach(g->{
                List<UfcQcSampleStdVo> qcSampleStdVoList = g.getQcSampleStdVoList();
                UfcQcSample qcSample = new UfcQcSample();
                qcSample.setQcSampleOid(g.getQcSampleOid());
                if(g.getSjsfhg()== false){
                    qcSample.setSjsfhg(g.getSjsfhg());
                    qcSample.setBhgyyid(g.getBhgyyid());
                    qcSample.setBhgyymc(g.getBhgyymc());
                }else {
                    qcSample.setSjsfhg(true);
                    qcSample.setBhgyyid("");
                    qcSample.setBhgyymc("");
                }
                ufcQcSampleService.updateById(qcSample);
                if(!EmptyUtil.isEmpty(qcSampleStdVoList)){
                    qcSampleStdVoList.forEach(t->{
                        UfcQcSampleStd qcSampleStd = new UfcQcSampleStd();
                        //判断是否可以新增
                        if(t.getQcSampleStdOid()== null || t.getQcSampleStdOid()== 0){
                            qcSampleStd.setQcSampleStdOid(SnowflakeIdUtils.generate());
                        }else {
                            qcSampleStd.setQcSampleStdOid(t.getQcSampleStdOid());
                        }
                        qcSampleStd.setJyxmid(t.getJyxmid());
                        qcSampleStd.setJyxmmc(t.getJyxmmc());
                        qcSampleStd.setQcItemFk(t.getQcItemFk());
                        qcSampleStd.setQcSampleFk(t.getQcSampleOid());
                        qcSampleStd.setSampleValue(t.getSampleValue());
                        qcSampleStd.setQcSampleFk(qcSample.getQcSampleOid());
                        qcSampleStdsList.add(qcSampleStd);
                    });
                }
            });
            if(!EmptyUtil.isEmpty(qcSampleStdsList)){
                ufcQcSampleStdService.saveOrUpdateBatch(qcSampleStdsList);
            }

        }
        //保存样本数据检验值


        Long qcbillfk = ufcInspectionMapper.getFk(inspectionSaveVo.getQcObjoid());
        //更新检验单

        Boolean sfhg = true;
        String bhgyy = "";

        if(!inspectionSaveVo.getHg()){
            sfhg=false;
            bhgyy=inspectionSaveVo.getBhgyy();
        }

        ufcQcBillService.update(new LambdaUpdateWrapper<UfcQcBill>()
                .set(UfcQcBill::getZt,"C")
                .set(UfcQcBill::getJyrFk,user.getEmployeeOid())
                .set(UfcQcBill::getHg,inspectionSaveVo.getHg())
                .set(UfcQcBill::getBhgyy,bhgyy).eq(UfcQcBill::getQcBilloid,qcbillfk));

        //更新送检单 JYR、JYRQ、ZT：检验完成后，状态改为“C|完成”。
        qcBilldataService.update(new LambdaUpdateWrapper<UfcQcBilldata>()
                .set(UfcQcBilldata::getZt,"C")
                .set(UfcQcBilldata::getJyr,user.getEmployeeName())
                .set(UfcQcBilldata::getJyrq, LocalDate.now()).eq(UfcQcBilldata::getQcBillFk,qcbillfk));

        //更新工票
        psWtService.update(new LambdaUpdateWrapper<UfcPsWt>()
                .set(UfcPsWt::getWcsjsj,LocalDate.now())
                /* .set(PsWt::getSjwc,true)
                 .set(PsWt::getSjyrgh,user.getCodeing())
                 .set(PsWt::getSjyrmc,user.getEmployeeName())*/
                .set(UfcPsWt::getSjhg,sfhg)
                .set(UfcPsWt::getSjbhgyyid,inspectionSaveVo.getBhgyyid())
                .set(UfcPsWt::getSjbhgyysm,inspectionSaveVo.getBhgyy())
                .eq(UfcPsWt::getPsWtoid,inspectionSaveVo.getPsWtoid()));



        return new Result().toSuccess();
    }


}
