package com.jln.ufc.web.action.ufc.ps.service.impl;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.ps.mapper.UfcPsWbrptMapper;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsWbrpt;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcWbRptJobAddDto;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcWbUpDto;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsWbrptService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author
 * @since 2020-02-23
 */
@Slf4j
@Service
public class UfcPsWbrptServiceImpl extends ServiceImpl<UfcPsWbrptMapper, UfcPsWbrpt> implements UfcPsWbrptService{

    @Override
    public Result<Page<UfcWbRptJobAddDto>> getWbRptJobAddDto(PageParameter<Long> parameter) {
        Page<UfcWbRptJobAddDto> addDto = this.baseMapper.getWbRptJobAddDto(new Page<>(parameter.getPageNum(), parameter.getPageSize()), parameter.getData());
        if(0!=addDto.getRecords().size()){
            for (UfcWbRptJobAddDto dto : addDto.getRecords()) {
                //处理不合格数据
                List<UfcWbUpDto> dtoList = this.baseMapper.getWbUpDtoList(dto.getPsWbrptoid());
                if(!EmptyUtil.isEmpty(dtoList)){
                    dtoList.forEach(d -> {
                        d.setWlInfo(dto.getWlInfo());
                    });
                    dto.setWbUpDtoList(dtoList);
                    dto.setQualified(true);
                }
            }
        }
        return new Result<Page<UfcWbRptJobAddDto>>().toSuccess(addDto);
    }

}
