package com.jln.ufc.web.action.ufc.ps.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.enums.WorkOderEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.pojo.FeedingTheDetailsVO;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.FeedingTheDetailsProcessingUtil;
import com.jln.common.utils.MyBaoBUtil;
import com.jln.common.utils.PageParameter;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.system.web.action.commonweb.parameterize.service.SysBusinessService;
import com.jln.system.web.action.sm.common.entity.CodeTable;
import com.jln.system.web.action.sm.common.service.CodeTableService;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBFactory;
import com.jln.ufc.web.action.ufc.bm.entity.UfcBStandardprocess;
import com.jln.ufc.web.action.ufc.bm.service.UfcBFactoryService;
import com.jln.ufc.web.action.ufc.bm.service.UfcBMaterialPropertyGroupService;
import com.jln.ufc.web.action.ufc.bm.service.UfcBStandardprocessService;
import com.jln.ufc.web.action.ufc.pp.mapper.UfcWoMapper;
import com.jln.ufc.web.action.ufc.pp.pojo.UfcWo;
import com.jln.ufc.web.action.ufc.pp.pojo.UfcWogylx;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcGdpcQueryVo;
import com.jln.ufc.web.action.ufc.pp.service.UfcWogylxService;
import com.jln.ufc.web.action.ufc.ps.mapper.UfcPsWbMapper;
import com.jln.ufc.web.action.ufc.ps.mapper.UfcPsWsMapper;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcBUd;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPpTechnologicalWogylx;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsProcessCard;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsTechnologicalProcess;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsWs;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWb;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWsList;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsgylx;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPswSVoData;
import com.jln.ufc.web.action.ufc.ps.service.UfcPpTechnologicalWogylxService;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsProcessCardService;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsTechnologicalProcessService;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsWsService;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsgylxService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2022/1/17 21:48
 * Version:1.0
 **/
@Service
public class UfcPsWsServiceImpl extends ServiceImpl<UfcPsWsMapper, UfcPsWs> implements UfcPsWsService {

    @Autowired
    private UfcPsWbMapper ufcPsWbMapper;

    @Autowired
    private UfcBMaterialPropertyGroupService bMaterialPropertyGroupService;
    
    @Autowired
    private UfcPsgylxService ufcPsgylxService;
    /**
     * 定制流程卡 数据层
     */
    @Autowired
    private UfcPsWsMapper ufcPsWsMapper;

    @Autowired
    private UfcWoMapper ufcWoMapper;

    @Autowired
    private SysBusinessService sysBusinessService;
    
    @Autowired
    private UfcPsWsService ufcPsWsService;

    @Autowired
    private CodeTableService codeTableService;
    
    @Autowired
    private UfcPsProcessCardService ufcPsProcessCardService;
    
    @Autowired
    private UfcWogylxService ufcWogylxService;
    
    @Autowired
    private UfcPpTechnologicalWogylxService ppTechnologicalWogylxService;
    
    @Autowired
    private UfcPsTechnologicalProcessService psTechnologicalProcessService;
    
    @Autowired
    private UfcBStandardprocessService bStandardprocessService;
    
    @Autowired
    private UfcBFactoryService ufcBFactoryService;
    
    @Value("${topPid}")
    private Long topPid;

    @Value("${closePid}")
    private Long closePid;
    
    /**
     * 排程计划-自动编码前缀
     */
    private static final String WS_CODE_PERFIX="wsCode";

    /**
     * 参数默认需要校验的状态：Y
     */
    private static final String DEFAULT_CALIBRATION="Y";

    /**
     * 参数名:生产订单维护时是否需要维护工艺路线号
     * 参数说明:
     *   控制生产订单维护时是否需要有工艺路线号。设为Y时：需要维护工艺路线号才能保存。设为N时，不需要维护工艺路线号就能保存。默认为Y。
     */
    private static final String PPK015="PPK015";

    @Override
    public Result<Page<UfcPsWsList>> getPsWsList(PageParameter<UfcGdpcQueryVo> page) {
        List<String> ztList=new ArrayList<>();
        switch (page.getData().getParamType()){
            case 1:
                ztList.add("F");
                ztList.add("I");
                break;
            case 2:
                ztList.add("F");
                ztList.add("R");
                ztList.add("S");
                ztList.add("B");
                ztList.add("K");
                break;
            case 3:
                ztList.add("C");
                ztList.add("R");
                break;
        }
        page.getData().setZtList(ztList);
        Page<UfcPsWsList> list = ufcPsWsMapper.getPsWsList(new Page<>(page.getPageNum(), page.getPageSize()), page.getData());
        if (list.getRecords().size() > 0){
            bMaterialPropertyGroupService.packedAbsorber(list);
            //处理投料控制参数
            for (UfcPsWsList record : list.getRecords()) {

                //1.第一步 查询出当前作业计划工序清单有哪些工序数据
                LambdaQueryWrapper<UfcPsgylx> wrapper = new LambdaQueryWrapper<>();
                wrapper.select(UfcPsgylx::getPsGylxOid,UfcPsgylx::getBzgxid,UfcPsgylx::getBzgxmc);
                wrapper.eq(UfcPsgylx::getPsWsFk,record.getPsWsoid());
                List<UfcPsgylx> ufcPsgylxes = ufcPsgylxService.getBaseMapper().selectList(wrapper);

                //2.第二步 查询出当前作业计划工序已经生成了订单数据
                Map<Long, UfcPsgylx> map = ufcPsgylxes.stream().collect(Collectors.toMap(UfcPsgylx::getPsGylxOid, psgylx -> psgylx, (key1, key2) -> key1));
                LambdaQueryWrapper<UfcPsWb> queryWrapper=new LambdaQueryWrapper<>();
                queryWrapper.select(UfcPsWb::getPsWboid,UfcPsWb::getPsGylxFk,UfcPsWb::getGxid,UfcPsWb::getGxmc);
                queryWrapper.eq(UfcPsWb::getPsWsFk,record.getPsWsoid());
                List<UfcPsWb> psWbs = ufcPsWbMapper.selectList(queryWrapper);
                if(EmptyUtil.isEmpty(psWbs)){
                    //还没没有调度
                    record.setDispatchStatus("B");
                    //TO-DO 处理未调度生成的工序信息数据
                }
                for (UfcPsWb psWb : psWbs) {
                    Long key = psWb.getPsGylxFk();
                    map.remove(key);
                }
                if(EmptyUtil.isEmpty(map) || map.size() == psWbs.size()){
                    //已调度完成
                    record.setDispatchStatus("A");
                }
                if(EmptyUtil.isEmpty(record.getDispatchStatus())){
                    //部分调度：
                    record.setDispatchStatus("C");
                }

                //查询订单合格数量和不合格数量
//                Map<String,BigDecimal> count = ufcWoMapper.selectWoHgsl(record.getWooid(), true);
//                if(!EmptyUtil.isEmpty(count)){
//                    record.setHgsl(count.get("hgsl")==null ? new BigDecimal(0) : count.get("hgsl"));
//                    record.setBhgsl(count.get("bhgsl") == null ? new BigDecimal(0) : count.get("bhgsl"));
//                }
                //查询流程卡最后一道工序合格数量
                BigDecimal hgsl = ufcWoMapper.selectHgsl(record.getPsWsoid());
                record.setHgsl(hgsl);
                BigDecimal bhgsl = ufcWoMapper.seletBhgsl(record.getPsWsoid());
                record.setBhgsl(bhgsl);

                FeedingTheDetailsVO detailsVO = FeedingTheDetailsProcessingUtil.processingData(record.getFeedingControlMode());
                record.setFeedingControlModeList(detailsVO.getFeedingControlModeList());
                record.setFeedingControlMode(detailsVO.getFeedingControlMode());
                if(WorkOderEnum.ISSUED.getValue().equals(record.getZt())){
                    //为下达状态的时候，查询当前流程卡正在执行的工序数据
                    Result<String> procedure = this.getCurrentExecutionProcedure(record.getPsWsoid(),WorkOderEnum.ISSUED,false);
                    if(procedure.confirmSuccess()){
                        record.setCurrentExecutionProcedure(procedure.getData());
                    }
                    //为下达状态的时候，查询当前流程卡已完成在的工序数据
                    Result<String> executionProcedure = this.getCurrentExecutionProcedure(record.getPsWsoid(),WorkOderEnum.COMPLETE,true);
                    //查询出合格数量出来
                    if(executionProcedure.confirmSuccess()){
                        record.setCompletedProcess(executionProcedure.getData());
                    }
                }
            }
        }
        return new Result<Page<UfcPsWsList>>().toSuccess().setData(list);
    }

    @Override
    public Result<Page<UfcPsWsList>> getPsWsLists(PageParameter<UfcGdpcQueryVo> page) {
        List<String> ztList=new ArrayList<>();
        switch (page.getData().getParamType()){
            case 1:
                ztList.add("F");
                ztList.add("I");
                break;
            case 2:
                ztList.add("F");
                ztList.add("R");
                ztList.add("S");
                ztList.add("B");
                ztList.add("K");
                break;
            case 3:
                ztList.add("C");
//                ztList.add("R");
                break;
        }
        page.getData().setZtList(ztList);
        Page<UfcPsWsList> list = ufcPsWsMapper.getPsWsList(new Page<>(page.getPageNum(), page.getPageSize()), page.getData());
        if (list.getRecords().size() > 0){
            bMaterialPropertyGroupService.packedAbsorber(list);
            //处理投料控制参数
            for (UfcPsWsList record : list.getRecords()) {

                //1.第一步 查询出当前作业计划工序清单有哪些工序数据
                LambdaQueryWrapper<UfcPsgylx> wrapper = new LambdaQueryWrapper<>();
                wrapper.select(UfcPsgylx::getPsGylxOid,UfcPsgylx::getBzgxid,UfcPsgylx::getBzgxmc);
                wrapper.eq(UfcPsgylx::getPsWsFk,record.getPsWsoid());
                List<UfcPsgylx> ufcPsgylxes = ufcPsgylxService.getBaseMapper().selectList(wrapper);

                //2.第二步 查询出当前作业计划工序已经生成了订单数据
                Map<Long, UfcPsgylx> map = ufcPsgylxes.stream().collect(Collectors.toMap(UfcPsgylx::getPsGylxOid, psgylx -> psgylx, (key1, key2) -> key1));
                LambdaQueryWrapper<UfcPsWb> queryWrapper=new LambdaQueryWrapper<>();
                queryWrapper.select(UfcPsWb::getPsWboid,UfcPsWb::getPsGylxFk,UfcPsWb::getGxid,UfcPsWb::getGxmc);
                queryWrapper.eq(UfcPsWb::getPsWsFk,record.getPsWsoid());
                List<UfcPsWb> psWbs = ufcPsWbMapper.selectList(queryWrapper);
                if(EmptyUtil.isEmpty(psWbs)){
                    //还没没有调度
                    record.setDispatchStatus("B");
                    //TO-DO 处理未调度生成的工序信息数据
                }
                for (UfcPsWb psWb : psWbs) {
                    Long key = psWb.getPsGylxFk();
                    map.remove(key);
                }
                if(EmptyUtil.isEmpty(map) || map.size() == psWbs.size()){
                    //已调度完成
                    record.setDispatchStatus("A");
                }
                if(EmptyUtil.isEmpty(record.getDispatchStatus())){
                    //部分调度：
                    record.setDispatchStatus("C");
                }

                //查询订单合格数量和不合格数量
                Map<String,BigDecimal> count = ufcWoMapper.selectWoHgsl(record.getWooid(),true);
                if(!EmptyUtil.isEmpty(count)){
                    record.setHgsl(count.get("hgsl")==null ? new BigDecimal(0) : count.get("hgsl"));
                    record.setBhgsl(count.get("bhgsl") == null ? new BigDecimal(0) : count.get("bhgsl"));
                }

                FeedingTheDetailsVO detailsVO = FeedingTheDetailsProcessingUtil.processingData(record.getFeedingControlMode());
                record.setFeedingControlModeList(detailsVO.getFeedingControlModeList());
                record.setFeedingControlMode(detailsVO.getFeedingControlMode());
                if(WorkOderEnum.ISSUED.getValue().equals(record.getZt())){
                    //为下达状态的时候，查询当前流程卡正在执行的工序数据
                    Result<String> procedure = this.getCurrentExecutionProcedure(record.getPsWsoid(),WorkOderEnum.ISSUED,false);
                    if(procedure.confirmSuccess()){
                        record.setCurrentExecutionProcedure(procedure.getData());
                    }
                    //为下达状态的时候，查询当前流程卡已完成在的工序数据
                    Result<String> executionProcedure = this.getCurrentExecutionProcedure(record.getPsWsoid(),WorkOderEnum.COMPLETE,true);
                    //查询出合格数量出来
                    if(executionProcedure.confirmSuccess()){
                        record.setCompletedProcess(executionProcedure.getData());
                    }
                }
            }
        }
        return new Result<Page<UfcPsWsList>>().toSuccess().setData(list);
    }

    /**
     * 生产订单排程接口——生产订单排程详情查看 默认查询oid
     *
     * @param pswsoid
     * @return
     */
    @Override
    public Result getpswslistoid(Long pswsoid) {
        if (EmptyUtil.isEmpty(pswsoid)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        UfcPsWsList psWsList = ufcPsWsMapper.getpswslistoid(pswsoid);
        if (EmptyUtil.isEmpty(psWsList)){
            return new Result().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        bMaterialPropertyGroupService.packedAbsorber(psWsList);
        //处理投料控制参数
        FeedingTheDetailsVO detailsVO = FeedingTheDetailsProcessingUtil.processingData(psWsList.getFeedingControlMode());
        psWsList.setFeedingControlModeList(detailsVO.getFeedingControlModeList());
        psWsList.setFeedingControlMode(detailsVO.getFeedingControlMode());
        //报表存储
        List<UfcPsWsList> lists = new ArrayList<>();
        lists.add(psWsList);
        MyBaoBUtil.map.put("PS0402-1",lists);
        MyBaoBUtil.map.put("PS0201-1",lists);
        MyBaoBUtil.map.put("PS0401-1",lists);
        return new Result().toSuccess(psWsList);

    }

    @Override
    public Result<String> getCurrentExecutionProcedure(Long psWsFk,WorkOderEnum workOderEnum,Boolean complete) {
        List<UfcPsWb> psWbs = this.ufcPsWbMapper.getUfcPsWbList(psWsFk,workOderEnum.getValue());
        if(EmptyUtil.isEmpty(psWbs)){
            //不存在数据，直接返回
            return new Result<>().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        StringBuffer buffer=new StringBuffer();
        for (UfcPsWb psWb : psWbs) {
            if(!EmptyUtil.isEmpty(psWb.getGxid())){
                buffer.append(psWb.getGxid());
                buffer.append("|");
            }
            if(!EmptyUtil.isEmpty(psWb.getGxmc())){
                buffer.append(psWb.getGxmc());
            }
            if(complete){
                BigDecimal fkVO = this.ufcPsWbMapper.getGxFkVO(psWb.getPsWboid());
                if(!EmptyUtil.isEmpty(fkVO)){
                    buffer.append("|");
                    buffer.append(fkVO);
                }else {
                    buffer.append("|");
                    buffer.append(0);
                }
            }
            buffer.append(",");
        }
        buffer.deleteCharAt(buffer.length()-1);
        return new Result<String>().toSuccess(buffer.toString());
    }

    @Override
    public Result getCpph(Long pswboid) {
        String cpph = null;
        try{
            cpph = ufcPsWsMapper.getCpph(pswboid);
        }catch (Exception e){
            throw new CustomException(-1, "查询产品批号失败");
        }
        return new Result().setData(cpph);
    }

    
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result addpswsLj(UfcPswSVoData pswSVoData, User user) {
        if (EmptyUtil.isEmpty(pswSVoData) || EmptyUtil.isEmpty(user)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        if(EmptyUtil.isEmpty(pswSVoData.getPsWsVo().getProdScheFk())){
            return new Result().toFailure("请维护排程到具体程度的生产线或工段或工位!");
        }
        if(EmptyUtil.isEmpty(pswSVoData.getPsWsVo().getJhwgrq())){
            return new Result().toFailure("请输入计划完工日期数据!");
        }
        //判断生产批号是否重复
        boolean the = determineThe(pswSVoData.getProductionBatchList());
        if(the){
            return new Result().toFailure("生产批号重复，请重新输入!");
        }
        UfcWo wo = ufcWoMapper.selectOne(new LambdaQueryWrapper<UfcWo>().eq(UfcWo::getWooid, pswSVoData.getWooid()));

        BigDecimal xqsl = wo.getXqsl();
        wo.setYpcsl(pswSVoData.getYpcsl().add(pswSVoData.getBcpcsl()));
        verifyone("PSK003",pswSVoData.getYpcsl(),pswSVoData.getBcpcsl(),wo.getXqsl());
        /*BigDecimal add = pswSVoData.getBcpcsl().add(pswSVoData.getYpcsl());
        BigDecimal subtract = xqsl.subtract(add);
        int j = subtract.compareTo(BigDecimal.ZERO);
        if (j < 0) {
            return new Result().toFailure(ResultCodeEnum.PSERROR11064);
        }*/
        wo.getYpcsl().add(pswSVoData.getBcpcsl());
        List<UfcPsWs> newPsWs = new ArrayList();
        Integer woxh = getWoxh(pswSVoData.getWooid());
        Integer code = getJhpch(pswSVoData.getWooid());
        //System.out.print("工单号" + code);

        //单个订单数量为空时 默认为 本次排产数量
        if (EmptyUtil.isEmpty(pswSVoData.getNoteNumber())) {
            pswSVoData.setNoteNumber(pswSVoData.getBcpcsl());
        }
        Integer index=0;
        //剩余本次排产数量大于0
        while (pswSVoData.getBcpcsl().intValue() > 0){

            List<String> productionBatchList = pswSVoData.getProductionBatchList();
            if(productionBatchList.isEmpty()){
                return new Result().toFailure("没有传入生产批次号");
            }

            //本次排产数量
            BigDecimal bcpc = new BigDecimal(0);
            if((pswSVoData.getBcpcsl().intValue() - pswSVoData.getNoteNumber().intValue()) > 0){
                bcpc =  pswSVoData.getNoteNumber();
            }else{
                bcpc =  pswSVoData.getBcpcsl();
            }

            woxh++;
            code++;
            
            Long bFactoryFk = pswSVoData.getPsWsVo().getBFactoryFk();
            UfcBFactory bFactory = ufcBFactoryService.getById(bFactoryFk);
            String yyyyMMdd = null;
            // 判断是否为三分厂 编码:100017
            if ("100017".equals(bFactory.getGcid())) {
                yyyyMMdd = getCode();
            } else {
                yyyyMMdd = codeTableService.getCodeing(WS_CODE_PERFIX,false).getData();
            }
            List<UfcPsWs> ufcPsWsList = this.list(new LambdaQueryWrapper<UfcPsWs>()
                                                .eq(UfcPsWs::getJhid, yyyyMMdd)
                                                .eq(UfcPsWs::getDel, 0));
            if (!EmptyUtil.isEmpty(ufcPsWsList)) {
                return new Result().toFailure("排程计划号重复!!");
            }
            UfcPsWs pswsnew = new UfcPsWs();
            BeanUtils.copyProperties(pswSVoData.getPsWsVo(), pswsnew);
            pswsnew.setPcsl(bcpc);//
            pswsnew.setZlh(pswSVoData.getZlh());
            pswsnew.setPsWsoid(SnowflakeIdUtils.generate());//UUID主键
            pswsnew.setLx("C");//C|产品，L|零星
            pswsnew.setWoxh(woxh);//订单序号:对应订单排产次数，从1递增
            pswsnew.setJhrq(LocalDate.now());
            pswsnew.setJhid(yyyyMMdd);// 排程计划号
            pswsnew.setJhrFk(user.getEmployeeOid());//制订计划人外键(外键关联员表）
            pswsnew.setWoFk(pswSVoData.getPsWsVo().getWoFk());//生产订单外键
            pswsnew.setProdScheFk(pswSVoData.getPsWsVo().getProdScheFk());//排产到具体外键，根据排产程度状态确定当前字段是那张表的外键
            pswsnew.setZt("I");//状态：I|初始、F|确认、R|下达、S|暂停、C|完成
            pswsnew.setSysCreated(LocalDateTime.now());//创建人oid
            pswsnew.setSysLastUpdBy(user.getEmployeeOid());
            pswsnew.setSysCreatedBy(user.getEmployeeOid());//最后修改人oid

            //生成作业排程计划号
            UfcPsProcessCard psProcessCard = new UfcPsProcessCard();
            psProcessCard.setWoFk(pswSVoData.getPsWsVo().getWoFk());
            psProcessCard.setZyprocessOid(SnowflakeIdUtils.generate());
            psProcessCard.setProcessId(pswsnew.getJhid());
            ufcPsProcessCardService.save(psProcessCard);
            pswsnew.setProcessCardFk(psProcessCard.getZyprocessOid());

            if(!EmptyUtil.isEmpty(productionBatchList.get(index))){
                pswsnew.setProductionBatch(productionBatchList.get(index));
            }
            index++;
            //---------------处理生产投料增加的字段：数据来源-生产订单数据直接带入-----------------------------
            pswsnew.setReleaseControlType(wo.getReleaseControlType());
            pswsnew.setFeedingControlMode(wo.getFeedingControlMode());
            //---------------处理生产投料增加的字段：数据来源-生产订单数据直接带入-----------------------------
            newPsWs.add(pswsnew);
            //遍历传入的生产批次号生产ps_ps
            pswSVoData.setBcpcsl(new BigDecimal(pswSVoData.getBcpcsl().intValue() - pswSVoData.getNoteNumber().intValue()));

            //增加逻辑：订单 对于是否必须存在订单工艺路线的校验
            List<Long> longList=new ArrayList<>(1);
            longList.add(wo.getWooid());
            Boolean aBoolean = verifyProductStructure(longList);
            //注意为 true的时候，订单不存在订单工艺路线
            if(!aBoolean){
                //在生成排程时重新生成工艺路线
                List<UfcWogylx> list = ufcWogylxService.list(new LambdaQueryWrapper<UfcWogylx>().eq(UfcWogylx::getWoFk, wo.getWooid()).eq(UfcWogylx::getDel,0));
                if(EmptyUtil.isEmpty(list)){
                    return new Result().toFailure("不允许生成没有工艺路线的排程计划!");
                }
                List<UfcPsgylx> psgylxes = new ArrayList<>(list.size());
                //新旧主键关系对照
                Map<Long,Long> primaryKeyRelationship=new HashMap<>();

                List<UfcPpTechnologicalWogylx> ppTechnologicalWogylxs = ppTechnologicalWogylxService.list(new LambdaQueryWrapper<UfcPpTechnologicalWogylx>().in(UfcPpTechnologicalWogylx::getProcessRouteFk, list.get(0).getWoFk()));

                for (UfcPpTechnologicalWogylx ppTechnologicalWogylx : ppTechnologicalWogylxs) {
                    Long processOid = ppTechnologicalWogylx.getTechnologicalProcessOid();
                    ppTechnologicalWogylx.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                    primaryKeyRelationship.put(processOid,ppTechnologicalWogylx.getTechnologicalProcessOid());
                }
                //处理Pid关系
                for (UfcPpTechnologicalWogylx ppTechnologicalWogylx : ppTechnologicalWogylxs) {
                    //复制节点信息
                    UfcPsTechnologicalProcess psTechnologicalProcess = new UfcPsTechnologicalProcess();
                    Long pid = ppTechnologicalWogylx.getTechnologicalProcessPid();
                    //起点不需要重置pid
                    if(!topPid.equals(pid)||!closePid.equals(pid)){
                        Long aLong = primaryKeyRelationship.get(pid);
                        if(!EmptyUtil.isEmpty(aLong)){
                            ppTechnologicalWogylx.setTechnologicalProcessPid(aLong);
                        }
                    }
                    BeanUtils.copyProperties(ppTechnologicalWogylx,psTechnologicalProcess);
                    psTechnologicalProcess.setPsTechnologicalProcessOid(ppTechnologicalWogylx.getTechnologicalProcessOid());
                    psTechnologicalProcess.setProcessRouteFk(pswsnew.getPsWsoid());
                    psTechnologicalProcessService.save(psTechnologicalProcess);

                }

                list.forEach(wogylx -> {
                    UfcPsgylx psgylx = new UfcPsgylx();
                    UfcBStandardprocess byId = bStandardprocessService.getById(wogylx.getBStandardprocessFk());
                    if(!EmptyUtil.isEmpty(byId)){
                        BeanUtils.copyProperties(byId,psgylx);
                        psgylx.setBStandardprocessFk(byId.getBStandardprocessoid());
                    }
                    BeanUtils.copyProperties(wogylx,psgylx);
                    psgylx.setPsGylxOid(SnowflakeIdUtils.generate());
                    psgylx.setPsWsFk(pswsnew.getPsWsoid());
                    psgylx.setSysLastUpd(LocalDateTime.now());
                    psgylx.setSysLastUpdBy(user.getUserId());
                    psgylx.setWogylxFk(wogylx.getWogylxoid());
                    //重新配置节点外键
                    Long processFk = psgylx.getTechnologicalProcessFk();
                    if(!EmptyUtil.isEmpty(processFk)){
                        Long aLong = primaryKeyRelationship.get(processFk);
                        psgylx.setTechnologicalProcessFk(aLong);
                    }
                    psgylx.setZt("I");
                    psgylxes.add(psgylx);
                });

                ufcPsgylxService.saveBatch(psgylxes);
            }
            //修改紧急程度排序号
            LambdaUpdateWrapper<UfcBUd> wrapper=new LambdaUpdateWrapper<>();
            wrapper.eq(UfcBUd::getBUdoid,pswSVoData.getPsWsVo().getBudFk());
        }
        boolean bl = this.saveBatch(newPsWs);
        int i = ufcWoMapper.updateById(wo);
        if (i<1){
            throw new CustomException(-1,"更新工单失败");
        }
        if (!bl) {
            return new Result().toFailure(ResultCodeEnum.BMERROR1011);
        } else {
            return new Result().toSuccess(newPsWs.get(0).getPsWsoid());
        }
    }

    @Override
    public Result getpswsYesBatch(List<Long> list) {
        if (EmptyUtil.isEmpty(list)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }

        for (Long pswsoid : list) {
            //1.第一步 查询出当前作业计划工序清单有哪些工序数据
            LambdaQueryWrapper<UfcPsgylx> wrapper = new LambdaQueryWrapper<>();
            wrapper.select(UfcPsgylx::getPsGylxOid,UfcPsgylx::getBzgxid,UfcPsgylx::getBzgxmc);
            wrapper.eq(UfcPsgylx::getPsWsFk,pswsoid);
            List<UfcPsgylx> ufcPsgylxes = ufcPsgylxService.getBaseMapper().selectList(wrapper);

            //2.第二步 查询出当前作业计划工序已经生成了订单数据
            Map<Long, UfcPsgylx> map = ufcPsgylxes.stream().collect(Collectors.toMap(UfcPsgylx::getPsGylxOid, psgylx -> psgylx, (key1, key2) -> key1));
            LambdaQueryWrapper<UfcPsWb> queryWrapper=new LambdaQueryWrapper<>();
            queryWrapper.select(UfcPsWb::getPsWboid,UfcPsWb::getPsGylxFk,UfcPsWb::getGxid,UfcPsWb::getGxmc);
            queryWrapper.eq(UfcPsWb::getPsWsFk,pswsoid);
            List<UfcPsWb> psWbs = ufcPsWbMapper.selectList(queryWrapper);
            if(EmptyUtil.isEmpty(psWbs)){
                //还没没有调度
                return new Result().toFailure("流程卡还未调度！");
                //TO-DO 处理未调度生成的工序信息数据
            }
            for (UfcPsWb psWb : psWbs) {
                Long key = psWb.getPsGylxFk();
                map.remove(key);
            }
            /*if(EmptyUtil.isEmpty(map) || map.size() == psWbs.size()){
                //已调度完成
                record.setDispatchStatus("A");
            }
            if(EmptyUtil.isEmpty(record.getDispatchStatus())){
                //部分调度：
                record.setDispatchStatus("C");
            }*/
        }

        /* Result result = new Result<>();*/
        QueryWrapper<UfcPsWs> wrapper = new QueryWrapper<>();
        wrapper.in("ps_wsoid", list);
        int a = ufcPsWsMapper.selectCount(wrapper);
        if (a != list.size()) {
            return new Result().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        QueryWrapper<UfcPsWs> wrappera = new QueryWrapper<>();
        wrappera.in("ps_wsoid", list);
        wrappera.eq("zt", "I");
        int b = ufcPsWsMapper.selectCount(wrappera);
        if (b != list.size()) {
            return new Result().toFailure("状态不为初始I");
        }
        UpdateWrapper<UfcPsWs> wrapperq = new UpdateWrapper();
        wrapperq.in("ps_wsoid", list);
        wrapperq.set("zt", "F");
        Boolean ty = ufcPsWsService.update(wrapperq);
        if (ty == false) {
            return new Result().toFailure(ResultCodeEnum.PPERROR10161);
        } else {
            return new Result().toSuccess("确认成功");
        }
    }

    /**
     * 判断生产批号是否重复
     * @param batchNumber
     * @return
     */
    private boolean determineThe(List<String> batchNumber){
        LambdaQueryWrapper<UfcPsWs> wrapper=new LambdaQueryWrapper();
        wrapper.in(UfcPsWs::getProductionBatch,batchNumber);
        Integer count = this.baseMapper.selectCount(wrapper);
        return 0!=count;
    }

    public void verifyone(String code,BigDecimal ypcsl,BigDecimal pcsl,BigDecimal xqsl) {
        //TODO  调用用户查询  当前编码值  查询出值是否什么内容
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        if (!ruleValue.confirmSuccess()) {
            throw new CustomException(ruleValue.getCode(), ruleValue.getMsg());
        }
        String o = ruleValue.getData().get(0).toString();
        if ("N".equals(o)) {
            int bj = (ypcsl.add(pcsl)).compareTo(xqsl);
            if (bj==1){
                throw new CustomException(-1,"排产数量超过需求数量");
            }
            return;
        } else {
            //判断是否为数字
            boolean matches = o.matches("-[0-9]+(.[0-9]+)?|[0-9]+(.[0-9]+)?");
            if (matches) {
                //转换为BigDecimal
                BigDecimal bigDecimal = new BigDecimal(o);
                xqsl = xqsl.add(xqsl.multiply(bigDecimal));
                int bj = (ypcsl.add(pcsl)).compareTo(xqsl);
                if (bj==1){
                    throw new CustomException(-1,"排产数量超过需求数量");
                }
                return;
            }
        }
    }

    private Integer getWoxh(String wofk) {
        List<UfcPsWs> list = this.ufcPsWsService.list(new LambdaQueryWrapper<UfcPsWs>().select(UfcPsWs::getWoxh).eq(UfcPsWs::getWoFk, wofk).orderByDesc(UfcPsWs::getWoxh));
        if (list.size() == 0) {
            return 0;
        } else {
            return list.get(0).getWoxh();
        }
    }

    private Integer getJhpch(String wofk) {
        List<UfcPsWs> list = this.ufcPsWsService.list(new LambdaQueryWrapper<UfcPsWs>().select(UfcPsWs::getJhid).like(UfcPsWs::getSysCreated, LocalDate.now()).orderByDesc(UfcPsWs::getJhid));

        if (list.size() <= 0) {
            return 0;
        } else {
            return Integer.parseInt(list.get(0).getJhid().substring(list.get(0).getJhid().length() - 1));
        }
    }

    /**
     * 订单下达的时候：判断是否需要校验订单必须存在工艺路线操作
     *   规则：生产投料控制状态为 4|投料不控制时，PPK015数据为 N时满足不校验条件
     * @param idList
     * @return true:不需要校验  false:需要校验
     */
    public Boolean verifyProductStructure(List<Long> idList){
        //先去重
        idList=idList.stream().distinct().collect(Collectors.toList());
        Boolean aBoolean = whetherToCheck(PPK015);
        if(aBoolean){
            //参数设置满足条件，进一步判断：订单产出投料控制状态
            LambdaQueryWrapper<UfcWo> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(UfcWo::getReleaseControlType,"4");
            wrapper.eq(UfcWo::getWooid,idList);
            Integer count = ufcWoMapper.selectCount(wrapper);
            if(0==count){
                //所有 投料控制状态都不为 4|投料不控制
                return true;
            }
            if(count!=idList.size()){
                //选择的订单数据中，存在非投料不控制的数据
                return true;
            }
        }
        return false;
    }

    /**
     * 是否校验:
     * @return
     */
    private Boolean whetherToCheck(String code){
        //TODO  调用用户查询  当前编码值  查询出值是否什么内容
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        if(!ruleValue.confirmSuccess()){
            //需要执行校验的状态
            return true;
        }
        String o = ruleValue.getData().get(0).toString();
        if(DEFAULT_CALIBRATION.equals(o)){
            return true;
        }
        //为N的时候不需要检验
        return false;
    }
    
    public String getCode() {
        String result = "";
        String[] years = {"A","B","C","D","E","F","H","J","K","L","M","N","P","R","S","T","U","V","W","X"};
        int startYear = 1990;
        
        //获取当前时间
        LocalDateTime currentDate = LocalDateTime.now();
        //获取年份
        int year = currentDate.getYear();
        int num = year - startYear;
        int index = num - (20 * (num / 20));
        result += years[index];
        
        //获取月份
        int month = currentDate.getMonthValue();
        switch (month){
            case 10:
                result += "O";
                break;
            case 11:
                result += "N";
                break;
            case 12:
                result += "D";
                break;
            default:
                result += month;
        }
        
        // 获取流水号
        List<CodeTable> list = codeTableService.getBaseMapper().selectList(new LambdaQueryWrapper<CodeTable>().eq(CodeTable::getCodeType, "gdpc_code"));
        if (EmptyUtil.isEmpty(list) || list.get(0) == null) {
            throw new CustomException(-1, "流水号规则不存在");
        }
        
        CodeTable codeTable = list.get(0);

        String codeIng = codeTable.getCodeIng();
        int monthValue = Integer.parseInt(codeIng.substring(4, 6));

        // 是当月
        if (month == monthValue) {
            int ing = Integer.parseInt(codeIng.substring(8));
            ing++;
            if ( ing < 10) {
                result += "000" + ing;
            } else if ( ing < 100) {
                result += "00" + ing;
            } else if ( ing < 1000) {
                result += "0" + ing;
            } else {
                result += ing;
            }
            codeTable.setCodeIng(codeIng.substring(0,8) + result.substring(2));
        } else {
            // 从0001开始
            result += "0001";
            DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyyMMdd");
            String time = dtf.format(currentDate);
            codeTable.setCodeIng(time + "0001");
        }
        
        // 更新
        codeTableService.update(new LambdaUpdateWrapper<CodeTable>()
                            .set(CodeTable::getCodeIng, codeTable.getCodeIng())
                            .set(CodeTable::getVersion, codeTable.getVersion() + 1)
                            .eq(CodeTable::getCodeOid, codeTable.getCodeOid())
                            .eq(CodeTable::getVersion, codeTable.getVersion()));

        return result;
    }



    

}
