package com.jln.ufc.web.action.ufc.qc.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.LoginUser;
import com.jln.common.annotation.ValidationRules;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcItem;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcitemInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcUpBatchQcItemClass;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcItemService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author 
 * @since 2020-02-25
 */
@RestController
@RequestMapping("/ufc/qc/qc01/qc0102")
@Api(tags = "检验项目维护")
public class UfcQcItemController {
    @Autowired
    private UfcQcItemService bQcItemService;

    @ApiOperation(value = "检验项目列表",notes="检验类型列表")
    @PostMapping("/selectPage")
    public Result<Page<UfcQcitemInfo>> selectPage(@RequestBody PageParameter<Long> page ) {
        return bQcItemService.selectPage(page);
    }

    @ApiOperation(notes = "获取检验项目信息",value = "获取检验项目信息")
    @GetMapping("/get")
    public Result<UfcQcitemInfo> getdetailbyoid(@RequestParam Long oid){
        return bQcItemService.getdetailbyoid(oid);
    }

    @ApiOperation(value = "保存检验项目信息接口",notes="保存检验项目信息接口")
    @PostMapping("/save")
    @ValidationRules(value = "QCB0059")
    public Result save(@Validated @RequestBody UfcQcitemInfo bQcTypeInfo, @LoginUser User user)  {return bQcItemService.save(bQcTypeInfo,user);}

    @ApiOperation(value = "获取检验项目接口批量删除",notes="获取检验项目接口批量删除")
    @PostMapping("/delete")
    public Result deletes(@Validated @RequestBody List<Long> list) {return bQcItemService.deletes(list); }

    @ApiOperation(value = "获取检验项目接口批量停用",notes="获取检验项目接口批量停用")
    @PostMapping("/blockups")
    public Result blockups(@Validated @RequestBody List<Long> list) {return bQcItemService.blockups(list); }

    @ApiOperation(value = "检验项目可用列表",notes="检验项目可用列表")
    @PostMapping("/selectIsuse")
    public Result<Page<UfcQcItem>> selectIsuse() {
        return bQcItemService.selectIsuse();
    }

    @ApiOperation(value = "查询检验项目是否被引用",notes="查询检验项目是否被引用")
    @PostMapping("/selectQcItem")
    public Result selectQcItem(@RequestBody List<Long> list){
        return bQcItemService.selectQcItem(list);
    }

    @ApiOperation(value = "批量修改分类",notes="批量修改分类")
    @PostMapping("/upBatchQcItemClass")
    public Result upBatchQcItemClass(@RequestBody UfcUpBatchQcItemClass upBatchQcItemClass){
        return bQcItemService.upBatchQcItemClass(upBatchQcItemClass);
    }
}
