package com.jln.ufc.web.action.ufc.qc.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcRule;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleSelectInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleView;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcRuleService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author: Luca.Liu
 * @date: 2022/3/11
 */
@Api(tags = "检验规程维护接口",value = "检验规程维护接口")
@RestController
@RequestMapping("/ufc/qc/qc01/qc0104")
@Validated
public class UfcQcRuleController {
    
    @Autowired
    private UfcQcRuleService ufcQcRuleService;

    @ApiOperation(value = "检验规程维护接口——检验规程查询列表", notes = "检验规程维护接口——检验规程查询列表")
    @PostMapping("/getQcRuleList")
    public Result<Page<UfcQcRuleView>> getQcRuleList(@RequestBody PageParameter<UfcQcRuleSelectInfo> qcRuleSelectInfo) {
        return ufcQcRuleService.getQcRuleList(new Page<>(qcRuleSelectInfo.getPageNum(),qcRuleSelectInfo.getPageSize()),qcRuleSelectInfo.getData());
    }

    @ApiOperation(value = "检验规程维护接口——保存", notes = "检验规程维护接口——保存")
    @PostMapping("/saveQcRule")
    public Result saveQcRule(@RequestBody UfcQcRule qcRule, @LoginUser User user) {
        return ufcQcRuleService.saveQcRule(qcRule,user);
    }
}
