package com.jln.ufc.web.action.ufc.qc.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcStd;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcStdmx;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcStdDetailInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcStdSelectInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcStdView;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcStdService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author
 * @since 2020-02-25
 */
@Api(tags = "检验标准维护接口", value = "检验标准维护接口")
@RestController
@RequestMapping("/ufc/qc/qc01/qc0103")
@Validated
public class UfcQcStdController {
    @Autowired
    private UfcQcStdService qcStdService;

    @ApiOperation(value = "检验标准维护——检验标准详情", notes = "检验标准维护——检验标准详情")
    @PostMapping("/getQcStd")
    public Result<UfcQcStdView> getQcStd(@RequestBody PageParameter<UfcQcStdDetailInfo> qcStdSelectInfo) {
        return qcStdService.getQcStd(new Page<>(qcStdSelectInfo.getPageNum(), qcStdSelectInfo.getPageSize()), qcStdSelectInfo.getData());
    }

    @ApiOperation(value = "检验标准维护——检验标准保存", notes = "检验标准维护——检验标准保存")
    @PostMapping("/saveQcStd")
    public Result saveQcStd(@RequestBody @Validated UfcQcStd qcStd, @LoginUser User user) {
        return qcStdService.saveQcStd(qcStd, user);
    }

    @ApiOperation(value = "检验标准维护——检验标准查询列表", notes = "检验标准维护——检验标准查询列表")
    @PostMapping("/getQcStdList")
    public Result<Page<UfcQcStdView>> getQcStdList(@RequestBody PageParameter<UfcQcStdSelectInfo> qcStdSelectInfo) {
        return qcStdService.getQcStdList(new Page<>(qcStdSelectInfo.getPageNum(), qcStdSelectInfo.getPageSize()), qcStdSelectInfo.getData());
    }
    @ApiOperation(value = "检验标准维护——检验标准明细保存", notes = "检验标准维护——检验标准明细保存")
    @PostMapping("/saveQcStdmx")
    public Result saveQcStdmx(@RequestBody UfcQcStdmx qcStdmx, @LoginUser User user) {
        return qcStdService.saveQcStdmx(qcStdmx,user);
    }

    @ApiOperation(value = "检验标准维护——批量设置检验规程", notes = "检验标准维护——批量设置检验规程")
    @PostMapping("/addQcRule")
    public Result addQcRule(@RequestBody UfcQcRuleInfo qcRule, @LoginUser User user) {
        return qcStdService.addQcRule(qcRule, user);
    }

}
