package com.jln.ufc.web.action.ufc.qc.controller;


import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcTyRule;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleSelectInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleView;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcTyRuleService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 通用规程 前端控制器
 * </p>
 *
 * @author 
 * @since 2022-04-29
 */
@RestController
@RequestMapping("/ufc/qc/ufcQcTyRule")
public class UfcQcTyRuleController {

    @Autowired
    private UfcQcTyRuleService ufcQcTyRuleService;

    @ApiOperation(value = "通用规程新增、修改", notes = "通用规程新增、修改")
    @PostMapping("/saveQcTyRule")
    public Result saveQcTyRule(@RequestBody UfcQcTyRule ufcQcTyRule, @LoginUser User user) {
        return ufcQcTyRuleService.saveQcTyRule(ufcQcTyRule, user);
    }
    @ApiOperation(value = "通用规程删除", notes = "通用规程删除")
    @PostMapping("/delQcTyRule")
    public Result delQcTyRule(@RequestBody List<Long> oids) {
        return ufcQcTyRuleService.delQcTyRule(oids);
    }
    @ApiOperation(value = "通用规程查询列表", notes = "通用规程查询列表")
    @PostMapping("/pageQcTyRule")
    public Result pageQcTyRule(@RequestBody PageParameter<UfcQcRuleSelectInfo> qcRuleSelectInfo) {
        return ufcQcTyRuleService.pageQcTyRule(qcRuleSelectInfo);
    }
    @ApiOperation(value = "通用设置", notes = "通用设置")
    @PostMapping("/generalSettings")
    public Result generalSettings(@RequestBody List<UfcQcTyRule> qcTyRules) {
        return ufcQcTyRuleService.generalSettings(qcTyRules);
    }
    @ApiOperation(value = "通用规程——详情", notes = "通用规程——详情")
    @GetMapping("/getQcTyRule")
    public Result<UfcQcRuleView> getQcRule(@RequestParam("qcTyRuleoid") Long qcTyRuleoid) {
        return ufcQcTyRuleService.getQcTyRule(qcTyRuleoid);
    }

}
