package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author 
 * @since 2020-02-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("qc_item")
public class UfcQcItem extends Model<UfcQcItem> {

    private static final long serialVersionUID = 1L;

    /**
     * 检验项目主键
     */
    @TableId("qc_itemoid")
    private Long qcItemoid;

    /**
     * 检验项目编码
     */
    private String jyxmid;

    /**
     * 检验项目名称
     */
    private String jyxmmc;

    /**
     * 重要性等级
     */
    private String dj;

    /**
     * 类型
     */
    private String lx;

    /**
     * 控制方式
     */
    private String kzfs;

    /**
     * 计量单位
     */
    private String jldw;

    /**
     * 缺省值(数值型)
     */
    private BigDecimal qszf;

    /**
     * 缺省值(字符型)
     */
    private String qszs;

    /**
     * 缺省值(日期型)
     */
    private LocalDate qszd;

    /**
     * 枚举
     */
    private Boolean mj;

    /**
     * 枚举列表
     */
    private String mjlb;

    /**
     * 缺省值(枚举型)
     */
    private String qszm;

    /**
     * 抽样方式
     */
    private String cyfs;

    /**
     * 抽样数量
     */
    private BigDecimal ybsl;

    /**
     * 抽样百分比(%)
     */
    private BigDecimal bfb;

    /**
     * 抽样标准
     */
    private String cybz;

    /**
     * 检查水平
     */
    private String jcsp;

    /**
     * aql值
     */
    private BigDecimal aql;

    /**
     * 判别水平
     */
    private String pbsp;

    /**
     * rql值
     */
    private BigDecimal rql;

    /**
     * 最小样本数量
     */
    private BigDecimal zxybsl;

    /**
     * 小数位数
     */
    private BigDecimal xsws;

    /**
     * 计算公式
     */
    private String jsgs;

    /**
     * 检验方法
     */
    private String jyff;

    /**
     * 检验内容及要求
     */
    private String jynr;

    /**
     * 启用日期
     */
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate qyrq;

    /**
     * 停用日期
     */
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate tyrq;


    /**
     * 停用标志
     */
    private Boolean tybz;

    /**
     * 备注
     */
    private String bz;

    /**
     * 状态
     */
    private String zt;

    /**
     * 创建人oid
     */
    private Long sysCreatedBy;

    /**
     * 最后修改人oid
     */
    private Long sysLastUpdBy;

    /**
     * 所属岗位oid
     */
    private Long sysPostn;

    /**
     * 所属部门oid
     */
    private Long sysDivision;

    /**
     * 所属组织oid
     */
    private Long sysOrg;

    /**
     * 创建日期
     */
    private LocalDateTime sysCreated;

    private Integer del;

    /**
     * 检验项目分类外键
     */
    private Long qcItemClassFk;
    /**
     * 技术要求
     */
    private String jsyq;

    @ApiModelProperty(value = "分类代码")
    private String qcItemClassBarcode;

    @Override
    protected Serializable pkVal() {
        return this.qcItemoid;
    }

}
