package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author 
 * @since 2020-02-27
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("qc_rule")
public class UfcQcRule extends Model<UfcQcRule> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(example = "检验规程主键", required = true,dataType = "string")
    @TableId("qc_ruleoid")
    private Long qcRuleoid;

    @ApiModelProperty(example = "控制方式:M|每批控制，N|不控制", required = true,dataType = "string")
    private String kzfs;

    @ApiModelProperty(example = "单件检验:Y|采用，N|不采用", required = true,dataType = "string")
    private String djjy;

    @ApiModelProperty(example = "启动日期:2020-02-20", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate qyrq;

    @ApiModelProperty(example = "停用日期:2020-02-20", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate tyrq;

    @ApiModelProperty(example = "停用标志:fasle,true", required = true)
    private Boolean tybz;

    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态:I|初始、F|确认、C|完成", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "创建人oid:后台自动获取", required = true,dataType = "string")
    private Long sysCreatedBy;

    @ApiModelProperty(example = "最后修改人oid:后台自动获取", required = true,dataType = "string")
    private Long sysLastUpdBy;

    @ApiModelProperty(example = "创建日期:后台自动获取", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "检验类型外键", required = true,dataType = "string")
    private Long qcTypeFk;

    @ApiModelProperty(example = "检验标准外键", required = true,dataType = "string")
    private Long qcStdFk;

    @ApiModelProperty(example = "物料外键", required = true,dataType = "string")
    private Long bMaterialFk;

    @TableField(updateStrategy= FieldStrategy.IGNORED)
    @ApiModelProperty(example = "生产线外键", required = true,dataType = "string")
    private Long bProductionlineFk;

    @ApiModelProperty(example = "供应商外键", required = true,dataType = "string")
    private Long bSupplierFk;

    @ApiModelProperty(example = "标准工序外键", required = true,dataType = "string")
    private Long bStandardprocessFk;

    @ApiModelProperty(example = "修改时间:后台自动生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @TableLogic
    @ApiModelProperty(example = "删除标记:后台自动生成", required = true,dataType = "int")
    private Integer del;

    /**
     * 文档附件名称
     */
    @ApiModelProperty(example = "文档附件名称",dataType = "string")
    private String cessoryName;

    /**
     * 文档地址
     */
    @ApiModelProperty(example = "文档地址",dataType = "string")
    private String accessoryUrl;

    @Override
    protected Serializable pkVal() {
        return this.qcRuleoid;
    }

}
