package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 检验样本表
 * </p>
 *
 * @author 
 * @since 2021-08-24
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="QcSample对象", description="检验样本表")
@TableName("qc_sample")
public class UfcQcSample extends Model<UfcQcSample> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "检验样本主键")

    @TableId("qc_sample_oid")
    private Long qcSampleOid;

    @ApiModelProperty(value = "检验单号-来着qc_bill")
    @TableField("jydid")
    private String jydid;

    @ApiModelProperty(value = "样本编号-自动生成的数据")
    @TableField("ybbh")
    private String ybbh;

    @ApiModelProperty(value = "是否合格")
    @TableField("sjsfhg")
    private Boolean sjsfhg;

    @ApiModelProperty(value = "不合格原因编码-来自QC_UQREASON")
    @TableField("bhgyyid")
    private String bhgyyid;

    @ApiModelProperty(value = "不合格原因说明-来自QC_UQREASON")
    @TableField("bhgyymc")
    private String bhgyymc;

    @ApiModelProperty(value = "检验单外键")
    @TableField("qc_bill_fk")
    private Long qcBillFk;

    @ApiModelProperty(value = "检验标准外键--来自检验单-冗余字段")
    @TableField("qc_std_fk")
    private Long qcStdFk;


    @Override
    protected Serializable pkVal() {
        return this.qcSampleOid;
    }

}
