package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 检验样本-关联检验项目表
 * </p>
 *
 * @author 
 * @since 2021-08-24
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="QcSampleStd对象", description="检验样本-关联检验项目表")
@TableName("qc_sample_std")
public class UfcQcSampleStd extends Model<UfcQcSampleStd> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "检验样本-关联检验项目表")
    @TableId("qc_sample_std_oid")
    private Long qcSampleStdOid;

    @ApiModelProperty(value = "检验项目编码")
    @TableField("jyxmid")
    private String jyxmid;

    @ApiModelProperty(value = "检验项目名称")
    @TableField("jyxmmc")
    private String jyxmmc;

    @ApiModelProperty(value = "检验项目冗余字段：检验类型-S|字符串值、P|计件值、D|计点值、M|计量值、R|日期值 五种")
    @TableField("lx")
    private String lx;

    @ApiModelProperty(value = "控制方式-U|上限值、L|下限值、I|区间值、S|标准值-检验项目冗余字段")
    @TableField("kzfs")
    private String kzfs;

    @ApiModelProperty(value = "样本值")
    @TableField("sample_value")
    private String sampleValue;

    @ApiModelProperty(value = "检验项目外键")
    @TableField("qc_item_fk")
    private Long qcItemFk;

    @ApiModelProperty(value = "检验样本外键")
    @TableField("qc_sample_fk")
    private Long qcSampleFk;


    @Override
    protected Serializable pkVal() {
        return this.qcSampleStdOid;
    }

}
