package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotEmpty;
import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author 
 * @since 2020-02-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@JsonIgnoreProperties(ignoreUnknown = true)
@Accessors(chain = true)
@TableName("qc_std")
public class UfcQcStd extends Model<UfcQcStd> {

    private static final long serialVersionUID = 1L;
    @TableId("qc_stdoid")
    @ApiModelProperty(example = "检验标准主键", required = true,dataType = "string")
    private Long qcStdoid;

    @NotEmpty(message = "检验标准编号不能为空")
    @ApiModelProperty(example = "检验标准编号", required = true,dataType = "string")
    private String jybzid;

    @NotEmpty(message = "检验标准名称不能为空")
    @ApiModelProperty(example = "检验标准名称", required = true,dataType = "string")
    private String jybzmc;

    @ApiModelProperty(example = "检验方式:Q|全检、C|抽检、D|单件", required = true,dataType = "string")
    private String jyfs;

    @ApiModelProperty(example = "分类", required = true,dataType = "string")
    private String fl;

    @ApiModelProperty(example = "版本号:1、2、3",dataType = "int")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Integer version;

    @ApiModelProperty(example = "审批标识:0|未审批，1|已审批", required = true)
    private Boolean spbz;

    @ApiModelProperty(example = "启用日期:2020-02-20", required = true, dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate qyrq;

    @ApiModelProperty(example = "停用日期:2020-02-20", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    @TableField(updateStrategy= FieldStrategy.IGNORED)
    private LocalDate tyrq;

    @ApiModelProperty(example = "停用标志:0|未停用，1|已停用", required = true)
    private Boolean tybz;

    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态:I|初始、F|确认、C|完成", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "创建人oid:自动生成", required = true,dataType = "string")
    private Long sysCreatedBy;

    @ApiModelProperty(example = "最后修改人oid:自动生成", required = true,dataType = "string")
    private Long sysLastUpdBy;

    @ApiModelProperty(example = "创建日期:自动生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "检验类型外键", required = true,dataType = "string")
    private Long qcTypeFk;

    @TableLogic
    @ApiModelProperty(example = "删除标志:后台生成", required = true,dataType = "int")
    private Integer del;

    @ApiModelProperty(example = "最后修改日期:自动生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(example = "检验标准分类外键", required = true,dataType = "string")
    private Long qcStdClassFk;

    @ApiModelProperty(value = "分类代码")
    private String qcStdClassBarcode;

    @ApiModelProperty(value = "执行标准")
    @TableField(exist = false)
    private String zxbz;

    @Override
    protected Serializable pkVal() {
        return this.qcStdoid;
    }

}
