package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author 
 * @since 2020-02-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@JsonIgnoreProperties(ignoreUnknown = true)
@Accessors(chain = true)
@TableName("qc_stdmx")
public class UfcQcStdmx extends Model<UfcQcStdmx> {

    private static final long serialVersionUID = 1L;

    @TableId("qc_stdmxoid")
    @ApiModelProperty(example = "检验标准明细主键", required = true,dataType = "string")
    private Long qcStdmxoid;

    @ApiModelProperty(example = "检验项目序号:接口获取", required = true)
    private BigDecimal jyxmxh;

    @ApiModelProperty(example = "版本号:1、2、3",dataType = "int")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Integer version;

    @ApiModelProperty(example = "重要性等级:A|关键项目、B|主要项目、C|次要项目", required = true,dataType = "string")
    private String dj;

    @ApiModelProperty(example = "类型:S|字符串值、P|计件值、D|计点值、M|计量值、R|日期值", required = true,dataType = "string")
    private String lx;

    @ApiModelProperty(example = "控制方式:U|上限值、L|下限值、I|区间值、S|标准值", required = true,dataType = "string")
    private String kzfs;

    @ApiModelProperty(example = "计量单位:米、千米", required = true,dataType = "string")
    private String jldw;

    @ApiModelProperty(example = "缺省值(数值型):100", required = true)
    private BigDecimal qszf;

    @ApiModelProperty(example = "缺省值(字符型):一百", required = true,dataType = "string")
    private String qszs;

    @ApiModelProperty(example = "缺省值(日期型):2020-02-20", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate qszd;

    @ApiModelProperty(example = "枚举:", required = true)
    private Boolean mj;

    @ApiModelProperty(example = "枚举列表", required = true,dataType = "string")
    private String mjlb;

    @ApiModelProperty(example = "缺省值(枚举型)", required = true,dataType = "string")
    private String qszm;

    @ApiModelProperty(example = "用于合格性判定", required = true)
    private Boolean hg;

    @ApiModelProperty(example = "要求零缺陷", required = true)
    private Boolean zero;

    @ApiModelProperty(example = "抽样方式:P|百分比抽样、S|标准抽样、F|固定数抽样", required = true,dataType = "string")
    private String cyfs;

    @ApiModelProperty(example = "样本数量:1000", required = true)
    private BigDecimal ybsl;

    @ApiModelProperty(example = "抽样百分比(%):80", required = true)
    private BigDecimal bfb;

    @ApiModelProperty(example = "抽样标准:GB2828-87，GB2829-87,GB2828-2003，GB2829-2002", required = true,dataType = "string")
    private String cybz;

    @ApiModelProperty(example = "检查水平:S-1、S-2、S-3、S-4、I、II、III（用于抽样标准GB2828-87， GB2828-2003）", required = true,dataType = "string")
    private String jcsp;

    @ApiModelProperty(example = "aql值:100", required = true)
    private BigDecimal aql;

    @ApiModelProperty(example = "判别水平:I、II、III（用于抽样标准GB2829-87， GB2829-2002）", required = true,dataType = "string")
    private String pbsp;

    @ApiModelProperty(example = "rql值:100", required = true)
    private BigDecimal rql;

    @ApiModelProperty(example = "上限值:100", required = true)
    private BigDecimal sxz;

    @ApiModelProperty(example = "下限值:100", required = true)
    private BigDecimal xxz;

    @ApiModelProperty(example = "标准值:100", required = true)
    private BigDecimal bzz;

    @ApiModelProperty(example = "最小样本数量:100", required = true)
    private BigDecimal zxybsl;

    @ApiModelProperty(example = "小数位数:2", required = true)
    private BigDecimal xsws;

    @ApiModelProperty(example = "计算公式:1+2 = 3", required = true,dataType = "string")
    private String jsgs;

    @ApiModelProperty(example = "检验方法:试剂检验", required = true,dataType = "string")
    private String jyff;

    @ApiModelProperty(example = "检验内容:是否含有维生素", required = true,dataType = "string")
    private String jynr;

    @ApiModelProperty(example = "启用日期:2020-02-20", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDate qyrq;

    @ApiModelProperty(example = "停用日期:2020-02-20", required = true, dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate tyrq;

    @ApiModelProperty(example = "停用标志:0|未停用、1|已停用", required = true)
    private Boolean tybz;

    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态:I|初始、F|确认、C|完成", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "创建人oid:自动生成", required = true,dataType = "string")
    private Long sysCreatedBy;

    @ApiModelProperty(example = "最后修改人oid:自动生成", required = true,dataType = "string")
    private Long sysLastUpdBy;

    @ApiModelProperty(example = "创建日期:自动生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "检验标准外键", required = true,dataType = "string")
    private Long qcStdFk;

    @ApiModelProperty(example = "检验项目外键", required = true,dataType = "string")
    private Long qcItemFk;

    @TableLogic
    @ApiModelProperty(example = "删除:自动生成", required = true,dataType = "int")
    private Integer del;

    @ApiModelProperty(example = "最后修改日期:自动生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(example = "技术要求",dataType = "string")
    @TableField(exist = false)
    private String jsyq;

    @Override
    protected Serializable pkVal() {
        return this.qcStdmxoid;
    }

}
