package com.jln.ufc.web.action.ufc.qc.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 通用规程
 * </p>
 *
 * @author 
 * @since 2022-04-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="UfcQcTyRule对象", description="通用规程")
public class UfcQcTyRule extends Model<UfcQcTyRule> {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(value = "通用规程主键")
    private Long ufcQcTyRuleoid;

    @ApiModelProperty(value = "控制方式")
    private String kzfs;

    @ApiModelProperty(value = "单件检验")
    private String djjy;

    @ApiModelProperty(value = "启动日期")
    private LocalDate qyrq;

    @ApiModelProperty(value = "停用日期")
    private LocalDate tyrq;

    @ApiModelProperty(value = "停用标志")
    private Boolean tybz;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "状态")
    private String zt;

    @ApiModelProperty(value = "创建人oid")
    private Long sysCreatedBy;

    @ApiModelProperty(value = "最后修改人oid")
    private Long sysLastUpdBy;

    @ApiModelProperty(value = "创建日期")
    private LocalDateTime sysCreated;

    @ApiModelProperty(value = "检验类型外键")
    private Long qcTypeFk;

    @ApiModelProperty(value = "检验标准外键")
    private Long qcStdFk;

    @ApiModelProperty(value = "物料外键")
    private Long bMaterialFk;

    @ApiModelProperty(value = "生产线外键")
    private Long bProductionlineFk;

    @ApiModelProperty(value = "供应商外键")
    private Long bSupplierFk;

    @ApiModelProperty(value = "标准工序外键")
    private Long bStandardprocessFk;

    @ApiModelProperty(value = "最后一次修改时间")
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(value = "删除标记")
    private Boolean del;

    @ApiModelProperty(value = "文档附件名称")
    private String cessoryName;

    @ApiModelProperty(value = "文档地址")
    private String accessoryUrl;

    @ApiModelProperty(value = "通用标志")
    private Boolean tyRuleBz;


    @Override
    protected Serializable pkVal() {
        return this.ufcQcTyRuleoid;
    }

}
