package com.jln.ufc.web.action.ufc.qc.entity.vo;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDate;
import java.time.LocalDateTime;

@Data
public class UfcQcStdView {

    @ApiModelProperty(example = "检验标准主键", required = true,dataType = "string")
    private Long qcStdoid;

    @ApiModelProperty(example = "检验标准编号", required = true,dataType = "string")
    private String jybzid;

    @ApiModelProperty(example = "检验标准名称", required = true,dataType = "string")
    private String jybzmc;

    @ApiModelProperty(example = "检验类型", required = true,dataType = "string")
    private String jylx;

    @ApiModelProperty(example = "检验类型名称", required = true,dataType = "string")
    private String jylxmc;

    @ApiModelProperty(example = "检验方式", required = true,dataType = "string")
    private String jyfs;

    @ApiModelProperty(example = "分类", required = true,dataType = "string")
    private String fl;

    @ApiModelProperty(example = "版本号", required = true,dataType = "string")
    private String version;

    @ApiModelProperty(example = "审批标识", required = true)
    private String spbz;

    @ApiModelProperty(example = "启用日期", required = true,dataType = "date")
    //@DateTimeFormat(pattern ="yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate qyrq;

    @ApiModelProperty(example = "停用日期", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate tyrq;

    @ApiModelProperty(example = "停用标志", required = true)
    private Boolean tybz;

    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "维护人", required = true,dataType = "string")
    private String whr;

    @ApiModelProperty(example = "检验类型外键", required = true,dataType = "string")
    private Long qcTypeFk;

    @ApiModelProperty(example = "维护日期", required = true)
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime whrq;

    @ApiModelProperty(value = "检验标准分类编码")
    private String qcStdClassCode;

    @ApiModelProperty(value = "检验标准分类名称")
    private String qcStdClassName;

    @ApiModelProperty(value = "执行标准")
    private String zxbz;

    private Page<UfcQcStdmxView> qcStdmxViewPage;
}
