package com.jln.ufc.web.action.ufc.qc.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;

@Data
public class UfcQcStdmxView {

    @ApiModelProperty(example = "检验标准明细主键")
    private Long qcStdmxoid;

    @ApiModelProperty(example = "检验标准编号")
    private String jybzid;

    @ApiModelProperty(example = "检验项目序号")
    private BigDecimal jyxmxh;

    @ApiModelProperty(example = "检验项目编号")
    private String jyxmid;

    @ApiModelProperty(example = "检验项目名称")
    private String jyxmmc;

    @ApiModelProperty(example = "检验类型")
    private String jylx;

    @ApiModelProperty(example = "检验类型名称")
    private String jylxmc;

    @ApiModelProperty(example = "版本号")
    private Integer version;

    @ApiModelProperty(example = "重要性等级")
    private String dj;

    @ApiModelProperty(example = "类型")
    private String lx;

    @ApiModelProperty(example = "控制方式")
    private String kzfs;

    @ApiModelProperty(example = "计量单位")
    private String jldw;

    @ApiModelProperty(example = "缺省值(数值型)")
    private BigDecimal qszf;

    @ApiModelProperty(example = "缺省值(字符型)")
    private String qszs;

    @ApiModelProperty(example = "缺省值(日期型)")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate qszd;

    @ApiModelProperty(example = "枚举",value = "false")
    private Boolean mj;

    @ApiModelProperty(example = "枚举列表")
    private String mjlb;

    @ApiModelProperty(example = "缺省值(枚举型)")
    private String qszm;

    @ApiModelProperty(example = "用于合格性判定")
    private Boolean hg;

    @ApiModelProperty(example = "要求零缺陷",value = "fasle")
    private Boolean zero;

    @ApiModelProperty(example = "抽样方式")
    private String cyfs;

    @ApiModelProperty(example = "样本数量")
    private BigDecimal ybsl;

    @ApiModelProperty(example = "抽样百分比(%)")
    private BigDecimal bfb;

    @ApiModelProperty(example = "抽样标准")
    private String cybz;

    @ApiModelProperty(example = "检查水平")
    private String jcsp;

    @ApiModelProperty(example = "aql值")
    private BigDecimal aql;

    @ApiModelProperty(example = "判别水平")
    private String pbsp;

    @ApiModelProperty(example = "rql值")
    private BigDecimal rql;

    @ApiModelProperty(example = "上限值")
    private BigDecimal sxz;

    @ApiModelProperty(example = "下限值")
    private BigDecimal xxz;

    @ApiModelProperty(example = "标准值")
    private BigDecimal bzz;

    @ApiModelProperty(example = "最小样本数量")
    private BigDecimal zxybsl;

    @ApiModelProperty(example = "小数位数")
    private BigDecimal xsws;

    @ApiModelProperty(example = "计算公式", dataType = "string")
    private String jsgs;

    @ApiModelProperty(example = "检验方法",dataType = "string")
    private String jyff;

    @ApiModelProperty(example = "检验内容",dataType = "string")
    private String jynr;

    @ApiModelProperty(example = "启用日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate qyrq;

    @ApiModelProperty(example = "停用日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate tyrq;

    @ApiModelProperty(example = "检验标准主键", required = true,dataType = "string")
    private Boolean tybz;

    @ApiModelProperty(example = "备注",dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态", dataType = "string")
    private String zt;

    @ApiModelProperty(example = "最后修改人名称", dataType = "string")
    private String whr;

    @ApiModelProperty(example = "维护时间", dataType = "string")
    private String whrq;

    @ApiModelProperty(example = "检验标准外键", required = true,dataType = "string")
    private Long qcStdFk;

    @ApiModelProperty(example = "检验项目外键", required = true,dataType = "string")
    private Long qcItemFk;

    @ApiModelProperty(example = "技术要求")
    private String jsyq;

}
