package com.jln.ufc.web.action.ufc.qc.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcRule;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleSelectInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcRuleView;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author: Luca.Liu
 * @date: 2022/3/11
 */
@Component
public interface UfcQcRuleMapper extends BaseMapper<UfcQcRule> {

    List<UfcQcRuleView> getQcRuleList(@Param("page") Page<UfcQcRuleView> page, @Param("qcRuleSelectInfo") UfcQcRuleSelectInfo qcRuleSelectInfo);

    /**
     * @param wloid  物料外键
     * @param factoryOid  工厂外键
     * @param qcTypeFk  检验类型外键
     * @param bStandardprocessFk  工序外键
     * @param qcStdFk  检验标准外键
     * @return
     */
    UfcQcRule checkSelect(@Param("wlFk") Long wloid,
                          @Param("gcFk") Long factoryOid,
                          @Param("jylxFk") Long qcTypeFk,
                          @Param("gxFk") Long bStandardprocessFk,
                          @Param("jybzFk") Long qcStdFk);
}
