package com.jln.ufc.web.action.ufc.qc.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcItem;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcQcitemInfo;
import com.jln.ufc.web.action.ufc.qc.entity.vo.UfcUpBatchQcItemClass;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author 
 * @since 2020-02-25
 */
public interface UfcQcItemService extends IService<UfcQcItem> {
    /**
     * 通过主键查询检验项目信息
     * @param oid 工序主键
     * @return
     */
    Result<UfcQcitemInfo> getdetailbyoid(Long oid);

    /**
     * 分页查询检验项目信息
     * @param page 当前分页查询条件
     * @return
     */
    Result<Page<UfcQcitemInfo>> selectPage(PageParameter<Long> page);
    /**
     * 保存检验项目信息
     * @param bQcitemInfo 检验项目信息
     * @return
     */
    Result save(UfcQcitemInfo bQcitemInfo, User user);

    /**
     * 停用检验项目列表
     * @param list 检验项目信息
     * @return
     */
    Result blockups(List<Long> list);

    /**
     * 逻辑删除检验项目列表
     * @param list 检验项目信息
     * @return
     */
    Result deletes(List<Long> list);

    Result<Page<UfcQcItem>> selectIsuse();

    /**
     * @Author liyunlong
     * @Description //TODO 查询检验项目是否被引用
     * @Params [list]
     * @Returns com.jln.common.entity.Result
     **/
    Result selectQcItem(List<Long> list);

    Result upBatchQcItemClass(UfcUpBatchQcItemClass upBatchQcItemClass);
}
