package com.jln.ufc.web.action.ufc.qc.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.exception.CustomException;
import com.jln.system.web.action.commonweb.parameterize.validation.ValidationRules;
import com.jln.system.web.action.commonweb.sysrelevance.pojo.Dto.TableDataDto;
import com.jln.system.web.action.commonweb.sysrelevance.pojo.Vo.TableDataVo;
import com.jln.system.web.action.commonweb.sysrelevance.service.SysRelevanceTableRoleService;
import com.jln.system.web.action.sm.sm1001.entity.SysRole;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcBill;
import com.jln.ufc.web.action.ufc.qc.entity.UfcQcsdtmxgetView;
import com.jln.ufc.web.action.ufc.qc.mapper.UfcQcBillMapper;
import com.jln.ufc.web.action.ufc.qc.service.UfcQcBillService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author
 * @since 2020-02-19
 */
@Service
public class UfcQcBillServiceImpl extends ServiceImpl<UfcQcBillMapper, UfcQcBill> implements UfcQcBillService, ValidationRules<UfcQcBill> {
    @Autowired
    private SysRelevanceTableRoleService sysRelevanceTableRoleService;

    @Override
    public void verify(String code, User user, UfcQcBill paramers) throws CustomException {

    }

    @Override
    public void verify(String code, UfcQcBill paramers) throws CustomException {

    }

    @Override
    public Result<List<UfcQcsdtmxgetView>> getQcsdtmxgetViewList(Long qcStdFk, User user) {
        List<Long> tableDataVos = new ArrayList<>();
        TableDataDto tableDataDto = new TableDataDto();
        tableDataDto.setBusinessCode("QCK021");

        for (SysRole role : user.getSysRoles()) {
            tableDataDto.setRoleFk(role.getSysRoleId());
            Result<List<TableDataVo>> data = sysRelevanceTableRoleService.getTableRoleData(tableDataDto);
            if (data.confirmSuccess()) {
                for (TableDataVo item : data.getData()) {
                    tableDataVos.add(item.getId());
                }
            }
        }
        List<UfcQcsdtmxgetView> qcsdtmxgetViewList = baseMapper.getQcsdtmxgetViewList(qcStdFk, tableDataVos);
        return new Result().toSuccess(qcsdtmxgetViewList);
    }
}
