package com.jln.ufc.web.action.ufc.sm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.PageParameter;
import com.jln.system.web.action.sm.sm1001.pojo.vo.EmpListVo;
import com.jln.ufc.web.action.ufc.sm.entity.UfcSysEmployee;
import com.jln.ufc.web.action.ufc.sm.entity.dto.UfcEmployeeDTO;
import com.jln.ufc.web.action.ufc.sm.mapper.UfcSysEmployeeMapper;
import com.jln.ufc.web.action.ufc.sm.service.UfcSysEmployeeService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author
 * @since 2020-02-15
 */
@Service
public class UfcSysEmployeeServiceImpl extends ServiceImpl<UfcSysEmployeeMapper, UfcSysEmployee> implements UfcSysEmployeeService {

    @Override
    public Result<Page<EmpListVo>> getlist(PageParameter<UfcEmployeeDTO> parameter) {
        LambdaQueryWrapper<UfcSysEmployee> wrapper=new LambdaQueryWrapper<>();
        //查询检测校准试验中心 部门下的人员
        List<Long> list = this.getBaseMapper().selectByDept();
        wrapper.select(UfcSysEmployee::getJobNumber,UfcSysEmployee::getEmployeeOid,UfcSysEmployee::getEmployeeName,UfcSysEmployee::getCodeing);
        if(!EmptyUtil.isEmpty(parameter.getData())){
            if(!EmptyUtil.isEmpty(parameter.getData().getEmployeeName())){
                wrapper.like(UfcSysEmployee::getEmployeeName,parameter.getData().getEmployeeName());
            }
            if(!EmptyUtil.isEmpty(parameter.getData().getJobNumber())){
                wrapper.like(UfcSysEmployee::getJobNumber,parameter.getData().getJobNumber());
            }
            if(!EmptyUtil.isEmpty(parameter.getData().getCodeing())){
                wrapper.like(UfcSysEmployee::getCodeing,parameter.getData().getCodeing());
            }
        }
        if(!EmptyUtil.isEmpty(list)){
            wrapper.in(UfcSysEmployee::getEmployeeOid,list);
        }else{
            return new Result().toSuccess(new Page<EmpListVo>());
        }
        Page<UfcSysEmployee> employeePage = page(new Page<>(parameter.getPageNum(), parameter.getPageSize()), wrapper);
        if(0==employeePage.getTotal()){
            return new Result().toSuccess(new Page<EmpListVo>());
        }
        List<EmpListVo> employees=new ArrayList<>();
        Page<EmpListVo> empListVoPage=new Page<>();
        BeanUtils.copyProperties(employeePage,empListVoPage);
        for (UfcSysEmployee record : employeePage.getRecords()) {
            Long oid = record.getEmployeeOid();
            EmpListVo listVo = new EmpListVo();
            BeanUtils.copyProperties(record,listVo);
            listVo.setEmployeeOid(oid.toString());
            employees.add(listVo);
        }
        empListVoPage.setRecords(employees);
        return new Result<Page<EmpListVo>>().toSuccess().setData(empListVoPage);
    }
}
