package com.jln.system.web.action.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Profile;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
@Profile({"dev","master","stage"})
public class SwaggerConfig {
    @Bean("基础数据管理")
    public Docket createRestApibm() {
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("基础数据管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/bm.*"))
                .build();
    }
    @Bean("生产计划管理")
    public Docket createRestApipp() {
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("生产计划管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/pp.*"))
                .build();
    }
    @Bean("生产调度管理")
    public Docket createRestApips() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("生产调度管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/ps.*"))
                .build();
    }
    @Bean("生产异常管理")
    public Docket createRestApiam() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("生产异常管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/am.*"))
                .build();
    }
    @Bean("质量管理")
    public Docket createRestApiqc() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("质量管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/qc.*"))
                .build();
    }

    @Bean("SPC接口文档")
    public Docket createRestApiqc_spc() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("SPC接口文档")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/spc.*"))
                .build();
    }
    @Bean("系统管理")
    public Docket createRestApi() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("系统管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/sm.*"))
                .build();
    }
    @Bean("人员管理")
    public Docket createRestApipm() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("人员管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/pm.*"))
                .build();
    }
    @Bean("工装管理")
    public Docket createRestApifm() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("工装管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/fm.*"))
                .build();
    }
    @Bean("车间核算")
    public Docket createRestApiwa() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("车间核算")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/wa.*"))
                .build();
    }

    @Bean("移动端APP")
    public Docket createRestApima() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("移动端APP")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/ma.*"))
                .build();
    }
    @Bean("设备管理")
    public Docket createRestApiem() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("设备管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/em.*"))
                .build();
    }
    @Bean("物料管理")
    public Docket createRestApiwl() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("物料管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/mc.*"))
                .build();
    }

    @Bean("文档管理")
    public Docket createRestApidm() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("文档管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/dm.*"))
                .build();
    }

    @Bean("可视化排程管理")
    public Docket createRestApiksh() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("可视化排程管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/vs.*"))
                .build();
    }
    @Bean("目视化管理")
    public Docket createRestApikshkb() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("目视化管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/vm.*"))
                .build();
    }

    @Bean("公共基础数据接口")
    public Docket createRestComWeb() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("公共基础数据接口")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/commonweb.*"))
                .build();
    }

    @Bean("质量追溯管理")
    public Docket createRestApipt() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("pt")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/pt.*"))
                .build();
    }
    @Bean("刀具管理")
    public Docket createRestApictcreateRestApict() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("刀具管理")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/ct.*"))
                .build();
    }

    @Bean("标识管理模块")
    public Docket createRestApiBS() {
        return new Docket(DocumentationType.SWAGGER_2)
               
                .groupName("标识管理模块")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/bs.*"))
                .build();
    }
    @Bean("销售订单模块")
    public Docket createRestApiXSDD() {
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("销售订单模块")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/xsdd.*"))
                .build();
    }
    @Bean("实验室管理模块")
    public Docket createRestApiLab() {
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("实验室管理模块")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/lm.*"))
                .build();
    }

    @Bean("UFC管理模块")
    public Docket createRestApiUfc() {
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("UFC管理模块")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/ufc.*"))
                .build();
    }

    @Bean("ERP管理模块")
    public Docket createRestApiErp() {
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("ERP管理模块")
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jln.system"))
                .paths(PathSelectors.regex("/erp.*"))
                .build();
    }

    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("Spring Boot")
                .contact(new Contact("Bryan", "http://blog.bianxh.top/", ""))
                .version("1.0")
                .description("API")
                .build();
    }
}
