package com.jln.system.web.action.flywayhistory;


import com.jln.system.web.action.erp.flywayhistory.ErpDateBaseUpdate;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;

@Slf4j
@Service
public class FlywayModuleUtils {

    @Autowired
    private FlywayModule flywayModule;

    @Autowired
    private ErpDateBaseUpdate erpDateBaseUpdate;


    @Autowired
    private SystemDateBaseUpdate systemDateBaseUpdate;

    private static  String enabled;
    @Value("${spring.flyway.manual-enable}")
    public  void setEnabled(String enabled){
        FlywayModuleUtils.enabled=enabled;
    }

    @PostConstruct
    public void init(){
        if(Boolean.parseBoolean(enabled)){
            try {
                //执行产品部件的更新
                flywayModule.init();
                //执行当前项目定制的更新
                systemDateBaseUpdate.DateBaseUpdate();
                //执行erp相关接口对接字段的SQL更新
                erpDateBaseUpdate.DateBaseUpdate();
            }catch (Exception ex){
//                log.error("执行更新失败",ex);
                ex.printStackTrace();
                //异常抛出，程序终止
                throw ex;
            }

        }

    }
}
