package com.jln.system.web.action.erp.gxbg.controller;

import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.system.web.action.erp.gxbg.dto.ErpGxZyListAdd;
import com.jln.system.web.action.erp.gxbg.service.GxZyService;
import com.jln.system.web.action.erp.supplier.entity.Supplier;
import com.jln.system.web.action.erp.supplier.service.SupplierService;
import com.jln.system.web.action.ps.gxzyd.viewentity.GxZyJobConfirmDTO;
import com.jln.system.web.action.ps.gxzyd.viewentity.GxZyJobOfferDTO;
import com.jln.system.web.action.ps.gxzyd.viewentity.GxZyListAdd;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/erp/gxzy")
@Api(tags = "erp工序转移")
public class GxZyController {



    @Autowired
    private SupplierService supplierService;

    @Autowired
    private GxZyService gxZyService;

    @ApiOperation(value = "erp工序转移保存接口", notes = "erp工序转移保存接口")
    @PostMapping("addErpGxzy")
    public Result erpGxzy(@RequestBody ErpGxZyListAdd gxZyListAdd, @LoginUser User user) {
        return gxZyService.addGzZy(gxZyListAdd,user);
    }

    @ApiOperation(value = "erp-工序转移-转出人提交",notes="erp-工序转移-转出人提交")
    @PostMapping("/submitTransferee")
    public Result submitTransferee(@RequestBody GxZyJobOfferDTO dto, @LoginUser User user){
        try {
            return  gxZyService.erpGxzy(dto,user);
        } catch (Exception e) {
            return new Result().toFailure(e.getMessage());
        }
    }

    @ApiOperation(value = "工位机-工序转移详情-工序转出",notes="工位机-工序转移详情-工序转出")
    @PostMapping("/getErpGxZyListAdd")
    public Result<GxZyListAdd> getGxZyListAdd(@RequestBody GxZyJobOfferDTO dto,@LoginUser User user){
        return gxZyService.getGxZyListAdd(dto,user);
    }

    /**
     * 供应商下拉列表getGxZyListAdd
     */
    @ApiOperation(value = "供应商下拉列表",notes="供应商下拉列表")
    @PostMapping("/getGyxList")
    public Result getGyxList(@RequestBody PageParameter<Supplier> param){
        return supplierService.getGyxList(param);
    }

    /**
     * 确认提交
     * @param dto
     * @param user
     * @return
     */
    @ApiOperation(value = "工序转移--接收",notes="工序转移--接收")
    @PostMapping("/confirmationReceipt")
    public   Result confirmationReceipt(@RequestBody GxZyJobConfirmDTO dto, @LoginUser User user){
        try {
            return gxZyService.confirmationReceipt(dto,user);
        } catch (Exception e) {
            return new Result().toFailure(e.getMessage());
        }
    }

    @ApiOperation(value = "工位机-工序转移-主键查询zbgx状态",notes="工位机-工序转移-主键查询zbgx状态")
    @GetMapping("/getJudgeZbgx")
    public Result getJudgeZbgx(Long psWbFk){
        return gxZyService.getJudgeZbgx(psWbFk);
    }


    @ApiOperation(value = "转出撤回(组织->供应商)",notes="转出撤回(组织->供应商)")
    @PostMapping("/repealSubmitTransferee")
    public Result repealSubmitTransferee(@RequestBody GxZyJobOfferDTO dto,@LoginUser User user){
        return gxZyService.repealSubmitTransferee(dto,user);
    }

    @ApiOperation(value = "接收撤回(供应商->组织)",notes="接收撤回(供应商->组织)")
    @PostMapping("/repealConfirmationReceipt")
    public   Result repealConfirmationReceipt(@RequestBody GxZyJobOfferDTO dto,@LoginUser User user){
        return gxZyService.repealConfirmationReceipt(dto,user);
    }
    @ApiOperation(value = "工序转移删除接口",notes="工序转移删除接口")
    @PostMapping("/del")
    public   Result del(@RequestParam Long gxzydmxoid){
        return gxZyService.del(gxzydmxoid);
    }

}
