package com.jln.system.web.action.erp.gxbg.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.system.web.action.ps.production.pojo.dto.WbUpDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2021/6/17 10:28
 * Version:1.0
 **/
@Data
@ApiModel(value = "WbRptJobAddDto",description = "工单反馈的数据在工位机上面的添加对象")
@JsonIgnoreProperties(ignoreUnknown = true)
public class UfcWbRptJobAddDto {


    @ApiModelProperty(example = "0.000", value = "合格数量",required = true,dataType = "BigDecimal")
    private BigDecimal hgsl;

    @Length(max =250,message = "备注不能超过250字")
    @ApiModelProperty(example = "反馈说明：250字", value = "反馈说明",required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "0", value = "生产工单外键",required = true,dataType = "Long")
    private Long psWbFk;

    @ApiModelProperty(value = "物料信息-后端没处理给前端用的")
    private String wlInfo;

    @ApiModelProperty(value = "物料信息批次号-后端没处理给前端用的")
    private String wlInfoPh;

    @ApiModelProperty(value = "工单产出物料外键")
    private Long psWbOutFk;

    @ApiModelProperty(value = "是否不合格汇报：不合格汇报 true，合格汇报 false")
    private Boolean qualified;

    @DecimalMin(value = "0",message = "数量不能小于零")
    @ApiModelProperty(example = "0.000", value = "人工工时：保留三位小数")
    private BigDecimal rggs;

    @ApiModelProperty(value = "生产工单汇报主键")
    private Long psWbrptoid;

    /**
     * 2022-2-28 新增字段
     * 质量等级名称
     */
    private String mxZldjMc;

    /**
     * 精度名称
     */
    private String mxJdmc;

    /**
     * 温度系数名称
     */
    private String mxWdxsMc;

    /**
     * 产出物料批次号
     */
    private String ccwlpch;

    /**
     * 不合格数据说明
     */
    private List<WbUpDto> wbUpDtoList;

    @NotBlank(message = "请指定绑定方式")
    @ApiModelProperty(example = "物料绑定方式:sn|序列号,bt|批次号", required = true,dataType = "string")
    private String bdfs;

    /**
     * 产品批号
     */
    private String cpph;

    @ApiModelProperty(value = "设备外键")
    private List<Long> ufcEmEqucodoidFk;

    @ApiModelProperty(value = "接收说明改为接收不合格数，再作业反馈中保存到不合格数中")
    private String proofOfReceipt;

    @ApiModelProperty(value = "不合格类型")
    private String bhgfl;

    @ApiModelProperty(value = "不合格说明")
    private String bhgsm;
    @ApiModelProperty(value = "反馈日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")                    // 表示返回时间类型
    @JsonFormat(pattern="yyyy-MM-dd", timezone = "GMT+8")      // 表示接收时间类型
    private LocalDate fDate;

    @ApiModelProperty(value = "是否委外")
    private Boolean isOutsourcing;
    @ApiModelProperty(value = "批号日期")
    private LocalDate phrq;
}
