package com.jln.system.web.action.erp.gxbg.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.QcTypeEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.system.web.action.bm.B_Material.entity.BMaterial;
import com.jln.system.web.action.bm.B_Material.service.BMaterialService;
import com.jln.system.web.action.bm.factory.entity.BFactory;
import com.jln.system.web.action.bm.factory.service.BFactoryService;
import com.jln.system.web.action.bm.workshop.entity.BWorkshop;
import com.jln.system.web.action.bm.workshop.service.BWorkshopService;
import com.jln.system.web.action.commonweb.parameterize.service.SysBusinessService;
import com.jln.system.web.action.erp.gxbg.dto.*;
import com.jln.system.web.action.erp.gxbg.entity.UfcErpPsWbrpt;
import com.jln.system.web.action.erp.gxbg.entity.dto.UfcWbRptJobAddDto;
import com.jln.system.web.action.erp.gxbg.mapper.UfcErpPsWbrptMapper;
import com.jln.system.web.action.erp.gxbg.service.GxBgService;
import com.jln.system.web.action.erp.gxbg.service.UfcErpPsWbrptService;
import com.jln.system.web.action.erp.material.entity.ErpJd;
import com.jln.system.web.action.erp.ufcpswb.mapper.UfcPsWbMapper;
import com.jln.system.web.action.erp.ufcpswb.service.UfcPsWbService;
import com.jln.system.web.action.erp.wo.entity.UfcErpWo;
import com.jln.system.web.action.erp.wo.entity.WoExpand;
import com.jln.system.web.action.erp.wo.mapper.UfcErpWoMapper;
import com.jln.system.web.action.erp.wo.mapper.WoExpandMapper;
import com.jln.system.web.action.pp.planImport.entity.Wo;
import com.jln.system.web.action.pp.planImport.mapper.WoMapper;
import com.jln.system.web.action.ps.gwj.entity.PsWt;
import com.jln.system.web.action.ps.gwj.mapper.BzzMapper;
import com.jln.system.web.action.ps.gwj.pojo.dto.DjhCreateDto;
import com.jln.system.web.action.ps.gwj.service.JobDispatchingHandleService;
import com.jln.system.web.action.ps.gwj.service.PsWtService;
import com.jln.system.web.action.ps.production.entity.PsSn;
import com.jln.system.web.action.ps.production.entity.PsWb;
import com.jln.system.web.action.ps.production.entity.PsWbrpt;
import com.jln.system.web.action.ps.production.pojo.dto.WbUpDto;
import com.jln.system.web.action.ps.production.pojo.vo.ProcessNodeVO;
import com.jln.system.web.action.ps.production.service.*;
import com.jln.system.web.action.qc.QualityInspectionWork.entity.QcBill;
import com.jln.system.web.action.qc.obj.entity.AccordingDTO;
import com.jln.system.web.action.qc.qcRule.entity.QcRule;
import com.jln.system.web.action.sm.common.service.CodeTableService;
import com.jln.system.web.action.util.CookieData;
import com.jln.system.web.action.util.ERPHttpUtils;
import com.jln.system.web.action.util.ERPParam;
import com.jln.ufc.web.action.ufc.ps.mapper.UfcPsWbrptMapper;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsWbrpt;
import com.jln.ufc.web.action.ufc.qc.entity.*;
import com.jln.ufc.web.action.ufc.qc.mapper.UfcHmBillMapper;
import com.jln.ufc.web.action.ufc.qc.mapper.UfcQcBillMapper;
import com.jln.ufc.web.action.ufc.qc.mapper.UfcQcStdmxMapper;
import com.jln.ufc.web.action.ufc.qc.mapper.UfcQcTyRuleMapper;
import com.jln.ufc.web.action.ufc.qc.service.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;
import java.util.stream.Collectors;

import static com.jln.system.web.action.util.ERPHttpUtils.login;

@Service
@Slf4j
public class GxBgServiceImpl implements GxBgService {
    @Autowired
    private PsWbService psWbService;
    @Autowired
    private PsWbrptService psWbrptService;
    @Autowired
    private WoMapper woMapper;
    @Autowired
    @Qualifier("erpWoExpandMapper")
    private WoExpandMapper woExpandMapper;
    @Autowired
    private UfcErpPsWbrptService ufcErpPsWbrptService;
    @Value("${erp.ERP_SAVE_URL}")
    private String ERP_SAVE_URL;
    @Autowired
    private SysBusinessService sysBusinessService;
    @Autowired
    @Qualifier("ufcErpPsWbMapper")
    private UfcPsWbMapper ufcPsWbMapper;
    @Autowired
    private UfcPsWbService ufcPsWbService;
    @Autowired
    private PsWtService psWtService;
    @Autowired
    private BMaterialService bMaterialService;
    @Autowired
    private BFactoryService bFactoryService;
    @Autowired
    private BWorkshopService bWorkshopService;
    @Autowired
    private PsSnService psSnService;
    @Autowired
    private PsTechnologicalProcessService technologicalProcessService;
    @Autowired
    private BzzMapper bzzMapper;
    @Autowired
    private JobDispatchingHandleService jobDispatchingHandleService;
    @Autowired
    private UfcErpPsWbrptMapper ufcErpPsWbrptMapper;
    @Autowired
    private UfcQcBillService qcBillService;
    @Autowired
    private CodeTableService codeTableService;
    @Autowired
    private UfcQcSampleService ufcQcSampleService;
    @Autowired
    private UfcQcSampleStdService ufcQcSampleStdService;
    @Autowired
    private UfcHmBillService ufcHmBillService;
    @Autowired
    private UfcErpWoMapper ufcErpWoMapper;
    @Autowired
    private UfcQcTyRuleMapper ufcQcTyRuleMapper;
    @Autowired
    private UfcQcStdmxMapper ufcQcStdmxMapper;
    @Autowired
    private UfcPsWbrptMapper ufcPsWbrptMapper;
    @Autowired
    private UfcHmBillMapper ufcHmBillMapper;
    /**
     * 工序汇报
     * @param dtos
     * @param user
     * @return
     * @throws Exception
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public synchronized Result addReportReccord(List<UfcWbRptJobAddDto> dtos, User user) throws Exception {
        if(EmptyUtil.isEmpty(dtos.get(0).getHgsl())){
            return new Result().toFailure("合格数量不能为空！");
        }
        //查询工段信息
        PsWbDto pswb = ufcPsWbMapper.getPsWbInfo(dtos.get(0).getPsWbFk());

        //查询当前流转卡已汇报数量
        Integer count = woExpandMapper.selectCountBgsl(pswb.getPsWboid());
        int sum = count==null ? 0 : count;

        //判断是否需要首检
        if(!EmptyUtil.isEmpty(pswb) && pswb.getFirstInspectionProcess()){
            //判断工序是否已经首检完成
            LambdaQueryWrapper<UfcHmQcBill> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(UfcHmQcBill::getPsWbFk,pswb.getPsWboid());
            lambdaQueryWrapper.eq(UfcHmQcBill::getSfzj,false);
            lambdaQueryWrapper.eq(UfcHmQcBill::getGxJyfs,'S');
            int sj = ufcHmBillService.count(lambdaQueryWrapper);
            if(sj>0){
                throw new CustomException(-1, "未完成首检！");
            }

        }

        //查询当前工单汇报数量(合格数量+不合格数量 不包含当前汇报记录数量)
        BigDecimal hbsl = ufcPsWbService.selectHbsl(pswb.getPsWboid(),dtos.get(0).getPsWbrptoid());

        hbsl = hbsl==null?new BigDecimal(0):hbsl;

        //查询当前汇报记录不合格数量
        BigDecimal currentBhgsl = new BigDecimal(0);
        for (WbUpDto wbUpDto : dtos.get(0).getWbUpDtoList()) {
            if(!EmptyUtil.isEmpty(wbUpDto.getUnqualifiedQuantity())){
                currentBhgsl = currentBhgsl.add(wbUpDto.getUnqualifiedQuantity());
            }
        }


        //当前汇报数量+已汇报数量 > 排产数量
        if(hbsl.add(currentBhgsl).add(dtos.get(0).getHgsl()).compareTo(pswb.getPcsl())==1){
            throw new CustomException(-1, "汇报数量大于排产数量！");
        }

        //查询上一道工单合格数量
        Result<Integer> thePreviousPsWb = ufcPsWbService.getThePreviousPsWbNumber(pswb.getPsWboid());
        if(thePreviousPsWb.getCode()==0){
            //不允许本道工序作业反馈完工数量大于上道工序完工数量
            if(!verify("UFC_PSK0508")){
                if( hbsl.add(dtos.get(0).getHgsl()).intValue() > thePreviousPsWb.getData()){
                    return new Result().toFailure("工序作业反馈完工数量大于上道工序完工数量！");
                }
            }
        }

        // MES工序汇报
        Result result =ufcErpPsWbrptService.addReportRecord(dtos, user);
        if(!result.confirmSuccess()){
            return new Result().toFailure(result.getMsg());
        }
        //修改产品批号
        ufcErpPsWbrptService.updateCpph(pswb.getPsWboid(), dtos.get(0).getCpph());

        return new Result().toSuccess(result.getData());
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result erpGxbg(String pswbrptoid, User user) {
        Long psWbrptOid = null;
        if(EmptyUtil.isEmpty(pswbrptoid) || pswbrptoid.equals("undefined")){
            return new Result().toFailure("请先保存数据！");
        }else {
            psWbrptOid = Long.parseLong(pswbrptoid);
        }
        UfcErpPsWbrpt ufcerppswbrpt = ufcErpPsWbrptMapper.selectById(pswbrptoid);
        if(ufcerppswbrpt.getZt()=='R'){
            return new Result().toFailure("工序已经汇报，请勿重复提交！");
        }
        PsWbrpt pswbrpt = psWbrptService.getById(pswbrptoid);
        PsWb pswb = psWbService.getById(pswbrpt.getPsWbFk());
        LambdaQueryWrapper<PsWt> psWtLambdaQueryWrapper = new LambdaQueryWrapper<>();
        psWtLambdaQueryWrapper.eq(PsWt::getPsWbFk,pswb.getPsWboid());
        PsWt pswt = psWtService.getOne(psWtLambdaQueryWrapper);
        //判断是否需要专检
        if(pswt.getSfzj()){
            LambdaQueryWrapper<UfcHmQcBill> lambdaQuery = new LambdaQueryWrapper<>();
            lambdaQuery.eq(UfcHmQcBill::getPsWbrptFk,pswbrptoid);
            lambdaQuery.eq(UfcHmQcBill::getGxJyfs,'Z');
            List<UfcHmQcBill> list = ufcHmBillService.getBaseMapper().selectList(lambdaQuery);

            if(EmptyUtil.isEmpty(list)){
                throw new CustomException(-1, "未提交专检！");
            }

            LambdaQueryWrapper<UfcHmQcBill> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(UfcHmQcBill::getPsWbrptFk,pswbrptoid);
            lambdaQueryWrapper.eq(UfcHmQcBill::getSfzj,false);
            lambdaQueryWrapper.eq(UfcHmQcBill::getGxJyfs,'Z');
            int count = ufcHmBillService.count(lambdaQueryWrapper);
            if(count>0){
                return new Result().toFailure("未完成专检！");
            }

            List<Long> oid = list.stream().map(p -> p.getQcBillOid()).collect(Collectors.toList());

            LambdaQueryWrapper<UfcQcBill> wrapper = new LambdaQueryWrapper<>();
            wrapper.in(UfcQcBill::getQcBilloid,oid);
            wrapper.orderByDesc(UfcQcBill::getSysLastUpd);
            wrapper.last("limit 1");
            UfcQcBill isHg = qcBillService.getOne(wrapper);
            if(!isHg.getHg()){
                return new Result().toFailure("专检不合格，请联系相关人员确认后重新提交专检");
            }
        }
        //查询订单信息
        Wo wo =woMapper.selectById(pswb.getWoFk());
        LambdaQueryWrapper<WoExpand> wrapper = new LambdaQueryWrapper();
        wrapper.eq(WoExpand::getWoid,wo.getWoid());
        WoExpand woexpand = woExpandMapper.selectOne(wrapper);
        if(EmptyUtil.isEmpty(woexpand)){
            throw new CustomException(-1, "查询订单扩展参数为空");
        }

        //查询当前工序汇报数量(合格数量+不合格数量)
        BigDecimal hbsl = ufcPsWbService.selectHbsl(pswb.getPsWboid(),psWbrptOid);
        BigDecimal sl = pswbrpt.getHgsl().add((hbsl==null?new BigDecimal(0):hbsl));
        // TODO: 2022/3/22  工序完工数量控制
        //查询上一道工单合格数量
        Result<Integer> thePreviousPsWb = ufcPsWbService.getThePreviousPsWbNumber(pswb.getPsWboid());
        //查询不合格数量
        BigDecimal bhgsl = ufcPsWbService.selectBhgsl(pswbrpt.getPsWbFk());
        bhgsl = bhgsl==null?new BigDecimal(0):bhgsl;

        //查询当前工序已汇报数量(已确认:合格数量+不合格数量)
        BigDecimal yhbsl = ufcPsWbService.selectYhbsl(pswb.getPsWboid());
        yhbsl = yhbsl==null?new BigDecimal(0):yhbsl;
        //查询当前汇报记录数量 ：合格数量+不合格数量
        BigDecimal hbslById = ufcPsWbService.selectHbslById(psWbrptOid);

        //判断是否存在上道工序 如果不存在则合格数量+不合格数量时自动完工
        if (thePreviousPsWb.confirmSuccess()){
            if (hbslById.add(yhbsl).compareTo(BigDecimal.valueOf(thePreviousPsWb.getData())) ==1){
                return new Result().toFailure("当前工序的反馈数量不能大于上道工序的合格数量。");
            }
            if (hbslById.add(yhbsl).compareTo(BigDecimal.valueOf(thePreviousPsWb.getData())) ==0){
                //后续工序反馈:合格数量+不合格数量―不能大于上道工序合格数量，等于上道工序合格数量时，本工序自动完工。
                ufcErpPsWbrptService.verify7("PSK011", BigDecimal.valueOf(thePreviousPsWb.getData()), yhbsl.add(hbslById), pswb.getPsWboid(), user);
            }
        }else{
            //第一道工序
            if (hbslById.add(yhbsl).compareTo(pswb.getPcsl()) ==0){
                //后续工序反馈:合格数量+不合格数量―不能大于上道工序合格数量，等于上道工序合格数量时，本工序自动完工。
                ufcErpPsWbrptService.verify7("PSK011", pswb.getPcsl(), yhbsl.add(hbslById), pswb.getPsWboid(), user);
            }
        }


        /*else {
            ufcErpPsWbrptService.verify7("PSK011", pswb.getPcsl(), sl.add(bhgsl), pswb.getPsWboid(), user);
        }*/

        //根据订单erp汇报数量
        Integer erpBgsl =ufcErpPsWbrptService.selectErpBgsl(pswb.getPsWboid());
        erpBgsl = erpBgsl == null ? 0 : erpBgsl;

        ufcErpPsWbrptService.update(
                new LambdaUpdateWrapper<UfcErpPsWbrpt>()
                        .set(UfcErpPsWbrpt::getZt,'R')
                        .eq(UfcErpPsWbrpt::getUfcErpPsWbrptOid,psWbrptOid)
        );

        BigDecimal erpHbsl = new BigDecimal(0);
        // 已汇报数量 < 订单数量
        if(erpBgsl < woexpand.getErpjh() && pswbrpt.getHgsl().intValue()>0){
            erpHbsl = pswbrpt.getHgsl();
            //已汇报数量 + 当前汇报数量 > 订单数量
            if(erpBgsl+pswbrpt.getHgsl().intValue() > woexpand.getErpjh().intValue()){
                erpHbsl = new BigDecimal(woexpand.getErpjh().intValue() - erpBgsl);
            }
            //erp工序汇报
            try {
                //addReportRecord(ufcWbRptJobAddDto,wo,pswb.getPsWboid(),psWbrptOid,user);
                //查询订单扩展表数据
                LambdaQueryWrapper<UfcErpWo> lambdaQueryWrapper = new LambdaQueryWrapper<>();
                lambdaQueryWrapper.eq(UfcErpWo::getWoFk,wo.getWooid());
                UfcErpWo ufcErpWo = ufcErpWoMapper.selectOne(lambdaQueryWrapper);

                MesResultFiled mesResultFiled = woExpandMapper.selectErpParam(psWbrptOid);
                if(EmptyUtil.isEmpty(mesResultFiled)){
                    throw new Exception("工序汇报erp参数为空,请检查参数！");
                }
                //查询erp工厂编码和车间编码
                String gcid = woExpandMapper.selectGcid(wo.getBFactoryFk());
                String cjid = woExpandMapper.selectCjid(wo.getBWorkshopFk());

                //查询产出批次号
                String ccpch = woExpandMapper.selectCcpch(psWbrptOid);

                Result<CookieData> login = login();
                if(login.getCode()==-1){
                    throw new Exception(login.getMsg());
                }
                Map<String, Object> model = new LinkedHashMap<>();
                Map<String,Object> param=new LinkedHashMap<>();
                try {

                    Map<String,Object> fPrdOrgId = new HashMap<>();
                    fPrdOrgId.put("FNumber",gcid);
                    Map<String,Object> fWorkShopID = new HashMap<>();
                    fWorkShopID.put("FNUMBER",cjid);
                    Map<String,Object> fBillTypeID = new HashMap<>();
                    fBillTypeID.put("FNUMBER","GXHB03_SYS");
                    Map<String,Object> f_260_SJQR = new HashMap<>();
                    f_260_SJQR.put("FSTAFFNUMBER","");
                    Map<String,Object> f_220_BaseHCYFXM = new HashMap<>();
                    f_220_BaseHCYFXM.put("FNUMBER","");
                    Map<String,Object> f_220_BaseFGGX = new HashMap<>();
                    f_220_BaseFGGX.put("FNUMBER","");
                    Map<String,Object> f_101_BaseXSLX = new HashMap<>();
                    f_101_BaseXSLX.put("FNUMBER",mesResultFiled.getDjtXslxId());

                    model.put("FID",0);
                    model.put("FPrdOrgId",fPrdOrgId);
                    model.put("FWorkShopID",fWorkShopID);
                    model.put("FBillTypeID",fBillTypeID);
                    model.put("FDate",pswbrpt.getFkrq()==null?"":pswbrpt.getFkrq().toLocalDate());
                    model.put("FDescription","");
                    model.put("FIsEntrust",false);
                    model.put("FBoxNumber","");
                    model.put("FBillGenType","A");
                    model.put("FTotalRptQty",0);
                    model.put("F_220_Datesjhbrq",LocalDate.now());
                    model.put("FIsSynced",false);
                    model.put("F_260_SFNPI","");
                    model.put("F_260_SJQR",f_260_SJQR);
                    model.put("F_220_BaseHCYFXM",f_220_BaseHCYFXM);
                    model.put("FIsDelayAudit",false);
                    model.put("F_220_CheckBox",false);
                    model.put("F_260_JJRQ",LocalDate.now());
                    model.put("F_220_SFFG","");
                    model.put("F_220_BaseFGGX",f_220_BaseFGGX);
                    model.put("F_101_TextKHMC",mesResultFiled.getDjtKhmc()==null? "":mesResultFiled.getDjtKhmc());
                    model.put("F_101_BaseXSLX",f_101_BaseXSLX);
                    model.put("F_101_TextLZKH",mesResultFiled.getJhid()==null?"":mesResultFiled.getJhid());
                    model.put("F_101_TextDDLX",mesResultFiled.getMxYdlx()==null?"":mesResultFiled.getMxYdlx());

                    Map<String,Object> fMaterialId = new HashMap<>();
                    fMaterialId.put("FNUMBER",mesResultFiled.getWlid());
                    Map<String,Object> fUnitID = new HashMap<>();
                    fUnitID.put("FNumber",mesResultFiled.getDwid()==null?"":mesResultFiled.getDwid());
                    Map<String,Object> f_220_Assistantsjzldj = new HashMap<>();
                    f_220_Assistantsjzldj.put("FNumber","");
                    Map<String,Object> fReportType = new HashMap<>();
                    fReportType.put("FNUMBER","1224163");
                    Map<String,Object> fHMSXKHBQYD = new HashMap<>();
                    fHMSXKHBQYD.put("FNUMBER","");

                    Map<String,Object> fAUXPROPID__FF100001 = new HashMap<>();
                    if(EmptyUtil.isEmpty(ufcerppswbrpt.getMxZldjMc())){
                        fAUXPROPID__FF100001.put("FNumber",ufcErpWo.getMxFzsxmcZldj());
                    }else {
                        fAUXPROPID__FF100001.put("FNumber",ufcerppswbrpt.getMxZldjMc());
                    }
                    Map<String,Object> fAUXPROPID__FF100002 = new HashMap<>();
                    if(EmptyUtil.isEmpty(ufcerppswbrpt.getMxJdmc())){
                        fAUXPROPID__FF100002.put("FNumber",ufcErpWo.getMxFzsxmcJd());
                    }else {
                        fAUXPROPID__FF100002.put("FNumber",ufcerppswbrpt.getMxJdmc());
                    }

                    Map<String,Object> fShiftSliceId = new HashMap<>();
                    fShiftSliceId.put("FNUMBER","");
                    Map<String,Object> fShiftGroupId = new HashMap<>();
                    fShiftGroupId.put("FNUMBER","0");
                    Map<String,Object> fResourceId = new HashMap<>();
                    fResourceId.put("FNUMBER","0");
                    Map<String,Object> fEquipmentId = new HashMap<>();
                    fEquipmentId.put("FNUMBER","");
                    Map<String,Object> fInspector = new HashMap<>();
                    fInspector.put("FSTAFFNUMBER","0");
                    Map<String,Object> fActivity1Id = new HashMap<>();
                    fActivity1Id.put("FNUMBER","JBHD01_SYS");
                    Map<String,Object> fActivity2Id = new HashMap<>();
                    fActivity2Id.put("FNUMBER","JBHD02_SYS");
                    Map<String,Object> fActivity3Id = new HashMap<>();
                    fActivity3Id.put("FNUMBER","JBHD03_SYS");
                    Map<String,Object> fActivity4Id = new HashMap<>();
                    fActivity4Id.put("FNUMBER","");
                    Map<String,Object> fActivity5Id = new HashMap<>();
                    fActivity5Id.put("FNUMBER","");
                    Map<String,Object> fActivity6Id = new HashMap<>();
                    fActivity6Id.put("FNUMBER","");
                    Map<String,Object> fActivity1UnitID = new HashMap<>();
                    fActivity1UnitID.put("FNumber","minute");
                    Map<String,Object> fActivity2UnitID = new HashMap<>();
                    fActivity2UnitID.put("FNumber","minute");
                    Map<String,Object> fActivity3UnitID = new HashMap<>();
                    fActivity3UnitID.put("FNumber","minute");
                    Map<String,Object> fActivity4UnitID = new HashMap<>();
                    fActivity4UnitID.put("FNumber","");
                    Map<String,Object> fActivity5UnitID = new HashMap<>();
                    fActivity5UnitID.put("FNumber","");
                    Map<String,Object> fActivity6UnitID = new HashMap<>();
                    fActivity6UnitID.put("FNumber","");
                    Map<String,Object> fStockInOrgId = new HashMap<>();
                    fStockInOrgId.put("FNumber",gcid);
                    Map<String,Object> fMoPrdOrgId = new HashMap<>();
                    fMoPrdOrgId.put("FNumber",gcid);
                    Map<String,Object> fMoPrdDept = new HashMap<>();
                    fMoPrdDept.put("FNUMBER",cjid);
                    Map<String,Object> fBaseUnitID = new HashMap<>();
                    fBaseUnitID.put("FNumber",mesResultFiled.getDwid()==null?"":mesResultFiled.getDwid());
                    Map<String,Object> fPrdUnitID = new HashMap<>();
                    fPrdUnitID.put("FNumber",mesResultFiled.getDwid()==null?"":mesResultFiled.getDwid());
                    Map<String,Object> fOwnerId = new HashMap<>();
                    fOwnerId.put("FNumber","");
                    Map<String,Object> fBomId = new HashMap<>();
                    fBomId.put("FNUMBER",mesResultFiled.getBomBb());
                    Map<String,Object> fRouteId = new HashMap<>();
                    fRouteId.put("FNUMBER","");
                    Map<String,Object> fStockId = new HashMap<>();
                    fStockId.put("FNUMBER","");
                    Map<String,Object> fQCSchemeId = new HashMap<>();
                    fQCSchemeId.put("FNUMBER","");
                    Map<String,Object> fWorkCenterId = new HashMap<>();
                    fWorkCenterId.put("FNUMBER",mesResultFiled.getGzzx());
                    Map<String,Object> fProcessId = new HashMap<>();
                    fProcessId.put("FNUMBER",mesResultFiled.getGxid());
                    Map<String,Object> fDefectType = new HashMap<>();
                    fDefectType.put("FNUMBER","");
                    Map<String,Object> fAuxEquipmentId = new HashMap<>();
                    fAuxEquipmentId.put("FNUMBER","");
                    Map<String,Object> f_260_BaseWWGYS = new HashMap<>();
                    f_260_BaseWWGYS.put("FNUMBER","");
                    Map<String,Object> fMouldId = new HashMap<>();
                    fMouldId.put("FNUMBER","");
                    Map<String,Object> fSCKH = new HashMap<>();
                    fSCKH.put("FNumber","");
                    Map<String,Object> f_220_Basewlffr = new HashMap<>();
                    f_220_Basewlffr.put("FSTAFFNUMBER","");
                    Map<String,Object> fHMSXKH = new HashMap<>();
                    fHMSXKH.put("FNUMBER","");
                    Map<String,Object> fHMSXKHCJDYB = new HashMap<>();
                    fHMSXKHCJDYB.put("FNumber","");
                    Map<String,Object> f_101_BaseJJLX = new HashMap<>();
                    f_101_BaseJJLX.put("FID",mesResultFiled.getMxJjlx());
                    Map<String,Object> f_101_Base1ZXBZ1 = new HashMap<>();
                    f_101_Base1ZXBZ1.put("FNUMBER",mesResultFiled.getMxHnzxbzId());
                    Map<String,Object> f_101_BaseZXBZBM = new HashMap<>();
                    f_101_BaseZXBZBM.put("FNUMBER",mesResultFiled.getMxHnzxbzId());
                    Map<String,Object> f_101_BASEKHWLBM = new HashMap<>();
                    f_101_BASEKHWLBM.put("FNUMBER",mesResultFiled.getMxKhwlId());

                    Map<String,Object> fSTOCKLOCID__FF100001 = new HashMap<>();
                    fSTOCKLOCID__FF100001.put("FNumber","");
                    Map<String,Object> fSTOCKLOCID__FF100012 = new HashMap<>();
                    fSTOCKLOCID__FF100012.put("FNumber","");

                    Map<String,Object> fEmpinfoId = new HashMap<>();
                    fEmpinfoId.put("FStaffNumber",user.getEmployeeCode());
                    Map<String,Object> fSubEntity = new LinkedHashMap<>();
                    fSubEntity.put("FDETAILID",0);
                    fSubEntity.put("FEmpinfoId",fEmpinfoId);

                    Map<String,Object> fStockLocId = new LinkedHashMap<>();
                    fStockLocId.put("FSTOCKLOCID__FF100001",fSTOCKLOCID__FF100001);
                    fStockLocId.put("FSTOCKLOCID__FF100012",fSTOCKLOCID__FF100012);

                    Map<String,Object> fAuxPropId = new LinkedHashMap<>();
                    fAuxPropId.put("FAUXPROPID__FF100001",fAUXPROPID__FF100001);
                    fAuxPropId.put("FAUXPROPID__FF100002",fAUXPROPID__FF100002);

                    Map<String,Object> fEntity_Link = new LinkedHashMap<>();
                    fEntity_Link.put("FEntity_Link_FFlowId","");
                    fEntity_Link.put("FEntity_Link_FFlowLineId",0);
                    fEntity_Link.put("FEntity_Link_FRuleId","e0a7814e-59d7-48d1-900b-6df8e48b99b0");
                    fEntity_Link.put("FEntity_Link_FSTableName","T_SFC_OPERPLANNINGSEQ");
                    fEntity_Link.put("FEntity_Link_FSTableName","T_SFC_OPERPLANNINGSEQ");
                    fEntity_Link.put("FEntity_Link_FSBillId",mesResultFiled.getScjhdherId());
                    fEntity_Link.put("FEntity_Link_FSId",mesResultFiled.getGxxlid());

                    Map<String,Object> fEntity = new LinkedHashMap<>();
                    fEntity.put("FENTRYID",0);
                    fEntity.put("FMoNumber",mesResultFiled.getYdid());
                    fEntity.put("FMoRowNumber",mesResultFiled.getYdhh());
                    fEntity.put("FSourceBillType","SFC_OperationPlanning");
                    fEntity.put("FSourceBillNo",mesResultFiled.getWoid());
                    fEntity.put("FSrcInterId",mesResultFiled.getScjhdherId());
                    fEntity.put("FSrcEntrySeq",mesResultFiled.getXh()==null?1:mesResultFiled.getXh());
                    fEntity.put("FSrcEntryId",mesResultFiled.getGxxlid());
                    fEntity.put("FMoId",mesResultFiled.getYdhId());
                    fEntity.put("FMoEntryId",mesResultFiled.getYdhhId());
                    fEntity.put("FOptPlanId",mesResultFiled.getScjhdherId());
                    fEntity.put("FOptPlanSeqId",mesResultFiled.getGxxlid());
                    fEntity.put("FOptPlanOptId",mesResultFiled.getBtid());
                    fEntity.put("FOptPlanNo",mesResultFiled.getWoid());
                    fEntity.put("F_101_HMJYRQ",mesResultFiled.getPhrq());
                    Map<String,String> F_101_HMWDXSZB = new HashMap<>();
                    if(EmptyUtil.isEmpty(ufcerppswbrpt.getMxWdxsMc())){
                        F_101_HMWDXSZB.put("FNumber", ufcErpWo.getMxWdxszb());
                    }else {
                        F_101_HMWDXSZB.put("FNumber", ufcerppswbrpt.getMxWdxsMc());
                    }
                    fEntity.put("F_101_HMWDXSZB",F_101_HMWDXSZB);
            /*Map<String,String> fBFLowId = new HashMap<>();
            fBFLowId.put("FName","e1b158d0-5624-4fe1-94b3-65f1b215bf83");
            fEntity.put("FBFLowId",fBFLowId);*/
                    fEntity.put("FSeqType","M");
                    fEntity.put("FSeqNumber","0");
                    fEntity.put("FOperNumber",mesResultFiled.getSxh());
                    fEntity.put("FMaterialId",fMaterialId);
                    fEntity.put("FUnitID",fUnitID);
                    fEntity.put("FWastageQty",0);
                    fEntity.put("F_HMD_Qtysygfsl",0);
                    fEntity.put("FProcessFailQty",0);
                    fEntity.put("F_HMD_Qtyqggfsl",0);
                    fEntity.put("FMaterialFailQty",0);
                    fEntity.put("F_220_ComboBHGYY","");
                    fEntity.put("FFailQty",0);
                    fEntity.put("FReworkQty",0);
                    fEntity.put("FIsReworkRpt",false);
                    fEntity.put("FFinishQty",erpHbsl);
                    fEntity.put("FCheckSelQty",0);
                    fEntity.put("FQuaQty",erpHbsl);
                    fEntity.put("F_220_Assistantsjzldj",f_220_Assistantsjzldj);
                    fEntity.put("FManualAddNew",false);
                    fEntity.put("FPrdType",1);
                    fEntity.put("FOperDescription",mesResultFiled.getGxmc());
                    fEntity.put("FAuxPropId",fAuxPropId);
                    fEntity.put("FReportType",fReportType);
                    fEntity.put("FHMSXKHBQYD",fHMSXKHBQYD);
                    fEntity.put("F_260_XS","");

                    Map<String,Object> fLot = new HashMap<>();
                    //判断当前流转卡末道工序
                    PsWb isMdgx = woExpandMapper.selectIsMdgx(pswb.getPsWboid());
                    if(EmptyUtil.isEmpty(isMdgx)){
                        fLot.put("FNUMBER",ufcerppswbrpt.getCpph()+"."+mesResultFiled.getMxHth());
                    }else {
                        fLot.put("FNUMBER","");
                    }
                    fEntity.put("FLot",fLot);
                    fEntity.put("FConfOptStatus","B");
                    fEntity.put("FOptRemark","");
                    fEntity.put("FRefOptSeq","");
                    fEntity.put("FRefOptSeqName","");
                    fEntity.put("FRefOptNumber",0);
                    fEntity.put("FRefOptName","");
                    fEntity.put("FTotalQuaQty",0);
                    fEntity.put("FTotalFailQty",0);
                    fEntity.put("FPlanningQty",erpHbsl.intValue());
                    fEntity.put("FShiftSliceId",fShiftSliceId);
                    fEntity.put("FShiftGroupId",fShiftGroupId);
                    fEntity.put("FResourceId",fResourceId);
                    fEntity.put("FEquipmentId",fEquipmentId);
                    fEntity.put("FInspector",fInspector);
                    fEntity.put("FActivity1Id",fActivity1Id);
                    fEntity.put("FActivity2Id",fActivity2Id);
                    fEntity.put("FActivity3Id",fActivity3Id);
                    fEntity.put("FActivity4Id",fActivity4Id);
                    fEntity.put("FActivity5Id",fActivity5Id);
                    fEntity.put("FActivity6Id",fActivity6Id);
                    fEntity.put("FActivity1UnitID",fActivity1UnitID);
                    fEntity.put("FActivity2UnitID",fActivity2UnitID);
                    fEntity.put("FActivity3UnitID",fActivity3UnitID);
                    fEntity.put("FActivity4UnitID",fActivity4UnitID);
                    fEntity.put("FActivity5UnitID",fActivity5UnitID);
                    fEntity.put("FActivity6UnitID",fActivity6UnitID);
                    fEntity.put("FActivity1Qty",0);
                    fEntity.put("FActivity2Qty",pswbrpt.getRggs()==null?0:pswbrpt.getRggs().intValue());
                    fEntity.put("FActivity3Qty",0);
                    fEntity.put("FActivity4Qty",0);
                    fEntity.put("FActivity5Qty",0);
                    fEntity.put("FActivity6Qty",0);
                    fEntity.put("FSetStartTime","");
                    fEntity.put("FSetEndTime",LocalDate.now());
                    fEntity.put("FProcessStartTime",LocalDate.now());
                    fEntity.put("FProcessEndTime",LocalDate.now());
                    fEntity.put("FTeardownStartTime",LocalDate.now());
                    fEntity.put("FTeardownEndTime",LocalDate.now());
                    fEntity.put("FStockInOrgId",fStockInOrgId);
                    fEntity.put("FMoPrdOrgId",fMoPrdOrgId);
                    fEntity.put("FMoPrdDept",fMoPrdDept);
                    fEntity.put("FProjectNo","");
                    fEntity.put("FMtoNo","");
                    fEntity.put("FOptBillCreatType","A");
                    fEntity.put("FMilestoneOptNo",0);
                    fEntity.put("FMilestoneOptDesc","");
                    fEntity.put("FSrcMilesRptID",0);
                    fEntity.put("FStockInQuaSelAuxQty",0);
                    fEntity.put("FStockInQuaAuxQty",0);
                    fEntity.put("FBaseWastageQty",0);
                    fEntity.put("FStockInFailSelAuxQty",0);
                    fEntity.put("FStockInFailAuxQty",0);
                    fEntity.put("FBaseUnitID",fBaseUnitID);
                    fEntity.put("FBaseQuaQty",erpHbsl);
                    fEntity.put("FBaseProcessFailQty",0);
                    fEntity.put("FBaseMaterialFailQty",0);
                    fEntity.put("FBaseFailQty",0);
                    fEntity.put("FBaseReworkQty",0);
                    fEntity.put("FBaseFinishQty",erpHbsl);
                    fEntity.put("FBaseStockInQuaSelQty",0);
                    fEntity.put("FBaseStockInFailSelQty",0);
                    fEntity.put("FBaseStockInQuaQty",0);
                    fEntity.put("FPrdWastageQty",0);
                    fEntity.put("FBaseStockInFailQty",0);
                    fEntity.put("FPrdUnitID",fPrdUnitID);
                    fEntity.put("FPrdQuaQty",erpHbsl);
                    fEntity.put("FPrdProcessFailQty",0);
                    fEntity.put("FPrdMaterialFailQty",0);
                    fEntity.put("FPrdFailQty",0);
                    fEntity.put("FPrdReworkQty",0);
                    fEntity.put("FPrdFinishQty",erpHbsl);
                    fEntity.put("FPrdStockInQuaSelQty",0);
                    fEntity.put("FPrdStockInQuaQty",0);
                    fEntity.put("FPrdStockInFailSelQty",0);
                    fEntity.put("FPrdStockInFailQty",0);
                    fEntity.put("FOwnerTypeId","");
                    fEntity.put("FOwnerId",fOwnerId);
                    fEntity.put("FBomId",fBomId);
                    fEntity.put("FRouteId",fRouteId);
                    fEntity.put("FUnitTransHeadQty",1);
                    fEntity.put("FUnitTransOperQty",1);
                    fEntity.put("FStockId",fStockId);
                    fEntity.put("FStockLocId",fStockLocId);
                    fEntity.put("FDefectsSelQty",0);
                    fEntity.put("FNextOperId",0);
                    fEntity.put("FBaseCheckSelQty",0);
                    fEntity.put("FPrdCheckQty",0);
                    fEntity.put("FBaseCheckQty",0);
                    fEntity.put("FPrdCheckSelQty",0);
                    fEntity.put("FQCSchemeId",fQCSchemeId);
                    fEntity.put("FQualityCheck",false);
                    fEntity.put("FWorkCenterId",fWorkCenterId);
                    fEntity.put("FProcessId",fProcessId);
                    fEntity.put("FPrdTrackNo","");
                    fEntity.put("FIsFirstPieceInspect",false);
                    fEntity.put("FDefectType",fDefectType);
                    fEntity.put("FAuxEquipmentId",fAuxEquipmentId);
                    fEntity.put("FIsInputPrd",false);
                    fEntity.put("FReworkStatus","");
                    fEntity.put("FReworkSrcRptNo","");
                    fEntity.put("FReworkSrcRptId",0);
                    fEntity.put("FReworkSrcRptEntryId",0);
                    fEntity.put("FReworkSrcRptSeq",0);
                    fEntity.put("FReworkSeqId",0);
                    fEntity.put("FInspectTime",LocalDate.now());
                    fEntity.put("FDispatchDetailEntryId",0);
                    fEntity.put("FCostRate",0);
                    fEntity.put("FReworkType","");
                    fEntity.put("FReSelQty",0);
                    fEntity.put("FFullInputPsJson","");
                    fEntity.put("FReSelHeadQty",0);
                    fEntity.put("FReSelBaseQty",0);
                    fEntity.put("FISFULLPROCESS",false);
                    fEntity.put("FDefectDetail","");
                    fEntity.put("FMLot_Text","");
                    fEntity.put("FBarCode","");
                    fEntity.put("FDecimal_TotalTime",0);
                    fEntity.put("FCheckType","1");
                    fEntity.put("FWaitCheckQty",0);
                    fEntity.put("F_260_DecimalZGS",0);
                    fEntity.put("FPrdWaitCheckQty",0);
                    fEntity.put("FBaseWaitCheckQty",0);
                    fEntity.put("F_260_CheckBoxWW",false);
                    fEntity.put("F_260_BaseWWGYS",f_260_BaseWWGYS);
                    fEntity.put("FMouldId",fMouldId);
                    fEntity.put("FUnPackingMark","");
                    fEntity.put("F_260_TextWWDDH","");
                    fEntity.put("F_260_PriceWWDJ",0);
                    fEntity.put("F_ora_Amount",0);
                    fEntity.put("F_220_TextSCPH","");
                    fEntity.put("FSCKH",fSCKH);
                    fEntity.put("F_220_Decimalhgl",0);
                    fEntity.put("F_260_DateWWWG", LocalDate.now());
                    fEntity.put("F_260_MulLangTextQXMX", "");
                    fEntity.put("F_260_TS", false);
                    fEntity.put("F_220_BaseQtyhpsl", 0);
                    fEntity.put("F_220_BaseQtyhpslljruk", 0);
                    fEntity.put("F_260_JYGS", 0);
                    fEntity.put("F_220_textKDXH", "");
                    fEntity.put("F_220_Basewlffr",f_220_Basewlffr);
                    fEntity.put("F_220_Qtyjgzl",0);
                    fEntity.put("F_220_Qtyjgbzzl",0);
                    fEntity.put("F_220_Textshebei","");
                    fEntity.put("F_220_Textzcdj","");
                    if(EmptyUtil.isEmpty(isMdgx)){
                        //是否末道工序
                        fEntity.put("F_260_RKD",1);
                    }else {
                        fEntity.put("F_260_RKD",0);
                    }

                    fEntity.put("F_260_GXKZM","");
                    fEntity.put("F_260_BZ","");
                    fEntity.put("F_260_SZGS",0);
                    fEntity.put("F_260_FZGS",0);
                    fEntity.put("F_260_JCGS",0);
                    fEntity.put("FHMSXKH",fHMSXKH);
                    fEntity.put("FHMSXSFRKD","");
                    fEntity.put("F_220_Qtykwgsl",0);
                    fEntity.put("F_260_SFNPI1","");
                    fEntity.put("FHMSXBZ","");
                    fEntity.put("FHMSXKHCJDYB",fHMSXKHCJDYB);
                    fEntity.put("F_260_Qtyxk",0);
                    fEntity.put("F_260_JDDJ",0);
                    fEntity.put("F_220_QtyFGSL",0);
            /*Map<String, Object> F_101_BasePropertyZXBZBM1 = new HashMap<>();
            F_101_BasePropertyZXBZBM1.put("FDETAILID", mesResultFiled.getMxZxbzId());
            fEntity.put("F_101_BasePropertyZXBZBM1",F_101_BasePropertyZXBZBM1);*/
                    //fEntity.put("F_101_BasePropertyZXBZ",mesResultFiled.getZxbz());
                    //fEntity.put("F_101_BasePropertyKHWLMC",mesResultFiled.getMxKhwlmc());
                    fEntity.put("F_101_PriceCZDJ",mesResultFiled.getCzdj());
                    fEntity.put("F_101_TextKHHTH",mesResultFiled.getHth());
                    fEntity.put("F_101_DatePTSJ",mesResultFiled.getMxPtsj());
                    fEntity.put("F_101_QtyPTSL", EmptyUtil.isEmpty(mesResultFiled.getMxPtsl())?0.0:Double.parseDouble(String.valueOf(mesResultFiled.getMxPtsl())));
                    fEntity.put("F_101_Texthth1",mesResultFiled.getMxHth());
                    fEntity.put("F_101_BaseJJLX",f_101_BaseJJLX);
                    fEntity.put("F_101_PriceDJ", (mesResultFiled.getMxDj() == null ? 1 : mesResultFiled.getMxDj().intValue()));
                    fEntity.put("F_101_TextBZ",mesResultFiled.getMxBzSc());
                    fEntity.put("F_101_TextBZ1",mesResultFiled.getMxBzSc());
                    fEntity.put("F_101_DateXSDDJHSJ",mesResultFiled.getMxXsddyhrq());
                    fEntity.put("F_101_COMBOSFXCYS",mesResultFiled.getMxSfxcys());
                    fEntity.put("F_101_Base1ZXBZ1",f_101_Base1ZXBZ1);
                    //fEntity.put("F_101_BasePropertyIDH",mesResultFiled.getMxId());
                    fEntity.put("F_101_BaseZXBZBM",f_101_BaseZXBZBM);
                    fEntity.put("F_101_BASEKHWLBM",f_101_BASEKHWLBM);
                    fEntity.put("F_PAEZ_HMBATCHNO",ccpch);
                    fEntity.put("F_PAEZ_HMQCBATCHNO",ufcerppswbrpt.getCpph());
                    //fEntity.put("F_101_BasePropertyJDJSZT",mesResultFiled.getMxJd());
                    ArrayList<Map<String,Object>> fSubEntitys= new ArrayList();
                    fSubEntitys.add(fSubEntity);
                    fEntity.put("FSubEntity",fSubEntitys);
                    ArrayList<Map<String,Object>> fEntity_Links= new ArrayList();
                    fEntity_Links.add(fEntity_Link);
                    fEntity.put("FEntity_Link",fEntity_Links);

                    ArrayList<Map<String,Object>> array=new ArrayList<>();
                    array.add(fEntity);
                    model.put("FEntity",array);

                    Map<String,Object> data=new LinkedHashMap<>();
                    data.put("IsAutoAdjustField",false);
                    data.put("IsAutoSubmitAndAudit",true);
                    data.put("NeedUpDateFields",null);
                    data.put("NeedReturnFields",null);
                    data.put("IsDeleteEntry",true);
                    data.put("SubSystemId","");
                    data.put("IsVerifyBaseDataField",false);
                    data.put("IsEntryBatchFill",true);
                    data.put("ValidateFlag",true);
                    data.put("NumberSearch",true);
                    data.put("InterationFlags","");
                    data.put("IgnoreInterationFlag","");
                    data.put("Model",model);

                    param.put("formid","SFC_OperationReport");
                    param.put("data",data);
                }catch (Exception e){
                    throw new Exception("工序汇报erp参数评价错误！");
                }

                JSONObject paraStr=new JSONObject(param);

                Map<String, String> map = new HashMap<>();
                map.put("data", paraStr.toJSONString());
                System.out.println("erp报工地址："+ERP_SAVE_URL);
                System.out.println("erp报工Cookie："+"kdservice-sessionid=" + login.getData().getKdsvcSessionId() + ";ASP.NET_SessionId=" + login.getData().getSessionId());
                System.out.println("erp报工参数："+paraStr.toJSONString());
                String r = ERPHttpUtils.doPostSave(ERP_SAVE_URL, paraStr.toJSONString(), "kdservice-sessionid=" + login.getData().getKdsvcSessionId() + ";ASP.NET_SessionId=" + login.getData().getSessionId());
                System.out.println("erp接口返回值："+r);
                JSONObject jsonObject = JSONObject.parseObject(r);
                if(jsonObject.getJSONObject("Result").getJSONObject("ResponseStatus").get("IsSuccess").toString().equals("true")){
                    Integer bgoid = (Integer) jsonObject.getJSONObject("Result").get("Id");
                    String bgid =  String.valueOf(jsonObject.getJSONObject("Result").get("Number"));
                    LambdaQueryWrapper<UfcErpPsWbrpt> queryWrapper = new LambdaQueryWrapper<>();
                    queryWrapper.eq(UfcErpPsWbrpt::getPsWbrptFk,psWbrptOid);
                    UfcErpPsWbrpt ufcErpPsWbrpt = ufcErpPsWbrptService.getOne(queryWrapper);
                    ufcErpPsWbrpt.setErpBgSaveId(bgid);
                    ufcErpPsWbrpt.setErpBgSaveOid(bgoid);
                    //保存erp返回的工序报工编码
                    ufcErpPsWbrptService.getBaseMapper().updateById(ufcErpPsWbrpt);
                }else{
                    Map<String,Object> message = null;
                    try {
                        message = (Map<String, Object>) jsonObject.getJSONObject("Result").getJSONObject("ResponseStatus").getJSONArray("Errors").get(0);
                    }catch (Exception e){
                        throw new Exception(message.get("Message").toString());
                    }
                    throw new Exception(message.get("Message").toString());
                }
            } catch (Exception e) {
                throw new CustomException(-1, e.getMessage());
            }
        }
        return new Result().toSuccess();
    }

    @Override
    public Result getNextPhrq(Long pswboid) {
        String phrq = ufcErpPsWbrptMapper.getNextPhrq(pswboid);
        return new Result().toSuccess(phrq);
    }

    @Override
    public Result getCountZj(Long pswbrptoid) {
        LambdaQueryWrapper<UfcHmQcBill> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(UfcHmQcBill::getPsWbrptFk,pswbrptoid);
        Integer count =ufcHmBillMapper.selectCount(wrapper);
        return new Result().setData(count);
    }

    @Override
    public Result getCountSl(Long pswboid) {
        UfcGxFkVO ufcGxFkVO = ufcErpPsWbrptMapper.getCountSl(pswboid);
        return new Result().toSuccess(ufcGxFkVO);
    }


    @Override
    public Result gxbgSelect(String fbillNo) {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FID,FBillNo");
        params.setFormId("SFC_OperationReport");
        String erpParam="FBillNo='"+fbillNo+"'";

        params.setFilterString(erpParam);
        System.out.println(JSONObject.toJSONString(params));
        return ERPHttpUtils.others(params, GxbgQueryDto.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result del(List<Long> psWbrptoids,User user) {
        PsWbrpt list = psWbrptService.getById(psWbrptoids.get(0));
        if(EmptyUtil.isEmpty(psWbrptoids)){
            return new Result().toFailure("没有符合条件的删除数据!");
        }
        //查询工序是否汇报到erp
        List<String> erpBgSaveId = woExpandMapper.selectErpBgId(psWbrptoids);
        Result<List<ErpGxhb>> result = getErpGxhb(erpBgSaveId);
        if(!EmptyUtil.isEmpty(result) && !EmptyUtil.isEmpty(result.getData())){
            return new Result().toFailure("工序已在ERP汇报,请在ERP中删除工序汇报记录");
        }
        LambdaQueryWrapper<UfcErpPsWbrpt> wrapper = new LambdaQueryWrapper<>();
        wrapper.in(UfcErpPsWbrpt::getPsWbrptFk,psWbrptoids);
        wrapper.eq(UfcErpPsWbrpt::getZt,'R');
        int count = ufcErpPsWbrptService.count(wrapper);
        if(count>0){
            return new Result().toFailure("请先撤销汇报数据!");
        }
        try {
            // 删除 ps_wbrpt
            ufcErpPsWbrptMapper.deletePsWbrpt(psWbrptoids);
        }catch (Exception e){
            throw new CustomException(-1, "删除工序汇报记录失败");
        }
        try {
            // 删除 ps_wbuq
            ufcErpPsWbrptMapper.deletePsWbuq(psWbrptoids);
        }catch (Exception e){
            throw new CustomException(-1, "删除工序汇报记录失败");
        }
        try {
            // 删除 ufc_erp_ps_wbrpt
            ufcErpPsWbrptMapper.del(psWbrptoids);
        }catch (Exception e){
            throw new CustomException(-1, "删除工序汇报记录失败");
        }

        //工序反馈删除后更新工序完工状态
        LambdaUpdateWrapper<PsWb> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.set(PsWb::getZt,'R');
        updateWrapper.eq(PsWb::getPsWboid,list.getPsWbFk());
        psWbService.update(updateWrapper);

        //作业反馈，进行删除作业反馈记录时，需将专检记录删除，更新是否专检标识
        PsWb psWb = psWbService.getById(list.getPsWbFk());
        if(psWb.getSfzl()){
            psWtService.update(new LambdaUpdateWrapper<PsWt>()
                    .set(PsWt::getZjwc,false)
                    .set(PsWt::getWczjsl,null)
                    .eq(PsWt::getPsWbFk,psWb.getPsWboid()));
        }

        return new Result().toSuccess("删除成功");
    }

    private Result<List<ErpGxhb>> getErpGxhb(List<String> erpBgSaveId){
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FBillNo,FDocumentStatus");
        params.setFormId("SFC_OperationReport");
        params.setTopRowCount(0);
        String param = "";
        for (int i =0 ; i<erpBgSaveId.size();i++) {
            if(i==0){
                param = param +"FBillNo in ('"+erpBgSaveId.get(i)+"'";
            }else{
                param = param +" ,'"+erpBgSaveId.get(i)+"'";
            }
        }
        param = param +")";
        params.setFilterString(param);
        Result<List<ErpGxhb>> others = ERPHttpUtils.others(params, ErpGxhb.class);
        return others;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result countermand(List<Long> psWbrptoid, User user) {

        //查询工序是否汇报到erp
        List<String> erpBgSaveId = woExpandMapper.selectErpBgId(psWbrptoid);
        Result<List<ErpGxhb>> result = getErpGxhb(erpBgSaveId);
        if(!EmptyUtil.isEmpty(result) && !EmptyUtil.isEmpty(result.getData())){
            return new Result().toFailure("工序已在ERP汇报,请在ERP中删除工序汇报记录");
        }
        if (!EmptyUtil.isEmpty(psWbrptoid)) {
            psWbrptService.update(new LambdaUpdateWrapper<PsWbrpt>()
                    .set(PsWbrpt::getSysLastUpdBy,user.getEmployeeOid())
                    .set(PsWbrpt::getSysLastUpd, LocalDateTime.now())
                    .set(PsWbrpt::getZt, "I")
                    .in(PsWbrpt::getPsWbrptoid, psWbrptoid));

            //作业反馈，当逆向操作工序为专检工序时，进行删除作业反馈记录时，需将专检记录删除，并更新工序完工状态，和是否专检标识
            List<PsWbrpt> psWbrpts = psWbrptService.getBaseMapper().selectList(new LambdaQueryWrapper<PsWbrpt>().in(PsWbrpt::getPsWbrptoid, psWbrptoid));
            /*Result del = del(psWbrptoid, user);
            if(!del.confirmSuccess()){
                return del;
            }*/
            ufcErpPsWbrptService.update(new LambdaUpdateWrapper<UfcErpPsWbrpt>()
                    .set(UfcErpPsWbrpt::getZt,"I")
                    .in(UfcErpPsWbrpt::getUfcErpPsWbrptOid, psWbrptoid));

            if(!EmptyUtil.isEmpty(psWbrpts)){
                PsWb byId = psWbService.getById(psWbrpts.get(0).getPsWbFk());
                if(byId.getSfzl()){
                    psWtService.update(new LambdaUpdateWrapper<PsWt>()
                            .set(PsWt::getZjwc,false)
                            .set(PsWt::getWczjsl,null)
                            .eq(PsWt::getPsWbFk, psWbrpts.get(0).getPsWbFk()));
                    psWbService.update(new LambdaUpdateWrapper<PsWb>()
                            .set(PsWb::getZt,"R")
                            .eq(PsWb::getPsWboid, psWbrpts.get(0).getPsWbFk()));
                }
            }
            return new Result().toSuccess("修改成功");
        }

        //工序反馈删除后更新工序完工状态
        LambdaQueryWrapper<PsWbrpt> wrapper = new LambdaQueryWrapper<>();
        wrapper.in(PsWbrpt::getPsWbrptoid,psWbrptoid);
        List<PsWbrpt> list = psWbrptService.getBaseMapper().selectList(wrapper);
        LambdaUpdateWrapper<PsWb> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.set(PsWb::getZt,'R');
        updateWrapper.eq(PsWb::getPsWboid,list.get(0).getPsWbFk());
        psWbService.update(updateWrapper);

        return new Result().toFailure("没有符合条件的数据，将不会执行撤回操作!");
    }

    @Override
    public Result getPsWbMxInfo(Long pswborptoid,Long pswboid) {
        PsWbDto psWbDto = ufcPsWbMapper.getPsWbMxInfo(pswborptoid,pswboid).get(0);
        return new Result().setData(psWbDto);
    }

    @Override
    public Result getErpJd() {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FEntryID,FNumber,FDataValue,FDescription");
        params.setFormId("BOS_ASSISTANTDATA_DETAIL");
        params.setTopRowCount(0);
        String param = "FID.FName='精度' and FFORBIDSTATUS='A' and FDocumentStatus='C'";
        params.setFilterString(param);
        Result<List<ErpJd>> others = ERPHttpUtils.others(params, ErpJd.class);
        return others;
    }

    @Override
    public Result getErpZldj() {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FEntryID,FNumber,FDataValue,FDescription");
        params.setFormId("BOS_ASSISTANTDATA_DETAIL");
        params.setTopRowCount(0);
        String param = "FID.FName='质量等级' and FFORBIDSTATUS='A' and FDocumentStatus='C'";
        params.setFilterString(param);
        Result<List<ErpJd>> others = ERPHttpUtils.others(params, ErpJd.class);
        return others;
    }
    @Override
    public Result getErpWdxszb() {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FEntryID,FNumber,FDataValue,FDescription");
        params.setFormId("BOS_ASSISTANTDATA_DETAIL");
        params.setTopRowCount(0);
        String param = "FID.FName='温度系数组别' and FFORBIDSTATUS='A' and FDocumentStatus='C'";
        params.setFilterString(param);
        Result<List<ErpJd>> others = ERPHttpUtils.others(params, ErpJd.class);
        return others;
    }

    @Override
    public Result saveZjjl(Long pswbrptoid, User user) {
        if(EmptyUtil.isEmpty(pswbrptoid)){
            return new Result().toFailure("请先选中工序汇报数据！");
        }
        //查询工单主键
        PsWbrpt pswbrpt = psWbrptService.getById(pswbrptoid);
        UfcErpPsWbrpt ufcErpPsWbrpt = ufcErpPsWbrptService.getById(pswbrptoid);
        if('R'==ufcErpPsWbrpt.getZt()){
            return new Result().toFailure("汇报记录已确认，不能生成专检数据！");
        }
        PsWt pswt = ufcPsWbMapper.getPsWtOid(pswbrpt.getPsWbFk());

        //判断是否需要专检
        if(!pswt.getSfzj()){
            return new Result().toFailure("该工序不需要专检！");
        }
        Result r = this.saveGPFH(pswt.getPsWtoid(),user,pswbrpt);
        pswt.setWczjsl(null);
        pswt.setZjwc(false);
        psWtService.updateById(pswt);
        return r;
    }

    @Override
    @Transactional
    public Result saveGxbg(Long pswboid, Long pswboutoid) {
        //查询工段信息
        PsWbDto pswb = ufcPsWbMapper.getPsWbInfo(pswboid);

        //查询已汇报数量 不合格数量+合格数量
        BigDecimal hbsl = ufcPsWbService.selectHbsl(pswboid, null);
        hbsl = hbsl==null?new BigDecimal(0):hbsl;
        if(!EmptyUtil.isEmpty(hbsl) && pswb.getPcsl().compareTo(hbsl)==0){
            return new Result().toFailure("工序汇报数量已汇报完！");
        }
        //查询上一道工单合格数量
        Result<Integer> thePreviousPsWb = ufcPsWbService.getThePreviousPsWbNumber(pswb.getPsWboid());
        if(thePreviousPsWb.confirmSuccess()){
            if(hbsl.compareTo(new BigDecimal(thePreviousPsWb.getData()))==1){
                return new Result().toFailure("汇报数量不能大于上一道工序合格数量");
            }
        }

        //判断是否需要首检
        if(!EmptyUtil.isEmpty(pswb) && pswb.getFirstInspectionProcess()){
            LambdaQueryWrapper<UfcHmQcBill> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(UfcHmQcBill::getPsWbFk,pswboid);
            lambdaQueryWrapper.eq(UfcHmQcBill::getGxJyfs,'S');
            int count = ufcHmBillService.count(lambdaQueryWrapper);
            if(count==0){
                return new Result().toFailure("未提交首检！");
            }
            lambdaQueryWrapper.eq(UfcHmQcBill::getSfzj,false);
            //未专检数量
            int wzjsl = ufcHmBillService.count(lambdaQueryWrapper);
            if(wzjsl>0){
                return new Result().toFailure("首检未完成！");
            }
        }

        UfcPsWbrpt psWbrpt = new UfcPsWbrpt();
        //查询当前工单汇报数量(合格数量+不合格数量 不包含当前汇报记录数量)
        BigDecimal sl = ufcPsWbService.selectHbsl(pswboid,null);
        //获取上一道工序
        PsWb nextpswb = ufcPsWbMapper.selectNextGx(pswboid);
        if(EmptyUtil.isEmpty(nextpswb)){
            BigDecimal r = pswb.getPcsl().subtract(sl == null ? new BigDecimal(0) : sl);
                    //首道工序
            psWbrpt.setHgsl(r);
        }else{
            //上一道工单合格数量-当前工单已汇报数量
            BigDecimal r = new BigDecimal(thePreviousPsWb.getData()).subtract(sl == null ? new BigDecimal(0) : sl);
            psWbrpt.setHgsl(r);
        }
        psWbrpt.setPsWbrptoid(SnowflakeIdUtils.generate());
        psWbrpt.setPsWbFk(pswboid);
        psWbrpt.setPsWbOutFk(pswboutoid);
        psWbrpt.setWoFk(pswb.getWoFk());
        psWbrpt.setFkrq(LocalDateTime.now());
        psWbrpt.setFpsl(new BigDecimal(0));

        ufcPsWbrptMapper.insert(psWbrpt);
        UfcErpPsWbrpt ufcPsWbrpt = new UfcErpPsWbrpt();
        if(!EmptyUtil.isEmpty(nextpswb)){
            //查询上一道工序 产品批号和批号日期
            UfcErpPsWbrpt ufcErpPsWbrpt = ufcErpPsWbrptMapper.getOneRow(nextpswb.getPsWboid());
            if(!EmptyUtil.isEmpty(ufcErpPsWbrpt) && !EmptyUtil.isEmpty(ufcErpPsWbrpt.getCpph())){
                ufcPsWbrpt.setCpph(ufcErpPsWbrpt.getCpph());
            }
            if(!EmptyUtil.isEmpty(ufcErpPsWbrpt) && !EmptyUtil.isEmpty(ufcErpPsWbrpt.getPhrq())){
                ufcPsWbrpt.setPhrq(ufcErpPsWbrpt.getPhrq());
            }
        }
        ufcPsWbrpt.setPsWbrptFk(psWbrpt.getPsWbrptoid());
        ufcPsWbrpt.setUfcErpPsWbrptOid(psWbrpt.getPsWbrptoid());
        ufcErpPsWbrptMapper.insert(ufcPsWbrpt);
        return new Result().toSuccess(psWbrpt.getPsWbrptoid());
    }

    /**
     * 是否允许本道工序作业反馈完工数量大于上道工序完工数量。工序作业反馈非首道序的情况按照上道工序完工数量控制
     * @param code
     * @return
     */
    public Boolean verify(String code){
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        String o = ruleValue.getData().get(0).toString();
        if ("Y".equals(o)) {
            //非首道工序反馈数量允许大于上一道工序完工数量
            return true;
        }
        if ("N".equals(o)) {
            //非首道工序反馈数量不允许大于上一道工序完工数量
            return false;
        }
        return false;
    }

    @Transactional(rollbackFor = Exception.class)
    public Result saveGPFH(Long oid, User user,PsWbrpt pswbrpt) {
        boolean tyRuleBz = false;
        Long ufcQcTyRuleOid =null;
        LambdaQueryWrapper<PsWt> psWtLambdaQueryWrapper = new LambdaQueryWrapper<>();
        psWtLambdaQueryWrapper.eq(PsWt::getPsWtoid,oid);
        PsWt wt = psWtService.getOne(psWtLambdaQueryWrapper);
        //PsWt wt = (PsWt)psWtService.getOne((Wrapper)(new LambdaQueryWrapper()).eq(PsWt::getPsWtoid, oid), false);
        if (wt == null) {
            return (new Result()).setMsg("没有找到数据");
        } else {
            LambdaQueryWrapper<BMaterial> bMaterialLambdaQueryWrapper = new LambdaQueryWrapper<>();
            bMaterialLambdaQueryWrapper.eq(BMaterial::getBMaterialoid, wt.getBMaterialFk());
            bMaterialLambdaQueryWrapper.eq(BMaterial::getDel, false);
            BMaterial bMaterial = bMaterialService.getOne(bMaterialLambdaQueryWrapper);
            //BMaterial bMaterial = (BMaterial)this.bMaterialService.getOne((Wrapper)(new LambdaQueryWrapper()).eq(BMaterial::getBMaterialoid, wt.getBMaterialFk()));
            if (bMaterial == null) {
                return (new Result()).setMsg("没有找到物料");
            } else {
                LambdaQueryWrapper<BFactory> bFactoryLambdaQueryWrapper = new LambdaQueryWrapper<>();
                bFactoryLambdaQueryWrapper.eq(BFactory::getBFactoryoid, wt.getBFactoryFk());
                bFactoryLambdaQueryWrapper.eq(BFactory::getDel, false);
                BFactory bFactory = bFactoryService.getOne(bFactoryLambdaQueryWrapper);
                //BFactory bFactory = (BFactory)this.bFactoryService.getOne((Wrapper)(new LambdaQueryWrapper()).eq(BFactory::getBFactoryoid, wt.getBFactoryFk()));
                if (bFactory == null) {
                    return (new Result()).setMsg("没有找到工厂信息");
                } else {
                    LambdaQueryWrapper<BWorkshop> bWorkshopLambdaQueryWrapper = new LambdaQueryWrapper<>();
                    bWorkshopLambdaQueryWrapper.eq(BWorkshop::getBWorkshopoid, wt.getBWorkshopFk());
                    bWorkshopLambdaQueryWrapper.eq(BWorkshop::getDel, false);
                    BWorkshop bWorkshop = bWorkshopService.getOne(bWorkshopLambdaQueryWrapper);
                    //BWorkshop bWorkshop = (BWorkshop)this.bWorkshopService.getOne((Wrapper)(new LambdaQueryWrapper()).eq(BWorkshop::getBWorkshopoid, wt.getBWorkshopFk()));
                    if (bWorkshop == null) {
                        return (new Result()).setMsg("没有找到车间信息");
                    } else {
                        Boolean isSfzj = false;
                        if (!EmptyUtil.isEmpty(wt.getSfzj()) && wt.getSfzj()) {
                            isSfzj = true;
                        }

                        if (isSfzj) {
                            //查询检验规程
                            QcRule rule = this.ufcPsWbMapper.getQcTyeOid(wt.getBMaterialFk(), wt.getBWorklineFk(), wt.getBStandardprocessFk(), QcTypeEnum.SPECIAL_INSPECTION.getValue());
                            if (EmptyUtil.isEmpty(rule)) {
                                //查询检验规程，去掉产线查询条件
                                rule = this.ufcPsWbMapper.getQcTyeOid(wt.getBMaterialFk(),null, wt.getBStandardprocessFk(), QcTypeEnum.SPECIAL_INSPECTION.getValue());
                                if (EmptyUtil.isEmpty(rule)) {
                                    //没有检验规程，查询通用规程
                                    rule = new QcRule();
                                    UfcQcTyRule ufcQcTyRule = ufcQcTyRuleMapper.getQcTyeOid(null, wt.getBWorklineFk(), wt.getBStandardprocessFk(), QcTypeEnum.SPECIAL_INSPECTION.getValue());
                                    if(EmptyUtil.isEmpty(ufcQcTyRule)){
                                        ufcQcTyRule = ufcQcTyRuleMapper.getQcTyeOid(null, null, wt.getBStandardprocessFk(), QcTypeEnum.SPECIAL_INSPECTION.getValue());
                                    }
                                    if(EmptyUtil.isEmpty(ufcQcTyRule)){
                                        return (new Result()).toFailure("请先维护对应的检验规程或通用规程再进行操作");
                                    }
                                    BeanUtils.copyProperties(ufcQcTyRule,rule);
                                    ufcQcTyRuleOid = ufcQcTyRule.getUfcQcTyRuleoid();
                                    tyRuleBz = true;
                                }
                            }
                            //查询检验项目信息
                            LambdaQueryWrapper<UfcQcStdmx> lambdaQueryWrapper = new LambdaQueryWrapper<>();
                            lambdaQueryWrapper.eq(UfcQcStdmx::getQcStdFk,rule.getQcStdFk());
                            List<UfcQcStdmx> ufcQcStdmxs = ufcQcStdmxMapper.selectList(lambdaQueryWrapper);
                            BigDecimal zhuanJianNumber = new BigDecimal(0);
                            for (UfcQcStdmx ufcQcStdmx : ufcQcStdmxs) {
                                //固定数抽样
                                if(!EmptyUtil.isEmpty(ufcQcStdmx) && ufcQcStdmx.getCyfs().equals("F") && ufcQcStdmx.getYbsl().compareTo(zhuanJianNumber)==1){
                                    zhuanJianNumber = ufcQcStdmx.getYbsl();
                                }
                                //百分比抽样 作业反馈的合格数*百分比
                                try{
                                    if(!EmptyUtil.isEmpty(ufcQcStdmx) && ufcQcStdmx.getCyfs().equals("P")){
                                        BigDecimal ybsl = pswbrpt.getHgsl().divide(new BigDecimal(100)).multiply(ufcQcStdmx.getBfb()).setScale( 0, BigDecimal.ROUND_UP );
                                        if(ybsl.compareTo(zhuanJianNumber)==1){
                                            zhuanJianNumber=ybsl;
                                        }
                                    }
                                }catch (Exception e){
                                    throw new CustomException(-1, "获取百分比抽样样本数量失败！");
                                }
                            }

                            Boolean aBoolean = this.psWtService.whetherSingle(oid);
                            if (aBoolean) {
                                LambdaUpdateWrapper<PsSn> psSnLambdaUpdateWrapper = new LambdaUpdateWrapper<>();
                                psSnLambdaUpdateWrapper.set(PsSn::getCjbz,true);
                                psSnLambdaUpdateWrapper.set(PsSn::getSysCreated, LocalDateTime.now());
                                psSnLambdaUpdateWrapper.set(PsSn::getSysCreatedBy, user.getEmployeeOid());
                                psSnLambdaUpdateWrapper.eq(PsSn::getPsWtFk, oid);
                                boolean update = psSnService.update(psSnLambdaUpdateWrapper);
                                //int update = this.psSnService.getBaseMapper().update((Object)null, (Wrapper)((LambdaUpdateWrapper)((LambdaUpdateWrapper)((LambdaUpdateWrapper)(new LambdaUpdateWrapper()).set(PsSn::getCjbz, true)).set(PsSn::getSysCreated, LocalDateTime.now())).set(PsSn::getSysCreatedBy, user.getEmployeeOid())).eq(PsSn::getPsWtFk, oid));
                                if (update) {
                                    throw new CustomException(-1, "修改单件抽检标致失败！");
                                }
                            }

                            AccordingDTO accordingDTO = new AccordingDTO(wt.getPsWtoid(), wt.getGpid(), wt.getPsWbFk(), rule.getQcTypeFk(), QcTypeEnum.SPECIAL_INSPECTION.getValue(), zhuanJianNumber);
                            Result<Long> result1 = ufcPsWbService.firstAccordingToPswb(accordingDTO, user);
                            if (!result1.confirmSuccess()) {
                                throw new CustomException(-1, "生成送检单失败！");
                            }

                            Result<QcBill> result2 = this.ufcPsWbService.crateQcBillByFirst((Long)result1.getData(), rule.getQcStdFk(), user,pswbrpt.getPsWbFk(),false,pswbrpt.getPsWbrptoid(),tyRuleBz,ufcQcTyRuleOid);
                            if (!result2.confirmSuccess()) {
                                throw new CustomException(-1, "创建检验单失败！");
                            }

                            Result result3 = createSampleBySingle(zhuanJianNumber.intValue(), (QcBill)result2.getData(), user);
                            if (!result3.confirmSuccess()) {
                                throw new CustomException(-1, "创建样本失败！");
                            }
                        } else {
                            PsWb wb = psWbService.getById(wt.getPsWbFk());
                            Result<ProcessNodeVO> nodeVOResult = this.technologicalProcessService.getgetProcessNodePid(wb.getPsTechnologicalProcessFk(), wb.getPsWsFk(), wb.getGxid());
                            ProcessNodeVO data = (ProcessNodeVO)nodeVOResult.getData();
                            if (nodeVOResult.confirmSuccess() && !EmptyUtil.isEmpty(data)) {
                                Integer start = this.bzzMapper.queryStart(wt.getPsWbFk());
                                DjhCreateDto djhCreateDto = new DjhCreateDto();
                                djhCreateDto.setPsWbOid(wt.getPsWbFk());
                                djhCreateDto.setDjhStart(start);
                                djhCreateDto.setDjhEnd(start + (wt.getHgsl()==null?0:wt.getHgsl().intValue()));
                                this.jobDispatchingHandleService.createDjhInfo(djhCreateDto, user);
                            }
                        }

                        LambdaUpdateWrapper<PsWt> wu = new LambdaUpdateWrapper();
                        wu.set(wt.getSfzj(), PsWt::getTjzjsl, LocalDateTime.now());
                        wu.set(wt.getSfzj(), PsWt::getSftjzj, true);
                        wu.set(PsWt::getShwc, true);
                        wu.set(PsWt::getShrygh, user.getJobNumber());
                        wu.set(PsWt::getShrymc, user.getEmployeeName());
                        wu.eq(PsWt::getPsWtoid, wt.getPsWtoid());
                        boolean update = this.psWtService.update(wu);
                        if (!update) {
                            throw new CustomException(-1, "更新工票信息失败！");
                        } else {
                            return (new Result()).toSuccess(true);
                        }
                    }
                }
            }
        }
    }
    public Result createSampleBySingle(Integer alreadyAssignedNum, QcBill bill, User user) {
        if (EmptyUtil.isEmpty(alreadyAssignedNum)) {
            return new Result().toFailure("没有单件信息？");
        }
        //获取检验标准明细数据(检验项目信息)
        Result<List<UfcQcsdtmxgetView>> result3 = qcBillService.getQcsdtmxgetViewList(bill.getQcStdFk(), user);
        if (result3.confirmSuccess()) {
            List<UfcQcsdtmxgetView> data = result3.getData();
            if (!EmptyUtil.isEmpty(data)) {
                List<UfcQcSample> sampleList = new ArrayList<>();
                List<UfcQcSampleStd> sampleStds = new ArrayList<>();
                //生成样本信息
                for (int s = 0; s < alreadyAssignedNum; s++) {
                    UfcQcSample sample = new UfcQcSample();
                    sample.setQcSampleOid(SnowflakeIdUtils.generate());
                    sample.setJydid(bill.getJydid());

                    Result<String> result = codeTableService.getCodeing("样本编码", false);
                    if (!result.confirmSuccess()) {
                        return result;
                    }
                    String ybbh = result.getData();
                    sample.setYbbh(ybbh);
                    sample.setQcBillFk(bill.getQcBilloid());
                    sample.setQcStdFk(bill.getQcStdFk());
                    sampleList.add(sample);
                    //每一个样本对应的检验项目项目
                    for (UfcQcsdtmxgetView std : data) {
                        UfcQcSampleStd sampleStd = new UfcQcSampleStd();
                        sampleStd.setQcSampleStdOid(SnowflakeIdUtils.generate());
                        sampleStd.setQcSampleFk(sample.getQcSampleOid());
                        sampleStd.setQcItemFk(std.getQcItemFk());
                        sampleStd.setLx(std.getLx());
                        sampleStd.setKzfs(std.getKzfs());
                        sampleStd.setJyxmid(std.getJyxmid());
                        sampleStd.setJyxmmc(std.getJyxmmc());
                        sampleStds.add(sampleStd);
                    }
                }
                //保存样本信息
                boolean b1 = ufcQcSampleService.saveBatch(sampleList);
                if (!b1) {
                    return new Result().toFailure("创建样本信息失败");
                }
                //保存样本项目信息
                boolean b2 = ufcQcSampleStdService.saveBatch(sampleStds);
                if (!b2) {
                    return new Result().toFailure("创建样本项目信息失败");
                }
            }
        }
        return new Result().toSuccess();
    }

}
