package com.jln.system.web.action.erp.gxbg.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.*;
import com.jln.system.web.action.erp.gxbg.dto.ErpGxZyListAdd;
import com.jln.system.web.action.erp.gxbg.dto.ErpGxhb;
import com.jln.system.web.action.erp.gxbg.dto.GxzyErpParam;
import com.jln.system.web.action.erp.gxbg.entity.UfcErpGxzydmx;
import com.jln.system.web.action.erp.gxbg.mapper.UfcErpGxzydmxMapper;
import com.jln.system.web.action.erp.gxbg.service.GxBgService;
import com.jln.system.web.action.erp.gxbg.service.GxZyService;
import com.jln.system.web.action.erp.gxbg.service.UfcErpGxzydmxService;
import com.jln.system.web.action.erp.material.entity.ErpJd;
import com.jln.system.web.action.erp.ufcpswb.service.UfcPsWbService;
import com.jln.system.web.action.erp.wo.mapper.WoExpandMapper;
import com.jln.system.web.action.pp.planImport.entity.Wo;
import com.jln.system.web.action.pp.planImport.service.WoService;
import com.jln.system.web.action.ps.gwj.service.AbnormalProcessTransferService;
import com.jln.system.web.action.ps.gxzyd.entity.Gxzyd;
import com.jln.system.web.action.ps.gxzyd.entity.Gxzydmx;
import com.jln.system.web.action.ps.gxzyd.mapper.GxzydmxMapper;
import com.jln.system.web.action.ps.gxzyd.service.GxzydService;
import com.jln.system.web.action.ps.gxzyd.service.GxzydmxService;
import com.jln.system.web.action.ps.gxzyd.viewentity.GxZyJobConfirmDTO;
import com.jln.system.web.action.ps.gxzyd.viewentity.GxZyJobOfferDTO;
import com.jln.system.web.action.ps.gxzyd.viewentity.GxZyListAdd;
import com.jln.system.web.action.ps.production.entity.PsWb;
import com.jln.system.web.action.ps.production.pojo.dto.PsWbCompleteDto;
import com.jln.system.web.action.ps.production.pojo.vo.ProcessNodeVO;
import com.jln.system.web.action.ps.production.service.PsTechnologicalProcessService;
import com.jln.system.web.action.ps.production.service.PsWbService;
import com.jln.system.web.action.util.CookieData;
import com.jln.system.web.action.util.ERPHttpUtils;
import com.jln.system.web.action.util.ERPParam;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWb;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;

import static com.jln.system.web.action.util.ERPHttpUtils.login;

@Service
@Slf4j
public class GxZyServiceImpl implements GxZyService {

    @Autowired
    @Qualifier("erpWoExpandMapper")
    private WoExpandMapper woExpandMapper;

    @Autowired
    private WoService woService;

    @Autowired
    private GxzydService gxzydService;

    @Autowired
    private GxzydmxService gxzydmxService;

    @Autowired
    private UfcErpGxzydmxService ufcErpGxzydmxService;

    @Autowired
    private UfcErpGxzydmxMapper ufcErpGxzydmxMapper;

    @Autowired
    private PsWbService psWbService;

    @Autowired
    private GxzydmxMapper gxzydmxMapper;
    @Autowired
    private AbnormalProcessTransferService abnormalProcessTransferService;
    @Value("${erp.ERP_SAVE_URL}")
    private String ERP_SAVE_URL;

    @Autowired
    private UfcPsWbService ufcPsWbService;

    /**
     * 工序节点业务逻辑层
     */
    @Autowired
    private PsTechnologicalProcessService processService;


    @Transactional(rollbackFor = Exception.class)
    public synchronized Result erpGxzy(GxZyJobOfferDTO dto,User user) throws Exception {

        //查询工单信息
        PsWb psWb = psWbService.getById(dto.getPsWbFk());

        //查询工序转移详情
        Gxzydmx gxzyInfo = gxzydmxService.getById(dto.getGxzydmxoid());
        Gxzyd gxzyd = gxzydService.getById(gxzyInfo.getGxzydFk());
        if(!EmptyUtil.isEmpty(gxzyd) && "F".equals(gxzyd.getZt())){
            return new Result().toFailure("工序已经转出,请勿重复提交！");
        }

        //查询ERP已转移数量(当前订单 && 当前工序)
        Integer erpsum = ufcErpGxzydmxService.selectErpZysl(psWb.getWoFk(),psWb.getWogylxFk());
        erpsum = erpsum == null ? 0 : erpsum ;

        //查询ERP计划数量
        Integer erpjh = ufcErpGxzydmxService.selectErpJh(psWb.getWoFk());
        erpjh = erpjh == null ? 0 : erpjh;

        if(erpsum<erpjh){
            if(erpjh-erpsum<gxzyInfo.getTzzysl().intValue()){
                gxzyInfo.setTzzysl(new BigDecimal(erpjh-erpsum));
            }
            gxzy(true,gxzyInfo);
        }
        return this.submitTransferee(dto,user);
    }

    @Transactional(rollbackFor = Exception.class)
    public Result gxzy(Boolean zyzt,Gxzydmx gxzydmx) throws Exception {
        //上一道工序主键
        Long pswboid = gxzydmx.getJgPsWbFk();
        if(!zyzt){
            //查询下一道工单  获取工序编码
            Result<PsWb> nextPswb = ufcPsWbService.getNextPswb(gxzydmx.getWgPsWbFk());
            gxzydmx.setJgPsWbFk(gxzydmx.getWgPsWbFk());
            gxzydmx.setWgPsWbFk(nextPswb.getData().getPsWboid());
            gxzydmxService.updateById(gxzydmx);
        }
        //查询工序转移数据
        Gxzyd gxzyd = gxzydService.getById(gxzydmx.getGxzydFk());
        //查询订单信息
        Wo wo = woService.getById(gxzyd.getWoFk());
        //查询erp工厂编码和车间编码
        String gcid = woExpandMapper.selectGcid(wo.getBFactoryFk());
        String cjid = woExpandMapper.selectCjid(wo.getBWorkshopFk());
        Result<CookieData> login = login();
        GxzyErpParam gxzyErpParam = woExpandMapper.selectErpGxzyParam(gxzydmx.getGxzydmxoid());

        //查询流转卡号
        String lzkh = woExpandMapper.selectLzkh(pswboid);

        Map<String,Object> data=new LinkedHashMap<>();
        Map<String, Object> model = new LinkedHashMap<>();
        data.put("NeedUpDateFields",null);
        data.put("NeedReturnFields",null);
        data.put("IsDeleteEntry",true);
        data.put("SubSystemId","");
        data.put("IsVerifyBaseDataField",false);
        data.put("IsEntryBatchFill",true);
        data.put("ValidateFlag",true);
        data.put("NumberSearch",true);
        data.put("IsAutoAdjustField",false);
        data.put("InterationFlags","");
        data.put("IgnoreInterationFlag","");
        data.put("IsAutoSubmitAndAudit",true);

        model.put("FID",0);
        Map<String,Object> fBillTypeID = new HashMap<>();
        fBillTypeID.put("FID","001f29d2c9af844211e342cba3aaa38c");
        model.put("FBillTypeID",fBillTypeID);
        model.put("FBillNo","");
        if(zyzt){
            model.put("FBillDate",gxzyd.getYjrTime());
        }else{
            model.put("FBillDate",gxzyd.getJsrTime());
        }

        Map<String,Object> fProOrgId = new HashMap<>();
        fProOrgId.put("FNumber",gcid);
        model.put("FProOrgId", fProOrgId);
        Map<String,Object> fProductId = new HashMap<>();
        fProductId.put("FNUMBER",gxzyErpParam.getWlid());
        model.put("FProductId", fProductId);
        Map<String,Object> fProAuxPropId = new LinkedHashMap<>();
        Map<String,Object> fPROAUXPROPID__FF100001 = new HashMap<>();
        fPROAUXPROPID__FF100001.put("FNumber",gxzyErpParam.getMxFzsxmcZldj());
        Map<String,Object> fPROAUXPROPID__FF100002 = new HashMap<>();
        fPROAUXPROPID__FF100002.put("FNumber",gxzyErpParam.getMxFzsxmcJd());
        fProAuxPropId.put("FPROAUXPROPID__FF100001",fPROAUXPROPID__FF100001);
        fProAuxPropId.put("FPROAUXPROPID__FF100002",fPROAUXPROPID__FF100002);
        model.put("FProAuxPropId", fProAuxPropId);
        if(zyzt){
            //转出
            model.put("FTransferType", "C");
        }else {
            //接收
            model.put("FTransferType", "G");
        }
        model.put("FBusinessType","N");
        model.put("FDescription",lzkh==null?"":lzkh);
        Map<String,Object> fProDeptId = new HashMap<>();
        fProDeptId.put("FNUMBER",cjid);
        model.put("FProDeptId",fProDeptId);
        model.put("FMOBillNo",gxzyErpParam.getYdid());
        model.put("FMOEntrySeq",gxzyErpParam.getYdhh());
        Map<String,Object> fBomId = new HashMap<>();
        fBomId.put("FNUMBER",gxzyErpParam.getBomBb());
        model.put("FBomId",fBomId);
        Map<String,Object> fOperUnitId = new HashMap<>();
        fOperUnitId.put("FNumber",gxzyErpParam.getOutDwid());
        model.put("FOperUnitId",fOperUnitId);
        Map<String,Object> fProUnitId = new HashMap<>();
        fProUnitId.put("FNumber",gxzyErpParam.getOutDwid());
        model.put("FProUnitId",fProUnitId);
        model.put("FMOQty",gxzyErpParam.getXqsl());
        model.put("FMTONo","");
        Map<String,Object> fLot = new HashMap<>();
        fLot.put("FNumber",gxzyErpParam.getMxPh());
        model.put("FLot",fLot);
        Map<String,Object> fCreatorId = new HashMap<>();
        fCreatorId.put("FUserID","");
        model.put("FCreatorId",fCreatorId);
        model.put("FSaleOrderNo","");
        model.put("FCreateDate",LocalDate.now());
        model.put("FSaleOrderSeq",0);
        Map<String,Object> fModifierId = new HashMap<>();
        fModifierId.put("FUserID","");
        model.put("FModifierId",fModifierId);
        model.put("FModifyDate",LocalDate.now());
        model.put("FApproveDate",LocalDate.now());
        Map<String,Object> fApproverId = new HashMap<>();
        fApproverId.put("FUserID","");
        model.put("FApproverId",fApproverId);
        model.put("FCancelDate",LocalDate.now());
        Map<String,Object> fCancelId = new HashMap<>();
        fCancelId.put("FUserID","");
        model.put("FCancelId",fCancelId);
        model.put("FSourceBillType","SFC_OperationPlanning");
        model.put("FSrcOptPlanId",gxzyErpParam.getScjhdherId());
        model.put("FSourceBillNo",wo.getWoid());
        model.put("FSrcOptPlanOptId",gxzyErpParam.getOutBtid());
        model.put("FSrcOptPlanSeqId",gxzyErpParam.getGxxlid());
        model.put("FMOId",gxzyErpParam.getYdhId());
        model.put("FMOEntryId",gxzyErpParam.getYdhhId());
        model.put("FSrcRptEntryId",0);
        model.put("FGroupById","");
        model.put("FProductType","1");
        model.put("FProjectNo","");
        Map<String,Object> fStockInOrgId = new HashMap<>();
        fStockInOrgId.put("FNumber",gcid);
        model.put("FStockInOrgId",fStockInOrgId);
        model.put("FOwnerTypeId","BD_OwnerOrg");
        model.put("FInStockType","");
        Map<String,Object> fOwnerId = new HashMap<>();
        fOwnerId.put("FNumber",gcid);
        model.put("FOwnerId",fOwnerId);
        Map<String,Object> fStockId = new HashMap<>();
        fStockId.put("FNUMBER","");
        model.put("FStockId",fStockId);
        model.put("FOutOPBillNo",wo.getWoid());
        Map<String,Object> fStockLocId = new LinkedHashMap<>();
        Map<String,Object> fSTOCKLOCID__FF100001 = new HashMap<>();
        fSTOCKLOCID__FF100001.put("FNumber","");
        fStockLocId.put("FSTOCKLOCID__FF100001",fSTOCKLOCID__FF100001);
        Map<String,Object> fSTOCKLOCID__FF100012 = new HashMap<>();
        fSTOCKLOCID__FF100012.put("FNumber","");
        fStockLocId.put("FSTOCKLOCID__FF100012",fSTOCKLOCID__FF100012);
        model.put("FStockLocId",fStockLocId);
        model.put("FBalanceType","");
        model.put("FIsEntrust",false);
        model.put("FOutSeqNumber","0");
        model.put("FOutOperNumber",gxzyErpParam.getOutSxh());
        Map<String,Object> fOutProOrgId = new HashMap<>();
        fOutProOrgId.put("FNumber",gcid);
        model.put("FOutProOrgId",fOutProOrgId);
        Map<String,Object> fProxyOutProOrgId = new HashMap<>();
        fProxyOutProOrgId.put("FNumber",gcid);
        model.put("FProxyOutProOrgId",fProxyOutProOrgId);
        Map<String,Object> fOutDeptId = new HashMap<>();
        fOutDeptId.put("FNUMBER",cjid);
        model.put("FOutDeptId",fOutDeptId);
        Map<String,Object> fOutWorkCenterId = new HashMap<>();
        fOutWorkCenterId.put("FNUMBER",gxzyErpParam.getOutGzzx());
        model.put("FOutWorkCenterId",fOutWorkCenterId );

        Map<String,Object> fOutProcessId = new HashMap<>();
        fOutProcessId.put("FNUMBER",gxzyErpParam.getOutGxid());
        model.put("FOutProcessId", fOutProcessId);

        Map<String,Object> fOutEmpId = new HashMap<>();
        fOutEmpId.put("FSTAFFNUMBER","");
        model.put("FOutEmpId", fOutEmpId);

        model.put("FOutOperDescr", gxzyErpParam.getOutGxmc());

        Map<String,Object> fOutPurOrgId = new HashMap<>();
        fOutPurOrgId.put("FNumber",gcid);
        model.put("FOutPurOrgId", fOutPurOrgId);

        Map<String,Object> fInProOrgId = new HashMap<>();
        fInProOrgId.put("FNumber",gcid);
        model.put("FInProOrgId", fInProOrgId);

        model.put("FInOPBillNo", wo.getWoid());

        Map<String,Object> fInPurOrgId = new HashMap<>();
        fInPurOrgId.put("FNumber",gcid);
        model.put("FInPurOrgId", fInPurOrgId);

        model.put("FInOperId",gxzyErpParam.getInBtid());
        if(zyzt){
            Map<String,Object> fInSupplier = new HashMap<>();
            fInSupplier.put("FNUMBER",gxzyErpParam.getGysid());
            model.put("FInSupplier", fInSupplier);
        }else{
            Map<String,Object> fOutSupplier = new HashMap<>();
            fOutSupplier.put("FNUMBER",gxzyErpParam.getGysid());
            model.put("FOutSupplier", fOutSupplier);
        }

        model.put("FOutOperId", gxzyErpParam.getOutBtid());

        Map<String,Object> fInProcessId = new HashMap<>();
        fInProcessId.put("FNUMBER",gxzyErpParam.getInGxid());
        model.put("FInProcessId", fInProcessId);

        Map<String,Object> fInDeptId = new HashMap<>();
        fInDeptId.put("FNUMBER",cjid);
        model.put("FOutIsInStorePoint", false);
        model.put("FOutSeqType", "M");
        model.put("FInOperDescr",gxzyErpParam.getInGxmc());
        if(zyzt){
            //转出
            model.put("FOutIsOutSrc",false);
        }else{
            //转入
            model.put("FOutIsOutSrc",true);
        }
        model.put("FInSeqNumber","0");
        model.put("FInDeptId", fInDeptId);

        model.put("FInOperNumber",gxzyErpParam.getInSxh());
        if(zyzt){
            Map<String,Object> fInWorkCenterId = new HashMap<>();
            fInWorkCenterId.put("FNUMBER","");
            model.put("FInWorkCenterId", fInWorkCenterId);
        }else{
            Map<String,Object> fInWorkCenterId = new HashMap<>();
            fInWorkCenterId.put("FNUMBER",gxzyErpParam.getInGzzx());
            model.put("FInWorkCenterId", fInWorkCenterId);
        }

        Map<String,Object> fInEmpId = new HashMap<>();
        fInEmpId.put("FSTAFFNUMBER","");
        model.put("FInEmpId", fInEmpId);
        if(zyzt){
            model.put("FTransferQty", gxzydmx.getTzzysl());
            model.put("FOperTransferQty", gxzydmx.getTzzysl());
            model.put("FOperQualifiedQty", gxzydmx.getTzzysl());
        }else{
            model.put("FTransferQty", gxzydmx.getZysl());
            model.put("FOperTransferQty", gxzydmx.getZysl());
            model.put("FOperQualifiedQty", gxzydmx.getZysl());
        }
        model.put("FOperApplyQty", gxzydmx.getZysl());
        model.put("FApplyQty", gxzydmx.getZysl());
        if(zyzt){
            //转出
            model.put("FValQualifiedQty", 0);
            model.put("FQualifiedQty",gxzydmx.getTzzysl());
        }else{
            //接收 填接收数量
            model.put("FValQualifiedQty", 0);
            model.put("FQualifiedQty",gxzydmx.getZysl());
        }

        model.put("FOperUnqualifiedQty",0);
        model.put("FUnqualifiedQty",0);
        model.put("FIsFirstOperTransIn",false);
        model.put("FIsExistTransIn",true);
        model.put("FOperProFailQty",0);
        model.put("FValProFailQty",0);
        model.put("FProFailQty",0);
        model.put("FOperMatFailQty",0);
        model.put("FOperPreReworkQty",0);
        model.put("FPreReworkQty",0);
        model.put("FMatFailQty",0);
        model.put("FValMatFailQty",0);
        Map<String,Object> fSendCurrency = new HashMap<>();
        fSendCurrency.put("FNUMBER","PRE001");
        model.put("FSendCurrency",fSendCurrency);
        model.put("FIsInspect",false);
        Map<String,Object> fQCSchemeId = new HashMap<>();
        fQCSchemeId.put("FNUMBER","");
        model.put("FQCSchemeId",fQCSchemeId);
        model.put("FSendProFailPrice",0);
        Map<String,Object> fReceiveCurrency = new HashMap<>();
        fReceiveCurrency.put("FNUMBER","PRE001");
        model.put("FReceiveCurrency",fReceiveCurrency);
        if(zyzt){
            //转出
            model.put("FReceiveQualifiedPrice",0);
        }else{
            model.put("FReceiveQualifiedPrice",1);
        }
        model.put("FReceiveProFailPrice",0);
        model.put("FReceiveMatFailPrice",0);

        Map<String,Object> fReceiveValuationUnitId = new HashMap<>();
        if(zyzt){
            //转出
            fReceiveValuationUnitId.put("FNumber",gxzyErpParam.getOutDwid());
        }else{
            //接收
            fReceiveValuationUnitId.put("FNumber",gxzyErpParam.getInDwid());
        }
        model.put("FReceiveValuationUnitId",fReceiveValuationUnitId);
        model.put("FReceiveTaxRate",13);
        model.put("FSendMatFailPrice",0);
        model.put("FOperInspectSelectQty",0);

        Map<String,Object> fSendValuationUnitId = new HashMap<>();
        fSendValuationUnitId.put("FNumber",gxzyErpParam.getInDwid());
        model.put("FSendValuationUnitId",fSendValuationUnitId);
        model.put("FInspectSelectQty",0);
        if(zyzt){
            //转出
            model.put("FSendQualifiedPrice",gxzyErpParam.getMxDj().stripTrailingZeros());
        }else{
            //接收
            model.put("FInspectSelectQty",0);
        }
        model.put("FOperQuaSettleSelQty",0);
        model.put("FValQuaSettleSelQty",0);
        model.put("FQuaSettleSelQty",0);
        model.put("FOperInspectQty",0);
        model.put("FInspectQty",0);
        model.put("FQuaInStockSelQty",0);
        model.put("FOperQuaSettleQty",0);
        model.put("FValQuaSettleQty",0);
        model.put("FQuaSettleQty",0);
        model.put("FValProFailSettleSelQty",0);
        model.put("FOperProFailSettleSelQty",0);
        model.put("FQuaInStockQty",0);
        model.put("FProFailSettleSelQty",0);
        model.put("FOperProFailSettleQty",0);
        model.put("FValProFailSettleQty",0);
        model.put("FProFailSettleQty",0);
        model.put("FOperMatFailSettleSelQty",0);
        model.put("FValMatFailSettleSelQty",0);
        model.put("FMatFailSettleSelQty",0);
        model.put("FUnitTransHeadQty",1);
        model.put("FUnitTransOperQty",1);
        model.put("FOperMatFailSettleQty",0);
        model.put("FMatFailSettleQty",0);
        model.put("FValMatFailSettleQty",0);
        Map<String,Object> fBaseUnitId = new HashMap<>();
        fBaseUnitId.put("FNumber",gxzyErpParam.getOutDwid());
        model.put("FBaseUnitId",fBaseUnitId);
        model.put("FApplyBaseQty",gxzydmx.getZysl());
        if(zyzt){
            model.put("FTransferBaseQty",gxzydmx.getTzzysl());
        }else {
            model.put("FTransferBaseQty",gxzydmx.getZysl());
        }
        model.put("FUnQuaInStockSelQty",0);
        if(zyzt){
            model.put("FQualifiedBaseQty",gxzydmx.getTzzysl());
        }else {
            model.put("FQualifiedBaseQty",gxzydmx.getZysl());
        }
        model.put("FInspectSelectBaseQty",0);
        model.put("FUnQuaInStockQty",0);
        model.put("FUnqualifiedBaseQty",0);
        model.put("FProFailBaseQty",0);
        model.put("FInspectBaseQty",0);
        model.put("FPreReworkBaseQty",0);
        model.put("FMatFailBaseQty",0);
        model.put("FQuaSettleSelBaseQty",0);
        model.put("FQuaInStockSelBaseQty",0);
        model.put("FQuaSettleBaseQty",0);
        model.put("FUnQuaInStockSelBaseQty",0);
        model.put("FQuaInStockBaseQty",0);
        model.put("FUnQuaInStockBaseQty",0);
        model.put("FProFailSettleSelBaseQty",0);
        model.put("FProFailSettleBaseQty",0);
        model.put("FMatFailSettleSelBaseQty",0);
        model.put("FMatFailSettleBaseQty",0);
        model.put("FDemandType","");
        model.put("FDemandBillId",0);
        model.put("FDemandBillEntryId",0);
        model.put("FInspectEntryId",0);
        if(zyzt){
            //转出
            model.put("FConvertType","");
        }else{
            //接收
            model.put("FConvertType","0");
        }
        if(zyzt){
            //转出
            model.put("FReceiveQualifiedTaxPrice",0);
        }else{
            //接收
            model.put("FReceiveQualifiedTaxPrice",13);
        }
        model.put("FReceiveProFailTaxPrice",0);
        model.put("FReceiveMatFailTaxPrice",0);
        if(zyzt){
            //转出
            model.put("FSendQualifiedTaxPrice",13);
        }else{
            //接收
            model.put("FSendQualifiedTaxPrice",0);
        }
        model.put("FSendProFailTaxPrice",0);
        model.put("FSendMatFailTaxPrice",0);
        if(zyzt){
            //转出
            model.put("FRateOperQty",0);
        }else{
            //接收
            model.put("FRateOperQty",1);
        }
        model.put("FRateProQty",0);
        model.put("FRateValQty",0);
        Map<String,Object> fPriceLists = new HashMap<>();
        fPriceLists.put("FNUMBER","");
        model.put("FPriceList",fPriceLists);
        model.put("FOperStatus","");
        model.put("FInstockStatus","");
        model.put("FSettleStatus","");
        model.put("F_220_Qtyzyzl",0);
        model.put("FMOInStockQty",0);
        model.put("F_220_Qtyzybzzl",0);
        model.put("FDefectProcessEntryId",0);
        model.put("FMRBReviewEntryId",0);
        model.put("FTransDirection","");
        model.put("FBackwashSrcId",0);

        ArrayList<LinkedHashMap<String,Object>> fBillHead_Link = new ArrayList<>();
        LinkedHashMap<String,Object> link = new LinkedHashMap<>();
        link.put("FBillHead_Link_FFlowId","");
        link.put("FBillHead_Link_FFlowLineId",0);
        link.put("FBillHead_Link_FRuleId","SFC_OPTPLAN2OPTTRANSFER(OPEROUT)");
        link.put("FBillHead_Link_FSTableName","T_SFC_OPERPLANNINGSEQ");
        link.put("FBillHead_Link_FSBillId",gxzyErpParam.getScjhdherId());
        link.put("FBillHead_Link_FSId",gxzyErpParam.getGxxlid());
        link.put("FBillHead_Link_FTransferBaseQtyOld",gxzyErpParam.getTzzysl().intValue());
        link.put("FBillHead_Link_FTransferBaseQty",gxzyErpParam.getTzzysl().intValue());
        fBillHead_Link.add(link);
        model.put("FBillHead_Link",fBillHead_Link);

        data.put("Model",model);
        Map<String,Object> param=new LinkedHashMap<>();
        param.put("formid","SFC_OperationTransfer");
        param.put("data",data);

        JSONObject paraStr=new JSONObject(param);

        Map<String, String> map = new HashMap<>();
        map.put("data", paraStr.toJSONString());

        String r = ERPHttpUtils.doPostSave(ERP_SAVE_URL, paraStr.toJSONString(), "kdservice-sessionid=" + login.getData().getKdsvcSessionId() + ";ASP.NET_SessionId=" + login.getData().getSessionId());

        JSONObject jsonObject = JSONObject.parseObject(r);
        try {
            if(jsonObject.getJSONObject("Result").getJSONObject("ResponseStatus").get("IsSuccess").toString().equals("true")){
                System.out.println("----------------------erp接口返回值："+r+"---------------------");
                String bgid =  String.valueOf(jsonObject.getJSONObject("Result").get("Number"));
                LambdaQueryWrapper<UfcErpGxzydmx> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(UfcErpGxzydmx::getGxzydmxFk,gxzydmx.getGxzydmxoid());
                UfcErpGxzydmx query = ufcErpGxzydmxService.getOne(queryWrapper);
                LambdaUpdateWrapper<UfcErpGxzydmx> wrapper = new LambdaUpdateWrapper<>();
                wrapper.set(UfcErpGxzydmx::getErpGxzyid,bgid);
                if(zyzt){
                    wrapper.set(UfcErpGxzydmx::getErpGxzyid,bgid);
                    wrapper.set(UfcErpGxzydmx::getErpZysl,gxzydmx.getTzzysl());
                }else {
                    wrapper.set(UfcErpGxzydmx::getErpGxjsid,bgid);
                    wrapper.set(UfcErpGxzydmx::getErpJssl,(query.getErpJssl() == null ? 0:query.getErpJssl())+gxzydmx.getZysl().intValue());
                    gxzydmx.setWgPsWbFk(gxzydmx.getJgPsWbFk());
                    gxzydmx.setJgPsWbFk(pswboid);
                    gxzydmxService.updateById(gxzydmx);
                }
                wrapper.eq(UfcErpGxzydmx::getGxzydmxFk,gxzydmx.getGxzydmxoid());
                if(ufcErpGxzydmxService.update(wrapper)){
                    return new Result().toSuccess();
                }
            }else{
                Map<String,Object> message = null;
                try {
                    message = (Map<String, Object>) jsonObject.getJSONObject("Result").getJSONObject("ResponseStatus").getJSONArray("Errors").get(0);
                }catch (Exception e){
                    return new Result().toFailure("工序转移失败");
                }
                throw new CustomException(-1, message.get("Message").toString());
            }
        }catch (Exception e){
            throw new Exception(r);
        }
        return new Result().toFailure("工序转移失败");
    }

    @Override
    @Transactional
    public synchronized Result addGzZy(ErpGxZyListAdd gxZyListAdd, User user) {
        if(gxZyListAdd.getToProcessNumber().compareTo(gxZyListAdd.getPcsl()) == 1) {
            return new Result().toFailure("转移数量大于可转移数量");
        }

        //查询当前工单信息
        PsWb psWb =psWbService.getById(gxZyListAdd.getWgPsWbFk());

        //查询MES当前工单转移数量(不包含当前工序转移)
        Integer mesSum = ufcErpGxzydmxService.selectMesZysl(psWb.getPsWboid(),gxZyListAdd.getGxzydmxoid());
        mesSum= mesSum==null?0:mesSum;

        if( (mesSum + gxZyListAdd.getToProcessNumber().intValue() ) > psWb.getPcsl().intValue()){
            return new Result().toFailure("转移数量大于排产数量");
        }

        //查询上一道工单合格数量
        Result<Integer> thePreviousPsWb = ufcPsWbService.getThePreviousPsWbNumber(psWb.getPsWboid());
        if(!EmptyUtil.isEmpty(thePreviousPsWb)){
            if(thePreviousPsWb.getData() < gxZyListAdd.getToProcessNumber().intValue() + mesSum){
                return new Result().toFailure("转移数量大于上道工序合格数量！");
            }
        }

        //mes工序转移保存数据
        GxZyListAdd gxZyList = new GxZyListAdd();
        BeanUtils.copyProperties(gxZyListAdd,gxZyList);
        gxZyList.setBSuppliergysid(gxZyListAdd.getInGysid());
        Result gxzymx = gxzydmxService.addGzZy(gxZyList,user);


        if(!EmptyUtil.isEmpty(gxzymx.getData())){
            UfcErpGxzydmx  ufcErpGxzydmx = new UfcErpGxzydmx();

            LambdaQueryWrapper<UfcErpGxzydmx> quweyQrapper = new LambdaQueryWrapper<>();
            quweyQrapper.eq(UfcErpGxzydmx::getGxzydmxFk,gxzymx.getData());
            UfcErpGxzydmx mx =ufcErpGxzydmxService.getBaseMapper().selectOne(quweyQrapper);

            if(EmptyUtil.isEmpty(mx)){
                ufcErpGxzydmx.setUfcErpGxzydmxOid(SnowflakeIdUtils.generate());
            }else {
                ufcErpGxzydmx.setUfcErpGxzydmxOid(mx.getUfcErpGxzydmxOid());
            }
            ufcErpGxzydmx.setGxzydmxFk((Long)gxzymx.getData());
            ufcErpGxzydmx.setInGysid(gxZyListAdd.getInGysid());
            ufcErpGxzydmx.setOutGysid(gxZyListAdd.getOutGysid());
            ufcErpGxzydmx.setPsWbFk(psWb.getPsWboid());
            ufcErpGxzydmxService.saveOrUpdate(ufcErpGxzydmx);
        }
        return gxzymx;
    }

    @Override
    public Result<GxZyListAdd> getGxZyListAdd(GxZyJobOfferDTO dto, User user) {
        return gxzydmxService.getGxZyListAdd(dto,user);
    }

    /**
     * 工序转移---接收按钮
     * @param dto
     * @param user
     * @return
     * @throws Exception
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result confirmationReceipt(GxZyJobConfirmDTO dto, User user) throws Exception {

        Gxzydmx gxzydmx = gxzydmxService.getById(dto.getGxzydmxoid());
        Gxzyd gxzyd = gxzydService.getById(gxzydmx.getGxzydFk());

        if("C".equals(gxzyd.getZt())){
            return new Result().toFailure("工序已经接收！");
        }
        if("I".equals(gxzyd.getZt())){
            return new Result().toFailure("工序未转出！");
        }
        //当前工序 转出数量
        BigDecimal zcsl = gxzydmx.getTzzysl()==null?new BigDecimal(0):gxzydmx.getTzzysl();

        //当前工序已接收数量
        BigDecimal jssl = gxzydmx.getZysl()==null?new BigDecimal(0):gxzydmx.getZysl();

        if(zcsl.intValue()<jssl.add(dto.getNumberReceiving()).intValue()){
            return new Result().toFailure("接收数量大于转出数量！");
        }

        this.mesGxzy(dto,user);

        PsWb pswb = psWbService.getById(dto.getPsWbFk());
        //当前订单erp接收数量
        BigDecimal erpJssl = ufcErpGxzydmxMapper.selectErpJssl(dto.getPsWbFk());
        erpJssl = erpJssl==null?new BigDecimal(0):erpJssl;

        //查询ERP计划数量
        Integer erpjh = ufcErpGxzydmxService.selectErpJh(pswb.getWoFk());

        /*LambdaQueryWrapper<UfcErpGxzydmx> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(UfcErpGxzydmx::getGxzydmxFk,gxzydmx.getGxzydmxoid());
        UfcErpGxzydmx ufcErpGxzydmx = ufcErpGxzydmxService.getOne(wrapper);
        //erp转出数量(组织->供应商)
        Integer erpzysl = 0;
        if(!EmptyUtil.isEmpty(ufcErpGxzydmx) && !EmptyUtil.isEmpty(ufcErpGxzydmx.getErpZysl())){
            erpzysl = ufcErpGxzydmx.getErpZysl();
        }
        //erp接收数量(供应商 -> 组织)
        Integer erpjssl = 0;
        if(!EmptyUtil.isEmpty(ufcErpGxzydmx) && !EmptyUtil.isEmpty(ufcErpGxzydmx.getErpJssl())){
            erpzysl = ufcErpGxzydmx.getErpJssl();
        }*/
        gxzydmx.setZysl(dto.getNumberReceiving());

        if(erpjh>erpJssl.intValue()){
            if(erpJssl.intValue()+dto.getNumberReceiving().intValue()>erpjh){
                gxzydmx.setZysl(new BigDecimal(erpjh.intValue()-erpJssl.intValue()));
            }
            gxzy(false,gxzydmx);
        }

        gxzydmx.setZysl(dto.getNumberReceiving().add(jssl));
        //(转出数量+不合格数量) > 转移数量 = 任务完成
        //if((zcsl.intValue() + dto.getNumberReceiving().intValue())==gxzydmx.getZysl().intValue()){
        gxzyd.setZt("C");
        gxzyd.setProofOfReceipt(dto.getProofOfReceipt());
        gxzydService.updateById(gxzyd);
        //}
        gxzydmxService.updateById(gxzydmx);
        return new Result().toSuccess();
    }

    @Override
    public Result getJudgeZbgx(Long psWbFk) {
        if (EmptyUtil.isEmpty(psWbFk)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        Integer zbgx = ufcErpGxzydmxService.getJudgeZbgx(psWbFk);
        if (EmptyUtil.isEmpty(zbgx)) {
            return new Result().toFailure("查无数据");
        }
        return new Result().toSuccess(zbgx == 1);
    }

    @Override
    public Result repealSubmitTransferee(GxZyJobOfferDTO dto, User user) {
        LambdaQueryWrapper<UfcErpGxzydmx> gxzydmxLambdaQueryWrapper = new LambdaQueryWrapper<>();
        gxzydmxLambdaQueryWrapper.eq(UfcErpGxzydmx::getGxzydmxFk,dto.getGxzydmxoid());
        UfcErpGxzydmx ufcErpGxzydmx = ufcErpGxzydmxService.getOne(gxzydmxLambdaQueryWrapper);
        if(!EmptyUtil.isEmpty(ufcErpGxzydmx) && !EmptyUtil.isEmpty(ufcErpGxzydmx.getErpZysl())){
            return new Result().toFailure("Erp工序已转出,撤回失败！");
        }
        //第一步；通过主键查询出明细数据，判断当前工序是否能提交申请
        if (EmptyUtil.isEmpty(dto)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        Gxzydmx gxzydmx = gxzydmxService.getBaseMapper().selectById(dto.getGxzydmxoid());
        if (EmptyUtil.isEmpty(gxzydmx)) {
            return new Result().toFailure("当前转移记录不存在或已被删除!");
        }
        if (EmptyUtil.isEmpty(gxzydmx.getWgPsWbFk())) {
            return new Result().toFailure("数据异常，请联系管理员处理！");
        }
        if (!gxzydmx.getJgPsWbFk().equals(dto.getPsWbFk())) {
            return new Result().toFailure("当前工序非转出工序不能进行转出人撤销提交!");
        }
        if (!"F".equals(gxzydmx.getZt())) {
            return new Result().toFailure("非转出状态不允许撤销申请!");
        }
        //修改转移单明细和转移单状态
        updateZt(gxzydmx.getGxzydFk(), gxzydmx.getGxzydmxoid(), user, "I", false, false,null,null);
        return new Result().toSuccess();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result repealConfirmationReceipt(GxZyJobOfferDTO dto, User user) {
        //查询工序转移明细详情
        Gxzydmx gxzydmx = gxzydmxService.getById(dto.getGxzydmxoid());
        //查询工序转移信息
        Gxzyd gxzyd = gxzydService.getById(gxzydmx.getGxzydFk());
        LambdaQueryWrapper<UfcErpGxzydmx> gxzydmxLambdaQueryWrapper = new LambdaQueryWrapper<>();
        gxzydmxLambdaQueryWrapper.eq(UfcErpGxzydmx::getGxzydmxFk,dto.getGxzydmxoid());
        UfcErpGxzydmx ufcErpGxzydmx = ufcErpGxzydmxService.getOne(gxzydmxLambdaQueryWrapper);
        if(EmptyUtil.isEmpty(gxzydmx) || EmptyUtil.isEmpty(gxzyd) || EmptyUtil.isEmpty(ufcErpGxzydmx)){
            return new Result().toFailure("当前转移记录不存在或已被删除!");
        }
        try{
            if("C".equals(gxzyd.getZt())){
                if(!EmptyUtil.isEmpty(ufcErpGxzydmx.getErpGxjsid())){
                    Result<List<ErpGxhb>> result = this.getErpGxzy(ufcErpGxzydmx.getErpGxjsid());
                    if(!EmptyUtil.isEmpty(result) && !EmptyUtil.isEmpty(result.getData())){
                        return new Result().toFailure("请先删除erp接收数据!");
                    }
                }
                //根据工单查询汇报记录
                List<Long> psWbrptOid = ufcErpGxzydmxMapper.selectPsWbrpt(gxzydmx.getWgPsWbFk());
                //删除工序汇报记录
                if(!EmptyUtil.isEmpty(psWbrptOid)){
                    ufcErpGxzydmxMapper.deletePsWbrpt(psWbrptOid);
                }
                gxzydmx.setZt("F");
                gxzydmx.setZysl(new BigDecimal(0));
                gxzydmxService.updateById(gxzydmx);
                ufcErpGxzydmx.setErpJssl(0);
                ufcErpGxzydmx.setErpGxjsid(null);
                ufcErpGxzydmxService.updateById(ufcErpGxzydmx);
                gxzyd.setZt("F");
                gxzydService.updateById(gxzyd);

                //工序外协接收转出  逆向操作删除后，需要更新工序状态。
                PsWbCompleteDto psWbCompleteDto = new PsWbCompleteDto();
                psWbCompleteDto.setForce(false);
                psWbCompleteDto.setOid(gxzydmx.getWgPsWbFk());
                return psWbService.cancelTheCompletion(psWbCompleteDto,user);
            }else{
                if(!EmptyUtil.isEmpty(ufcErpGxzydmx.getErpGxzyid())){
                    Result<List<ErpGxhb>> result = this.getErpGxzy(ufcErpGxzydmx.getErpGxzyid());
                    if(!EmptyUtil.isEmpty(result) && !EmptyUtil.isEmpty(result.getData())){
                        return new Result().toFailure("请先删除erp转出数据!");
                    }
                }
                gxzydmx.setZt("I");
                gxzydmxService.updateById(gxzydmx);
                ufcErpGxzydmx.setErpJssl(0);
                ufcErpGxzydmx.setErpGxzyid(null);
                ufcErpGxzydmxService.updateById(ufcErpGxzydmx);
                gxzyd.setZt("I");
                gxzydService.updateById(gxzyd);
            }
        }catch (Exception e){
            throw new CustomException(-1,"工序转移撤销失败");
        }
        /*if(!EmptyUtil.isEmpty(ufcErpGxzydmx) && !EmptyUtil.isEmpty(ufcErpGxzydmx.getErpJssl())){
            return new Result().toFailure("Erp工序已接收,撤回失败！");
        }
        //第一步；通过主键查询出明细数据，判断当前工序是否能提交申请
        if (EmptyUtil.isEmpty(dto)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        if (EmptyUtil.isEmpty(gxzydmx)) {
            return new Result().toFailure("当前转移记录不存在或已被删除!");
        }
        if (EmptyUtil.isEmpty(gxzydmx.getWgPsWbFk())) {
            return new Result().toFailure("数据异常，请联系管理员处理！");
        }
        if (!gxzydmx.getWgPsWbFk().equals(dto.getPsWbFk())) {
            return new Result().toFailure("当前工序非接收工序不能进行撤销确认!");
        }
        if (!"C".equals(gxzydmx.getZt())) {
            return new Result().toFailure("非确认状态不允许进行撤销确认!");
        }*/
        //修改转移单明细和转移单状态
        //updateZt(gxzydmx.getGxzydFk(), gxzydmx.getGxzydmxoid(), user, "F", true, true,null,null);
        return new Result().toSuccess();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result del(Long gxzydmxoid) {
        //查询工序转移明细详情
        Gxzydmx gxzydmx = gxzydmxService.getById(gxzydmxoid);
        //查询工序转移信息
        Gxzyd gxzyd = gxzydService.getById(gxzydmx.getGxzydFk());
        LambdaQueryWrapper<UfcErpGxzydmx> gxzydmxLambdaQueryWrapper = new LambdaQueryWrapper<>();
        gxzydmxLambdaQueryWrapper.eq(UfcErpGxzydmx::getGxzydmxFk,gxzydmxoid);
        UfcErpGxzydmx ufcErpGxzydmx = ufcErpGxzydmxService.getOne(gxzydmxLambdaQueryWrapper);
        try {
            if(!EmptyUtil.isEmpty(gxzydmx) && "I".equals(gxzydmx.getZt())){
                ufcErpGxzydmxMapper.del(ufcErpGxzydmx.getUfcErpGxzydmxOid());
                ufcErpGxzydmxMapper.delGxzyd(gxzyd.getGxzydoid());
                ufcErpGxzydmxMapper.delGxzydmx(gxzydmx.getGxzydmxoid());
            }else {
                return new Result().toFailure("删除失败！");
            }
        }catch (Exception e){
            throw new CustomException(-1,"工序转移删除失败");
        }
        return new Result().toSuccess();
    }

    public void updateZt(Long gxzydFk, Long gxzydmxoid, User user, String zt, Boolean confirm, Boolean unconfirm,BigDecimal numberReceiving,String receiveThe) {
        //修改转移单明细和转移单状态
        LambdaUpdateWrapper<Gxzydmx> wrapper = new LambdaUpdateWrapper<>();
        wrapper.eq(Gxzydmx::getGxzydmxoid, gxzydmxoid);
        wrapper.set(Gxzydmx::getSysLastUpd, LocalDateTime.now());
        wrapper.set(Gxzydmx::getSysLastUpdBy, user.getEmployeeOid());
        wrapper.set(Gxzydmx::getZt, zt);
        if(!EmptyUtil.isEmpty(numberReceiving)){
            wrapper.set(Gxzydmx::getZysl, numberReceiving);
        }
        if(!EmptyUtil.isEmpty(receiveThe)){
            wrapper.set(Gxzydmx::getReceiveThe, receiveThe);
        }
        int update = gxzydmxService.getBaseMapper().update(null, wrapper);
        if (0 == update) {
            throw new CustomException(-1, "转出人提交失败！");
        }
        LambdaUpdateWrapper<Gxzyd> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.eq(Gxzyd::getGxzydoid, gxzydFk);
        updateWrapper.set(Gxzyd::getSysLastUpd, LocalDateTime.now());
        updateWrapper.set(Gxzyd::getSysLastUpdBy, user.getEmployeeOid());
        updateWrapper.set(Gxzyd::getZt, zt);
        if (confirm) {
            updateWrapper.set(Gxzyd::getJsrTime, LocalDateTime.now());
            updateWrapper.set(Gxzyd::getJsr, user.getEmployeeOid());
            updateWrapper.set(Gxzyd::getJsrgh, user.getCodeing());
        }
        if (unconfirm) {
            updateWrapper.set(Gxzyd::getJsrTime, null);
            updateWrapper.set(Gxzyd::getJsr, null);
            updateWrapper.set(Gxzyd::getJsrgh, null);
        }
        int update1 = this.gxzydService.getBaseMapper().update(null, updateWrapper);
        if (0 == update1) {
            throw new CustomException(-1, "转出人提交失败！");
        }
    }

    public Result submitTransferee(GxZyJobOfferDTO dto, User user) {
        //第一步；通过主键查询出明细数据，判断当前工序是否能提交申请
        if (EmptyUtil.isEmpty(dto)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        Gxzydmx gxzydmx = gxzydmxService.getBaseMapper().selectById(dto.getGxzydmxoid());
        if (EmptyUtil.isEmpty(gxzydmx)) {
            return new Result().toFailure("当前转移记录不存在或已被删除!");
        }
        if (EmptyUtil.isEmpty(gxzydmx.getWgPsWbFk())) {
            return new Result().toFailure("转出工序为空不能执行转出操作!");
        }
        if (!"I".equals(gxzydmx.getZt())) {
            return new Result().toFailure("非初始状态不允许提交申请!");
        }
        Gxzyd gxzyd = gxzydService.getById(gxzydmx.getGxzydFk());
        if(!EmptyUtil.isEmpty(gxzyd) && gxzyd.getYwlx().equals("E")){
            //外协转移
            //修改转移单明细和转移单状态
            gxzySubmit(gxzydmx, user, "F", false, false,null,null);
            return new Result().toSuccess();
        }else{
            if (!gxzydmx.getJgPsWbFk().equals(dto.getPsWbFk())) {
                return new Result().toFailure("当前工序非接收工序不能进行转出人提交!");
            }
            updateZt(gxzydmx.getGxzydFk(), gxzydmx.getGxzydmxoid(), user, "F", false, false,null,null);
            return new Result().toSuccess();
        }
    }
    /**
     * 外协转移
     * @param gxzydmx
     * @param user
     * @param zt
     * @param confirm
     * @param unconfirm
     * @param numberReceiving
     * @param receiveThe
     */
    public void gxzySubmit(Gxzydmx gxzydmx, User user, String zt, Boolean confirm, Boolean unconfirm,BigDecimal numberReceiving,String receiveThe) {
        //修改接收工单合转出工单
        //查询当前工单信息
        PsWb psWb = psWbService.getBaseMapper().selectById(gxzydmx.getWgPsWbFk());
        GxZyListAdd listAdd = gxzydmxMapper.getGxZyListAdd(psWb.getPsWboid());
        if (EmptyUtil.isEmpty(listAdd)) {
            throw new CustomException(-1, "当前工单数据有误！");
        }
        //查询下道工序信息
        Result<ProcessNodeVO> result = processService.getgetProcessNodePid(listAdd.getPsTechnologicalProcessFk(), listAdd.getPsWsFk(), listAdd.getGxid());

        //修改转移单明细和转移单状态
        LambdaUpdateWrapper<Gxzydmx> wrapper = new LambdaUpdateWrapper<>();
        wrapper.eq(Gxzydmx::getGxzydmxoid, gxzydmx.getGxzydmxoid());
        wrapper.set(Gxzydmx::getSysLastUpd, LocalDateTime.now());
        wrapper.set(Gxzydmx::getSysLastUpdBy, user.getEmployeeOid());
        wrapper.set(Gxzydmx::getZt, zt);
        //接收工序 ： 当前工序下一道工序
        wrapper.set(Gxzydmx::getWgPsWbFk,gxzydmx.getWgPsWbFk());
        //转出工序: 修改为当前工序工单外键(转出中的接收工序)
        wrapper.set(Gxzydmx::getJgPsWbFk,gxzydmx.getJgPsWbFk());
        if(!EmptyUtil.isEmpty(numberReceiving)){
            wrapper.set(Gxzydmx::getZysl, numberReceiving);
        }
        if(!EmptyUtil.isEmpty(receiveThe)){
            wrapper.set(Gxzydmx::getReceiveThe, receiveThe);
        }
        int update = gxzydmxMapper.update(null, wrapper);
        if (0 == update) {
            throw new CustomException(-1, "转出人提交失败！");
        }
        LambdaUpdateWrapper<Gxzyd> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.eq(Gxzyd::getGxzydoid, gxzydmx.getGxzydFk());
        updateWrapper.set(Gxzyd::getSysLastUpd, LocalDateTime.now());
        updateWrapper.set(Gxzyd::getSysLastUpdBy, user.getEmployeeOid());
        updateWrapper.set(Gxzyd::getZt, zt);
        if (confirm) {
            updateWrapper.set(Gxzyd::getJsrTime, LocalDateTime.now());
            updateWrapper.set(Gxzyd::getJsr, user.getEmployeeOid());
            updateWrapper.set(Gxzyd::getJsrgh, user.getCodeing());
        }
        if (unconfirm) {
            updateWrapper.set(Gxzyd::getJsrTime, null);
            updateWrapper.set(Gxzyd::getJsr, null);
            updateWrapper.set(Gxzyd::getJsrgh, null);
        }
        int update1 = this.gxzydService.getBaseMapper().update(null, updateWrapper);
        if (0 == update1) {
            throw new CustomException(-1, "转出人提交失败！");
        }
    }

    public Result mesGxzy(GxZyJobConfirmDTO dto, User user) {
        if (EmptyUtil.isEmpty(dto)) {
            return (new Result()).toFailure(ResultCodeEnum.MISS_PARAM);
        } else {
            Gxzydmx gxzydmx = gxzydmxMapper.selectById(dto.getGxzydmxoid());
            if (EmptyUtil.isEmpty(gxzydmx)) {
                return (new Result()).toFailure("当前转移记录不存在或已被删除!");
            } else if (EmptyUtil.isEmpty(gxzydmx.getWgPsWbFk())) {
                return (new Result()).toFailure("数据异常，请联系管理员处理！");
            } else if (!gxzydmx.getWgPsWbFk().equals(dto.getPsWbFk())) {
                return (new Result()).toFailure("当前工序非接收工序不能进行确认!");
            } else if (!"F".equals(gxzydmx.getZt())) {
                return (new Result()).toFailure("非转出状态不允许进行确认!");
            } else {
                this.updateZt(gxzydmx.getGxzydFk(), gxzydmx.getGxzydmxoid(), user, "F", true, false, dto.getNumberReceiving(), dto.getReceiveThe());
                LambdaUpdateWrapper<Gxzyd> updateWrapper = new LambdaUpdateWrapper();
                updateWrapper.eq(Gxzyd::getGxzydoid, gxzydmx.getGxzydFk());
                updateWrapper.set(Gxzyd::getJsrTime, dto.getJsrTime());
                updateWrapper.set(Gxzyd::getProofOfReceipt, dto.getProofOfReceipt());
                gxzydService.getBaseMapper().update(null, updateWrapper);
                Boolean process = this.abnormalProcessTransferService.receivingProcess(gxzydmx.getGxzydmxoid(), dto.getNumberReceiving(), gxzydmx.getTzzysl(), gxzydmx.getJgPsWbFk(), gxzydmx.getWgPsWbFk());
                log.info("工序转移异常数据执行情况：" + process);
                return (new Result()).toSuccess();
            }
        }
    }

    /**
     * 查询erp工序转移数据
     * @return
     */
    public Result getErpGxzy(String erpBgSaveId) {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FBillNo,FDocumentStatus");
        params.setFormId("SFC_OperationTransfer");
        params.setTopRowCount(0);
        String param = "FBillNo in ('"+erpBgSaveId+"')";
        params.setFilterString(param);
        Result<List<ErpGxhb>> others = ERPHttpUtils.others(params, ErpGxhb.class);
        return others;
    }
}
