package com.jln.system.web.action.erp.gxbg.service.impl;

import com.jln.common.entity.Result;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.erp.gxbg.entity.UfcErpGxzydmx;
import com.jln.system.web.action.erp.gxbg.mapper.UfcErpGxzydmxMapper;
import com.jln.system.web.action.erp.gxbg.service.UfcErpGxzydmxService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcGxzyInfo;
import com.jln.system.web.action.ps.zytl.pojo.vo.GxzyInfo;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;

/**
 * <p>
 * erp工序转移扩展表 服务实现类
 * </p>
 *
 * @author 
 * @since 2022-01-19
 */
@Service
public class UfcErpGxzydmxServiceImpl extends ServiceImpl<UfcErpGxzydmxMapper, UfcErpGxzydmx> implements UfcErpGxzydmxService {

    @Override
    public Integer getJudgeZbgx(Long psWbFk) {
        return this.getBaseMapper().getJudgeZbgx(psWbFk);
    }

    /**
     * 查询mes工序转移数量
     * @param psWbFk
     * @param gxzydmxoid
     * @return
     */
    @Override
    public Integer selectMesZysl(Long psWbFk, Long gxzydmxoid) {
        return this.getBaseMapper().selectMesZysl(psWbFk,gxzydmxoid);
    }

    /**
     * 查询erp工序转移数量
     * @param woFk
     * @return
     */
    @Override
    public Integer selectErpZysl(Long woFk,Long wogylxFk) {
        return this.getBaseMapper().selectErpZysl(woFk,wogylxFk);
    }

    /**
     * 查询宏明订单数量
     * @param woFk
     * @return
     */
    @Override
    public Integer selectErpJh(Long woFk) {
        return this.getBaseMapper().selectErpJh(woFk);
    }

    @Override
    public Integer getErpZysl(Long psWbFk) {
        return this.getBaseMapper().getErpZysl(psWbFk);
    }

    @Override
    public Integer getErpJssl(Long psWbFk) {
        return this.getBaseMapper().getErpJssl(psWbFk);
    }

    @Override
    public Result<UfcGxzyInfo> getProcessRemoval(Long psWbFk) {
        if (EmptyUtil.isEmpty(psWbFk)) {
            return new Result<>().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        UfcGxzyInfo removal = this.baseMapper.getProcessRemoval(psWbFk);
        if (EmptyUtil.isEmpty(removal)) {
            return new Result<>().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        BigDecimal number = this.baseMapper.getProcessRemovalNumber(psWbFk);
        removal.setZysl(number);
        return new Result<UfcGxzyInfo>().toSuccess(removal);
    }

    @Override
    public Result<UfcGxzyInfo> getProcessRollOut(Long psWbFk) {
        if (EmptyUtil.isEmpty(psWbFk)) {
            return new Result<>().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        UfcGxzyInfo removal = this.baseMapper.getProcessRollOut(psWbFk);
        if (EmptyUtil.isEmpty(removal)) {
            return new Result<>().toFailure(ResultCodeEnum.LOOK_UP_TO);
        }
        BigDecimal number = this.baseMapper.getProcessRollOutNumber(psWbFk);
        BigDecimal jssl = this.baseMapper.getMesJssl(psWbFk);
        removal.setZysl(number);
        removal.setJssl(jssl);
        return new Result<UfcGxzyInfo>().toSuccess(removal);
    }
}
