package com.jln.system.web.action.erp.gxbg.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.enums.WorkOderEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.system.web.action.commonweb.parameterize.service.SysBusinessService;
import com.jln.system.web.action.erp.gxbg.entity.dto.UfcWbRptJobAddDto;
import com.jln.system.web.action.erp.gxbg.entity.UfcErpPsWbrpt;
import com.jln.system.web.action.erp.gxbg.mapper.UfcErpPsWbrptMapper;
import com.jln.system.web.action.erp.gxbg.service.UfcErpPsWbrptService;
import com.jln.system.web.action.erp.ufcpswb.service.UfcPsWbService;
import com.jln.system.web.action.erp.wo.mapper.WoExpandMapper;
import com.jln.system.web.action.pp.proPrepare.entity.Wogylx;
import com.jln.system.web.action.pp.proPrepare.service.WogylxService;
import com.jln.system.web.action.ps.production.entity.PsWb;
import com.jln.system.web.action.ps.production.entity.PsWbuq;
import com.jln.system.web.action.ps.production.entity.PsWs;
import com.jln.system.web.action.ps.production.mapper.PsWbMapper;
import com.jln.system.web.action.ps.production.pojo.dto.PsWbCompleteDto;
import com.jln.system.web.action.ps.production.pojo.dto.WbUpDto;
import com.jln.system.web.action.ps.production.pojo.vo.PsWbRptNumberVo;
import com.jln.system.web.action.ps.production.service.PsWbService;
import com.jln.system.web.action.ps.production.service.PsWbrptService;
import com.jln.system.web.action.ps.production.service.PsWbuqService;
import com.jln.system.web.action.ps.production.service.PsWsService;
import com.jln.system.web.action.ps.production.service.impl.PsWbrptServiceImpl;
import com.jln.ufc.web.action.ufc.em.entity.UfcEmEqucodPsWbrpt;
import com.jln.ufc.web.action.ufc.em.service.UfcEmEqucodService;
import com.jln.ufc.web.action.ufc.pp.mapper.UfcWoMapper;
import com.jln.ufc.web.action.ufc.pp.pojo.UfcWo;
import com.jln.ufc.web.action.ufc.ps.mapper.UfcPsWbMapper;
import com.jln.ufc.web.action.ufc.ps.pojo.UfcPsWbrpt;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWb;
import com.jln.ufc.web.action.ufc.ps.service.UfcPsWbrptService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author 
 * @since 2022-02-24
 */
@Service
public class UfcErpPsWbrptServiceImpl extends ServiceImpl<UfcErpPsWbrptMapper, UfcErpPsWbrpt> implements UfcErpPsWbrptService {
    private static final Logger log = LoggerFactory.getLogger(PsWbrptServiceImpl.class);

    @Autowired
    private PsWbService psWbService;

    @Autowired
    private PsWbrptService psWbrptService;

    @Autowired
    private PsWbuqService psWbuqService;

    @Autowired
    private WogylxService wogylxService;

    @Autowired
    private SysBusinessService sysBusinessService;

    @Autowired
    private PsWbMapper psWbMapper;

   @Autowired
   private UfcErpPsWbrptService ufcErpPsWbrptService;

   @Autowired
   private PsWsService psWsService;

   @Autowired
   private UfcPsWbrptService ufcPsWbrptService;

    @Autowired
    private UfcPsWbService ufcPsWbService;

    @Autowired
    private UfcWoMapper ufcWoMapper;
    @Autowired
    private UfcPsWbMapper ufcPsWbMapper;
    @Autowired
    private UfcEmEqucodService ufcEmEqucodService;
    @Autowired
    private WoExpandMapper woExpandMapper;
    @Autowired
    private UfcErpPsWbrptMapper ufcErpPsWbrptMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result addReportRecord(List<UfcWbRptJobAddDto> dtos, User user) {
        BigDecimal bhgsl = new BigDecimal(0);
        if (EmptyUtil.isEmpty(dtos)) {
            return (new Result()).toFailure(ResultCodeEnum.MISS_PARAM);
        } else {
            Long psWbFk = ((UfcWbRptJobAddDto)dtos.get(0)).getPsWbFk();
            if (EmptyUtil.isEmpty(psWbFk)) {
                return (new Result()).toFailure("请指定工单数据在进行汇报数据的添加");
            } else {
                Result result = this.psWbService.haltedState(psWbFk);
                if (!result.confirmSuccess()) {
                    return result;
                } else {
                    PsWb byId = (PsWb)this.psWbService.getById(psWbFk);
                    if (EmptyUtil.isEmpty(byId)) {
                        return (new Result()).toFailure("工单数据有误!");
                    } else {
                        List<PsWbuq> wbuqList = new ArrayList();
                        List<Long> idList = new ArrayList();
                        BigDecimal newHgsl = new BigDecimal(0);

                            UfcWbRptJobAddDto dto = dtos.get(0);
                            newHgsl = newHgsl.add(dto.getHgsl());
                            UfcPsWbrpt wbrpt = new UfcPsWbrpt();
                            BigDecimal sum = new BigDecimal(0);
                            if (!EmptyUtil.isEmpty(dto.getPsWbrptoid()) && 0L != dto.getPsWbrptoid()) {
                                wbrpt.setPsWbrptoid(dto.getPsWbrptoid());
                                //当前工单汇报数量
                                BigDecimal dqgdhbsl = woExpandMapper.selectHgslByPsWb(byId.getPsWboid(), dto.getPsWbrptoid());
                                sum = dqgdhbsl==null?new BigDecimal(0):dqgdhbsl;
                            } else {
                                wbrpt.setPsWbrptoid(SnowflakeIdUtils.generate());
                                idList.add(wbrpt.getPsWbrptoid());
                                //当前工单汇报数量
                                if(!EmptyUtil.isEmpty(woExpandMapper.selectHgslByPsWb(byId.getPsWboid(),null))){
                                    sum = woExpandMapper.selectHgslByPsWb(byId.getPsWboid(),null) ;
                                }
                            }
                            byId.setHgsl(sum.add(newHgsl));
                            wbrpt.setWoFk(byId.getWoFk());
                            wbrpt.setGpid(byId.getGpid());
                            wbrpt.setEwm(byId.getGpid());
                            wbrpt.setSjkgrq(byId.getSjkgrq());
                            wbrpt.setSjwgrq(byId.getSjwgrq());
                            wbrpt.setHgsl(dto.getHgsl());
                            wbrpt.setRggs(dto.getRggs());
                            wbrpt.setBz(dto.getBz());
                            wbrpt.setZt("I");
                            wbrpt.setSysLastUpd(LocalDateTime.now());
                            wbrpt.setSysLastUpdBy(user.getEmployeeOid());
                            wbrpt.setPsWbFk(byId.getPsWboid());
                            wbrpt.setPsWbOutFk(dto.getPsWbOutFk());
                            //wbrpt.setUfcEmEqucodoidFk(dto.getUfcEmEqucodoidFk());
                            if(!EmptyUtil.isEmpty(dto.getFDate())){
                                wbrpt.setFkrq(dto.getFDate().atStartOfDay());
                            }
                        //新增设备关联数据
                        List<UfcEmEqucodPsWbrpt> ufcEmEqucods = new ArrayList<>();

                        //删除原来的关联数据
                        LambdaQueryWrapper<UfcEmEqucodPsWbrpt> wrapper = new LambdaQueryWrapper<>();
                        wrapper.in(UfcEmEqucodPsWbrpt::getPsWbrptFk,wbrpt.getPsWbrptoid());
                        ufcEmEqucodService.getBaseMapper().delete(wrapper);

                            if(!EmptyUtil.isEmpty(dto.getUfcEmEqucodoidFk())){

                                for (Long aLong : dto.getUfcEmEqucodoidFk()) {
                                    //判断设备编码是否为null
                                    if(EmptyUtil.isEmpty(aLong)){
                                        continue;
                                    }
                                    UfcEmEqucodPsWbrpt ufcEmEqucod = new UfcEmEqucodPsWbrpt();
                                    ufcEmEqucod.setPsWbrptEqucodoid(SnowflakeIdUtils.generate());
                                    ufcEmEqucod.setPsWbrptFk(wbrpt.getPsWbrptoid());
                                    ufcEmEqucod.setEmEqucodoidFk(aLong);
                                    ufcEmEqucods.add(ufcEmEqucod);
                                }
                            }
                            Integer[] xh = new Integer[]{1};
                            BigDecimal unqualifiedQuantity = new BigDecimal(0);
                            BigDecimal[] xk = new BigDecimal[]{unqualifiedQuantity};

                            if (!EmptyUtil.isEmpty(dto.getProofOfReceipt())){
                                WbUpDto wbUpDto = new WbUpDto();
                                //不合格分类 外协转移WF
                                if (!EmptyUtil.isEmpty(dto.getBhgfl())){
                                    wbUpDto.setFl(dto.getBhgfl());
                                }
                                //工序转移使用  不合格数量
                                if (!EmptyUtil.isEmpty(dto.getProofOfReceipt())){
                                    wbUpDto.setUnqualifiedQuantity(new BigDecimal(dto.getProofOfReceipt()));
                                }
                                List<WbUpDto> wbUpDtos = new ArrayList<>();
                                wbUpDtos.add(wbUpDto);
                                dto.setWbUpDtoList(wbUpDtos);
                            }
                            Long wbupOid = null;
                            if (!EmptyUtil.isEmpty(dto.getWbUpDtoList())) {

                                    for (WbUpDto wbUpDto : dto.getWbUpDtoList()) {
                                        PsWbuq wbuq = new PsWbuq();
                                        if (!EmptyUtil.isEmpty(wbUpDto.getPsWbuqoid()) && 0L != wbUpDto.getPsWbuqoid()) {
                                            wbupOid = wbUpDto.getPsWbuqoid();
                                            wbuq.setPsWbuqoid(wbUpDto.getPsWbuqoid());
                                        } else {
                                            wbupOid = SnowflakeIdUtils.generate();
                                            wbuq.setPsWbuqoid(wbupOid);
                                        }
                                        if(!EmptyUtil.isEmpty(wbUpDto.getUnqualifiedQuantity())){
                                            bhgsl = bhgsl.add(wbUpDto.getUnqualifiedQuantity());
                                        }
                                        wbuq.setUpxh(xh[0]);
                                        wbuq.setFkrq(LocalDate.now());
                                        wbuq.setFl(wbUpDto.getFl());
                                        //不合格说明
                                        if (!EmptyUtil.isEmpty(dto.getBhgsm())){
                                            wbuq.setBhgyymc(dto.getBhgsm());
                                        }
                                        wbuq.setSl(wbUpDto.getUnqualifiedQuantity());
                                        wbuq.setFxgxid(byId.getGxid());
                                        wbuq.setBhgxxid(wbUpDto.getBhgxxid());
                                        wbuq.setBhgxxmc(wbUpDto.getBhgxxmc());
                                        wbuq.setBfwlFk(wbUpDto.getBfwlFk());
                                        wbuq.setBfwlph(wbUpDto.getBfwlph());
                                        wbuq.setSysLastUpdBy(user.getEmployeeOid());
                                        wbuq.setSysLastUpd(LocalDateTime.now());
                                        wbuq.setZt("C");
                                        wbuq.setPsWbFk(wbrpt.getPsWbFk());
                                        wbuq.setPsWbrptFk(wbrpt.getPsWbrptoid());
                                        xh[0] = xh[0] + 1;
                                        BigDecimal quantity = wbUpDto.getUnqualifiedQuantity();
                                        if (!EmptyUtil.isEmpty(quantity)) {
                                            xk[0] = xk[0].add(quantity);
                                        }

                                        wbuqList.add(wbuq);
                                    }

                                wbrpt.setFpsl(xk[0]);
                                newHgsl = newHgsl.add(wbrpt.getFpsl());
                            }

                            BigDecimal bigDecimal = this.verifySl("PSK0250");

                            BigDecimal hgsl = byId.getPcsl();
                            PsWbRptNumberVo fk = this.getPsWbOutByPsWbFk(psWbFk, idList);
                            if (!EmptyUtil.isEmpty(fk)) {
                                BigDecimal newhgsl = EmptyUtil.isEmpty(fk.getHgsl()) ? BigDecimal.ZERO : fk.getHgsl();
                                BigDecimal fpsl = EmptyUtil.isEmpty(fk.getFpsl()) ? BigDecimal.ZERO : fk.getFpsl();
                                BigDecimal lfsl = EmptyUtil.isEmpty(fk.getLfsl()) ? BigDecimal.ZERO : fk.getLfsl();
                                BigDecimal newBhgsl = fpsl.add(lfsl);
                                hgsl = byId.getPcsl().subtract(newhgsl).subtract(newBhgsl);
                            }

                            if (newHgsl.compareTo(hgsl.add(bigDecimal)) == 1) {
                                throw new CustomException(-1, "汇报合格数量不能超过排产数量+允许超出值!");
                            }

                        if (!EmptyUtil.isEmpty(wbuqList)) {
                            boolean saveBatch = this.psWbuqService.saveOrUpdateBatch(wbuqList);
                            if (!saveBatch) {
                                throw new CustomException(-1, "添加工单汇报记录失败!");
                            }
                        }
                        //查询上一道工单
                        UfcPsWb ufcPsWb = this.baseMapper.getNextPsWb(dto.getPsWbFk());
                        //查询上一道工序批号日期、产品批号

                        UfcErpPsWbrpt phrqcpph = ufcErpPsWbrptMapper.getOneRow(ufcPsWb.getPsWboid());
                        UfcErpPsWbrpt ufcErpPsWbrpt = new UfcErpPsWbrpt();
                        ufcErpPsWbrpt.setUfcErpPsWbrptOid(wbrpt.getPsWbrptoid());
                        ufcErpPsWbrpt.setPsWbrptFk(wbrpt.getPsWbrptoid());
                        ufcErpPsWbrpt.setMxJdmc(dto.getMxJdmc());
                        ufcErpPsWbrpt.setMxWdxsMc(dto.getMxWdxsMc());
                        ufcErpPsWbrpt.setMxZldjMc(dto.getMxZldjMc());
                        if(!EmptyUtil.isEmpty(phrqcpph)){
                            if(!EmptyUtil.isEmpty(phrqcpph.getPhrq())){
                                ufcErpPsWbrpt.setPhrq(phrqcpph.getPhrq());
                            }else {
                                ufcErpPsWbrpt.setPhrq(dto.getPhrq());
                            }
                            if(!EmptyUtil.isEmpty(phrqcpph.getCpph())){
                                ufcErpPsWbrpt.setCpph(phrqcpph.getCpph());
                            }else {
                                ufcErpPsWbrpt.setCpph(dto.getCpph());
                            }
                        }else{
                            ufcErpPsWbrpt.setCpph(dto.getCpph());
                            ufcErpPsWbrpt.setPhrq(dto.getPhrq());
                        }
                        //委外工序，自动生成工序汇报记录状态为确认
                        if(!EmptyUtil.isEmpty(dto.getIsOutsourcing()) && dto.getIsOutsourcing()){
                            ufcErpPsWbrpt.setZt('R');
                        }else {
                            ufcErpPsWbrpt.setZt('I');
                        }
                        ufcErpPsWbrptService.saveOrUpdate(ufcErpPsWbrpt);
                        if(!EmptyUtil.isEmpty(ufcEmEqucods)){
                            ufcEmEqucodService.saveBatch(ufcEmEqucods);
                        }
                            psWbMapper.updateById(byId);
                            boolean batch = ufcPsWbrptService.saveOrUpdate(wbrpt);
                            if (!batch) {
                                throw new CustomException(-1, "添加工单汇报记录失败!");
                            }
                            //委外工序自动生成汇报记录，数量控制自动完工
                        if(!EmptyUtil.isEmpty(dto.getIsOutsourcing()) && dto.getIsOutsourcing()){
                            //委外自动生成汇报记录数量
                            BigDecimal hbsl = ufcPsWbService.selectHbsl(psWbFk, null);
                            // TODO: 2022/3/22  工序完工数量控制
                            //查询上一道工单合格数量
                            Result<Integer> thePreviousPsWb = ufcPsWbService.getThePreviousPsWbNumber(psWbFk);
                            //查询不合格数量
                            BigDecimal bhgslZdwg = ufcPsWbService.selectBhgsl(psWbFk);
                            bhgsl = bhgsl==null?new BigDecimal(0):bhgsl;
                            //判断是否存在上道工序 如果不存在则合格数量+不合格数量时自动完工
                            if (thePreviousPsWb.confirmSuccess()){
                                //后续工序反馈:合格数量+不合格数量―不能大于上道工序合格数量，等于上道工序合格数量时，本工序自动完工。
                                ufcErpPsWbrptService.verify7("PSK011", BigDecimal.valueOf(thePreviousPsWb.getData()), hbsl, byId.getPsWboid(), user);
                            }else {
                                ufcErpPsWbrptService.verify7("PSK011", byId.getPcsl(), hbsl, byId.getPsWboid(), user);
                            }
                        }
                            return new Result().setData(wbupOid);
                        }
                    }
                }
            }
    }

    @Override
    public Integer selectErpBgsl(Long wooid) {
        return this.getBaseMapper().selectErpBgsl(wooid);
    }

    @Override
    public int updateCpph(Long psWboid, String cpph) {
        return this.getBaseMapper().updateCpph(psWboid,cpph);
    }

    public BigDecimal verifySl(String code) {
        BigDecimal decimal = BigDecimal.ZERO;
        Result<List<Object>> ruleValue = this.sysBusinessService.getdefaultValue(code);
        if (ruleValue.confirmSuccess()) {
            try {
                Object o = ((List)ruleValue.getData()).get(0);
                decimal = new BigDecimal(o.toString());
                if (decimal.compareTo(BigDecimal.ZERO) == -1) {
                    log.info("自动生成反馈记录：参数值小于零,跳过 - 参数值:" + decimal);
                    decimal = BigDecimal.ZERO;
                }
            } catch (Exception var5) {
                log.info("自动生成反馈记录：参数值非数字!");
                decimal = BigDecimal.ZERO;
            }
        }

        return decimal;
    }

    public PsWbRptNumberVo getPsWbOutByPsWbFk(Long psWbFk, List<Long> notCountId) {
        if (EmptyUtil.isEmpty(psWbFk)) {
            return null;
        } else {
            LambdaQueryWrapper<UfcPsWbrpt> wrapper = new LambdaQueryWrapper();
            wrapper.eq(UfcPsWbrpt::getPsWbFk, psWbFk);
            wrapper.eq(UfcPsWbrpt::getZt, WorkOderEnum.COMPLETE.getValue());
            if (!EmptyUtil.isEmpty(notCountId)) {
                wrapper.notIn(UfcPsWbrpt::getPsWbrptoid, notCountId);
            }

            wrapper.orderByDesc(UfcPsWbrpt::getSjwgrq);
            List<UfcPsWbrpt> one = ufcPsWbrptService.getBaseMapper().selectList(wrapper);
            if (EmptyUtil.isEmpty(one)) {
                return null;
            } else {
                LocalDate dateTime = ((UfcPsWbrpt)one.get(0)).getSjwgrq();
                BigDecimal hgsl = new BigDecimal(0.0D);
                BigDecimal hysl = new BigDecimal(0.0D);
                BigDecimal fgsl = new BigDecimal(0.0D);
                BigDecimal fpsl = new BigDecimal(0.0D);
                BigDecimal lfsl = new BigDecimal(0.0D);
                Iterator var11 = one.iterator();

                while(var11.hasNext()) {
                    UfcPsWbrpt psWbrpt = (UfcPsWbrpt)var11.next();
                    if (!EmptyUtil.isEmpty(psWbrpt.getHgsl())) {
                        hgsl = hgsl.add(psWbrpt.getHgsl());
                    }

                    if (!EmptyUtil.isEmpty(psWbrpt.getHysl())) {
                        hysl = hysl.add(psWbrpt.getHysl());
                    }

                    if (!EmptyUtil.isEmpty(psWbrpt.getFgsl())) {
                        fgsl = fgsl.add(psWbrpt.getFgsl());
                    }

                    if (!EmptyUtil.isEmpty(psWbrpt.getFpsl())) {
                        fpsl = fpsl.add(psWbrpt.getFpsl());
                    }

                    if (!EmptyUtil.isEmpty(psWbrpt.getLfsl())) {
                        lfsl = lfsl.add(psWbrpt.getLfsl());
                    }
                }

                PsWbRptNumberVo wbrpt = new PsWbRptNumberVo();
                wbrpt.setHgsl(hgsl);
                wbrpt.setHysl(hysl);
                wbrpt.setFgsl(fgsl);
                wbrpt.setFpsl(fpsl);
                wbrpt.setLfsl(lfsl);
                wbrpt.setSjwgrq(dateTime);
                return wbrpt;
            }
        }
    }

    /**
     * 系统参数，控制工单反馈后如果工序的反馈数量大于等于工序的加工数量时，是否自动关闭工序，为Y则关闭，否则不关闭，缺省为Y。
     *
     * @param code
     * @param user
     */
    public void verify7(String code, BigDecimal pcsl, BigDecimal hgsl, Long pswbFk, User user) {
        //TODO  调用用户查询  当前编码值  查询出值是否什么内容
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        if (!ruleValue.confirmSuccess()) {
            throw new CustomException(ruleValue.getCode(), ruleValue.getMsg());
        }
        String o = ruleValue.getData().get(0).toString();
        //Y则关闭  工序的反馈数量等于工序的加工数量
        if ("Y".equals(o)) {
            if(hgsl.compareTo(pcsl) > -1){
                PsWbCompleteDto psWbCompleteDto = new PsWbCompleteDto();
                psWbCompleteDto.setOid(pswbFk);
                psWbCompleteDto.setForce(true);
                this.complete(psWbCompleteDto,user);
            }
        }
        //不校验
        return;
    }

    public Result complete(PsWbCompleteDto dto, User uid) {
        if (EmptyUtil.isEmpty(dto) || (EmptyUtil.isEmpty(uid))) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        //增加暂停不能操作的逻辑
        Result haltedState = psWbService.haltedState(dto.getOid());
        if(!haltedState.confirmSuccess()){
            return haltedState;
        }
        /**
         * 判断当前生产的合格数量是否等于排产数量了，如果等于，则可以完工不等于不能完工
         */
        LambdaQueryWrapper<PsWb> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(PsWb::getPsWboid, dto.getOid());
        wrapper.eq(PsWb::getZt, WorkOderEnum.ISSUED.getValue());
        wrapper.isNotNull(PsWb::getSjkgrq);
        PsWb psWb = psWbMapper.selectOne(wrapper);
        if (EmptyUtil.isEmpty(psWb)) {
            return new Result().toFailure(ResultCodeEnum.PSERROR11045);
        }
        Long wogylx = psWb.getWogylxFk();
        //根据当前工单主键去查询工单汇报表信息
        PsWbRptNumberVo fk = psWbrptService.getPsWbOutByPsWbFk(dto.getOid());
        BigDecimal hgsl=BigDecimal.ZERO;
        BigDecimal bhgsl=BigDecimal.ZERO;
        BigDecimal fpsl=BigDecimal.ZERO;
        BigDecimal lfsl=BigDecimal.ZERO;
        if (!EmptyUtil.isEmpty(fk)) {
            hgsl=EmptyUtil.isEmpty(fk.getHgsl())?BigDecimal.ZERO:fk.getHgsl();
            fpsl = EmptyUtil.isEmpty(fk.getFpsl())?BigDecimal.ZERO:fk.getFpsl();
            lfsl = EmptyUtil.isEmpty(fk.getLfsl())?BigDecimal.ZERO:fk.getLfsl();
            bhgsl=fpsl.add(lfsl);
        }
        if(!dto.getForce()){
            Result psk0250 = verifyQualified("PSK0250", hgsl, psWb.getPcsl(), bhgsl);
            if(!psk0250.confirmSuccess()){
                return psk0250;
            }
        }
        UfcPsWb wb = new UfcPsWb();
        //拷贝数量等信息
        if (!EmptyUtil.isEmpty(fk)) {
            BeanUtils.copyProperties(fk, wb);
            wb.setHgsl(fk.getHgsl());
        } else {
            wb.setHgsl(new BigDecimal("0"));
        }
        //TODO 需要胡玉才处理
        verifySl("PSK014");

        verifyContro("PSK015", wb);



        //将实际开工日期置为空
        wb.setSjkgrq(null);
        //将二维码置为空
        wb.setEwm(null);
        wb.setPsWboid(dto.getOid());
        wb.setSysCreatedBy(uid.getEmployeeOid());
        wb.setSysCreated(LocalDateTime.now());
        wb.setSjwgrq(LocalDate.now());
        //修改状态为完成状态
        wb.setZt(WorkOderEnum.COMPLETE.getValue());
        wb.setPsWsFk(psWb.getPsWsFk());
        wb.setWoFk(psWb.getWoFk());
        wb.setBz(dto.getBz());
        wb.setCompletionPeopleFk(uid.getEmployeeOid());

        wb.setFpsl(fpsl);
        wb.setLfsl(lfsl);
        if(!EmptyUtil.isEmpty(dto.getCompleteOne())&&0!=dto.getCompleteOne()){
            wb.setCompletionPeopleFk(dto.getCompleteOne());
        }
        PsWb oldPsWb = psWbMapper.selectById(dto.getOid());
        if(EmptyUtil.isEmpty(oldPsWb.getHgsl())){
            wb.setHgsl(hgsl);
        }else{
            wb.setHgsl(hgsl.add(oldPsWb.getHgsl()));
        }
        boolean number = updateNumber(wb);
        if (!number) {
            return new Result().toFailure(ResultCodeEnum.PSERROR11050);
        }
        //TO-DO---判断工序是否为末道工序，当前工单上的订单工艺路线信息中工单类型
        //TO-DO 为末道工序的时候，需要将数量信息回填（订单排程ps_ws）|wo
        Boolean aBoolean = wogylxService.whetherTheFinalProcess(wogylx);
        if (aBoolean) {
            //当前工序是末道工序
            //A.修改工单排程信息数据
            Result result = this.summaryTheNumber(wb, uid);
            if (!result.confirmSuccess()) {
                throw new CustomException(result.getCode(), result.getMsg());
            }
            //B.汇总订单数据
            Result theNumber = this.summaryTheNumber(wb, uid);
            if (!theNumber.confirmSuccess()) {
                throw new CustomException(theNumber.getCode(), theNumber.getMsg());
            }
        }
        //增加执行 PSK026逻辑,PSK027逻辑
        return this.disposeComplete(wb.getWoFk(),wb.getPsWsFk(),psWb.getWogylxFk(),aBoolean);
    }

    /**
     * 系统参数 工单完工的时候，校验反馈的合格数量在一定范围类不提示，自动完成
     * @param code  参数编码
     * @param hgsl  不合格数量
     * @param bhgsl 不合格数量
     *  参数值存在的时候：判断 合格数量+不合格数量 在区间值类（排产数量+N 排产数量-5）
     */
    public Result verifyQualified(String code,BigDecimal hgsl,BigDecimal pcsl,BigDecimal bhgsl) {
        BigDecimal decimal = BigDecimal.ZERO;
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        if (ruleValue.confirmSuccess()) {
            try {
                Object o = ruleValue.getData().get(0);
                decimal = new BigDecimal(o.toString());
                if( decimal.compareTo(BigDecimal.ZERO) == -1){
                    log.info("自动生成反馈记录：参数值小于零,跳过 - 参数值:" + decimal);
                    decimal=BigDecimal.ZERO;
                }
            }catch (Exception ex){
                log.info("自动生成反馈记录：参数值非数字!");
                decimal=BigDecimal.ZERO;
            }

        }

        /**
         * 判断当前生产合格数量+不合格数量是否等于排产数量
         */
        BigDecimal add = hgsl.add(bhgsl);
        //上限值
        BigDecimal upperLimitValue = pcsl.add(decimal);
        //下限值
        BigDecimal lowerLimitingValue = pcsl.subtract(decimal);
        if(add.compareTo(upperLimitValue)==1){
            //合格数量+不合格数量 大于排产数量+系数值
            return new Result().toFailure(ResultCodeEnum.PSERROR11049);
        }
        if(add.compareTo(lowerLimitingValue)==-1){
            //合格数量+不合格数量 小于 排产数量-系数值
            return new Result().toFailure(ResultCodeEnum.PSERROR11048);
        }
        return new Result().toSuccess();
    }
    /**
     * 系统参数   控制参数，控制工号不允许为空。值域为Y/N，默认为N，参数值为Y时，控制工号不允许为空。
     *
     * @param code
     */
    public void verifyContro(String code, UfcPsWb psWb) {
        //TODO  调用用户查询  当前编码值  查询出值是否什么内容
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        if (!ruleValue.confirmSuccess()) {
            return;
        }
        String o = ruleValue.getData().get(0).toString();
        if ("Y".equals(o)) {
            //参数值为Y时，控制工号不允许为空
            if (EmptyUtil.isEmpty(psWb.getWbid())) {
                throw new CustomException(ResultCodeEnum.PSERROR11079);
            }
        }
        //不校验入库数量
        return;
    }
    public boolean updateNumber(UfcPsWb psWb) {
        if (EmptyUtil.isEmpty(psWb)) {
            return false;
        }
        if (EmptyUtil.isEmpty(psWb.getPsWboid())) {
            return false;
        }

        int update = ufcPsWbMapper.updateNumber(psWb);
        return 0 != update;
    }
    public Result summaryTheNumber(UfcPsWb psWb, User user) {
        if(EmptyUtil.isEmpty(psWb)){
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        if(EmptyUtil.isEmpty(psWb.getPsWsFk())){
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        PsWs ws = new PsWs();
        ws.setPsWsoid(psWb.getPsWsFk());
        //合格数量
        if(!EmptyUtil.isEmpty(psWb.getHgsl())){
            ws.setHgsl(psWb.getHgsl());
        }
        //回用数量
        if(!EmptyUtil.isEmpty(psWb.getHysl())){
            ws.setHysl(psWb.getHysl());
        }
        //返工数量
        if(!EmptyUtil.isEmpty(psWb.getFgsl())){
            ws.setFgsl(psWb.getFgsl());
        }
        //废品数量
        if(!EmptyUtil.isEmpty(psWb.getFpsl())){
            ws.setFpsl(psWb.getFpsl());
        }
        //废料数量
        if(!EmptyUtil.isEmpty(psWb.getLfsl())){
            ws.setLfsl(psWb.getLfsl());
        }
        //入库单数量
        if(!EmptyUtil.isEmpty(psWb.getRkdsl())){
            ws.setRkdsl(psWb.getRkdsl());
        }
        //入库数量
        if(!EmptyUtil.isEmpty(psWb.getRksl())){
            ws.setRksl(psWb.getRksl());
        }
        //修改状态为完成
        ws.setZt(WorkOderEnum.COMPLETE.getValue());
        //实际完工日期
        ws.setSjwgrq(psWb.getSjwgrq());
        ws.setSysLastUpdBy(user.getEmployeeOid());
        ws.setSysCreated(LocalDateTime.now());
        int byId = psWsService.getBaseMapper().updateById(ws);
        if(0==byId){
            return new Result().toFailure("修改排程计划完工失败");
        }
        return new Result().toSuccess();
    }

    public Result disposeComplete(Long woFk,Long wsFk,Long wogylxId,Boolean isLastGx){
        Result result = disposeCloseWogylx(woFk, wsFk, wogylxId);
        StringBuffer buffer=new StringBuffer();
        if(result.isWarr()){
            buffer.append(result.getWarrmsg());
        }
        Result closeWo = disposeCloseWo(isLastGx, woFk, wsFk);
        if(closeWo.isWarr()){
            if(0!=buffer.length()){
                buffer.append("-");
            }
            buffer.append(closeWo.getWarrmsg());
        }
        if(0!=buffer.length()){
            return new Result().toWarr(buffer.toString());
        }
        return new Result().toSuccess();
    }
    /**
     * 处理参数 PSK026的业务逻辑 和 PSK027的业务逻辑
     * @param wogylxId  订单工艺路线外键
     * @param woFk      订单外键
     * @param wsFk      排程计划外键
     * @return
     */
    public Result disposeCloseWogylx(Long woFk,Long wsFk,Long wogylxId){
        Boolean aBoolean = whetherToCheck("PSK026");
        if(aBoolean){
            //判断当前订单下的排程计划是否为关闭状态。
            LambdaQueryWrapper<PsWs> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(PsWs::getWoFk,woFk);
            wrapper.ne(PsWs::getPsWsoid,wsFk);
            wrapper.ne(PsWs::getZt, WorkOderEnum.COMPLETE.getValue());
            Integer count = psWsService.getBaseMapper().selectCount(wrapper);
            if(0!=count){
                return new Result().toWarr("参数:PSK026-执行自动关闭逻辑时，发现其他排程计划存在未关闭状态，将不会自动关闭订单工艺路线!");
            }
            //执行关闭订单工艺路线逻辑:
            Wogylx wogylx=new Wogylx();
            wogylx.setWogylxoid(wogylxId);
            wogylx.setZt(WorkOderEnum.COMPLETE.getValue());
            boolean byId = wogylxService.updateById(wogylx);
            if(!byId){
                return new Result().toWarr("参数:PSK026-执行自动关闭逻辑时，自动关闭订单工艺路线失败!请手动处理!");
            }
        }
        return new Result().toSuccess();
    }

    /**
     * 是否校验:
     * @return
     */
    private Boolean whetherToCheck(String code){
        //TODO  调用用户查询  当前编码值  查询出值是否什么内容
        Result<List<Object>> ruleValue = sysBusinessService.getdefaultValue(code);
        if(!ruleValue.confirmSuccess()){
            //需要执行校验的状态
            return true;
        }
        String o = ruleValue.getData().get(0).toString();
        if("Y".equals(o)){
            return true;
        }
        //为N的时候不需要检验
        return false;
    }


    /**
     * 处理参数 PSK026的业务逻辑 和 PSK027的业务逻辑
     * @param isLastGx  是否末工序
     * @param woFk      订单外键
     * @param wsFk      排程计划外键
     * @return
     */
    public Result disposeCloseWo(Boolean isLastGx,Long woFk,Long wsFk){
        Boolean aBoolean = whetherToCheck("PSK027");
        if(aBoolean){
            //需要执行自动关闭末工序操作：
            if(isLastGx){
                //是末道工序
                //判断当前订单下的排程计划是否为关闭状态。
                LambdaQueryWrapper<PsWs> wrapper=new LambdaQueryWrapper<>();
                wrapper.eq(PsWs::getWoFk,woFk);
                wrapper.ne(PsWs::getPsWsoid,wsFk);
                wrapper.ne(PsWs::getZt, WorkOderEnum.COMPLETE.getValue());
                Integer count = psWsService.getBaseMapper().selectCount(wrapper);
                if(0!=count){
                    return new Result().toWarr("参数:PSK027-执行自动关闭逻辑时，发现其他排程计划存在未关闭状态，将不会自动关闭订单!");
                }
                //其余排程计划为关闭状态，执行关闭订单逻辑。
                UfcWo wo = new UfcWo();
                wo.setZt(WorkOderEnum.COMPLETE.getValue());
                wo.setWooid(woFk);
                int update = ufcWoMapper.updateById(wo);
                if(update==0){
                    return new Result().toWarr("参数:PSK027-执行自动关闭逻辑时，关闭订单失败,请手动处理!");
                }
            }
        }

        return new Result().toSuccess();
    }

}
