package com.jln.system.web.action.erp.material.controller;



import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.entity.Result;
import com.jln.system.web.action.erp.material.jopo.dto.ERPMaterialQueryDTO;
import com.jln.system.web.action.erp.material.service.MaterialService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
 * @ClassName:
 * @Description:
 * @Author:wangxinxin Date:2021/10/124 11:51
 * Version:1.0
 **/
@RestController
@RequestMapping("/erp/material")
@Api(tags = "同步erp物料信息", description = "同步erp物料信息")
public class MaterialController {
    @Autowired
    private MaterialService materialService;

    @ApiOperation(value = "查询ERP物料分类信息", notes = "查询ERP物料分类信息")
    @GetMapping("/syncMaterialsClass")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncMaterialsClass() {
        return materialService.syncMaterialsClass();
    }

    @ApiOperation(value = "查询ERP物料信息", notes = "查询ERP物料信息")
    @PostMapping("/syncMaterials")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncMaterials(@RequestBody @Valid ERPMaterialQueryDTO query) {
        return materialService.syncMaterials(query);
    }

//    @ApiOperation(value = "保存ERP物料信息", notes = "保存ERP物料信息")
//    @PostMapping("/saveMaterial")
//    @JsonIgnoreProperties(ignoreUnknown = true)
//    @IgnoreUserLoginToken
//    public Result<String> saveMaterial(@RequestBody List<ERPMaterialVO> users) {
//        return materialService.saveMaterial(users);
//    }

    /**
     * 同步物料清单数量
     * @param woid  订单编码
     * @return
     */
    @ApiOperation(value = "宏明订单物料清单数量刷新接口", notes = "宏明订单物料清单数量刷新接口")
    @PostMapping("/woRefresh")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result woRefresh(@RequestBody List<String> woid) {
        return materialService.woRefresh(woid);
    }


}
