package com.jln.system.web.action.erp.material.service;


import com.jln.common.entity.Result;
import com.jln.system.web.action.erp.material.jopo.dto.ERPMaterialQueryDTO;
import com.jln.system.web.action.erp.material.jopo.vo.ERPMaterialVO;

import java.util.List;

/**
 * @ClassName: 组织机构及部门
 * @Description:
 * @Author:wangxinxin Date:2021/10/124 11:51
 * Version:1.0
 **/
public interface MaterialService {

    /**
     * 查询ERP物料信息
     *
     * @param query
     * @return
     */
    Result<List<ERPMaterialVO>> queryMaterial(ERPMaterialQueryDTO query);

    /**
     * 保存ERP物料信息
     *
     * @param materials
     * @return
     */
    //Result<String> saveMaterial(List<ERPMaterialVO> materials);

    /**
     * 同步ERP用户信息
     *
     * @param query
     * @return
     */
    Result<String> syncMaterials(ERPMaterialQueryDTO query);

    /**
     * 查询ERP物料分类信息
     * @return
     */
    Result<String> syncMaterialsClass();

    /**
     * 宏明订单物料清单数量刷新接口
     * @return
     * @param woid
     */
    Result woRefresh(List<String> woid);


}
