package com.jln.system.web.action.erp.material.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.jln.common.entity.Result;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.bm.B_Material.entity.BMaterialclass;
import com.jln.system.web.action.bm.B_Material.service.BMaterialclassService;
import com.jln.system.web.action.bm.factory.entity.BFactory;
import com.jln.system.web.action.bm.factory.service.BFactoryService;
import com.jln.system.web.action.erp.material.entity.BMaterial;
import com.jln.system.web.action.erp.material.entity.UfcErpBMaterial;
import com.jln.system.web.action.erp.material.entity.UfcErpBMaterialRelevance;
import com.jln.system.web.action.erp.material.jopo.dto.ERPMaterialQueryDTO;
import com.jln.system.web.action.erp.material.jopo.vo.ERPMaterialClassVO;
import com.jln.system.web.action.erp.material.jopo.vo.ERPMaterialVO;
import com.jln.system.web.action.erp.material.jopo.vo.WoRefreshVo;
import com.jln.system.web.action.erp.material.service.ErpBMaterialService;
import com.jln.system.web.action.erp.material.service.MaterialService;
import com.jln.system.web.action.erp.material.service.UfcErpBMaterialRelevanceService;
import com.jln.system.web.action.erp.material.service.UfcErpBMaterialService;
import com.jln.system.web.action.erp.wo.entity.WoExpand;
import com.jln.system.web.action.erp.wo.service.WoExpandService;
import com.jln.system.web.action.pp.proPrepare.entity.Wobom;
import com.jln.system.web.action.pp.proPrepare.service.WobomService;
import com.jln.system.web.action.util.ERPHttpUtils;
import com.jln.system.web.action.util.ERPParam;
import com.jln.system.web.action.util.ERPParams;
import javafx.scene.input.DataFormat;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @ClassName: 组织机构及部门
 * @Description:
 * @Author:wangxinxin Date:2021/10/124 11:51
 * Version:1.0
 **/
@Service
@EnableScheduling  //扫描定时器
public class MaterialServiceImpl implements MaterialService {

    @Value("${erp.MAINTAINER}")
    private Long MAINTAINER;

    @Value("${topPid}")
    private Long topPid;

    @Autowired
    @Qualifier("erpBMaterialServiceImpl")
    private ErpBMaterialService erpBMaterialService;


    @Autowired
    private BMaterialclassService materialclassService;

    @Autowired
    private WobomService wobomService;

    @Autowired
    private WoExpandService woExpandService;

    @Autowired
    private BFactoryService bFactoryService;

    @Autowired
    private UfcErpBMaterialRelevanceService ufcErpBMaterialRelevanceService;

    @Autowired
    private UfcErpBMaterialService ufcErpBMaterialService;

    @Override
    public Result<List<ERPMaterialVO>> queryMaterial(ERPMaterialQueryDTO query) {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FMATERIALID,FDEFAULTROUTING,FIsKitting,FNUMBER,FNAME,FSPECIFICATION,FMaterialGroup,FBaseUnitId.FNUMBER,FBaseUnitId.FName,FErpClsID,FIsBatchManage," +
                "FApproveDate,FForbidDate,FCreatorId,FModifierId,FModifyDate,FForbidStatus,FDocumentStatus,FUseOrgId,F_101_ComboJSZTBS,F_101_TextID,F_101_HMD_AssistantWDZB," +
                "F_101_PLMZXBZ,F_101_PLMYSGF,F_101_PLMCGBZ,F_101_PLMXMBH,F_101_PLMXH,F_101_BaseXMBH,F_101_BaseZXBZ,F_101_BaseYSGF,F_101_BaseCGBZ,F_101_BasePropertyCGBZBM," +
                "F_101_BasePropertyYSGFBM,F_101_BaseXMBH.Fnumber,F_101_BaseZXBZ.Fnumber,F_101_BaseYSGF.Fname,F_101_BaseCGBZ.Fname,F_101_BaseCGBZ.Fnumber,F_101_BaseYSGF.Fnumber");
        params.setFormId("BD_MATERIAL");
        params.setTopRowCount(0);
        params.setLimit(query.getLimit());
        String erpParam = null;
        if (!EmptyUtil.isEmpty(query.getStartTime())) {
            erpParam="FModifyDate > '"+query.getStartTime()+"' and "+"(FUseOrgId=100013 or FUseOrgId=100016 or FUseOrgId=100017 or FUseOrgId=100018)";
        }else{
            erpParam="FUseOrgId=100013 or FUseOrgId=100016 or FUseOrgId=100017 or FUseOrgId=100018";
        }
        params.setFilterString(erpParam);
        params.setStartRow(query.getLimit() * (query.getPage() - 1));
        return ERPHttpUtils.other(params, ERPMaterialVO.class);
    }

    private UfcErpBMaterial voCopyUfc(ERPMaterialVO erpMaterialVO){
        UfcErpBMaterial ufcErpBMaterial = new UfcErpBMaterial();
        ufcErpBMaterial.setUfcErpBMaterialOid(erpMaterialVO.getFMATERIALID());
        ufcErpBMaterial.setWlPlmZxbz(erpMaterialVO.getF_101_PLMZXBZ());
        ufcErpBMaterial.setWlPlmYsgf(erpMaterialVO.getF_101_PLMYSGF());
        ufcErpBMaterial.setWlPlmCgbz(erpMaterialVO.getF_101_PLMCGBZ());
        ufcErpBMaterial.setWlPlmXmbh(erpMaterialVO.getF_101_PLMXMBH());
        ufcErpBMaterial.setWlPlmXh(erpMaterialVO.getF_101_PLMXH());
        ufcErpBMaterial.setWlXmbh(erpMaterialVO.getF_101_BaseXMBH());
        ufcErpBMaterial.setWlHmZxbz(erpMaterialVO.getF_101_BaseZXBZ());
        ufcErpBMaterial.setWlHmZxbzFnumber(erpMaterialVO.getF_101_BaseZXBZFnumber());
        ufcErpBMaterial.setWlHmYsgf(erpMaterialVO.getF_101_BaseYSGF());
        ufcErpBMaterial.setWlHmYsgfFname(erpMaterialVO.getF_101_BaseYSGFFname());
        ufcErpBMaterial.setWlHmCgbz(erpMaterialVO.getF_101_BaseCGBZ());
        ufcErpBMaterial.setWlHmCgbzFname(erpMaterialVO.getF_101_BaseCGBZFname());
        ufcErpBMaterial.setWlCgbzbm(erpMaterialVO.getF_101_BasePropertyCGBZBM());
        ufcErpBMaterial.setWlHmCgbzFnumber(erpMaterialVO.getF_101_BaseCGBZFnumber());
        ufcErpBMaterial.setWlYsgfbm(erpMaterialVO.getF_101_BasePropertyYSGFBM());
        ufcErpBMaterial.setWlHmYsgfFnumber(erpMaterialVO.getF_101_BaseYSGFFnumber());
        return ufcErpBMaterial;
    }

    public Result<String> saveMaterial(List<ERPMaterialVO> materials,List<BFactory> bFactoryList) {
        if (EmptyUtil.isEmpty(materials)) {
            return new Result<String>().toFailure("不能传空过来！");
        }

        List<BMaterial> bMaterials = new ArrayList<>();
        List<UfcErpBMaterial> ufcErpBMaterials = new ArrayList<>();
        List<UfcErpBMaterialRelevance> bMaterialRelevances = new ArrayList<>();
        for (ERPMaterialVO material : materials) {
            BMaterial wl = new BMaterial();
            wl.setBMaterialoid(material.getFMATERIALID());
            wl.setWlid(material.getFNUMBER());
            wl.setMc(material.getFNAME());
            wl.setGg(material.getFSPECIFICATION());
            if ("C".equals(material.getFDocumentStatus()) && "A".equals(material.getFForbidStatus())) {
                wl.setTybz(false);
            } else if("B".equals(material.getFForbidStatus())){
                wl.setTybz(true);
            }
            LocalDate qyrq = material.getFApproveDate() == null ? null : LocalDate.of(material.getFApproveDate().getYear(), material.getFApproveDate().getMonth(), material.getFApproveDate().getDayOfMonth());
            LocalDate tyrq = material.getFForbidDate() == null ? null : LocalDate.of(material.getFForbidDate().getYear(), material.getFForbidDate().getMonth(), material.getFForbidDate().getDayOfMonth());
            wl.setQyrq(qyrq);
            wl.setTyrq(tyrq);
            wl.setBbh(material.getFErpClsID());
//            wl.setDjgl(material.getFIsBatchManage());
            wl.setJldw(material.getFBaseUnitIdFName() == null ? "" : material.getFBaseUnitIdFName());
            // TODO: 2021/10/27 物料分类主键直接存的ERP主键，后续处理未MES主键
            wl.setWloid(material.getFMATERIALID());
            wl.setBMaterialclassFk(material.getFMaterialGroup());
            wl.setSysLastUpd(material.getFModifyDate());
            wl.setSysLastUpdBy(MAINTAINER);
            //mes新增、工艺路线号、是否关键件
            wl.setProcessRoute(material.getFDEFAULTROUTING());
            wl.setFIsKitting(material.getFIsKitting());

            //使用该编码关联查询出工厂的主键以及名称进行存储至物料基本信息中
            List<BFactory> bFactory = bFactoryList.stream().filter(s->s.getGcid().equals(material.getFUseOrgId())).collect(Collectors.toList());
            //BFactory bFactory = bFactoryService.getOne(new LambdaQueryWrapper<BFactory>().eq(BFactory::getGcid, material.getFUseOrgId()).eq(BFactory::getDel, 0));
            if(EmptyUtil.isEmpty(bFactory)){
                return new Result<String>().toFailure("工厂主键【"+material.getFUseOrgId()+"】不存在,请先维护工厂！");
            }
            wl.setDefaultFactoryFk(bFactory.get(0).getBFactoryoid());
            wl.setDefaultFactory(bFactory.get(0).getGcmc());
            wl.setPhkz(material.getFIsBatchManage());

            bMaterials.add(wl);

            UfcErpBMaterialRelevance bMaterialRelevance = new UfcErpBMaterialRelevance();
            bMaterialRelevance.setBMaterialoid(material.getFMATERIALID());
            bMaterialRelevance.setAssistantWDZB(material.getF_101_HMD_AssistantWDZB());
            bMaterialRelevance.setJsztbs(material.getF_101_ComboJSZTBS());
            bMaterialRelevance.setTextID(material.getF_101_TextID());
            bMaterialRelevances.add(bMaterialRelevance);

            //将物料扩展数据字段添加到对象中
            UfcErpBMaterial ufcErpBMaterial = voCopyUfc(material);
            ufcErpBMaterial.setBMaterialFk(material.getFMATERIALID());

            ufcErpBMaterials.add(ufcErpBMaterial);
        }
        ufcErpBMaterialService.saveOrUpdateBatch(ufcErpBMaterials);
        erpBMaterialService.saveOrUpdateBatch(bMaterials);
        ufcErpBMaterialRelevanceService.saveOrUpdateBatch(bMaterialRelevances);
        return new Result().toSuccess();
    }

    @Override
    public Result<String> syncMaterials(ERPMaterialQueryDTO query) {
        int page = 1;
        //查询所有工厂
        LambdaQueryWrapper<BFactory> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(BFactory::getDel,false);
        List<BFactory> bFactoryList = bFactoryService.getBaseMapper().selectList(wrapper);
        while (true) {
            query.setLimit(50);
            query.setPage(page);
            Result<List<ERPMaterialVO>> material = queryMaterial(query);
            if (!material.confirmSuccess()) {
                return new Result<>().toFailure(material.getMsg());
            }
            List<ERPMaterialVO> data = material.getData();
            if (data.size() == 0) {
                break;
            }
            page++;
            Result<String> result = saveMaterial(data,bFactoryList);
            if (!result.confirmSuccess()) {
                return new Result<>().toFailure(result.getMsg());
            }
        }
        return new Result<String>().toSuccess();
    }

    @Override
    public Result<String> syncMaterialsClass() {
        List<BMaterialclass> bMaterialclassList = new ArrayList<>();
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FID,FNUMBER,FNAME,FPARENTID");
        params.setFormId("SAL_MATERIALGROUP");
        String erpParam = null;

        erpParam="FNUMBER like '101%'";

        params.setFilterString(erpParam);
        int page = 1;
        while (true) {
            params.setLimit(2000);
            params.setStartRow(params.getLimit() * (page - 1));
            Result<List<ERPMaterialClassVO>> other = ERPHttpUtils.other(params, ERPMaterialClassVO.class);
            if (!other.confirmSuccess()) {
                return new Result<>().toFailure(other.getMsg());
            }
            if (other.getData().size() == 0) {
                break;
            }else {
                for (ERPMaterialClassVO item:other.getData()) {
                    BMaterialclass bMaterialclass = new BMaterialclass();
                    bMaterialclass.setBMaterialclassoid(item.getFID());
                    bMaterialclass.setPiid(item.getFNUMBER());
                    bMaterialclass.setMc(item.getFNAME());
                    if(item.getFPARENTID() == 0){
                        bMaterialclass.setParentOid(topPid);
                    }else{
                        bMaterialclass.setParentOid(item.getFPARENTID());
                    }
                    bMaterialclass.setSysLastUpd(LocalDateTime.now());
                    bMaterialclass.setSysLastUpdBy(0L);
                    bMaterialclass.setSysCreatedBy(0L);
                    bMaterialclassList.add(bMaterialclass);
                }
            }
            page++;
        }
        boolean b = materialclassService.saveOrUpdateBatch(bMaterialclassList);
        if (!b) {
            return new Result<String>().toFailure("保存物料分类信息失败！");
        }
        return new Result().toSuccess();
    }

    @Override
    public Result woRefresh(List<String> woid) {
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FNeedQty2,FMustQty,FPickedQty,FMOBillNO,FEntity_FEntryID");
        params.setFormId("PRD_PPBOM");
        params.setTopRowCount(0);
        String param = null;
        LambdaQueryWrapper<WoExpand> woExpandLambdaQueryWrapper = new LambdaQueryWrapper<>();
        woExpandLambdaQueryWrapper.in(WoExpand::getWoid,woid);

        List<WoExpand> woExpand = woExpandService.getBaseMapper().selectList(woExpandLambdaQueryWrapper);
        if(!EmptyUtil.isEmpty(woExpand)){
            for (int i = 0 ;i < woExpand.size() ; i++) {
                if(i==0){
                    param = "(FMOBillNO='"+woExpand.get(i).getYdid()+"' and FMOEntrySeq = "+woExpand.get(i).getYdhh()+")";
                }else{
                    param =param+ " or (FMOBillNO='"+woExpand.get(i).getYdid()+"' and FMOEntrySeq = "+woExpand.get(i).getYdhh()+")";
                }
            }
        }
        params.setFilterString(param);
        Result<List<WoRefreshVo>> others = ERPHttpUtils.others(params, WoRefreshVo.class);
        if (!others.confirmSuccess()){
            return new Result().toFailure(others.getMsg());
        }
        //请求成功之后同步数据
        //分别查询出物料清单信息中的：“需求数量、应发数量（分配数量）、已领数量（已发放数量）”，
        // 并更新生产订单物料清单对应的需求数量、应发数量（分配数量）、已领数量（已发放数量）
        List<WoRefreshVo> data = others.getData();
        //新建存储物料清单集合
        List<Wobom> list = new ArrayList<>();

        for (WoRefreshVo datum : data) {
            Wobom wobom = new Wobom();
            wobom.setXqsl(datum.getFNeedQty2());
            wobom.setFpsl(datum.getFMustQty());
            wobom.setYffsl(datum.getFPickedQty());
            wobom.setWobomoid(datum.getFEntity_FEntryID());
            list.add(wobom);
        }

        //更新数量
        if (!EmptyUtil.isEmpty(list)){
            boolean b = wobomService.updateBatchById(list);
            if (b){
                return new Result().toSuccess();
            }else {
                return new Result().toFailure(ResultCodeEnum.FAILUTE);
            }
        }else {
            return new Result().toFailure(ResultCodeEnum.FAILUTE);
        }
    }

    /**
     * 定时任务
     * 每天同步物料数据
     */
    @Scheduled(cron = "0 0 0 * * ?")
    private void timerMaterial(){
        ERPMaterialQueryDTO erpMaterialQueryDTO = new ERPMaterialQueryDTO();
        LocalDateTime datetime = LocalDateTime.now().plusDays(-2);
        DateTimeFormatter f = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        String time1 = datetime.format(f);
        erpMaterialQueryDTO.setStartTime(time1);
        syncMaterials(erpMaterialQueryDTO);
    }
}
