package com.jln.system.web.action.erp.organization.controller;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.entity.Result;
import com.jln.system.web.action.erp.organization.jopo.dto.ERPOrganizationQueryDTO;
import com.jln.system.web.action.erp.organization.service.OrganizationService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

/**
 * @ClassName: 组织机构及部门
 * @Description:
 * @Author:wangxinxin Date:2021/10/124 11:51
 * Version:1.0
 **/
@RestController
@RequestMapping("/erp/org")
@Api(tags = "组织机构及部门同步接口", description = "组织机构及部门同步接口")
public class OrganizationController {
    @Autowired
    private OrganizationService organizationService;

    @ApiOperation(value = "查询ERP组织机构", notes = "查询ERP组织机构")
    @PostMapping("/syncOrganizations")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncOrganizations(@RequestBody @Valid ERPOrganizationQueryDTO query) {
        return organizationService.syncOrganizations(query);
    }

//    @ApiOperation(value = "保存ERP的组织机构", notes = "保存ERP的组织机构")
//    @PostMapping("/saveOrganizations")
//    @JsonIgnoreProperties(ignoreUnknown = true)
//    @IgnoreUserLoginToken
//    public Result<String> saveOrganizations(@RequestBody List<ERPOrganizationVO> organizations) {
//        return organizationService.saveOrganizations(organizations);
//    }

    @ApiOperation(value = "查询ERP部门信息", notes = "查询ERP部门信息")
    @PostMapping("/syncDepartments")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncDepartments(@RequestBody @Valid ERPOrganizationQueryDTO query) {
        return organizationService.syncDepartments(query);
    }

//    @ApiOperation(value = "保存ERP部门信息", notes = "保存ERP部门信息")
//    @PostMapping("/saveDepartments")
//    @JsonIgnoreProperties(ignoreUnknown = true)
//    @IgnoreUserLoginToken
//    public Result<String> saveDepartments(@RequestBody List<ERPDepartmentVO> departments) {
//        return organizationService.saveDepartments(departments);
//    }

}
