package com.jln.system.web.action.erp.organization.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.BusinessAn;
import com.jln.common.annotation.BusinessValue;
import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.system.web.action.erp.organization.jopo.dto.ERPUserQueryDTO;
import com.jln.system.web.action.erp.organization.service.UserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/erp/user")
@Api(tags = "用户同步接口")
public class UserController {

    @Autowired
    private UserService userService;

    @ApiOperation(value = "查询ERP用户信息", notes = "查询ERP用户信息")
    @PostMapping("/syncUsers")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncUsers(@RequestBody @Valid ERPUserQueryDTO query) {
        return userService.syncUsers(query);
    }

//    @ApiOperation(value = "保存ERP用户信息", notes = "保存ERP用户信息")
//    @PostMapping("/saveUsers")
//    @JsonIgnoreProperties(ignoreUnknown = true)
//    @IgnoreUserLoginToken
//    public Result<String> saveUsers(@RequestBody List<ERPUserVO> users) {
//        return userService.saveUsers(users);
//    }

    @ApiOperation(value = "产线工厂可用列表(当前登录人下部门对应的工厂)",notes="产线工厂可用列表(当前登录人下部门对应的工厂)")
    @GetMapping("/selectIsuse")
    public Result selectIsuse(@LoginUser User user) {
        return userService.selectIsuse(user);
    }
    @ApiOperation(value = "删除用户接口",notes="删除用户接口")
    @GetMapping("/delUser")
    public Result delUser(@RequestParam Long userId) {
        return userService.delUser(userId);
    }
}
