package com.jln.system.web.action.erp.organization.jopo.vo;

import com.alibaba.fastjson.annotation.JSONField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;

@Data
public class ERPOrganizationVO {
    /**
     * 禁用状态：A否，B是
     */
    @ApiModelProperty(value = "禁用状态：A否，B是", example = "A")
    private String FFORBIDSTATUS;
    /**
     * 数据状态：C 已审核
     */
    @ApiModelProperty(value = "数据状态：C 已审核", example = "C")
    private String FDocumentStatus;
    /**
     * 组织机构编码
     */
    @ApiModelProperty(value = "组织机构编码", example = "001")
    private String FNUMBER;
    /**
     * 组织机构名称
     */
    @ApiModelProperty(value = "组织机构名称", example = "成都宏明集团")
    private String FNAME;
    /**
     * 组织联系号码
     */
    @ApiModelProperty(value = "组织联系号码", example = " ")
    private String FTEL;
    /**
     * 组织机构主键
     */
    @ApiModelProperty(value = "组织机构主键", example = "1")
    private Long FOrgID;
    /**
     * 1|工厂，2|车间，3|生产线，4|工段，5|工位
     */
    @ApiModelProperty(value = "1|工厂，2|车间，3|生产线，4|工段，5|工位", example = "101")
    private String FORGFORMID;
    /**
     * erp更新时间
     */
    @ApiModelProperty(value = "erp更新时间", example = "2019-09-04T10:58:29.59")
    @JSONField(format = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime FModifyDate;

}
