package com.jln.system.web.action.erp.organization.service;


import com.jln.common.entity.Result;
import com.jln.system.web.action.erp.organization.jopo.dto.ERPOrganizationQueryDTO;
import com.jln.system.web.action.erp.organization.jopo.vo.ERPDepartmentVO;
import com.jln.system.web.action.erp.organization.jopo.vo.ERPOrganizationVO;

import java.util.List;

/**
 * @ClassName: 组织机构及部门
 * @Description:
 * @Author:wangxinxin Date:2021/10/124 11:51
 * Version:1.0
 **/
public interface OrganizationService {

    /**
     * 查询ERP的组织机构
     *
     * @param query
     * @return
     */
    Result<List<ERPOrganizationVO>> queryOrganizations(ERPOrganizationQueryDTO query);

    /**
     * 同步ERP的组织机构
     *
     * @param query
     * @return
     */
    Result<String> syncOrganizations(ERPOrganizationQueryDTO query);

    /**
     * 保存ERP的组织机构
     *
     * @param organizations
     * @return
     */
    Result<String> saveOrganizations(List<ERPOrganizationVO> organizations);

    /**
     * 查询ERP部门信息
     *
     * @param query
     * @return
     */
    Result<List<ERPDepartmentVO>> queryDepartments(ERPOrganizationQueryDTO query);

    /**
     * 保存ERP的部门信息
     *
     * @param departments
     * @return
     */
    public Result<String> saveDepartments(List<ERPDepartmentVO> departments);

    /**
     * 同步ERP的部门信息
     *
     * @param query
     * @return
     */
    Result<String> syncDepartments(ERPOrganizationQueryDTO query);
}
