package com.jln.system.web.action.erp.processroute.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.system.web.action.erp.processroute.pojo.vo.BProductProcessFlowVo;
import com.jln.system.web.action.erp.processroute.pojo.vo.BStandardprocessFlowInfoVO;
import com.jln.system.web.action.erp.processroute.service.ProcessRouteService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Api(tags = "同步erp工艺路线维护")
@RestController
@RequestMapping("/erp/processroute")
public class ProcessRouteController {

    @Autowired
    private ProcessRouteService processRouteService;

    @ApiOperation(value = "同步标准工艺路线信息接口",notes="同步标准工艺路线信息接口")
    @PostMapping("/saveBzgy")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result save(@RequestBody List<BStandardprocessFlowInfoVO> bStandardprocessFlowInfos, @LoginUser User user){
        return processRouteService.save(bStandardprocessFlowInfos,user);
    }

    @ApiOperation(value = "同步产品工艺路线信息接口",notes="同步产品工艺路线信息接口")
    @PostMapping("/saveCpgy")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result saveCpgy(@RequestBody List<BProductProcessFlowVo> bProductProcessFlowVos, @LoginUser User user){
        return processRouteService.saveCpgy(bProductProcessFlowVos,user);
    }

    @ApiOperation(value = "同步删除产品工艺路线信息接口",notes="同步删除产品工艺路线信息接口")
    @PostMapping("/delCpgy")
    @JsonIgnoreProperties(ignoreUnknown = true)
    public Result delCpgy(@RequestBody List<Long> oids, @LoginUser User user){
        return processRouteService.delCpgy(oids,user);
    }

}
