package com.jln.system.web.action.erp.processroute.pojo.vo;

import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.time.LocalDateTime;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class BStandardprocessFlowInfoVO {

    private static final long serialVersionUID = 1L;
    @ApiModelProperty(example = "标准产品工艺路线主键", required = true,dataType = "string")
    @TableId
    private Long bStandardprocessflowoid;

    @NotBlank(message = "标准产品工艺路线编码不能为空")
    @ApiModelProperty(example = "标准产品工艺路线编码：1001", required = true,dataType = "string")
    @Size(max = 20,message = "标准产品工艺路线编码最大长度为20个字节")
    private String bzgylxid;

    @NotBlank(message = "标准产品工艺路线名称不能为空")
    @ApiModelProperty(example = "标准产品工艺路线名称：测试", required = true,dataType = "string")
    @Size(max = 24,message = "标准产品工艺路线名称最大长度为24个字节")
    private String bzgymc;

    @ApiModelProperty(example = "工艺路线类别：测试", required = true,dataType = "string")
    private String gylxlb;

    @Size(max = 255,message = "工厂编码最大长度为255个字节")
    @ApiModelProperty(example = "工厂编码：不需要填", required = true,dataType = "string")
    private String gcid;
    @ApiModelProperty(example = "工厂名称：不需要填", required = true,dataType = "string")
    private String gcmc;

    @Size(max = 255,message = "备注最大长度为255个字节")
    @ApiModelProperty(example = "备注:测试", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "序号", required = true,dataType = "int")
    private Integer xh;

    @ApiModelProperty(example = "停用标志", required = true,dataType = "bool")
    private Boolean tybz;

    /**
     * 启用日期
     */
    @ApiModelProperty(example = "启用日期", required = true,dataType = "date")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd")
    private LocalDate qyrq;
    /**
     * 停用日期
     */
    @ApiModelProperty(example = "停用日期", required = true,dataType = "date")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd")
    private LocalDate tyrq;

    @Size(max = 4,message = "状态最大长度为4个字节")
    @ApiModelProperty(example = "状态", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "最后修改日期", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @ApiModelProperty(example = "最后修改人", required = true,dataType = "Long")
    private Long sysLastUpdBy;

    @JsonProperty("gcCode")
    @ApiModelProperty(example = "工厂编码", required = true,dataType = "Long")
    private String gcCode;

    @ApiModelProperty(example = "维护人", required = true,dataType = "string")
    private String userName;

    @ApiModelProperty(example = "版本号：BM001", required = true,dataType = "string")
    private String bbh;

    @ApiModelProperty(example = "是否发布", required = true,dataType = "boolean")
    private Boolean isFb;

    @ApiModelProperty(example = "是否缺省版本", required = true,dataType = "boolean")
    private Boolean isQsbb;

    @ApiModelProperty(example = "标准工艺路线目录外键", required = true,dataType = "long")
    private Long stdprocatFk;

    @ApiModelProperty(example = "物料编码", required = true,dataType = "long")
    private String bmCode;

}
