package com.jln.system.web.action.erp.processroute.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.common.utils.StringUtils;
import com.jln.system.web.action.bm.B_Material.entity.BMaterial;
import com.jln.system.web.action.bm.B_Material.service.BMaterialService;
import com.jln.system.web.action.bm.Standardprocessflow.entity.BStandardprocessflow;
import com.jln.system.web.action.bm.Standardprocessflow.entity.BStdprocat;
import com.jln.system.web.action.bm.Standardprocessflow.mapper.BStdprocatMapper;
import com.jln.system.web.action.bm.Standardprocessflow.service.BStandardprocessflowService;
import com.jln.system.web.action.bm.Standardprocessflow.service.BStdprocatService;
import com.jln.system.web.action.bm.factory.entity.BFactory;
import com.jln.system.web.action.bm.factory.mapper.BFactoryMapper;
import com.jln.system.web.action.bm.productprocess.entity.BProcessBom;
import com.jln.system.web.action.bm.productprocess.entity.BProductprocess;
import com.jln.system.web.action.bm.productprocess.entity.BProductprocessType;
import com.jln.system.web.action.bm.productprocess.entity.BProductprocessdetail;
import com.jln.system.web.action.bm.productprocess.service.BProcessBomService;
import com.jln.system.web.action.bm.productprocess.service.BProductprocessService;
import com.jln.system.web.action.bm.productprocess.service.BProductprocessTypeService;
import com.jln.system.web.action.bm.productprocess.service.BProductprocessdetailService;
import com.jln.system.web.action.bm.productprocessdetails.entity.BProcessparameters;
import com.jln.system.web.action.bm.productprocessdetails.service.BProcessparametersService;
import com.jln.system.web.action.erp.processroute.pojo.vo.*;
import com.jln.system.web.action.erp.processroute.service.ProcessRouteService;
import com.jln.system.web.action.mes.organize.entity.SysOrganize;
import com.jln.system.web.action.mes.organize.service.SysOrganizeService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class ProcessRouteServiceImpl implements ProcessRouteService {

    @Autowired
    private BStandardprocessflowService bStandardprocessflowService;

    @Autowired
    private BStdprocatMapper bStdprocatMapper;

    @Autowired
    private BStdprocatService bStdprocatService;

    @Autowired
    private BFactoryMapper bFactoryMapper;

    @Autowired
    private BMaterialService bMaterialService;

    @Autowired
    private BProductprocessdetailService bProductprocessdetailService;

    @Autowired
    private BProductprocessService bProductprocessService;

    @Autowired
    private BProcessparametersService bProcessparametersService;

    @Autowired
    private BProcessBomService bProcessBomService;

    @Autowired
    private BProductprocessTypeService bProductprocessTypeService;

    @Autowired
    private SysOrganizeService sysOrganizeService;

    @Override
    @Transactional(rollbackFor = {CustomException.class,Exception.class})
    public Result save(List<BStandardprocessFlowInfoVO> bStandardprocessFlowInfos, User user) {
        if (EmptyUtil.isEmpty(bStandardprocessFlowInfos)){
            return new Result().toFailure("请传递参数!");
        }
        //新建list存放标准工艺路线对象
        List<BStandardprocessflow> list = new ArrayList<>();
        //存放目录
        List<BStdprocat> bStdprocatList = new ArrayList<>();

        for (BStandardprocessFlowInfoVO bStandardprocessFlowInfo : bStandardprocessFlowInfos) {
            if (EmptyUtil.isEmpty(bStandardprocessFlowInfo)) {
                throw new CustomException(-1,"传入的参数不能为空！");
            }
            if (EmptyUtil.isEmpty(bStandardprocessFlowInfo.getGcCode())){
                throw new CustomException(-1,"传入的参数中，工厂主键不能为空！");
            }
            LambdaQueryWrapper<SysOrganize> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(SysOrganize::getOrganizeCode,bStandardprocessFlowInfo.getGcCode());
            SysOrganize one = sysOrganizeService.getOne(lambdaQueryWrapper);
            if(StringUtils.isNull(one)){
                throw new CustomException(ResultCodeEnum.BMERROR1047);
            }else {
                LambdaQueryWrapper<BFactory> queryWrapper =new LambdaQueryWrapper<>();
                queryWrapper.eq(BFactory::getDel,0);
                queryWrapper.le(BFactory::getQyrq, LocalDateTime.now());
                queryWrapper.and(wrapper->wrapper.gt(BFactory::getTyrq,LocalDateTime.now()).or().eq(BFactory::getTyrq,"").or().isNull(BFactory::getTyrq));
                queryWrapper.eq(BFactory::getTybz,false);
                queryWrapper.eq(BFactory::getGcid,one.getOrganizeCode());
                if(bFactoryMapper.selectCount(queryWrapper)==0) {
                    throw new CustomException(ResultCodeEnum.BMERROR1048);
                }
            }

            BStdprocat bStdprocat = new BStdprocat();
            //根据工厂编码查询工厂信息
            LambdaQueryWrapper<BFactory> bFactoryLambdaQueryWrapper = new LambdaQueryWrapper();
            bFactoryLambdaQueryWrapper.eq(BFactory::getGcid,bStandardprocessFlowInfo.getGcCode());
            BFactory bfactory = bFactoryMapper.selectOne(bFactoryLambdaQueryWrapper);


            bStdprocat.setBzgylxid(bStandardprocessFlowInfo.getBzgylxid());
            bStdprocat.setBzgylxmc(bStandardprocessFlowInfo.getBzgymc());
            bStdprocat.setGcid(bStandardprocessFlowInfo.getGcCode());
            bStdprocat.setTybz(false);
            bStdprocat.setQyrq(LocalDate.now());
            bStdprocat.setFkBFactory(bfactory.getBFactoryoid());
            bStdprocat.setSysLastUpd(LocalDateTime.now());
            bStdprocat.setSysLastUpdBy(user.getUserId());
            //判断目录外键是否存在,如果存在则不用新增
            if(!EmptyUtil.isEmpty(bStandardprocessFlowInfo.getStdprocatFk())){
                bStdprocat.setBStdprocatoid(bStandardprocessFlowInfo.getStdprocatFk());
            } else{
                bStdprocat.setBStdprocatoid(SnowflakeIdUtils.generate());
            }
            bStdprocatList.add(bStdprocat);

            BStandardprocessflow bStandardprocessflow = new BStandardprocessflow();
            BeanUtils.copyProperties(bStandardprocessFlowInfo, bStandardprocessflow);
            //维护人oid和维护时间
            bStandardprocessflow.setSysLastUpdBy(user.getEmployeeOid());
            bStandardprocessflow.setSysLastUpd(LocalDateTime.now());
            bStandardprocessflow.setStdprocatFk(bStdprocat.getBStdprocatoid());
            bStandardprocessflow.setBFactoryFk(bfactory.getBFactoryoid());
            list.add(bStandardprocessflow);
        }

        boolean b1 = bStdprocatService.saveOrUpdateBatch(bStdprocatList);
        if(b1){
            boolean b2 = bStandardprocessflowService.saveOrUpdateBatch(list);
            if(b2){
                return new Result().toSuccess();
            }
        }
        return new Result().toFailure("标准工艺路线同步失败!");
        //存放标准工艺路线目录外键
        /*final Long[] stdprocat = {null};
        bStandardprocessFlowInfos.forEach(bStandardprocessFlowInfo -> {
            if (EmptyUtil.isEmpty(bStandardprocessFlowInfo)) {
                throw new CustomException(-1,"传入的参数不能为空！");
            }
            if (EmptyUtil.isEmpty(bStandardprocessFlowInfo.getGcCode())){
                throw new CustomException(-1,"传入的参数中，工厂主键不能为空！");
            }
            LambdaQueryWrapper<SysOrganize> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(SysOrganize::getOrganizeCode,bStandardprocessFlowInfo.getGcCode());
            SysOrganize one = sysOrganizeService.getOne(lambdaQueryWrapper);
            if(StringUtils.isNull(one)){
                throw new CustomException(ResultCodeEnum.BMERROR1047);
            } else {
                LambdaQueryWrapper<BFactory> queryWrapper =new LambdaQueryWrapper<>();
                queryWrapper.eq(BFactory::getDel,0);
                queryWrapper.le(BFactory::getQyrq, LocalDateTime.now());
                queryWrapper.and(wrapper->wrapper.gt(BFactory::getTyrq,LocalDateTime.now()).or().eq(BFactory::getTyrq,"").or().isNull(BFactory::getTyrq));
                queryWrapper.eq(BFactory::getTybz,false);
                queryWrapper.eq(BFactory::getGcid,one.getOrganizeCode());
                if(bFactoryMapper.selectCount(queryWrapper)==0) {
                    throw new CustomException(ResultCodeEnum.BMERROR1048);
                }
            }
            BStandardprocessflow bStandardprocessflow = new BStandardprocessflow();
            BeanUtils.copyProperties(bStandardprocessFlowInfo, bStandardprocessflow);
            //校验版本号是否重复
            boolean qsver = checkQsver(bStandardprocessflow.getBStandardprocessflowoid(), bStandardprocessflow.getBbh(), bStandardprocessflow.getStdprocatFk());
            if (qsver) {
                throw new CustomException(ResultCodeEnum.BSERROR18006);
            }
            //新增
            if (EmptyUtil.isEmpty(bStandardprocessflow.getBStandardprocessflowoid())) {
                bStandardprocessflow.setBStandardprocessflowoid(SnowflakeIdUtils.generate());
                bStandardprocessflow.setDel(0);

                //新增判断是否开启默认版本，并判断是否存在已经启动的版本号
                if (bStandardprocessflow.getIsQsbb()) {
                    //查看是否已存在缺省版本
                    int count1 = bStandardprocessflowService.count(new LambdaQueryWrapper<BStandardprocessflow>().eq(BStandardprocessflow::getStdprocatFk,
                            bStandardprocessflow.getStdprocatFk()).eq(BStandardprocessflow::getDel, 0).eq(BStandardprocessflow::getIsQsbb, 1));
                    if (count1 > 0) {
                        throw new CustomException(ResultCodeEnum.BMERROR1132);
                    }
                }
            } else {
                //判断是否存在标准工艺路线目录，如果不存在目录则MES中将不能查看
                BStandardprocessflow byId = bStandardprocessflowService.getById(bStandardprocessflow.getBStandardprocessflowoid());
                if (!EmptyUtil.isEmpty(byId.getStdprocatFk())){
                    stdprocat[0] = byId.getStdprocatFk();
                }

                //新增判断是否开启默认版本，并判断是否存在已经启动的版本号----------编辑判断
                if (bStandardprocessflow.getIsQsbb()) {
                    //查看是否已存在缺省版本
                    int count = bStandardprocessflowService.count(new LambdaQueryWrapper<BStandardprocessflow>().eq(BStandardprocessflow::getStdprocatFk, bStandardprocessflow.getStdprocatFk()).eq(BStandardprocessflow::getDel, 0)
                            .eq(BStandardprocessflow::getIsQsbb, 1).ne(BStandardprocessflow::getBStandardprocessflowoid, bStandardprocessflow.getBStandardprocessflowoid()));
                    if (count > 0) {
                        throw new CustomException(ResultCodeEnum.BMERROR1132);
                    }
                } else {
                    //取消版本号为启动版本号的时候，通过修改工艺路线目录的版本号字段设置为空
                    LambdaUpdateWrapper<BStdprocat> wrapper = new LambdaUpdateWrapper<>();
                    wrapper.set(BStdprocat::getQsver, null);
                    wrapper.eq(BStdprocat::getBStdprocatoid, bStandardprocessFlowInfo.getStdprocatFk());
                    //不用判断一定成功
                    this.bStdprocatMapper.update(null, wrapper);
                }
            }
            //维护人oid和维护时间
            bStandardprocessflow.setSysLastUpdBy(user.getEmployeeOid());
            bStandardprocessflow.setSysLastUpd(LocalDateTime.now());

            list.add(bStandardprocessflow);
        });
        //判断是否存在标准工艺路线目录
        if (!EmptyUtil.isEmpty(stdprocat[0])){
            list.forEach(bStandardprocessflow -> bStandardprocessflow.setStdprocatFk(stdprocat[0]));
        }else {
            BStdprocat bStdprocat = new BStdprocat();
            bStdprocat.setBzgylxid(SnowflakeIdUtils.generate().toString());
            Result result = bStdprocatService.addStdprocat(bStdprocat, user);
            list.forEach(bStandardprocessflow -> bStandardprocessflow.setStdprocatFk((Long)result.getData()));
        }
        boolean b = bStandardprocessflowService.saveOrUpdateBatch(list);
        if (!b) {
            throw new CustomException(ResultCodeEnum.VMERROR14003);
        }
        List<Long> collect = list.stream().map(BStandardprocessflow::getBStandardprocessflowoid).collect(Collectors.toList());
        return new Result<>().toSuccess(collect);*/
    }

    @Override
    @Transactional(rollbackFor = {CustomException.class,Exception.class})
    public Result saveCpgy(List<BProductProcessFlowVo> bProductProcessFlowVos, User user) {
        //实体类入参判空
        if (EmptyUtil.isEmpty(bProductProcessFlowVos)) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }

        //新建产品工艺路线对象容器
        List<BProductprocess> bProductprocesses = new ArrayList<>(bProductProcessFlowVos.size());
        //存放产品工艺路线明细对象
        List<BProductprocessdetail> bProductprocessdetails = new ArrayList<>(bProductProcessFlowVos.size());
        //存放工艺参数对象
        List<BProcessparameters> bProcessparametersList = new ArrayList<>(bProductProcessFlowVos.size());
        //存放工序物料清单对象
        List<BProcessBom> bProcessBoms = new ArrayList<>(bProductProcessFlowVos.size());
        //存放工艺路线类别对象
        List<BProductprocessType> bProductprocessTypes = new ArrayList<>();
        bProductProcessFlowVos.forEach(bProductProcessFlowVo -> {
            if (EmptyUtil.isEmpty(bProductProcessFlowVo)) {
                throw new CustomException(-1,"传入的参数不能为空！");
            }
            if (EmptyUtil.isEmpty(bProductProcessFlowVo.getGCCode())){
                throw new CustomException(-1,"传入的参数中，工厂编码不能为空！");
            }
            if (EmptyUtil.isEmpty(bProductProcessFlowVo.getCPCode())){
                throw new CustomException(-1,"传入的参数中，物料编码不能为空！");
            }
            LambdaQueryWrapper<SysOrganize> lambdaQueryWrapper = new LambdaQueryWrapper<>();
            lambdaQueryWrapper.eq(SysOrganize::getOrganizeCode,bProductProcessFlowVo.getGCCode());
            SysOrganize sysOrganize = sysOrganizeService.getOne(lambdaQueryWrapper);
            if(StringUtils.isNull(sysOrganize)){
                throw new CustomException(ResultCodeEnum.BMERROR1047);
            } else {
                LambdaQueryWrapper<SysOrganize> queryWrapper =new LambdaQueryWrapper<>();
                queryWrapper.eq(SysOrganize::getDel,0);
                queryWrapper.eq(SysOrganize::getOrganizeCode,bProductProcessFlowVo.getGCCode());
                if(sysOrganizeService.count(queryWrapper)==0) {
                    throw new CustomException(ResultCodeEnum.BMERROR1048);
                }
            }
            BProductprocessType bProductprocessType = new BProductprocessType();
            BProductprocessType one5 = bProductprocessTypeService.getOne(new LambdaQueryWrapper<BProductprocessType>().eq(BProductprocessType::getId, bProductProcessFlowVo.getCPGYClassCode()));
            if (!EmptyUtil.isEmpty(one5)){
                bProductprocessType.setBProductprocessTypeOid(one5.getBProductprocessTypeOid());
            }else {
                bProductprocessType.setBProductprocessTypeOid(SnowflakeIdUtils.generate());
            }
            bProductprocessType.setId(bProductProcessFlowVo.getCPGYClassCode());
            bProductprocessType.setMc(bProductProcessFlowVo.getCPGYClassName());
            bProductprocessType.setSysLastUpd(LocalDateTime.now());
            bProductprocessType.setSysLastUpdBy(user.getEmployeeOid());
            bProductprocessTypes.add(bProductprocessType);

            BProductprocess bProductprocess = new BProductprocess();
            bProductprocess.setBFactoryFk(sysOrganize.getSysOrganizeId());
            bProductprocess.setBProcatFk(bProductprocessType.getBProductprocessTypeOid());
            BMaterial bMaterial = bMaterialService.getOne(new LambdaQueryWrapper<BMaterial>().eq(BMaterial::getWlid, bProductProcessFlowVo.getCPCode()));
            bProductprocess.setBMaterialFk(bMaterial.getBMaterialoid());
            if (!EmptyUtil.isEmpty(bProductProcessFlowVo.getCPGYCode())){
                bProductprocess.setCpgyid(bProductProcessFlowVo.getCPGYCode());
            }
            if (!EmptyUtil.isEmpty(bProductProcessFlowVo.getCPGYName())){
                bProductprocess.setCpgymc(bProductProcessFlowVo.getCPGYName());
            }

            bProductprocess.setVersionNumber(bProductProcessFlowVo.getVersion());
            //根据编码查询记录，如果存在则编辑，否则为新增。
            BProductprocess one = bProductprocessService.getOne(new LambdaQueryWrapper<BProductprocess>().eq(BProductprocess::getCpgyid, bProductProcessFlowVo.getCPGYCode()));
            if (!EmptyUtil.isEmpty(one)){
                bProductprocess.setBProductprocessoid(one.getBProductprocessoid());
            }else {
                bProductprocess.setBProductprocessoid(SnowflakeIdUtils.generate());
            }
            bProductprocess.setDel(0);
            //维护人oid和维护时间
            bProductprocess.setSysLastUpdBy(user.getEmployeeOid());
            bProductprocess.setSysLastUpd(bProductProcessFlowVo.getSys_upd());
            //判断停用标志  停用之后清空启用日期  不停用就清空停用日期
            bProductprocess.setTybz(false);
            bProductprocesses.add(bProductprocess);
            //工序内容
            JSONArray gx = bProductProcessFlowVo.getGx();
            List<GxVo> gxVos = JSONArray.parseArray(gx.toString(), GxVo.class);
            gxVos.forEach(gxVo -> {
                BProductprocessdetail bProductprocessdetail = new BProductprocessdetail();
                bProductprocessdetail.setCpgyid(bProductprocess.getCpgyid());
                BProductprocessdetail one1 = bProductprocessdetailService.getOne(new LambdaQueryWrapper<BProductprocessdetail>().eq(BProductprocessdetail::getGxid, gxVo.getGXID()));
                if (!EmptyUtil.isEmpty(one1)){
                    bProductprocessdetail.setBProductprocessdetailoid(one1.getBProductprocessdetailoid());
                }else {
                    bProductprocessdetail.setBProductprocessdetailoid(SnowflakeIdUtils.generate());
                }
                bProductprocessdetail.setDel(0);
                bProductprocessdetail.setGxid(gxVo.getGXID());
                bProductprocessdetail.setGxmc(gxVo.getGXName());
                bProductprocessdetail.setGxlx(gxVo.getGXLX());
                bProductprocessdetail.setXh(Integer.valueOf(gxVo.getXH()));
                bProductprocessdetail.setSlgx(gxVo.getSLGX() ? 1:0);
                bProductprocessdetail.setXlgx(gxVo.getXLGX() ? 1:0);
                bProductprocessdetail.setJgbgx(gxVo.getBGGX());
                bProductprocessdetail.setFirstInspectionProcess(gxVo.getSJGX());
                bProductprocessdetail.setCsgx(gxVo.getCSGX() ? 1:0);
                bProductprocessdetail.setGjgx(gxVo.getGJGX() ? 1:0);
                bProductprocessdetail.setSpecialProcess(gxVo.getTSGX());
                bProductprocessdetail.setBProductprocessFk(bProductprocess.getBProductprocessoid());
                bProductprocessdetail.setSysLastUpd(LocalDateTime.now());
                bProductprocessdetail.setSysLastUpdBy(user.getEmployeeOid());
                bProductprocessdetails.add(bProductprocessdetail);
                //工艺参数内容
                JSON processParameters = gxVo.getProcessParameters();
                ProcessParametersVo processParametersVo = JSON.parseObject(String.valueOf(processParameters), ProcessParametersVo.class);
                BProcessparameters bProcessparameters = new BProcessparameters();
                BProcessparameters one2 = bProcessparametersService.getOne(new LambdaQueryWrapper<BProcessparameters>().eq(BProcessparameters::getPmid, processParametersVo.getCSCode()));
                if (!EmptyUtil.isEmpty(one2)){
                    bProcessparameters.setBProcessparametersoid(one2.getBProcessparametersoid());
                }else {
                    bProcessparameters.setBProcessparametersoid(SnowflakeIdUtils.generate());
                }
                bProcessparameters.setPmid(processParametersVo.getCSCode());
                bProcessparameters.setPmms(processParametersVo.getCSMS());
                bProcessparameters.setGcid(bProductProcessFlowVo.getGCCode());
                bProcessparameters.setJldw(processParametersVo.getCComunit());
                bProcessparameters.setType(processParametersVo.getTYPE());
                bProcessparameters.setKzfs(processParametersVo.getKZFS());
                bProcessparameters.setSzbzz(BigDecimal.valueOf(Long.parseLong(processParametersVo.getBZZ())));
                bProcessparameters.setSxz(BigDecimal.valueOf(Long.parseLong(processParametersVo.getSXZ())));
                bProcessparameters.setXxz(BigDecimal.valueOf(Long.parseLong(processParametersVo.getXXZ())));
                bProcessparameters.setBz(processParametersVo.getBZ());
                bProcessparameters.setBproductprocessdetailfk(bProductprocessdetail.getBProductprocessdetailoid());
                bProcessparameters.setFactoryfk(sysOrganize.getSysOrganizeId());
                bProcessparameters.setGxid(gxVo.getGXID());
                bProcessparametersList.add(bProcessparameters);
                //工序物料清单内容
                JSONArray gxwlList = gxVo.getGXWLList();
                List<GXWLVo> gxwlVos = JSONArray.parseArray(gxwlList.toString(), GXWLVo.class);
                gxwlVos.forEach(gxwlVo -> {
                    BProcessBom bProcessBom = new BProcessBom();
                    BProcessBom one3 = bProcessBomService.getOne(new LambdaQueryWrapper<BProcessBom>().eq(BProcessBom::getMaterialFk, bMaterial.getBMaterialoid())
                            .eq(BProcessBom::getBProductProcessDetailFk, bProductprocessdetail.getBProductprocessdetailoid()));
                    if (!EmptyUtil.isEmpty(one3)){
                        bProcessBom.setBProcessBomOid(one3.getBProcessBomOid());
                    }else {
                        bProcessBom.setBProcessBomOid(SnowflakeIdUtils.generate());
                    }
                    bProcessBom.setWlid(gxwlVo.getCInvCode());
                    BMaterial one4 = bMaterialService.getOne(new LambdaQueryWrapper<BMaterial>().eq(BMaterial::getWlid, gxwlVo.getCInvCode()));
                    bProcessBom.setMaterialFk(one4.getBMaterialoid());
                    bProcessBom.setBProductProcessFk(bProductprocess.getBProductprocessoid());
                    bProcessBom.setBProductProcessDetailFk(bProductprocessdetail.getBProductprocessdetailoid());
                    bProcessBom.setSysLastUpd(LocalDateTime.now());
                    bProcessBom.setSysLastUpdBy(user.getEmployeeOid());
                    bProcessBoms.add(bProcessBom);
                });
            });
        });
        boolean b = bProductprocessService.saveOrUpdateBatch(bProductprocesses);
        if (b){
            boolean b1 = bProductprocessdetailService.saveOrUpdateBatch(bProductprocessdetails);
            if (b1){
                bProcessparametersService.saveOrUpdateBatch(bProcessparametersList);
                bProcessBomService.saveOrUpdateBatch(bProcessBoms);
                List<Long> collect = bProductprocesses.stream().map(BProductprocess::getBProductprocessoid).collect(Collectors.toList());
                return new Result().toSuccess(collect);
            }else {
                return new Result().toFailure(ResultCodeEnum.FAILUTE);
            }
        }else {
            return new Result().toFailure(ResultCodeEnum.FAILUTE);
        }

    }

    @Override
    @Transactional(rollbackFor = {CustomException.class,Exception.class})
    public Result delCpgy(List<Long> oids, User user) {
        //1.首先删除工序下的工序物料清单与工艺参数
        oids.forEach(aLong -> {
            //根据产品工艺路线主键查询工序
            List<BProductprocessdetail> list = bProductprocessdetailService.list(new LambdaQueryWrapper<BProductprocessdetail>().in(BProductprocessdetail::getBProductprocessFk, oids));
            List<Long> collect = list.stream().map(BProductprocessdetail::getBProductprocessdetailoid).collect(Collectors.toList());
            //2.删除工序下的工序物料清单与工艺参数
            boolean remove = bProcessparametersService.remove(new LambdaQueryWrapper<BProcessparameters>().in(BProcessparameters::getBproductprocessdetailfk, collect));
            boolean remove1 = bProcessBomService.remove(new LambdaQueryWrapper<BProcessBom>().in(BProcessBom::getBProductProcessDetailFk, collect));
            if (remove && remove1){
                //3.删除工序
                bProductprocessdetailService.removeByIds(collect);
            }
        });
        //4.删除产品工序路线
        boolean b = bProductprocessService.removeByIds(oids);
        if (b){
            return new Result().toSuccess();
        }else {
            return new Result().toFailure(ResultCodeEnum.FAILUTE);
        }
    }




    /**
     * 校验版本号是否重复
     *
     * @param oid
     * @param qsver
     * @return
     */
    private boolean checkQsver(Long oid, String qsver, Long fk) {
        if (EmptyUtil.isEmpty(qsver)) {
            return false;
        }
        LambdaQueryWrapper<BStandardprocessflow> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.ne(!EmptyUtil.isEmpty(oid), BStandardprocessflow::getBStandardprocessflowoid, oid);
        queryWrapper.eq(BStandardprocessflow::getDel, 0);
        queryWrapper.eq(BStandardprocessflow::getStdprocatFk, fk);
        queryWrapper.eq(BStandardprocessflow::getBbh, qsver);
        int count = bStandardprocessflowService.count(queryWrapper);
        return count > 0;
    }

}
