package com.jln.system.web.action.erp.supplier.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.entity.Result;
import com.jln.system.web.action.erp.supplier.service.SupplierService;
import com.jln.system.web.action.util.ERPQueryDTO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;


@Api(tags = "同步erp供应商信息")
@RestController
@RequestMapping("/erp/supplier")
public class SupplierController {
    @Autowired
    private SupplierService supplierService;

    @ApiOperation(value = "查询ERP供应商分类信息", notes = "查询ERP供应商分类信息")
    @GetMapping("/syncSupplierClass")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncSupplierClass() {
        return supplierService.syncSupplierClass();
    }

    @ApiOperation(value = "查询ERP供应商信息", notes = "查询ERP供应商信息")
    @PostMapping("/syncSupplier")
    @JsonIgnoreProperties(ignoreUnknown = true)
    @IgnoreUserLoginToken
    public Result<String> syncSupplier(@RequestBody @Valid ERPQueryDTO query) {
        return supplierService.syncSupplier(query);
    }
}
