package com.jln.system.web.action.erp.ufcpswb.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.common.annotation.ApplyForPermission;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.system.web.action.erp.ufcpswb.entity.dto.*;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcGwjVo;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcWobomVo;
import com.jln.system.web.action.erp.ufcpswb.service.UfcPsWbService;
import com.jln.system.web.action.erp.ufcpswb.service.UfcWobomService;
import com.jln.system.web.action.ps.gwj.pojo.dto.CjheckQcSampleStdDto;
import com.jln.system.web.action.ps.gwj.pojo.dto.ImportPersonnelSaveDto;
import com.jln.system.web.action.ps.gwj.pojo.dto.SubmitFirstInspectionDTO;
import com.jln.system.web.action.ps.gwj.pojo.vo.TestSamplesVO;
import com.jln.system.web.action.ps.production.pojo.vo.PsWbQuery;
import com.jln.system.web.action.ps.production.viewenity.PsWbEntity;
import com.jln.system.web.action.ps.production.viewenity.PsWbList;
import com.jln.system.web.action.ps.zytl.pojo.vo.ConstructionCompleteDetailsVo;
import com.jln.ufc.web.action.ufc.ps.pojo.dto.UfcSubmitFirstInspectionDTO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author 
 * @since 2020-02-10
 */
@RestController
@RequestMapping("/ufc/erp/psWb")
@Api(value = "生产工单模块",tags = "生产工单模块")
public class UfcPsWbController {

    @Autowired
    private UfcPsWbService ufcPsWbService;

    @Autowired
    @Qualifier("UfcErpWobomServiceImpl")
    private UfcWobomService ufcWobomService;

    /**
     * 查询当前工单 专检(sfjygx)、委外(zbgx)、首检(first_inspection_process)
     * @return
     */
    @ApiOperation(value = "生成工票数据", notes = "生成工票数据")
    @PostMapping("/gxkgNext")
    public Result gxkgNext(@RequestBody ImportPersonnelSaveDto importPersonnelSaveDto,@LoginUser User user){
        return ufcPsWbService.gxkgNext(importPersonnelSaveDto, user);
    }

    /**
     * 根据工单主键查询 专检(sfjygx)、委外(zbgx)、首检(first_inspection_process)
     * @return
     */
    @ApiOperation(value = "根据工单主键查询 专检(sfjygx)、委外(zbgx)、首检(first_inspection_process)", notes = "根据工单主键查询 专检(sfjygx)、委外(zbgx)、首检(first_inspection_process)")
    @PostMapping("/getPsWbInfo")
    public Result getPsWbIn(@RequestParam Long psWboid){
        return ufcPsWbService.getPsWbInfo(psWboid);
    }

    /**
     * 提交首检
     * @return
     */
    @ApiOperation(value = "提交首检",notes="提交首检")
    @PostMapping("/submitFirstInspection")
    public Result submitFirstInspection(@RequestBody UfcSubmitFirstInspectionDTO dto, @LoginUser User user){
        return ufcPsWbService.submitFirstInspection(dto,user);
    }


    @ApiOperation(notes = "首检完成按钮", value = "首检完成按钮")
    @PostMapping("/cjheckQcSampleStduUpd")
    public  Result<Page<TestSamplesVO>> getQcSampleByCardPage(@RequestBody CjheckQcSampleStdDto cjheckQcSampleStdDto, @LoginUser User user){
        return ufcPsWbService.cjheckQcSampleStd(cjheckQcSampleStdDto,user);
    }


    /**
     * 查询提交首检次数
     * @return
     */
    @ApiOperation(value = "查询提交首检次数",notes="查询提交首检次数")
    @GetMapping("/getSubmitNumber")
    public Result getSubmitNumber(@RequestParam Long wtOid){
        return ufcPsWbService.getSubmitNumber(wtOid);
    }

    /**
     * 查询工票主键
     * @return
     */
    @ApiOperation(value = "查询工票主键",notes="查询工票主键")
    @PostMapping("/getPsWtOid")
    public Result getPsWtOid(@RequestParam Long pswboid){
        return ufcPsWbService.getPsWtOid(pswboid);
    }
    /**
     * 查询上一道工单转出数量
     * @return
     */
    @ApiOperation(value = "查询上一道工单转出数量",notes="查询上一道工单转出数量")
    @GetMapping("/getThePreviousPsWbNumber")
    public Result getThePreviousPsWbNumber(@RequestParam Long pswboid){
        return ufcPsWbService.getThePreviousPsWbNumber(pswboid);
    }

    @ApiOperation(value = "查询报工列表", notes = "查询报工列表")
    @PostMapping("/getHistory")
    public Result<Page<UfcPsWbrptHistoryVO>> getHistory(@RequestBody PageParameter<Map<String, Object>> parameter){
        return ufcPsWbService.getHistory(parameter);
    }

    @ApiOperation(value = "查询订单是否完工", notes = "查询订单是否完工")
    @PostMapping("/getWoWgzt")
    public Result getWoWgzt(@RequestBody List<String> wooid) {
        return ufcPsWbService.getWoWgzt(wooid);
    }

    @ApiOperation(value = "获取下一道工单接口", notes = "获取下一道工单接口")
    @GetMapping("/getNextPswb")
    public Result getNextPswb(@RequestParam Long pswboid) {
        return ufcPsWbService.getNextPswb(pswboid);
    }

    @ApiOperation(value = "生产订单下达接口——检查物料清单(计划跟踪--查询物料清单/生产准备--物料清单)", notes = "生产订单下达接口——检查物料清单(计划跟踪--查询物料清单/生产准备--物料清单)")
    @PostMapping("/getWobomList")
    public Result<UfcWobomVo> getWobomList(@RequestBody PageParameter<UfcWoSelectDto> pageParameter) {
        return ufcWobomService.getWobomList(new Page<>(pageParameter.getPageNum(),pageParameter.getPageSize()),pageParameter.getData());
    }

    /**
     * 生成工单接口——生成工单-----------辽晶
     * @param ufcPswbEntity
     * @return
     */
    @ApiOperation(value = "生成工单接口——生成工单-----------辽晶", notes = "生成工单接口——生成工单-----------辽晶")
    @PostMapping("/addpswbLj")
    public Result addpswbLj(@RequestBody UfcPswbEntity ufcPswbEntity, @LoginUser User user) {
        return ufcWobomService.addpswbLj(ufcPswbEntity, user);
    }

    /**
     * 首检撤销
     */
    @ApiOperation(value = "撤销首检", notes = "撤销首检")
    @PostMapping("/revokeSj")
    public Result revokeSj(@RequestBody UfcCjheckQcSampleStdDto ufcCjheckQcSampleStdDto,@LoginUser User user) {
        return ufcWobomService.revokeSj(ufcCjheckQcSampleStdDto, user);
    }

    /**
     * 生产工单——生产工单列表（不需要查询条件）
     *
     * @param page
     * @return
     */
    @ApplyForPermission
    @ApiOperation(value = "生产工单接口——生产工单列表 ", notes = "生产工单接口——生产工单列表 ")
    @PostMapping("/getpswblist")
    public Result<Page<UfcPsWbList>> getpswblist(@RequestBody PageParameter<PsWbQuery> page) {
        return ufcPsWbService.getpswblist(page);
    }

    @ApiOperation(value = "工位机-工单完工查询详情接口-查询工单信息",notes = "工位机-工单完工查询详情接口-查询工单信息")
    @PostMapping("getConstructionCompleteDetailsVo")
    public Result<ConstructionCompleteDetailsVo> getConstructionCompleteDetailsVo(@RequestParam("psWbFk") Long psWbFk){
        return ufcPsWbService.getConstructionCompleteDetailsVo(psWbFk);
    }


    /**
     * 查询当前工序的前一工序属性是否专检
     */
    @ApiOperation(value = "查询是否专检", notes = "查询是否专检")
    @GetMapping("/getSfjygx")
    public Result revokeSj(@RequestParam String wbOid) {
        return ufcWobomService.getSfjygx(wbOid);
    }

    /**
     * 查询当前工序的前一工序的流程批号
     */
    @ApiOperation(value = "查询流程批号", notes = "查询流程批号")
    @GetMapping("/getCcsn")
    public Result getCcsn(@RequestParam String wbOid) {
        return ufcWobomService.getCcsn(wbOid);
    }

    @ApiOperation(value = "查询上一道工序检验标准", notes = "查询上一道工序检验标准")
    @PostMapping("/getJybzmc")
    public Result getJybzmc(@RequestBody UfcGwjVo ufcGwjVo) {
        return ufcWobomService.getJybzmc(ufcGwjVo);
    }

    @ApiOperation(value = "工序信息--查询上一道工序报工记录", notes = "工序信息--查询上一道工序报工记录")
    @PostMapping("/getNextGxBg")
    public Result getNextGxBg(@RequestBody PageParameter<Long> parameter) {
        return ufcPsWbService.getNextGxBg(parameter);
    }


}
