package com.jln.system.web.action.erp.ufcpswb.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import com.jln.system.web.action.pp.proPrepare.entity.Wobom;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * <p>
 * 生产订单物料清单
 * </p>
 *
 * @author
 * @since 2020-02-20
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("wobom")
public class UfcWobom extends Model<Wobom> {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(example = "生产订单物料清单主键", required = true,dataType = "string")
    private Long wobomoid;

    @ApiModelProperty(example = "生产订单号:2020020001", required = true,dataType = "string")
    private String woid;

    @ApiModelProperty(example = "序号:0、1、2、3", required = true,dataType = "int")
    private Integer bomxh;

    @ApiModelProperty(example = "发料日期:2020-02-22", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate flrq;

    @ApiModelProperty(example = "需求数量:1000", required = true)
    private BigDecimal xqsl;

    @ApiModelProperty(example = "分配数量:1000", required = true)
    private BigDecimal fpsl;

    @ApiModelProperty(example = "领料单数量:1000", required = true)
    private BigDecimal lldsl;

    @ApiModelProperty(example = "已发放数量:1000", required = true)
    private BigDecimal yffsl;

    @ApiModelProperty(example = "超定额领料单数量:1000", required = true)
    private BigDecimal cdelldsl;

    @ApiModelProperty(example = "超定额已发放数量:1000", required = true)
    private BigDecimal cdeyffsl;

    @ApiModelProperty(example = "发放原则:Y|领料发放；N|定额倒扣", required = true,dataType = "string")
    private String ffyz;

    @ApiModelProperty(example = "副产品:0、1", required = true,dataType = "int")
    private Integer fcp;

    @ApiModelProperty(example = "损耗率:10", required = true)
    private BigDecimal shlz;

    @ApiModelProperty(example = "物料批号:0001", required = true,dataType = "string")
    private String wlph;

    @ApiModelProperty(example = "损耗值:100", required = true)
    private BigDecimal shz;

    @ApiModelProperty(example = "主关键物料:0、1", required = true,dataType = "int")
    private Integer zgjwl;

    @ApiModelProperty(example = "原产品:0、1", required = true,dataType = "int")
    private Integer ycp;

    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态:I|初始、R|下达、S|暂停、C|完成", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "创建人oid:后台生成", required = true,dataType = "string")
    private Long sysCreatedBy;

    @ApiModelProperty(example = "最后修改人oid:后台生成", required = true,dataType = "string")
    private Long sysLastUpdBy;

    @ApiModelProperty(example = "创建时间:后台生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "最后修改时间:后台生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @TableLogic
    @ApiModelProperty(example = "删除标记:后台生成", required = true,dataType = "int")
    private Integer del;

    @ApiModelProperty(example = "生产订单外键", required = true,dataType = "string")
    private Long woFk;

    @ApiModelProperty(example = "物料外键", required = true,dataType = "string")
    private Long bMaterialFk;

    @ApiModelProperty(example = "产品工艺路线明细外键", required = true,dataType = "string")
    private Long bProductprocessdetailFk;

    @ApiModelProperty(example = "工序外键", dataType = "string")
    private Long bStandardprocessFk;


    @ApiModelProperty(value = "发放工序号")
    private String gxid;


    @Override
    protected Serializable pkVal() {
        return this.wobomoid;
    }

}
