package com.jln.system.web.action.erp.ufcpswb.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jln.common.entity.PswlsxInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@ApiModel("工单排程（生产工单）")
public class UfcPsWbList extends PswlsxInfo {

    @ApiModelProperty(example = "生产工单主键", required = true,dataType = "Long")
    private Long psWboid;

    @ApiModelProperty(value = "工厂编号")
    private String gcid;

    @ApiModelProperty(value = "工厂名称")
    private String gcmc;

    @ApiModelProperty(value = "车间部门编号")
    private String cjid;

    @ApiModelProperty(value = "车间部门名称")
    private String cjmc;

    @ApiModelProperty(value = "生产线编号")
    private String scxid;

    @ApiModelProperty(value = "生产线名称")
    private String scxmc;

    //工段编码
    @ApiModelProperty(value = "工段编码")
    private  String  gdid;
    //工段名称
    @ApiModelProperty(value = "工段名称"  )
    private  String  gdmc;
    //工位编码
    @ApiModelProperty(value = "工位编码" )
    private  String  gwid;

    //工位名称
    @ApiModelProperty(value = "工位名称" )
    private  String  gwmc;

    @ApiModelProperty(value = "状态：i|初始、f|确认、r|下达、s|暂停、c|完成")
    private String zt;

    @ApiModelProperty(value = "排程程度：cx|排程至产线gd|排程至工段 gw|排程至工位")
    private String pccd;
    
    @ApiModelProperty(value = "工单编号：按照工单编号的规则生成")
    private String wbid;

    @ApiModelProperty(value = "工票号:按照工票编号的规则生成")
    private String gpid;
    
    @ApiModelProperty(value = "工序号 ")
    private String gxid;
    
    @ApiModelProperty(value = "工序名称 ")
    private String gxmc;
    
    @ApiModelProperty(value = "排产数量")
    private BigDecimal pcsl;
    
    @ApiModelProperty(value = "需求数量 ")
    private BigDecimal hgsl;
    
    @ApiModelProperty(value = "生产订单号")
    private String woid;

    @ApiModelProperty(value = "生产订单号")
    private Long woFk;

    @ApiModelProperty(value = "订单序号")
    private Integer woxh;
    
    @ApiModelProperty(value = "排程计划号")
    private String jhid;

    @ApiModelProperty(value = "物料编码")
    private String wlid;
    @ApiModelProperty(value = "物料属性用-物料主键")
    private Long bMaterialoid;


    @ApiModelProperty(value = "计划序号")
    private String jhxh;
    @ApiModelProperty(value = "物料名称")
    private String mc;

    @ApiModelProperty(value = "规格型号")
    private String gg;

    @ApiModelProperty(value = "计量单位")
    private String jldw;


    @ApiModelProperty(value = "图号")
    private String tz;


    @ApiModelProperty(value = "材料")
    private String cl;
    
    @ApiModelProperty(value = "Id")
    private String id;
    
    @ApiModelProperty(value = "制令号")
    private String bcid;
    
    @ApiModelProperty(value = "制令号")
    private String bzid;

    @ApiModelProperty(value = "生产设备list:如有多个，用逗号隔开（设备表主键）")
    private String sblist;


    @ApiModelProperty(value = "人员list:如有多个，用逗号隔开(员工表主键)")
    private String rylist;
    
    @ApiModelProperty(value = "制令号")
    private String zlh;


    @ApiModelProperty(value = "计划开工日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jhkgrq;


    @ApiModelProperty(value = "计划完工日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jhwgrq;

    
    @ApiModelProperty(value = "备注")
    private String bz;

    private LocalDate whsj;
    private String whr;
    private String gwjid;
    private String jhrq;
    private String bzgxid;
    private Long bomid;
    private Long bBomFk;
    private String bomxh;
    private String cpgyid;
    private Long bFactoryFk;

    @ApiModelProperty(value = "工作中心")
    private String gzzx;

    @ApiModelProperty(value = "需求数量")
    private BigDecimal xqsl;

    @ApiModelProperty(value = "作业流程卡号")
    private String processId;
    @ApiModelProperty(value = "工艺路线名称")
    private String bzgxmc;
   /* @ApiModelProperty(value = "流转方式")
    private String lzfs;*/
    @ApiModelProperty(value = "标准产量")
    private String bzcl;
    @ApiModelProperty(value = "标准工时")
    private String bzgs;
    @ApiModelProperty(value = "标准人数")
    private String bzrs;
    @ApiModelProperty(value = "作业方式")
    private String zyfs;
    @ApiModelProperty(value = "采集内容")
    private String cjnr;
    @ApiModelProperty(value = "是否批次上料")
    private Boolean isPcsl;
    @ApiModelProperty(value = "经过本工序")
    private Boolean jgbgx;
    @ApiModelProperty(value = "关键物料校验")
    private Boolean gjwljy;
    @ApiModelProperty(value = "合格率预警")
    private Boolean hglyj;
    @ApiModelProperty(value = "合格率预警阀值")
    private String hglyjfz;

    @ApiModelProperty(value = "节点名称")
    private String nodeName;

    @ApiModelProperty(value = "节点编码")
    private String nodeCode;

    @ApiModelProperty(value = "流转方式：A|流转节点内的所有工序,S|流转节点内的某一道工序")
    private String transferMode;

    @ApiModelProperty(example = "原排程计划保留数量", required = true)
    private BigDecimal keepTheNumberOf;

    @ApiModelProperty(example = "拆分数量", required = true)
    private BigDecimal breakUpTheNumber;

    @ApiModelProperty(example = "原排产数量", required = true)
    private BigDecimal originalSchedule;



    @ApiModelProperty(value = "计划开工日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate oldJhkgrq;


    @ApiModelProperty(value = "计划完工日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate oldJhwgrq;

    @ApiModelProperty(value = "下达人id")
    private Long xdrId;

    @ApiModelProperty(value = "下达人")
    private String xdr;
    
    @ApiModelProperty(value = "下达日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate xdrq;


    @ApiModelProperty(value = "是否委外")
    private Integer zbgx;
    @ApiModelProperty(value = "是否专检")
    private Boolean sfjygx;
    /**
     * 是否首检
     */
    private Boolean firstInspectionProcess;

}
