package com.jln.system.web.action.erp.ufcpswb.entity.dto;

import com.jln.ufc.web.action.ufc.em.entity.vo.HistoryVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;

/**
 * @author: Luca.Liu
 * @date: 2021/12/6
 */
@ApiModel("生产工单分页查询显示数据")
@Data
public class UfcPsWbrptHistoryVO {

    @ApiModelProperty(example = "产出物料批次号")
    private String ccsn;
    @ApiModelProperty(example = "产出物料信息")
    private String wlxx;
    @ApiModelProperty(example = "合格数量")
    private BigDecimal hgsl;
    @ApiModelProperty(example = "不合格数量")
    private BigDecimal fpsl;
    @ApiModelProperty(example = "生产工单汇报主键")
    private Long psWbrptoid;

    @ApiModelProperty(example = "不合格明细主键")
    private Long psWbuqoid;

    @ApiModelProperty(example = "产出物料外键")
    private Long psWbOutFk;
    @ApiModelProperty(example = "状态")
    private String zt;
    /**
     * 2022-2-28 新增字段
     * 质量等级名称
     */
    private String woMxZldjMc;

    /**
     * 精度名称
     */
    private String woMxJdmc;

    /**
     * 温度系数名称
     */
    private String woMxWdxsMc;

    private String pswbMxZldjMc;

    private String pswbMxJdmc;

    private String pswbMxWdxsMc;

    /**
     * 产品批号
     */
    private String cpph;
    
    private String sbmc;
    
    private String sbbm;

    @ApiModelProperty(example = "不合格分类")
    private String fl;
    @ApiModelProperty(example = "不合格现象")
    private String bhgxxmc;
    @ApiModelProperty(example = "反馈说明")
    private String bz;
    @ApiModelProperty(example = "实际工时")
    private BigDecimal rggs;

    @ApiModelProperty(example = "设备外键")
    private Long ufcEmEqucodoidFk;

    @ApiModelProperty(example = "不合格现象编码")
    private String bhgxxid;
    
    @ApiModelProperty(example = "明细.辅助属性名称（质量等级）")
    private String woMxFzsxmcZldj;
    @ApiModelProperty(example = "明细.辅助属性名称（精度）")
    private String woMxFzsxmcJd;
    @ApiModelProperty(example = "明细.温度系数组别")
    private String woMxWdxszb;
    @ApiModelProperty(example = "明细.温度系数组别")
    private LocalDate fDate;

    @ApiModelProperty(example = "批号日期")
    private LocalDate phrq;
    @ApiModelProperty(example = "设备资产编号")
    private String zcid;
    @ApiModelProperty(example = "设备信息")
    private List<HistoryVo> ufcEmEqucods;

}
