package com.jln.system.web.action.erp.ufcpswb.entity.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.jln.common.entity.PswlsxInfo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDate;

@Data
public class UfcWobomVo extends PswlsxInfo {

    @ApiModelProperty(example = "生产订单物料清单主键")
    private Long wobomoid;

    @ApiModelProperty(example = "生产订单号")
    private String woid;

    @ApiModelProperty(example = "序号")
    private String bomxh;

    @ApiModelProperty(example = "物料编码")
    private String wlid;

    @ApiModelProperty(example = "物料名称")
    private String wlmc;

    @ApiModelProperty(example = "规格型号")
    private String gg;

    @ApiModelProperty(example = "图号")
    private String th;

    @ApiModelProperty(example = "材质")
    private String cz;

    @ApiModelProperty(example = "计量单位")
    private String jldw;

    @ApiModelProperty(example = "发料日期")
    private LocalDate flrq;

    @ApiModelProperty(example = "需求数量")
    private BigDecimal xqsl;

    @ApiModelProperty(example = "分配数量")
    private BigDecimal fpsl;

    @ApiModelProperty(example = "领料单数量")
    private BigDecimal lldsl;

    @ApiModelProperty(example = "已发放数量")
    private BigDecimal yffsl;

    @ApiModelProperty(example = "超定额领料单数量")
    private String cdelldsl;

    @ApiModelProperty(example = "超定额已发放数量")
    private String cdeyffsl;

    @ApiModelProperty(example = "发放原则")
    private String ffyz;

    @ApiModelProperty(example = "副产品")
    private String fcp;

    @ApiModelProperty(example = "损耗率(%)")
    private String shlz;

    @ApiModelProperty(example = "物料批号")
    private String wlph;

    @ApiModelProperty(example = "损耗值")
    private String shz;

    @ApiModelProperty(example = "主关键物料")
    private String zgjwl;

    @ApiModelProperty(example = "原产品")
    private String ycp;

    @ApiModelProperty(example = "备注")
    private String bz;

    @ApiModelProperty(example = "状态")
    private String zt;

    @ApiModelProperty(example = "生产订单外键")
    private Long woFk;

    @ApiModelProperty(example = "物料外键")
    private Long bMaterialFk;
    /**
     * 物料属性用-物料主键
     */
    @ApiModelProperty(value = "物料属性用-物料主键", example = "000000", hidden = true)
    @JsonProperty("bMaterialoid")
    private Long bMaterialoid;

    @ApiModelProperty(example = "维护人")
    private String whr;

    @ApiModelProperty(example = "维护时间")
    private String whrq;

    @ApiModelProperty(example = "工序编号")
    private String gxid;

    @ApiModelProperty(example = "工序名称")
    private String gxmc;

    @ApiModelProperty(example = "工序名称")
    private String ngxmc;

    @ApiModelProperty(example = "工序名称")
    private String ngxid;


    @ApiModelProperty(example = "产品工艺路线明细外键", required = true, dataType = "string")
    private Long bProductprocessdetailFk;

    @ApiModelProperty(example = "标准工序外键", required = true, dataType = "string")
    private Long bStandardprocessFk;

    @ApiModelProperty(example = "产品工艺路线主键")
    private Long wogylxoid;

    @ApiModelProperty(example = "原订单保留数量", required = true)
    private BigDecimal keepTheNumberOf;

    @ApiModelProperty(example = "拆分数量", required = true)
    private BigDecimal breakUpTheNumber;

}
