package com.jln.system.web.action.erp.ufcpswb.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jln.system.web.action.erp.gxbg.dto.PsWbDto;
import com.jln.system.web.action.erp.ufcpswb.entity.dto.UfcPsWbList;
import com.jln.system.web.action.erp.ufcpswb.entity.dto.UfcPsWbrptHistoryVO;
import com.jln.system.web.action.ps.gwj.entity.PsWt;
import com.jln.system.web.action.ps.production.entity.PsWb;
import com.jln.system.web.action.ps.production.pojo.vo.PsWbQuery;
import com.jln.system.web.action.ps.production.pojo.vo.PsWbrptNumberSum;
import com.jln.system.web.action.ps.production.viewenity.PsWbList;
import com.jln.system.web.action.ps.zytl.pojo.vo.ConstructionCompleteDetailsVo;
import com.jln.system.web.action.qc.qcRule.entity.QcRule;
import com.jln.ufc.web.action.ufc.pp.pojo.vo.UfcWoVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author 
 * @since 2020-02-10
 */
@Component("ufcErpPsWbMapper")
public interface UfcPsWbMapper extends BaseMapper<PsWb> {

    PsWbDto getPsWbInfo(Long pswboid);

    PsWt getPsWtOid(@Param("pswboid") Long pswboid);

    List<PsWbDto> getPsWbMxInfo(@Param("pswbrptoid") Long pswbrptoid,@Param("pswboid") Long pswboid);

    Page<UfcPsWbrptHistoryVO> getHistory(Page page,
                                         @Param("psWbFk") Long psWbFk,
                                         @Param("type") String type);

    QcRule getQcTyeOid(@Param("bMaterialFk") Long bMaterialFk, @Param("productionLineFk") Long productionLineFk, @Param("standardProcessFk") Long standardProcessFk, @Param("qcType") String qcType);

    List<UfcWoVo> getWoWgzt(@Param("wooid") List<String> wooid);

    PsWb selectNextGx(Long wbId);

    PsWb getNextPswb(Long pswboid);

    /**
     * 生产工单——生产工单列表（不需要查询条件）
     * @param
     * @return
     */
    Page<UfcPsWbList> getpswblist(Page<Object> objectPage, @Param("data") PsWbQuery data);

    ConstructionCompleteDetailsVo getConstructionCompleteDetailsVo(@Param("psWbFk") Long psWbFk);

    PsWbrptNumberSum getPsWbrptNumberSum(@Param("psWbFk") Long psWbFk);

    BigDecimal getInspect(@Param("psWbFk") Long psWbFk);

    BigDecimal selectHbsl(@Param("psWboid") Long psWboid,@Param("pswbrptoid")Long pswbrptoid);

    BigDecimal selectBhgsl(Long psWbFk);

    BigDecimal selectYhbsl(Long psWboid);

    BigDecimal selectHbslById(Long psWbrptOid);
}
