package com.jln.system.web.action.erp.ufcpswb.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.IsDeleteEnum;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.system.web.action.bm.B_Material.service.BMaterialPropertyGroupService;
import com.jln.system.web.action.bm.productprocess.entity.BProductprocessdetail;
import com.jln.system.web.action.bm.productprocess.mapper.BProductprocessdetailMapper;
import com.jln.system.web.action.commonweb.parameterize.service.SysBusinessService;
import com.jln.system.web.action.erp.ufcpswb.entity.UfcWobom;
import com.jln.system.web.action.erp.ufcpswb.entity.dto.UfcCjheckQcSampleStdDto;
import com.jln.system.web.action.erp.ufcpswb.entity.dto.UfcPswbEntity;
import com.jln.system.web.action.erp.ufcpswb.entity.dto.UfcWoSelectDto;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcGwjVo;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcCcsnVo;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcGwjVo;
import com.jln.system.web.action.erp.ufcpswb.entity.vo.UfcWobomVo;
import com.jln.system.web.action.erp.ufcpswb.mapper.UfcWobomMapper;
import com.jln.system.web.action.erp.ufcpswb.service.UfcWobomService;
import com.jln.system.web.action.pp.planModify.pojo.dto.WoBgNumberInfo;
import com.jln.system.web.action.pp.planModify.service.WobgCheckService;
import com.jln.system.web.action.pp.proPrepare.entity.PsWpbom;
import com.jln.system.web.action.pp.proPrepare.entity.Wogylx;
import com.jln.system.web.action.pp.proPrepare.mapper.PsWpbomMapper;
import com.jln.system.web.action.pp.proPrepare.pojo.vo.PsWpBomWhicleVO;
import com.jln.system.web.action.pp.proPrepare.pojo.vo.WoBomWsInfo;
import com.jln.system.web.action.pp.proPrepare.pojo.vo.WsbomVo;
import com.jln.system.web.action.pp.proPrepare.service.PsWpbomService;
import com.jln.system.web.action.pp.proPrepare.service.WogylxService;
import com.jln.system.web.action.ps.gwj.entity.PsWt;
import com.jln.system.web.action.ps.gwj.service.PsWtService;
import com.jln.system.web.action.ps.production.entity.PsWb;
import com.jln.system.web.action.ps.production.entity.PsWbrpt;
import com.jln.system.web.action.ps.production.entity.PsWs;
import com.jln.system.web.action.ps.production.entity.Psgylx;
import com.jln.system.web.action.ps.production.mapper.PsWbbomMapper;
import com.jln.system.web.action.ps.production.pojo.vo.FirstProcedureVO;
import com.jln.system.web.action.ps.production.service.*;
import com.jln.system.web.action.ps.production.viewenity.PsWbEntity;
import com.jln.system.web.action.ps.production.viewenity.PsWbGxEntity;
import lombok.extern.slf4j.Slf4j;
import ma.glasnost.orika.MapperFacade;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * <p>
 * 生产订单物料清单 服务实现类
 * </p>
 *
 * @author
 * @since 2020-02-20
 */
@Slf4j
@Service("UfcErpWobomServiceImpl")
public class UfcWobomServiceImpl extends ServiceImpl<UfcWobomMapper, UfcWobom> implements UfcWobomService {

    /**
     * 物料属性-属性组的业务逻辑层
     */
    @Autowired
    private BMaterialPropertyGroupService bMaterialPropertyGroupService;

    @Autowired
    private WobgCheckService wobgCheckService;

    @Autowired
    private PsWbService psWbService;

    @Autowired
    private PsWsService psWsService;

    @Autowired
    private WogylxService wogylxService;

    @Autowired
    private PsgylxService psgylxService;

    @Autowired
    private MapperFacade mapperFacade;

    @Autowired
    private BProductprocessdetailMapper bProductprocessdetailMapper;    //工艺路线明细业务逻辑

    @Autowired
    private SysBusinessService sysBusinessService;

    private static final String IS_TRUE="Y";

    @Autowired
    private PsWbbomMapper psWbbomMapper;

    @Autowired
    private PsWpbomMapper psWpbomMapper;

    @Autowired
    private PsWpbomService psWpbomService;

    @Value("${topPid}")
    private Long topPid;

    @Autowired
    private PsWtService psWtService;

    @Autowired
    private PsWbrptService psWbrptService;

    /**
     * 工单物料清单业务逻辑层
     */
    @Autowired
    private PsWbbomService psWbbomService;


    @Override
    public Result<UfcWobomVo> getWobomList(Page<UfcWobomVo> page, UfcWoSelectDto woSelectDto) {
        Long wooid = woSelectDto.getWooid();
        if (EmptyUtil.isEmpty(wooid)) {
            return new Result().toFailure(ResultCodeEnum.PPERROR10038);
        }
        Page<UfcWobomVo> wobomView = page.setRecords(this.baseMapper.getWobomList(page, woSelectDto));
        bMaterialPropertyGroupService.packedAbsorber(wobomView);
        if(0!=wobomView.getRecords().size()){
            Result<WoBgNumberInfo> info = wobgCheckService.getWoBgNumberInfo(page.getRecords().get(0).getWoFk());
            if(info.confirmSuccess()){
                for (UfcWobomVo record : wobomView.getRecords()) {
                    record.setKeepTheNumberOf(info.getData().getKeepTheNumberOf());
                    record.setBreakUpTheNumber(info.getData().getBreakUpTheNumber());
                }
            }
        }
        return new Result().toSuccess(wobomView);
    }

    @Override
    public Result addpswbLj(UfcPswbEntity ufcPswbEntity, User user) {
        if (EmptyUtil.isEmpty(ufcPswbEntity.getPs_wsoids())) {
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        DateFormat df = new SimpleDateFormat("yyyyMMdd");
        Calendar calendar = Calendar.getInstance();
        String dateName = df.format(calendar.getTime());
        Integer wbid1 = getWbid();
        List<PsWb> addPswb = new ArrayList<>();
        //转换工序主键集合
        List<Long> gxoids = ufcPswbEntity.getPsWbGxEntityList().stream().map(PsWbGxEntity::getGxoid).collect(Collectors.toList());
        //判断是否有重复工单
        List<PsWb> psWbs = psWbService.getBaseMapper().selectList(new LambdaQueryWrapper<PsWb>()
                .in(PsWb::getPsWsFk, ufcPswbEntity.getPs_wsoids())
                .in(PsWb::getPsGylxFk, gxoids)
        );
        if (psWbs.size() > 0) {
            return new Result<>().toFailure("不允许重复生产工单");
        }
        for (Long ps_wsoid : ufcPswbEntity.getPs_wsoids()) {
            // 获取生成订单排程详情信息
            PsWs psWs = psWsService.getBaseMapper().selectById(ps_wsoid);
            // 获取生产订单订单订单数量，初始化工单排产数量
            LambdaQueryWrapper<Wogylx> wogylxLambdaQueryWrapper = new LambdaQueryWrapper<>();
            wogylxLambdaQueryWrapper.eq(Wogylx::getWoFk, psWs.getWoFk()).eq(Wogylx::getDel, 0);
            List<Wogylx> wogylxlist = wogylxService.getBaseMapper().selectList(wogylxLambdaQueryWrapper);

            // 获取生产订单工艺路线信息
            List<Psgylx> psgylxes = psgylxService.getBaseMapper().selectList(new LambdaQueryWrapper<Psgylx>().in(Psgylx::getPsGylxOid, gxoids));
            if (psgylxes.size() < 1) {
                return new Result<>().toFailure("没有工单工艺路线无法生产订单");
            }
            //通过订单工艺路线明显主键 获取工艺路线主键
            Map<Long, Wogylx> collect = new HashMap<>();
            if (!EmptyUtil.isEmpty(wogylxlist)) {
                collect = wogylxlist.stream().collect(Collectors.toMap(Wogylx::getWogylxoid, Function.identity(), (key1, key2) -> key2));
            }

            if (psgylxes.size() == wogylxlist.size()) {
                for (int i = 0; i < psgylxes.size(); i++) {
                    if (!EmptyUtil.isEmpty(wogylxlist.get(i).getBStandardprocessFk())) {
                        psgylxes.get(i).setBStandardprocessFk(wogylxlist.get(i).getBStandardprocessFk());
                    }
                    if (!EmptyUtil.isEmpty(wogylxlist.get(i).getWogylxoid())) {
                        psgylxes.get(i).setWogylxFk(wogylxlist.get(i).getWogylxoid());
                    }
                }
            }

            for (Psgylx item : psgylxes) {
                wbid1++;
                String jhh = "WS" + new SimpleDateFormat("yyyyMMdd", Locale.CHINESE).format(new Date()) + String.format("%0" + 4 + "d", wbid1);
                PsWs newPs = psWs;
                // 复制生成订单详情到生产订单
                PsWb pswb = mapperFacade.map(psWs, PsWb.class);
                // 初始化生产订单信息
                pswb.setBz("");
                pswb.setSysCreatedBy(user.getEmployeeOid());
                pswb.setSysCreated(LocalDateTime.now());
                // 设置生产工单排产数量
                pswb.setPcsl(newPs.getPcsl());
                // 设置生产工单序号
                pswb.setWoxh(newPs.getWoxh());
                pswb.setWbid(jhh);
                pswb.setGpid(jhh);
                // 工单工艺路线外键
                pswb.setPsGylxFk(item.getPsGylxOid());

                // 订单工艺路线外键
                pswb.setWogylxFk(item.getWogylxFk());

                //基础工序外键
                pswb.setBStandardprocessFk(item.getBStandardprocessFk());

                // 生产订单外键
                pswb.setPsWboid(SnowflakeIdUtils.generate());
                pswb.setGxid(item.getGxid());
                pswb.setGxmc(item.getBzgxmc());
                if (!EmptyUtil.isEmpty(collect)) {
                    Wogylx wogylx = collect.get(item.getWogylxFk());
                    if (!EmptyUtil.isEmpty(wogylx)) {
                        pswb.setBProductprocessFk(wogylx.getBProductprocessdetailFk());
                    }
                }
                pswb.setPsWsFk(newPs.getPsWsoid());
                pswb.setPsTechnologicalProcessFk(item.getTechnologicalProcessFk());
                pswb.setBWorklineFk(newPs.getBProductionlineFk());
                pswb.setBWorkstationFk(newPs.getBWorkstationFk());
                pswb.setBMaterialFk(newPs.getBMaterialFk());
                pswb.setZlh(newPs.getZlh());
                pswb.setProcessCardFk(newPs.getProcessCardFk());
                pswb.setJhxh(newPs.getWoxh());
                pswb.setSort(item.getSort());

                //查询产品工艺路线明细
                BProductprocessdetail productprocessdetail = bProductprocessdetailMapper.selectById(pswb.getBProductprocessFk());
                if (!EmptyUtil.isEmpty(productprocessdetail)) {
                    if (EmptyUtil.isEmpty(productprocessdetail.getGjgx())) {
                        pswb.setSfgj(false);
                    } else {
                        pswb.setSfgj(productprocessdetail.getGjgx() == 0 ? false : true);
                    }
                    pswb.setSfzl(productprocessdetail.getGjwljy());
                    pswb.setSfsj(productprocessdetail.getFirstInspectionProcess());
                    pswb.setSfdl(productprocessdetail.getIndividualManagement());
                    pswb.setSfscdj(productprocessdetail.getSingleGenerating());
                }
                addPswb.add(pswb);
            }
        }
        boolean bl = psWbService.saveBatch(addPswb);
        if (!bl) {
            return new Result().toFailure("调度成功");
        }
        //增加逻辑-当调度生成工单的时候 自动生成 排程计划物料清单、工单物料清单数据
        return this.initWbBom(addPswb.get(0).getPsWboid(),user);
    }

    @Override
    public Result revokeSj(UfcCjheckQcSampleStdDto ufcCjheckQcSampleStdDto, User user) {
        //查询工票数据
        PsWt pswt = psWtService.getById(ufcCjheckQcSampleStdDto.getPsWtoid());
        LambdaQueryWrapper<PsWbrpt> wbrptLambdaQueryWrapper = new LambdaQueryWrapper<>();
        wbrptLambdaQueryWrapper.eq(PsWbrpt::getPsWbFk,pswt.getPsWbFk());
        int row = psWbrptService.count(wbrptLambdaQueryWrapper);
        if(row > 0){
            return new Result().toFailure("工序已经报告,不允许撤回！");
        }
        //更新首检工票
        if(ufcCjheckQcSampleStdDto.getZjsj()== 1 ){
            psWtService.update(new LambdaUpdateWrapper<PsWt>()
                    .set(PsWt::getWcsjsj,null)
                    .set(PsWt::getSjwc,false)
                    .set(PsWt::getSjyrgh,null)
                    .set(PsWt::getSjyrid,null)
                    .set(PsWt::getSjyrmc,null)
                    .eq(PsWt::getPsWtoid,ufcCjheckQcSampleStdDto.getPsWtoid()));

        }
        return new Result().toSuccess();
    }

    @Override
    public Result getSfjygx(String wbOid) {
        Boolean sfjygx = this.baseMapper.getSfjygx(wbOid);
        return new Result().toSuccess(sfjygx);
    }

    @Override
    public Result getCcsn(String wbOid) {
        UfcCcsnVo ccsn = this.baseMapper.getCcsn(wbOid);
        return new Result().toSuccess(ccsn);
    }

    @Override
    public Result getJybzmc(UfcGwjVo ufcGwjVo) {
        String jybzmc = this.baseMapper.getJybzmc(ufcGwjVo);
        if(EmptyUtil.isEmpty(jybzmc)){
            jybzmc = this.baseMapper.getTygcmc(ufcGwjVo);
            if(EmptyUtil.isEmpty(jybzmc)){
                ufcGwjVo.setBMaterialFk(null);
                ufcGwjVo.setDefaultFactoryFk(null);
                jybzmc = this.baseMapper.getTygcmc(ufcGwjVo);
            }
        }
        return new Result().toSuccess(jybzmc);
    }

    private Integer getWbid() {

        List<PsWb> list = this.psWbService.list(new LambdaQueryWrapper<PsWb>().select(PsWb::getWbid).like(PsWb::getSysCreated, LocalDate.now()).orderByDesc(PsWb::getWbid));

        if (list.size() <= 0) {
            return 0;
        } else {
            return Integer.parseInt(list.get(0).getWbid().substring(list.get(0).getWbid().length() - 1));
        }
    }

    public Result initWbBom(Long psWbId, User user) {
        Result<List<Object>> listResult = sysBusinessService.getdefaultValue("PSK0257");
        if(!listResult.confirmSuccess()){
            //没有查询出数据，直接返回成功不执行下面的逻辑
            return new Result().toSuccess();
        }
        String string = listResult.getData().get(0).toString();
        if(!IS_TRUE.equals(string)){
            //参数设置为N|不需要执行逻辑
            return new Result().toSuccess();
        }
        //查询出排程计划外键
        LambdaQueryWrapper<PsWb> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(PsWb::getPsWboid,psWbId);
        wrapper.select(PsWb::getPsWsFk,PsWb::getBFactoryFk);
        PsWb wb = this.psWbService.getBaseMapper().selectOne(wrapper);
        if(EmptyUtil.isEmpty(wb)){
            log.error("工单未生成");
        }
        Boolean aBoolean = whetherWoBom(wb.getPsWsFk());
        if(aBoolean){
            //工单物料清单已经生成过了，将不会继续生成
            log.info("工单物料清单已经生成过了，将不会继续生成-对应排程计划主键:["+wb.getPsWsFk()+"]");
            return new Result().toWarr("工序物料清单已经生成过了，将不会按照首工序物料清单规则继续生成");
        }
        //查询出当前排程计划的首道工序
        List<FirstProcedureVO> procedure = psWbbomMapper.getFirstProcedure(wb.getPsWsFk());
        if(EmptyUtil.isEmpty(procedure)){
            log.info("首道工序对应的工单没有生成-对应排程计划主键:["+wb.getPsWsFk()+"]");
        }
        Long psWb = getFisterPsWb(procedure);
        //--按照首道工序生成工序物料清单逻辑
        Result result = this.initialize(wb.getPsWsFk(), user);
        if(!result.confirmSuccess()){
            log.info("当前作业计划没有需要投料的内容，将不会按照首工序物料清单规则生成-对应排程计划主键:["+wb.getPsWsFk()+"]");
            return new Result().toWarr("当前作业计划没有需要投料的内容，将不会按照首工序物料清单规则生成");
        }
        //--按照首道工序生产工单物料清单逻辑
        Result psWbBom = psWbbomService.firstInitPsWbBom(psWb, user,wb.getBFactoryFk());
        if(!psWbBom.confirmSuccess()){
            log.error(psWbBom.getMsg()+wb.getPsWsFk()+"]");
            return psWbBom;
        }
        if (psWbBom.isWarr()){
            return psWbBom;
        }
        return new Result().toSuccess();

    }


    /**
     * 判断工单物料清单是否存在
     * @param psWsFk 排程计划外键
     * @return
     */
    private Boolean whetherWoBom(Long psWsFk){
        Integer aLong = psWbbomMapper.whetherWoBom(psWsFk);
        return 0!=aLong;

    }

    private Long getFisterPsWb(List<FirstProcedureVO> procedure){
        if(EmptyUtil.isEmpty(procedure)){
            return null;
        }
        if(procedure.size()==1){
            return procedure.get(0).getPsWboid();
        }
        for (FirstProcedureVO vo : procedure) {
            if(!vo.getTechnologicalProcessPid().equals(topPid)){
                //存在多个首道工序的 取工序节点为首节点的数据
                return vo.getPsWboid();
            }
        }
        return procedure.get(0).getPsWboid();
    }

    public Result initialize(Long psWsFk, User user) {
        List<PsWpBomWhicleVO> vos = whichDel(psWsFk, null);
        Map<Long, PsWpBomWhicleVO> collect=new HashMap<>();
        List<Long> longs=null;
        if(!EmptyUtil.isEmpty(vos)){
            List<PsWpBomWhicleVO> psWpBomWhicleVOS = vos.stream().filter(psWpBomWhicleVO -> !EmptyUtil.isEmpty(psWpBomWhicleVO.getMcWomrdetailoid())).collect(Collectors.toList());
            longs = vos.stream().map(psWpBomWhicleVO -> psWpBomWhicleVO.getPsWpbomoid()).collect(Collectors.toList());
            //将产生领料数据的数据弄出来
            collect = psWpBomWhicleVOS.stream().collect(Collectors.toMap(PsWpBomWhicleVO::getBMaterialFk, Function.identity(), (k1, k2) -> k1));

        }
        //第一步:查询出订单物料清单数据
        List<WoBomWsInfo> wobomList = psWpbomMapper.getWobom(psWsFk);
        if(EmptyUtil.isEmpty(wobomList)){
            return new Result().toFailure(ResultCodeEnum.PPERROR10230);
        }
        List<Long> idList=new ArrayList<>();
        List<WoBomWsInfo> woBomWsInfoList=new ArrayList<>();
        if(EmptyUtil.isEmpty(collect)){
            Map<Long, PsWpBomWhicleVO> finalCollect = collect;
            wobomList.forEach(woBomWsInfo -> {
                PsWpBomWhicleVO whicleVO = finalCollect.get(woBomWsInfo.getBMaterialFk());
                if(!EmptyUtil.isEmpty(whicleVO)){
                    idList.add(whicleVO.getPsWpbomoid());
                }else {
                    //存在已经领料的数据-不重新生成
                    woBomWsInfoList.add(woBomWsInfo);
                }
            });

            //将能删除的数据删除戴掉
            if(!EmptyUtil.isEmpty(idList)){
                longs.removeAll(idList);
            }

        }

        if(!EmptyUtil.isEmpty(longs)){
            del(longs);
        }
        //查询出订单需求数量
        BigDecimal xqsl = psWpbomMapper.getWoXqsl(psWsFk);
        //查询出本次排程数量
        WsbomVo pcsl = psWpbomMapper.getPsWsPcslInfo(psWsFk);
        List<PsWpbom> wpbomList=new ArrayList<>();

        woBomWsInfoList.forEach(wobom -> {
            PsWpbom wpbom=new PsWpbom();
            wpbom.setPsWpbomoid(SnowflakeIdUtils.generate());
            //产品结构号冗余字段去掉
            wpbom.setBomxh(wobom.getBomxh());
            wpbom.setWoid(wobom.getWoid());
            wpbom.setQyrq(LocalDate.now());
            wpbom.setTybz(0);
            wpbom.setZt("I");
            wpbom.setSysCreated(LocalDateTime.now());
            wpbom.setSysCreatedBy(user.getEmployeeOid());
            wpbom.setSysLastUpd(LocalDateTime.now());
            wpbom.setSysLastUpdBy(user.getEmployeeOid());
            //TO-DO--工厂外键不存在，需要查询出来
            wpbom.setBFactoryFk(pcsl.getBFactoryFk());
            wpbom.setBProductprocessdetailFk(wobom.getBProductprocessdetailFk());
            wpbom.setBMaterialFk(wobom.getBMaterialFk());
            wpbom.setWobomFk(wobom.getWobomoid());
            wpbom.setWoFk(wobom.getWoFk());
            //订单工艺路线取不到值
            wpbom.setDel(IsDeleteEnum.NotDelete.getStatus());
            //TO-DO --排程计划号冗余字段
            wpbom.setProcessId(pcsl.getProcessId());
            //计算排产数量
            wpbom.setPcsl(wobom.getXqsl());
            wpbom.setFpsl(wobom.getFpsl());
            wpbom.setYffsl(wobom.getYffsl());
            wpbom.setFfyz(wobom.getFfyz());
            wpbom.setFcp(wobom.getFcp());
            //TO-DO-发放工序号
            wpbom.setGxid(wobom.getGxid());
            wpbom.setBomid(wobom.getBomid());
            wpbom.setShlz(wobom.getShlz());
            wpbom.setShz(wobom.getShz());
            wpbom.setZgjwl(wobom.getZgjwl());
            wpbom.setYcp(wobom.getYcp());
            if(!EmptyUtil.isEmpty(wobom.getFfyz())){
                if(!"Y".equals(wobom.getFfyz())||!"N".equals(wobom.getFfyz())){
                    wpbom.setFfyz("Y");
                }
            }else {
                wpbom.setFfyz("Y");
            }
            wpbom.setPsWsFk(psWsFk);
            wpbom.setFlrq(LocalDate.now());
            wpbomList.add(wpbom);
        });
        boolean batch = psWpbomService.saveBatch(wpbomList);
        if(!batch){
            return new Result().toFailure(ResultCodeEnum.BMERROR1015);
        }
        return new Result().toSuccess();
    }

    /**
     * 判断哪些数据不能删除
     * @param psWsFk
     * @return
     */
    private List<PsWpBomWhicleVO> whichDel(Long psWsFk,List<Long> idList){
        return psWpbomMapper.getPsWpBomWhicleVO(psWsFk, idList);
    }
    public Result del(List<Long> idList) {
        //TODO  判断删除的数据是否允许删除
        List<PsWpBomWhicleVO> vos = whichDel(null, idList);
        if(EmptyUtil.isEmpty(vos)){
            return new Result().toFailure("将要删除的数据不存在或已被删除!");
        }
        Map<Long, PsWpBomWhicleVO> collect = vos.stream().collect(Collectors.toMap(PsWpBomWhicleVO::getPsWpbomoid, Function.identity(), (k1, k2) -> k1));
        for (Long aLong : idList) {
            PsWpBomWhicleVO vo = collect.get(aLong);
            if(!EmptyUtil.isEmpty(vo)){
                if(!EmptyUtil.isEmpty(vo.getMcWomrdetailoid())){
                    return new Result().toFailure("已产生领料记录不允许删除!");
                }
            }
        }
        boolean byIds = this.removeByIds(idList);
        if(!byIds){
            return new Result().toFailure("删除失败!");
        }
        return new Result().toSuccess();
    }
}
