package com.jln.system.web.action.erp.wo.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 生产订单扩展表
 * </p>
 *
 * @author 
 * @since 2022-01-06
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class UfcErpWo extends Model<UfcErpWo> {

    private static final long serialVersionUID = 1L;

    /**
     * 生产订单扩展表主键
     */
    @TableId
    private Long ufcErpWoOid;

    /**
     * 生产订单外键
     */
    private Long woFk;

    /**
     * 单据头.单据日期
     */
    private LocalDateTime djtDjrq;

    /**
     * 单据头.审核人
     */
    private Integer djtShr;

    /**
     * 单据头.审核日期
     */
    private LocalDateTime djtShrq;

    /**
     * 单据头.客户名称
     */
    private String djtKhmc;

    /**
     * 单据头.流转卡号
     */
    private String djtLzkh;

    /**
     * 单据头.销售类型ID
     */
    private String djtXslxId;

    /**
     * 销售类型名称
     */
    private String xslxmc;

    /**
     * 明细.需求组织
     */
    private Integer mxXqzz;

    /**
     * 明细.物料编码ID
     */
    private Integer mxWlbmId;

    /**
     * 明细.ID号
     */
    private String mxId;

    /**
     * 明细.辅助属性ID
     */
    private Integer mxFzsxId;

    /**
     * 明细.辅助属性名称（质量等级）
     */
    private String mxFzsxmcZldj;

    /**
     * 明细.辅助属性名称（精度）
     */
    private String mxFzsxmcJd;

    /**
     * 明细.温度系数组别
     */
    private String mxWdxszb;

    /**
     * 明细.配套时间
     */
    private LocalDateTime mxPtsj;

    /**
     * 明细.配套数量
     */
    private BigDecimal mxPtsl;

    /**
     * 明细.阶段（技术状态）
     */
    private String mxJd;

    /**
     * 明细.合同号
     */
    private String mxHth;

    /**
     * 明细.军检类型ID
     */
    private Integer mxJjlx;

    /**
     * 军检类型名称
     */
    private String mxJjmc;

    /**
     * 明细.单价
     */
    private BigDecimal mxDj;

    /**
     * 明细.备注
     */
    private String mxBz;

    /**
     * 明细.备注（生产）
     */
    private String mxBzSc;

    /**
     * 明细.销售订单要货日期
     */
    private LocalDateTime mxXsddyhrq;

    /**
     * 明细.是否下场验收
     */
    private String mxSfxcys;

    /**
     * 明细.HM执行标准编码
     */
    private String mxHnzxbzId;

    /**
     * 明细.执行标准ID
     */
    private Integer mxZxbzId;

    /**
     * 明细.客户物料编码
     */
    private String mxKhwlId;

    /**
     * 明细.客户物料名称
     */
    private String mxKhwlmc;

    /**
     * 明细.HM项目编号ID
     */
    private Integer mxHmxmbh;

    /**
     * 明细.HM项目编码
     */
    private String mxHmxmbmId;

    /**
     * 明细.BOM ID
     */
    private Integer mxBomId;

    /**
     * BOM版本
     */
    private String bomBb;

    /**
     * 明细.批号ID
     */
    private Integer mxPhId;

    /**
     * 明细.批号
     */
    private String mxPh;

    /**
     * 明细.入库组织（传名称）
     */
    private Integer mxRkzz;

    /**
     * 明细.源单类型
     */
    private String mxYdlx;

    /**
     * 明细.源单编号
     */
    private String mxYdbmId;

    /**
     * 明细.源单分录行号
     */
    private Integer mxYdflhh;

    /**
     * 预留文本字段
     */
    private String customTextOne;

    /**
     * 预留文本字段
     */
    private String customTextTwo;

    /**
     * 预留文本字段
     */
    private String customTextThree;

    /**
     * 预留文本字段
     */
    private String customTextFour;

    /**
     * 预留文本字段
     */
    private String customTextFive;

    /**
     * 预留日期时间字段
     */
    private LocalDateTime customDatetimeOne;

    /**
     * 预留日期时间字段
     */
    private LocalDateTime customDatetimeTwo;
    /**
     * 2022-1-7 新增字段
     * 产值单件
     */
    private BigDecimal czdj;
    /**
     * 2022-1-17 新增字段
     * erp工艺路线编码
     */
    private String cpgyCode;

    /**
     * 2022-2-28 新增字段
     * 质量等级名称
     */
    private String mxZldjMc;

    /**
     * 精度名称
     */
    @TableField(value="mx_jd_mc")
    private String mxJdmc;

    /**
     * 温度系数名称
     */
    private String mxWdxsMc;
    /**
     * 执行标准名称
     */
    private String mxZxbzMc;
    /**
     * 审核人名称
     */
    private String djtShrMc;

    @Override
    protected Serializable pkVal() {
        return this.ufcErpWoOid;
    }

}
