package com.jln.system.web.action.erp.wo.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @author: Luca.Liu
 * @date: 2022/1/19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("wogylx")
public class UfcWogylx extends Model<UfcWogylx> {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty(example = "生产订单工艺路线主键", required = true,dataType = "string")
    private Long wogylxoid;

    @ApiModelProperty(example = "生产订单号:2020020001", required = true,dataType = "string")
    private String woid;

    @ApiModelProperty(example = "工序号:1、2、3", required = true,dataType = "int")
    private String gxid;

    @ApiModelProperty(example = "工序名称:打磨", required = true,dataType = "string")
    private String gxmc;

    @ApiModelProperty(example = "工序类型:S|首道工序、O|中间工序、M|末道工序", required = true,dataType = "string")
    private String gxlx;

    @ApiModelProperty(example = "关键工序:0、1、2、3", required = true,dataType = "int")
    private Integer gjgx;

    @ApiModelProperty(example = "上料:0、1", required = true,dataType = "int")
    private Integer slgx;

    @ApiModelProperty(example = "下料:0、1", required = true,dataType = "int")
    private Integer xlgx;

    @ApiModelProperty(example = "测试:0、1", required = true,dataType = "int")
    private Integer csgx;

    @ApiModelProperty(example = "设备数:1000", required = true)
    private BigDecimal sbs;

    @ApiModelProperty(example = "人数:1000", required = true)
    private BigDecimal rs;

    @ApiModelProperty(example = "工位机编码:001", required = true,dataType = "string")
    private String gwjid;

    @ApiModelProperty(example = "排产优先级:0、1、2、3", required = true)
    private String pcyxj;

    @ApiModelProperty(example = "计划开工日期:2020-02-22 00:00:00", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jhkgrq;

    @ApiModelProperty(example = "计划完工日期:2020-02-22 00:00:00", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jhwgrq;

    @ApiModelProperty(example = "需求数量:1000", required = true)
    private BigDecimal xqsl;

    @ApiModelProperty(example = "排产数量:1000", required = true)
    private BigDecimal pcsl;

    @ApiModelProperty(example = "发出数量:1000", required = true)
    private BigDecimal fcsl;

    @ApiModelProperty(example = "回收数量:1000", required = true)
    private BigDecimal hssl;

    @ApiModelProperty(example = "接收数量:1000", required = true)
    private BigDecimal jssl;

    @ApiModelProperty(example = "转移数量:1000", required = true)
    private BigDecimal zysl;

    @ApiModelProperty(example = "完成数量:1000", required = true)
    private BigDecimal wcsl;

    @ApiModelProperty(example = "工废数量:1000", required = true)
    private BigDecimal fpsl;

    @ApiModelProperty(example = "料废数量:1000", required = true)
    private BigDecimal lfsl;

    @ApiModelProperty(example = "返工数量:1000", required = true)
    private BigDecimal fgsl;

    @ApiModelProperty(example = "回用数量:1000", required = true)
    private BigDecimal hysl;

    @ApiModelProperty(example = "交接批量:1000", required = true)
    private BigDecimal jjpl;

    @ApiModelProperty(example = "排产倍数:10", required = true)
    private BigDecimal pcbs;

    @ApiModelProperty(example = "转包工序:0、1、2、3", required = true,dataType = "int")
    private Integer zbgx;

    @ApiModelProperty(example = "转包提前期:1000", required = true)
    private BigDecimal zblt;

    @ApiModelProperty(example = "转包成本:1000", required = true)
    private BigDecimal zbcb;

    @ApiModelProperty(example = "标准准备时间(m):10", required = true)
    private BigDecimal bzzbsj;

    @ApiModelProperty(example = "标准加工时间(m):10", required = true)
    private BigDecimal bzjgsj;

    @ApiModelProperty(example = "标准排队时间(h):10", required = true)
    private BigDecimal bzpdsj;

    @ApiModelProperty(example = "标准转移时间(h):10", required = true)
    private BigDecimal bzzysj;

    @ApiModelProperty(example = "标准等待时间(h):10", required = true)
    private BigDecimal bzddsj;

    @ApiModelProperty(example = "单件人工费用:1000", required = true)
    private BigDecimal djrg;

    @ApiModelProperty(example = "单件人工工时(h):100", required = true)
    private BigDecimal rgsj;

    @ApiModelProperty(example = "实际开工日期:2020-02-22 00:00:00", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate sjkgrq;

    @ApiModelProperty(example = "实际完工日期:2020-02-22 00:00:00", required = true,dataType = "date")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate sjwgrq;

    @ApiModelProperty(example = "实际准备时间(m):100", required = true)
    private BigDecimal sjzbsj;

    @ApiModelProperty(example = "实际加工时间(m):100", required = true)
    private BigDecimal sjjgsj;

    @ApiModelProperty(example = "废品损失:1000", required = true)
    private BigDecimal fpss;

    @ApiModelProperty(example = "废品回收:1000", required = true)
    private BigDecimal fphs;

    @ApiModelProperty(example = "自动移出:0、1", required = true,dataType = "int")
    private Integer zdyc;

    @ApiModelProperty(example = "自动移入:0、1", required = true,dataType = "int")
    private Integer zdyr;

    @ApiModelProperty(example = "备注", required = true,dataType = "string")
    private String bz;

    @ApiModelProperty(example = "状态:I|初始、R|下达、S|暂停；C|完成", required = true,dataType = "string")
    private String zt;

    @ApiModelProperty(example = "创建人oid:token获取", required = true,dataType = "string")
    private Long sysCreatedBy;

    @ApiModelProperty(example = "最后修改人oid:token获取", required = true,dataType = "string")
    private Long sysLastUpdBy;

    @ApiModelProperty(example = "创建时间:自动生成", required = true,dataType = "date")
    private LocalDateTime sysCreated;

    @ApiModelProperty(example = "最后修改时间:自动生成", required = true,dataType = "date")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysLastUpd;

    @TableLogic
    @ApiModelProperty(example = "删除标记:自动生成", required = true,dataType = "int")
    private Integer del;

    @ApiModelProperty(example = "生产订单外键", required = true,dataType = "string")
    private Long woFk;

    @ApiModelProperty(example = "产品工艺路线明细外键", required = true,dataType = "string")
    private Long bProductprocessdetailFk;

    @ApiModelProperty(example = "生产线外键", required = true,dataType = "string")
    private Long bProductionlineFk;

    @ApiModelProperty(example = "工段外键", required = true,dataType = "string")
    private Long bWorksectionFk;

    @ApiModelProperty(example = "工站外键", required = true,dataType = "string")
    private Long bWorkstationFk;

    @ApiModelProperty(example = "供应商外键", required = true,dataType = "string")
    private Long bSupplierFk;

    @ApiModelProperty(example = "标准工序外键", required = true,dataType = "string")
    private Long bStandardprocessFk;

    //------------------------增加字段----------------------------------------------

    @ApiModelProperty(example = "订单工序节点外键", value = "订单工序外键")
    private Long technologicalProcessFk;

    //-----------------------以下数据来源：产品工艺路线明细（B_productprocess_detail）------------------------------

    @ApiModelProperty(example = "作业方式 PC、PDA、DCT", required = true)
    private String zyfs;

    @ApiModelProperty(example = "采集内容 PD|产能、PD|产能和缺陷", required = true)
    private String cjnr;

    @ApiModelProperty(example = "是否批次上料 1是 0不是", required = true)
    private Boolean isPcsl;

    @ApiModelProperty(example = "是否经过本工序", required = true)
    private Boolean jgbgx;

    @ApiModelProperty(example = "关键物料校验", required = true)
    private Boolean gjwljy;

    @ApiModelProperty(example = "合格率预警", required = true)
    private Boolean hglyj;

    @ApiModelProperty(example = "合格率预警阀值 百分比", required = true)
    private BigDecimal hglyjfz;

    //标准工艺路线明细带出

    @ApiModelProperty(example = "标准产量", value = "标准产量")
    private BigDecimal bzcl;

    @ApiModelProperty(example = "标准工时", value = "标准产量")
    private BigDecimal bzgs;

    @ApiModelProperty(example = "标准人数", value = "标准人数")
    private Integer bzrs;

    //------------------------增加字段----------------------------------------------

    /**
     * 是否允许入库
     */
    @ApiModelProperty(value = "是否允许入库", example = "false", position = 101)
    private Boolean sfyxrk;

    /**
     * 默认入库仓库
     */
    @ApiModelProperty(value = "默认入库仓库", example = "2000000", position = 102)
    private String mrrkck;

    /**
     * 是否允许变更产品
     */
    @ApiModelProperty(value = "是否允许变更产品", example = "false", position = 106)
    private Boolean sfyxbgcp;

    /**
     * 是否允许拆分流程卡
     */
    @ApiModelProperty(value = "是否允许拆分流程卡", example = "false", position = 105)
    private Boolean sfyxcslck;

    /**
     * 是否校验工序
     */
    @ApiModelProperty(value = "是否校验工序", example = "false", position = 100)
    private Boolean sfjygx;

    /**
     * 是否进行数量校验
     */
    @ApiModelProperty(value = "是否进行数量校验", example = "false", position = 107)
    private Boolean sfjxsljy;

    /**
     * 特殊过程
     */
    @ApiModelProperty(value = "特殊过程", example = "false", position = 107)
    private Boolean specialProcess;
    /**
     * 首检工序
     */
    @ApiModelProperty(value = "首检工序", example = "false", position = 107)
    private Boolean firstInspectionProcess;
    /**
     * 单件管理
     */
    @ApiModelProperty(value = "单件管理", example = "false", position = 107)
    private Boolean individualManagement;
    /**
     * 单件生成
     */
    @ApiModelProperty(value = "单件生成", example = "false", position = 107)
    private Boolean singleGenerating;

    /**
     * 是否允许自动接收
     */
    @ApiModelProperty(value = "是否允许自动接收", example = "false", position = 104)
    private Boolean sfyxzdjs;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    /**
     * 2021-11-30 新增字段
     */
    @ApiModelProperty(value = "标准工艺路线明细序号")
    private Integer xh;
    @ApiModelProperty(value = "表体id")
    private Integer Btid;
    @ApiModelProperty(value = "工序id号")
    private Integer Id;
    @ApiModelProperty(value = "顺序号")
    private Integer Sxh;
    @ApiModelProperty(value = "是否首检")
    private Boolean Sfsj;

    @Override
    protected Serializable pkVal() {
        return this.wogylxoid;
    }
    
    
}
