package com.jln.system.web.action.erp.wo.pojo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;

/**
 * @ClassName:  第三方调用接口对ERP的使用-物料清单实体类
 * @Description:
 * @Author:三刀 Date:2021/10/28 14:27
 * Version:1.0
 **/
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "woBomErp",description = "第三方调用接口对ERP的使用-物料清单实体类")
public class WoBomErp {

    @ApiModelProperty(value = "物料清单序号",example = "1")
    private Integer bomxh;

    @ApiModelProperty(value = "发放原则:Y|领料发放；N|定额倒扣",example = "Y")
    private String ffyz="Y";

    @ApiModelProperty(value = "副产品:0，1默认0",example = "0")
    private Integer fcp=0;

    @ApiModelProperty(value = "损耗率",example = "0.05")
    private BigDecimal shlz=BigDecimal.ZERO;

    @ApiModelProperty(value = "物料批号",example = "PH100212312")
    private String wlph;

    @ApiModelProperty(value = "损耗值",example = "1.1")
    private BigDecimal shz=BigDecimal.ZERO;

    @ApiModelProperty(value = "原产品：0,1 默认0",example = "0")
    private Integer ycp=0;

    @ApiModelProperty(value = "备注",example = "0")
    private String bz;

    @ApiModelProperty(value = "需求数量",example = "1560")
    private BigDecimal xqsl;

    @ApiModelProperty(value = "物料编码",example = "FL01")
    private String cInvCode;

    @ApiModelProperty(value = "工序编码",example = "0002")
    private String gxid;

    @ApiModelProperty(value = "订单号",example = "ERP-202110280002")
    private String orderCode;

    /**
     * 2021-11-30 新增字段
     */
    @ApiModelProperty(value = "工序号编码")
    private Integer Gxh;
    @ApiModelProperty(value = "工序号id")
    private Integer Gxhid;
    @ApiModelProperty(value = "工序顺序号")
    private Integer Gxsxh;

    @ApiModelProperty(value = "物料清单行id")
    private Integer fentryId;
}
