package com.jln.system.web.action.erp.wo.pojo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import com.jln.system.web.action.erp.wo.entity.UfcErpWo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @ClassName:  生产订单添加-提供给ERP调用接口的参数
 * @Description:
 * @Author:三刀 Date:2021/10/28 11:11
 * Version:1.0
 **/
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "woErpDto",description = "订单部分提供给ERP调用的实体类")
public class WoErpDto {

    @ApiModelProperty(value = "订单号",example = "ERP-202110280002")
    private String orderCode;

    //-新增字段:(ERP中的生产订单号)
    @ApiModelProperty(value = "源单号",example = "ERP-202110280002")
    private String ydid;

    //-新增字段:(ERP中的订单行号)
    @ApiModelProperty(value = "行号",example = "1")
    private Integer ydhh;

    //-新增字段
    @ApiModelProperty(value = "执行标准",example = "执行新标准")
    private String zxbz;

    //-新增字段
    @ApiModelProperty(value = "订单金额",example = "1580.00")
    private BigDecimal ddje;

    @ApiModelProperty(value = "工厂编码",example = "1017")
    private String gcCode;

    @ApiModelProperty(value = "车间编码",example = "GJ01")
    private String cjCode;

    @ApiModelProperty(value = "订单类型:VP|量产、SM|试产、PP|小批量、RM|改型、RW|返工、RP|返修",example = "VP")
    private String orderType="VP";

    @ApiModelProperty(value = "物料编码",example = "202108")
    private String cInvCode;

    @ApiModelProperty(value = "物料名称 老干妈",example = "202108")
    private String cInvName;

    @ApiModelProperty(value = "订单数量",example = "1203")
    private BigDecimal orderSL;

    @ApiModelProperty(value = "订单状态",example = "默认为I|初始（订单状态:I|初始、F|确认、R|下达、S|暂停；C|完成）")
    private String status="F";

    @ApiModelProperty(value = "计划开工日期",example = "2021-10-28")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate planStDate;

    @ApiModelProperty(value = "计划完工日期",example = "2021-11-28")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate planCpDate;

    @ApiModelProperty(value = "创建日期",example = "2021-11-28 00:00:00")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime createDate;

    @ApiModelProperty(value = "制令号",example = "SN-105121")
    private String zlh;

    @ApiModelProperty(value = "产品工艺路线编码",example = "SN-105121")
    private String cpgyCode;

    //-新增字段
    @ApiModelProperty(value = "ERP修改时间",example = "2021-11-28 00:00:00")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_TIME_PATTERN)
    private LocalDateTime sysUpd;

    /**
     * 2021-11-30 新增字段
     */
    //-新增字段
    @ApiModelProperty(value = "生产计划单号id(erp工序计划单主键)")
    private Integer scjhdherId;
    @ApiModelProperty(value = "源单号id(erp生成订单主键)")
    private Integer ydhId;
    @ApiModelProperty(value = "行号id(erp计划单行号主键)")
    private Integer ydhhId;
    @ApiModelProperty(value = "客户合同号",example = "客户合同号")
    private String Hth;
    @ApiModelProperty(value = "物料id")
    private Long wlId;
    @ApiModelProperty(value = "宏明计划数量")
    private Integer Hmjh;
    @ApiModelProperty(value = "Erp计划数量")
    private Integer Erpjh;
    @ApiModelProperty(value = "表示数据是新增还是修改的标识(MES不需要存储：1为新增，2为修改)")
    private Integer aebj;

    /**
     * 2022-01-06 新增字段
     */
    @ApiModelProperty(value = "生产订单新增参数")
    private UfcErpWo ufcErpWo;

    //-新增字段
    @ApiModelProperty(value = "生产订单备注")
    private String bz;
}
