package com.jln.system.web.action.erp.wo.pojo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jln.common.constant.LocalDateTimeConst;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.time.LocalDate;

/**
 * @ClassName:   订单工艺路线-提供给ERP使用的数据
 * @Description:
 * @Author:三刀 Date:2021/10/28 14:33
 * Version:1.0
 **/
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "wogylxErp",description = "订单工艺路线-提供给ERP使用的数据")
public class WogylxErp {

    @ApiModelProperty(value = "产品工艺路线明细编码",example = "0002")
    private String gxid;

    @ApiModelProperty(value = "产品工艺路线明细名称",example = "为")
    private String gxmc;

    @ApiModelProperty(value = "工序类型:S|首道工序、O|中间工序、M|末道工序",example = "S")
    private String gxlx;

    @ApiModelProperty(value = "关键工序：0,1",example = "0")
    private Integer gjgx=0;

    @ApiModelProperty(value = "上料工序:0,1",example = "0")
    private Integer slgx=0;

    @ApiModelProperty(value = "下料:0、1",example = "0")
    private Integer xlgx=0;

    @ApiModelProperty(value = "测试:0、1",example = "0")
    private Integer csgx=0;

    @ApiModelProperty(value = "设备数",example = "20")
    private BigDecimal sbs=BigDecimal.ZERO;

    @ApiModelProperty(value = "人数",example = "25")
    private BigDecimal rs=BigDecimal.ZERO;

    @ApiModelProperty(value = "排产倍数",example = "2.00")
    private BigDecimal pcbs=BigDecimal.ZERO;

    //需求数量为零的时候自动取订单需求数量
    @ApiModelProperty(value = "需求数量",example = "1520")
    private BigDecimal xqsl;

    @ApiModelProperty(value = "转包工序：0,1",example = "1")
    private Integer zbgx;

    @ApiModelProperty(value = "转包提前期",example = "10.0")
    private BigDecimal zblt=BigDecimal.ZERO;

    @ApiModelProperty(value = "转包成本",example = "25.00")
    private BigDecimal zbcb=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准准备时间(m):10",example = "12")
    private BigDecimal bzzbsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准加工时间(m):10",example = "15")
    private BigDecimal bzjgsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准排队时间(h):10",example = "13")
    private BigDecimal bzpdsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准转移时间(h):10",example = "14")
    private BigDecimal bzzysj=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准等待时间(h):10",example = "17")
    private BigDecimal bzddsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "单件人工费用",example = "21")
    private BigDecimal djrg=BigDecimal.ZERO;

    @ApiModelProperty(value = "单件人工工时(h)",example = "22")
    private BigDecimal rgsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "实际开工日期",example = "2021-10-28")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate sjkgrq;

    @ApiModelProperty(value = "实际完工日期",example = "2021-11-28")
    @JsonFormat(pattern = LocalDateTimeConst.DATE_PATTERN)
    private LocalDate sjwgrq;

    @ApiModelProperty(value = "实际准备时间(m)",example = "21")
    private BigDecimal sjzbsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "实际加工时间(m)",example = "20")
    private BigDecimal sjjgsj=BigDecimal.ZERO;

    @ApiModelProperty(value = "废品损失",example = "20")
    private BigDecimal fpss=BigDecimal.ZERO;

    @ApiModelProperty(value = "废品回收",example = "20")
    private BigDecimal fphs=BigDecimal.ZERO;

    @ApiModelProperty(value = "自动移出:0、1",example = "0")
    private Integer zdyc=0;

    @ApiModelProperty(value = "自动移入:0、1",example = "0")
    private Integer zdyr=0;

    @ApiModelProperty(value = "自动移入:0、1",example = "0")
    private Integer bz=0;

    @ApiModelProperty(value = "状态:I|初始、R|下达、S|暂停；C|完成",example = "I")
    private String zt="F";

    @ApiModelProperty(value = "作业方式 PC、PDA、DCT",example = "PC")
    private String zyfs="PC";

    @ApiModelProperty(value = "采集内容 PD|产能、PD|产能和缺陷",example = "PD")
    private String cjnr="PD";

    @ApiModelProperty(value = "是否批次上料 1是 0不是",example = "false")
    private Boolean isPcsl=false;

    @ApiModelProperty(value = "是否经过本工序",example = "false")
    private Integer jgbgx;

    @ApiModelProperty(value = "关键物料校验",example = "false")
    private Boolean gjwljy=false;

    @ApiModelProperty(value = "合格率预警",example = "false")
    private Boolean hglyj=false;

    @ApiModelProperty(value = "合格率预警阀值",example = "2.2")
    private BigDecimal hglyjfz=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准产量",example = "5.2")
    private BigDecimal bzcl=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准工时",example = "5.2")
    private BigDecimal bzgs=BigDecimal.ZERO;

    @ApiModelProperty(value = "标准人数",example = "10")
    private Integer bzrs=0;

    @ApiModelProperty(value = "订单号",example = "ERP-202110280002")
    private String orderCode;

    /**
     * 2021-11-30 新增字段
     */
    @ApiModelProperty(value = "标准工艺路线明细序号")
    private Integer xh;
    @ApiModelProperty(value = "表体id")
    private Integer Btid;
    @ApiModelProperty(value = "工序id号")
    private Integer Id;
    @ApiModelProperty(value = "顺序号")
    private Integer Sxh;
    @ApiModelProperty(value = "是否首检")
    private Boolean Sfsj;

    /**
     * 2022-1-7 新增字段
     * 工作中心
     */
    private String gzzx;
    /**
     *  工序序列id
     */
    private Integer gxxlid;

    /**
     *  单位编码
     */
    private String dwid;

    /**
     * 2022-2-11 新增字段
     * HMMES是否需要检验
     */
    private Boolean sfjygx;
    /**
     * 是否首检
     */
    private Boolean firstInspectionProcess;
}
