package com.jln.system.web.action.erp.wo.service;


import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.system.web.action.erp.wo.pojo.*;
import com.jln.system.web.action.pp.planImport.pojo.dto.WoDto;

import java.util.List;

/**
 * @ClassName:  订单同步erp数据对外提供接口：初始化订单数据（生成订单物料清单、订单工艺路线、订单数据）
 * @Description:
 * @Author:三刀 Date:2021/10/28 15:37
 * Version:1.0
 **/

public interface WoErpService {

    /**
     * 订单初始化：
     * @param woInitDtoList 订单添加数据
     * @param user  用户信息
     * @return
     */
    Result woInit(List<WoInitDto> woInitDtoList, User user);

    /**
     * 订单初始化:
     * @param woInitDtoList 订单添加数据
     * @param user          用户信息
     * @param isUpdate      是否修改方法
     * @return
     */
    Result woInit(List<WoInitDto> woInitDtoList, User user, Boolean isUpdate);

    /**
     * 订单修改-会重置 工艺路线、物料清单数据
     * @param woInitDtoList 订单修改数据
     * @param user   用户信息
     * @return
     */
    Result orderModify(List<WoInitDto> woInitDtoList, User user);

    /**
     *  删除订单号
     * @param codeList 订单编码
     * @return
     */
    Result removeOrder(List<String> codeList);

    /**
     * 修改订单物料清单数据
     * @param woBomErp  订单物料清单
     * @param user  用户信息
     * @return
     */
    Result materialsModify(WoBomErp woBomErp, User user);

    /**
     * 修改订单工艺路线数据
     * @param wogylxErp  订单工艺路线
     * @param user   用户数据
     * @return
     */
    Result processRouteModify(WogylxErp wogylxErp, User user);

    /**
     * 订单工艺路线删除接口
     * @param wogylxRemoves
     * @return
     */
    Result processRouteRemove(List<WogylxRemove> wogylxRemoves);


    /**
     * 订单物料清单删除接口
     * @param wogylxRemoves
     * @return
     */
    Result materialsRemove(List<WobomRemove> wogylxRemoves);

    /**
     * 获取辅助属性精度、质量等级
     * @param type 查询类型
     * @return
     */
    Result getFzsx(String type);

    /**
     * 保存
     * @param wo
     * @param user
     * @return
     */
    Result saveWo(WoDto wo, User user);

    Boolean getErpWoInfo(List<String> woid);

    Result erpDelWo(List<String> woid);
}
