package com.jln.system.web.action.erp.wo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.jln.common.entity.Result;
import com.jln.common.enums.ResultCodeEnum;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.erp.wo.entity.WoExpand;
import com.jln.system.web.action.erp.wo.mapper.WoExpandMapper;
import com.jln.system.web.action.erp.wo.pojo.UfcErpProductDetailVo;
import com.jln.system.web.action.erp.wo.pojo.UfcErpProductMainVo;
import com.jln.system.web.action.erp.wo.pojo.UfcErpSl;
import com.jln.system.web.action.erp.wo.service.UfcErpProductService;
import com.jln.system.web.action.erp.wo.service.WoExpandService;
import com.jln.system.web.action.ps.production.service.PsWbService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;

@Service
public class UfcErpProductServiceImpl implements UfcErpProductService {

    @Autowired
    private WoExpandService woExpandService;

    @Autowired
    private PsWbService psWbService;

    @Autowired
    private WoExpandMapper woExpandMapper;

    @Override
    public Result getStartWorkNumber(String woid) {
        if (EmptyUtil.isEmpty(woid)){
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }
        //
        WoExpand woExpand = woExpandService.getOne(new LambdaQueryWrapper<WoExpand>().eq(WoExpand::getWoid, woid));
        UfcErpProductMainVo ufcErpProductMainVo = new UfcErpProductMainVo();
        BeanUtils.copyProperties(woExpand,ufcErpProductMainVo);

        List<UfcErpProductDetailVo> ufcErpProductDetailVo = woExpandMapper.getStartWorkNumber(woExpand.getWooid());
        BigDecimal mdgx = woExpandMapper.getMdgxSl(ufcErpProductDetailVo.get(ufcErpProductDetailVo.size()-1).getGxid(),woExpand.getWooid());
        ufcErpProductDetailVo.get(ufcErpProductDetailVo.size()-1).setKgsl(mdgx);
        List<UfcErpSl> ufcErpSl = woExpandMapper.getSl(woExpand.getWooid());
        if (!EmptyUtil.isEmpty(ufcErpProductDetailVo)){
            for (int i = 0; i < ufcErpProductDetailVo.size(); i++) {
                if (!EmptyUtil.isEmpty(ufcErpSl.get(i))){
                    ufcErpProductDetailVo.get(i).setHmzzsl(ufcErpProductDetailVo.get(i).getKgsl().subtract(ufcErpSl.get(i).getYfksl()));
                    if (ufcErpSl.get(i).getZzsl().compareTo(BigDecimal.valueOf(0)) <= 0){
                        ufcErpProductDetailVo.get(i).setZzsl(BigDecimal.valueOf(0));
                    }else {
                        ufcErpProductDetailVo.get(i).setZzsl(ufcErpSl.get(i).getZzsl());
                    }
                }
            }
        }
        ufcErpProductDetailVo.forEach(ufcErpProductDetailVo1 -> {
            if (EmptyUtil.isEmpty(ufcErpProductDetailVo1.getZzsl())){
                ufcErpProductDetailVo1.setZzsl(BigDecimal.valueOf(0));
            }
            if (EmptyUtil.isEmpty(ufcErpProductDetailVo1.getHmzzsl())){
                ufcErpProductDetailVo1.setHmzzsl(ufcErpProductDetailVo1.getKgsl());
            }
        });
        ufcErpProductMainVo.setUfcErpProductDetailVo(ufcErpProductDetailVo);
        return new Result().toSuccess(ufcErpProductMainVo);
    }
}
