package com.jln.system.web.action.erp.wo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.IsDeleteEnum;
import com.jln.common.enums.WorkOderEnum;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.EmptyUtil;
import com.jln.common.utils.JacksonUtil;
import com.jln.common.utils.JsonUtils;
import com.jln.common.utils.SnowflakeIdUtils;
import com.jln.system.web.action.bm.B_Material.entity.BMaterial;
import com.jln.system.web.action.bm.B_Material.service.BMaterialService;
import com.jln.system.web.action.bm.factory.entity.BFactory;
import com.jln.system.web.action.bm.factory.service.BFactoryService;
import com.jln.system.web.action.bm.productprocess.entity.BProductprocess;
import com.jln.system.web.action.bm.productprocess.entity.BProductprocessdetail;
import com.jln.system.web.action.bm.productprocess.service.BProductprocessService;
import com.jln.system.web.action.bm.productprocess.service.BProductprocessdetailService;
import com.jln.system.web.action.bm.standardprocess.entity.BStandardprocess;
import com.jln.system.web.action.bm.standardprocess.service.BStandardprocessService;
import com.jln.system.web.action.bm.workshop.entity.BWorkshop;
import com.jln.system.web.action.bm.workshop.service.BWorkshopService;
import com.jln.ufc.web.action.entity.ResultUfc;
import com.jln.ufc.web.action.enums.UfcResultCodeEnum;
import com.jln.system.web.action.erp.wo.entity.*;
import com.jln.system.web.action.erp.wo.pojo.*;
import com.jln.system.web.action.erp.wo.service.*;
import com.jln.system.web.action.pp.planImport.entity.Wo;
import com.jln.system.web.action.pp.planImport.pojo.dto.WoDto;
import com.jln.system.web.action.pp.planImport.service.WoService;
import com.jln.system.web.action.pp.proPrepare.entity.PpTechnologicalWogylx;
import com.jln.system.web.action.pp.proPrepare.entity.Wobom;
import com.jln.system.web.action.pp.proPrepare.service.PpTechnologicalWogylxService;
import com.jln.system.web.action.pp.proPrepare.service.WobomService;
import com.jln.system.web.action.ps.production.entity.PsWs;
import com.jln.system.web.action.ps.production.service.PsWsService;
import com.jln.system.web.action.util.ERPHttpUtils;
import com.jln.system.web.action.util.ERPParam;
import com.jln.system.web.action.util.FzsxType;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.*;
import java.util.stream.Collectors;



/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2021/10/28 15:39
 * Version:1.0
 **/
@Slf4j
@Service
public class WoErpServiceImpl implements WoErpService {

    /**
     * 工厂业务逻辑层
     */
    @Autowired
    private BFactoryService bFactoryService;

    /**
     * 车间业务逻辑层
     */
    @Autowired
    private BWorkshopService bWorkshopService;

    /**
     * 物料业务逻辑层
     */
    @Autowired
    private BMaterialService bMaterialService;

    /**
     * 订单工艺路线业务逻辑层
     */
    @Autowired
    private BProductprocessService bProductprocessService;

    /**
     * 标准工序业务逻辑处理
     */
    @Autowired
    private BStandardprocessService bStandardprocessService;

    /**
     * 产品工艺路线明细逻辑处理
     */
    @Autowired
    private BProductprocessdetailService bProductprocessdetailService;

    /**
     * 订单业务逻辑层
     */
    @Autowired
    private WoService woService;

    /**
     * 订单物料清单逻辑层
     */
    @Autowired
    private WobomService wobomService;

    /**
     * 订单工艺路线业务逻辑层
     */
    @Autowired
    private ErpWogylxServiceImpl erpWogylxService;

    @Autowired
    private WoExpandService woExpandService;

    @Autowired
    private UfcErpWoService ufcErpWoService;
    @Autowired
    private UfcErpPpTechnologicalWogylxService ufcErpPpTechnologicalWogylxService;
    @Autowired
    private PsWsService psWsService;
    /**
     * 订单工艺路线-流程节点数据
     */
    @Autowired
    private PpTechnologicalWogylxService ppTechnologicalWogylxService;

    @Value("${topPid}")
    private Long topPid;

    private ArrayList<PpTechnologicalWogylx> recursion(List<PpTechnologicalWogylx> result1Data,Long oid,ArrayList<PpTechnologicalWogylx> list){

        if(EmptyUtil.isEmpty(oid)){
            Optional<PpTechnologicalWogylx> optional = result1Data.stream().filter(item -> item.getTechnologicalProcessPid().toString().equals(String.valueOf(topPid))).findFirst();
            list.add(optional.get());
            recursion(result1Data,optional.get().getTechnologicalProcessOid(),list);
        }else{
            Optional<PpTechnologicalWogylx> optional = result1Data.stream().filter(item -> item.getTechnologicalProcessPid().toString().equals(String.valueOf(oid))).findFirst();
            if (optional.isPresent()) {
                // 存在
                list.add(optional.get());
                recursion(result1Data,optional.get().getTechnologicalProcessOid(),list);
            } else {
                // 不存在
                return list;
            }
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result woInit(List<WoInitDto> woInitDtoList, User user,Boolean isUpdate) {
        if(EmptyUtil.isEmpty(woInitDtoList)){
            return new Result().toFailure("请传递值!");
        }
        List<Wo> woList=new ArrayList<>();
        List<Wogylx> wogylxList=new ArrayList<>();
        List<Wobom> wobomList=new ArrayList<>();
        List<PpTechnologicalWogylx> ppTechnologicalWogylxes=new ArrayList<>();
        List<WoExpand> expandList=new ArrayList<>();
        List<UfcErpWo> ufcErpWos=new ArrayList<>();
        //订单修改情况的时候-将当前订单相关的数据删除掉
        List<Long> udpateWoDis=new ArrayList<>();
        for (WoInitDto woInitDto : woInitDtoList) {
            //根据订单编码查询订单数据 如果订单编码存在则先删除相关数据
            LambdaQueryWrapper<Wo> woQueryWrapper = new LambdaQueryWrapper<>();
            woQueryWrapper.eq(Wo::getWoid,woInitDto.getOrderCode());
            woQueryWrapper.eq(Wo::getDel,false);
            Wo checkWo = woService.getBaseMapper().selectOne(woQueryWrapper);

            if(!EmptyUtil.isEmpty(checkWo)){
                try {
                    //删除订单扩展表 wo_expand 数据
                    LambdaUpdateWrapper<WoExpand> woExpandQueryWrapper = new LambdaUpdateWrapper<>();
                    woExpandQueryWrapper.eq(WoExpand::getWoid,woInitDto.getOrderCode());
                    woExpandService.getBaseMapper().delete(woExpandQueryWrapper);

                    //删除订单扩展表 ufc_erp_wo 数据
                    LambdaUpdateWrapper<UfcErpWo> ufcErpWoQueryWrapper = new LambdaUpdateWrapper<>();
                    ufcErpWoQueryWrapper.eq(UfcErpWo::getWoFk,checkWo.getWooid());
                    ufcErpWoService.getBaseMapper().delete(ufcErpWoQueryWrapper);

                    //删除订单物料清单 wobom 数据
                    //LambdaUpdateWrapper<Wobom> wobomQueryWrapper = new LambdaUpdateWrapper<>();
                    //wobomQueryWrapper.in(Wobom::getWoFk,checkWo.getWooid());
                    int i = ufcErpPpTechnologicalWogylxService.delWoBom(checkWo.getWooid());

                    //根据订单外键查询工序节点数据
                    LambdaQueryWrapper<PpTechnologicalWogylx> ppTechnologicalWogylxWrapper=new LambdaQueryWrapper<>();
                    ppTechnologicalWogylxWrapper.eq(PpTechnologicalWogylx::getProcessRouteFk,checkWo.getWooid());
                    List<PpTechnologicalWogylx> list = ppTechnologicalWogylxService.getBaseMapper().selectList(ppTechnologicalWogylxWrapper);
                    //从list集合中，取出字段technologicalProcessOid的列表
                    List<Long> technologicalProcessOid = list.stream().map(p -> p.getTechnologicalProcessOid()).collect(Collectors.toList());
                    //删除工序节点 pp_technological_wogylx 数据
                    ppTechnologicalWogylxService.getBaseMapper().deleteBatchIds(technologicalProcessOid);

                    //删除工序扩展表 ufc_erp_pp_technological_wogylx 数据
                    //LambdaUpdateWrapper<UfcErpPpTechnologicalWogylx> ufcErpPpTechnologicalWogylxUpdateWrapper = new LambdaUpdateWrapper<>();
                    //ufcErpPpTechnologicalWogylxUpdateWrapper.in(UfcErpPpTechnologicalWogylx::getPpTechnologicalWogylxFk,technologicalProcessOid);
                    //ufcErpPpTechnologicalWogylxService.getBaseMapper().delete(ufcErpPpTechnologicalWogylxUpdateWrapper);
                    ufcErpPpTechnologicalWogylxService.del(technologicalProcessOid);

                    //删除工序 wogylx 数据
                    //LambdaUpdateWrapper<Wogylx> wogylxQueryWrapper = new LambdaUpdateWrapper<>();
                    //wogylxQueryWrapper.in(Wogylx::getWoFk,checkWo.getWooid());
                    //erpWogylxService.getBaseMapper().delete(wogylxQueryWrapper);
                    ufcErpPpTechnologicalWogylxService.delWogylx(checkWo.getWooid());

                    //删除订单 wo  数据
                    //woService.getBaseMapper().deleteById(checkWo.getWooid());
                    ufcErpPpTechnologicalWogylxService.delWo(checkWo.getWooid());
                }catch (Exception e){
                    throw new CustomException(-1, "数据删除失败！");
                }

            }
                isUpdate=false;
                Result<Wo> result = disposeWo(woInitDto, user);
                UfcErpWo ufcErpWo = new UfcErpWo();
                BeanUtils.copyProperties(woInitDto.getUfcErpWo(),ufcErpWo);
                ufcErpWo.setUfcErpWoOid(SnowflakeIdUtils.generate());
                ufcErpWo.setCpgyCode(woInitDto.getCpgyCode());
                ufcErpWo.setMxPh(woInitDto.getUfcErpWo().getMxPh());
                ufcErpWo.setMxZldjMc(woInitDto.getUfcErpWo().getMxZldjMc());
                ufcErpWo.setMxJdmc(woInitDto.getUfcErpWo().getMxJdmc());
                ufcErpWo.setMxZxbzMc(woInitDto.getUfcErpWo().getMxZxbzMc());
                ufcErpWo.setMxWdxsMc(woInitDto.getUfcErpWo().getMxWdxsMc());
                ufcErpWo.setDjtShrMc(woInitDto.getUfcErpWo().getDjtShrMc());
                ufcErpWos.add(ufcErpWo);
                if(!result.confirmSuccess()){
                    return result.setMsg(result.getMsg()+" 异常的订单号为：["+woInitDto.getOrderCode()+"]");
                }
                //TODO 需要在订单数据中-控制订单号不允许重复
                Result<Long> generate=processingData(woInitDto.getOrderCode(),isUpdate);
                if(!generate.confirmSuccess()){
                    return generate;
                }
                //记录修改订单的主键
                if(isUpdate){
                    udpateWoDis.add(generate.getData());
                }
                Wo data = result.getData();
                data.setWooid(generate.getData());
                ufcErpWo.setWoFk(generate.getData());
                WoExpand expandResult = disposeWoExpand(woInitDto, data.getWooid());
                expandList.add(expandResult);
                List<Wogylx> list=null;
                //TO-DO -未生存工艺节点信息数据
                //排序
                List<WogylxErp> wogylxErpShort=woInitDto.getWogylxList().stream().sorted(Comparator.comparing(WogylxErp::getSxh)).collect(Collectors.toList());
                Result<List<PpTechnologicalWogylx>> listResult1 = disposePpTechnologicalWogylx(wogylxErpShort, data.getWooid());
                if(listResult1.confirmSuccess()){
                    List<PpTechnologicalWogylx> result1Data = listResult1.getData();
                    ppTechnologicalWogylxes.addAll(result1Data);
                    Map<String, PpTechnologicalWogylx> wogylxMap=result1Data.stream().collect(Collectors.toMap(PpTechnologicalWogylx::getNodeCode, wogylx -> wogylx, (key1, key2) -> key1));
                    //处理工艺路线数据
                    //TODO 未处理-订单工艺路线工序编码唯一
                    Result<List<Wogylx>> listResult = disposeWogylx(woInitDto.getWogylxList(), user, data.getWooid(),data.getWoid(), data.getBProductprocessFk(),result1Data);
                    if(!listResult.confirmSuccess()){
                        return listResult.setMsg(listResult.getMsg()+" 异常的订单号为：["+woInitDto.getOrderCode()+"]");
                    }
                    list = listResult.getData();
                }
                Map<String, Wogylx> wogylxMap=null;
                if(!EmptyUtil.isEmpty(list)){
                    wogylxList.addAll(list);
                    wogylxMap = list.stream().collect(Collectors.toMap(Wogylx::getGxid, wogylx -> wogylx, (key1, key2) -> key1));
                }
                //处理订单物料清单数据
                //TODO 未处理-订单物料清单 序号唯一
                Result<List<Wobom>> woBom = disposeWoBom(woInitDto.getWobomList(), user, data.getWooid(),data.getWoid(), wogylxMap);
                if(!woBom.confirmSuccess()){
                    return woBom.setMsg(woBom.getMsg()+" 异常的订单号为：["+woInitDto.getOrderCode()+"]");
                }
                List<Wobom> bomData = woBom.getData();
                if(!EmptyUtil.isEmpty(bomData)){
                    wobomList.addAll(bomData);
                }
                //将需要添加的数据订单数据保存添加队列中
                woList.add(data);
        }
        log.error("订单添加数据："+ JacksonUtil.toString(woList));
        log.error("订单物料清单添加数据："+ JacksonUtil.toString(wobomList));
        log.error("订单工艺路线添加数据："+ JacksonUtil.toString(wogylxList));
        log.error("订单工艺路线节点添加数据："+ JacksonUtil.toString(ppTechnologicalWogylxes));
        if(!isUpdate){
            //执行添加数据
            if(!EmptyUtil.isEmpty(woList)){
                boolean batch = this.woService.saveBatch(woList);
                if(!batch){
                    return new Result().toFailure("添加订单失败!");
                }
            }
        }else {
            //执行修改数据
            if(!EmptyUtil.isEmpty(woList)){
                boolean batch = this.woService.updateBatchById(woList);
                if(!batch){
                    return new Result().toFailure("添加订单失败!");
                }
            }
            removeWoCorrelation(udpateWoDis);
        }

        if(!EmptyUtil.isEmpty(wogylxList)){
            boolean batch = this.erpWogylxService.saveBatch(wogylxList);
            if(!batch){
                return new Result().toFailure("添加订单工艺路线失败!");
            }
        }
        if(!EmptyUtil.isEmpty(wobomList)){
            boolean batch = this.wobomService.saveBatch(wobomList);
            if(!batch){
                return new Result().toFailure("添加订单物料清单失败!");
            }
        }
        if(!EmptyUtil.isEmpty(ppTechnologicalWogylxes)){
            boolean batch = this.ppTechnologicalWogylxService.saveBatch(ppTechnologicalWogylxes);
            if(!batch){
                return new Result().toFailure("添加订单工艺路线失败!");
            }
        }
        //订单拓展数据
        if(!EmptyUtil.isEmpty(expandList)){
            boolean batch = this.woExpandService.saveBatch(expandList);
            if(!batch){
                return new Result().toFailure("添加订单数据失败!");
            }
        }
        //订单扩展数据
        if(!EmptyUtil.isEmpty(ufcErpWos)){
            boolean batch = ufcErpWoService.saveBatch(ufcErpWos);
            if(!batch){
                return new Result().toFailure("添加订单数据失败!");
            }
        }
        return new Result().toSuccess();
    }

    @Override
    public Result woInit(List<WoInitDto> woInitDtoList, User user) {
        return woInit(woInitDtoList,user,false);
    }

    /**
     * 订单修改-会重置 工艺路线、物料清单数据
     * @param woInitDtoList 订单修改数据
     * @param user   用户信息
     * @return
     */
    @Override
    public Result orderModify(List<WoInitDto> woInitDtoList, User user) {
        return woInit(woInitDtoList,user,true);
    }

    @Override
    public Result removeOrder(List<String> codeList) {
        if(EmptyUtil.isEmpty(codeList)){
            return new Result().toFailure("请传递需要删除的数据!");
        }
        //通过订单编码查询出符合条件的订单数据
        LambdaQueryWrapper<Wo> wrapper=new LambdaQueryWrapper<>();
        wrapper.in(Wo::getWoid,codeList);
        wrapper.select(Wo::getWooid,Wo::getZt,Wo::getWoid);
        List<Wo> woList = this.woService.getBaseMapper().selectList(wrapper);
        if(EmptyUtil.isEmpty(woList)){
            return new Result().toFailure("当前选择需要删除的订单数据在本系统中不存在!");
        }
        List<Long> removeId=new ArrayList<>();
        for (Wo wo : woList) {
            Long wooid = wo.getWooid();
            //订单状态为 I或者F可以删除
            if(WorkOderEnum.CONFIRM.getValue().equals(wo.getZt())||WorkOderEnum.INITAL.getValue().equals(wo.getZt())){
                removeId.add(wooid);
            }else {
                Result toFailure = new ResultUfc<>().toFailure(UfcResultCodeEnum.ERPERROR30011);
                toFailure.setMsg(toFailure.getMsg()+" 异常数据：订单号["+wo.getWoid()+"]-状态：["+wo.getZt()+"]").setData(wo.getZt());
                return toFailure;
            }

        }
        //执行删除订单逻辑
        boolean byIds = woService.removeByIds(removeId);
        if(!byIds){
            return new ResultUfc().toFailure(UfcResultCodeEnum.ERPERROR30012);
        }
        //执行删除订单相关数据逻辑
        removeWoCorrelation(removeId);
        return new Result().toSuccess();
    }

    @Override
    public Result materialsModify(WoBomErp woBomErp, User user) {
        //第一步：参数校验
        if(EmptyUtil.isEmpty(woBomErp)){
            return new Result().toFailure("请传递参数!");
        }
        if(EmptyUtil.isEmpty(woBomErp.getOrderCode())){
            return new Result().toFailure("请指定订单号数据!");
        }
        if(EmptyUtil.isEmpty(woBomErp.getBomxh())){
            return new Result().toFailure("请指定物料序号!");
        }
        //通过订单加序号定位到物料编码数据，执行物料编码的修改
        LambdaQueryWrapper<Wobom> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(Wobom::getWoid,woBomErp.getOrderCode());
        wrapper.eq(Wobom::getBomxh,woBomErp.getBomxh());
        wrapper.select(Wobom::getWobomoid);
        List<Wobom> one = this.wobomService.getBaseMapper().selectList(wrapper);
        if(EmptyUtil.isEmpty(one)){
            return new Result().toFailure("订单号：["+woBomErp.getOrderCode()+"] 物料清单序号:["+woBomErp.getBomxh()+"] 对应的订单物料清单数据在系统中不存在!");
        }
        Map<String,Wogylx> wogylxMap=new HashMap<>();
        if(!EmptyUtil.isEmpty(woBomErp.getGxid())){
            LambdaQueryWrapper<Wogylx> queryWrapper=new LambdaQueryWrapper<>();
            queryWrapper.eq(Wogylx::getWoid,woBomErp.getOrderCode());
            queryWrapper.eq(Wogylx::getGxid,woBomErp.getGxid());
            List<Wogylx> wogylxList = this.erpWogylxService.getBaseMapper().selectList(queryWrapper);
            if(!EmptyUtil.isEmpty(wogylxList)){
                wogylxMap.put(wogylxList.get(0).getGxid(),wogylxList.get(0));
            }
        }
        Result<Wobom> result = disposeWoBomOne(woBomErp, user, wogylxMap);
        if(!result.confirmSuccess()){
            return result;
        }
        Wobom data = result.getData();
        data.setWobomoid(one.get(0).getWobomoid());
        boolean byId = this.wobomService.updateById(data);
        if(!byId){
            return new Result().toFailure("修改物料清单数据失败!");
        }
        return new Result().toSuccess();
    }

    @Override
    public Result processRouteModify(WogylxErp wogylxErp, User user) {
        //第一步：参数校验
        if(EmptyUtil.isEmpty(wogylxErp)){
            return new Result().toFailure("请传递参数!");
        }
        if(EmptyUtil.isEmpty(wogylxErp.getOrderCode())){
            return new Result().toFailure("请指定订单号数据!");
        }
        if(EmptyUtil.isEmpty(wogylxErp.getGxid())){
            return new Result().toFailure("请指定工序号数据!");
        }
        //第二步：通过工序号+订单号 定位到订单工艺路线数据
        LambdaQueryWrapper<Wogylx> wrapper=new LambdaQueryWrapper<>();
        wrapper.select(Wogylx::getWogylxoid);
        wrapper.eq(Wogylx::getGxid,wogylxErp.getGxid());
        wrapper.eq(Wogylx::getWoid,wogylxErp.getOrderCode());
        List<Wogylx> list = this.erpWogylxService.getBaseMapper().selectList(wrapper);
        if(EmptyUtil.isEmpty(list)){
            return new Result().toFailure("订单号：["+wogylxErp.getOrderCode()+"] 工序号:["+wogylxErp.getGxid()+"] 对应的订单物料工艺路线在系统中不存在!");
        }
        Result<UfcWogylx> result = disposeWogylxOne(wogylxErp, user,null);
        if(!result.confirmSuccess()){
            return result;
        }
        Wogylx data = new Wogylx();
        BeanUtils.copyProperties(result.getData(),data);
        //工序信息不能修改
        data.setBStandardprocessFk(null);
        data.setBProductprocessdetailFk(null);
        Wogylx wogylx = data.setWogylxoid(list.get(0).getWogylxoid());
        boolean updateById = this.erpWogylxService.updateById(wogylx);
        if(!updateById){
            return new Result().toFailure("修改工艺路线数据失败!");
        }
        return new Result().toSuccess();
    }

    @Override
    public Result processRouteRemove(List<WogylxRemove> wogylxRemoves) {
        if(EmptyUtil.isEmpty(wogylxRemoves)){
            return new Result().toFailure("请传递数据!");
        }
        for (WogylxRemove remove : wogylxRemoves) {
            if(EmptyUtil.isEmpty(remove.getGxid())){
                return new Result().toFailure("删除时必须传递工序号!");
            }
            if(EmptyUtil.isEmpty(remove.getOrderCode())){
                return new Result().toFailure("删除时必须传递订单号!");
            }
        }
        //删除数据-异常数据
        List<WogylxRemove> errorList=new ArrayList<>();
        for (WogylxRemove remove : wogylxRemoves) {
            LambdaQueryWrapper<Wogylx> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(Wogylx::getWoid,remove.getOrderCode());
            wrapper.eq(Wogylx::getGxid,remove.getGxid());
            boolean remove1 = this.erpWogylxService.remove(wrapper);
            if(!remove1){
                errorList.add(remove);
            }
        }
        if(!EmptyUtil.isEmpty(errorList)){
            return new Result().toWarr("删除的数据中有部分数据不存在系统中，详情见返回数据的data字段!").setData(errorList);
        }
        return new Result().toSuccess();
    }

    @Override
    public Result materialsRemove(List<WobomRemove> wogylxRemoves) {
        if(EmptyUtil.isEmpty(wogylxRemoves)){
            return new Result().toFailure("请传递数据!");
        }
        for (WobomRemove remove : wogylxRemoves) {
            if(EmptyUtil.isEmpty(remove.getBomxh())){
                return new Result().toFailure("删除时必须物料清单序号!");
            }
            if(EmptyUtil.isEmpty(remove.getOrderCode())){
                return new Result().toFailure("删除时必须传递订单号!");
            }
        }
        //删除数据-异常数据
        List<WobomRemove> errorList=new ArrayList<>();
        for (WobomRemove remove : wogylxRemoves) {
            LambdaQueryWrapper<Wobom> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(Wobom::getWoid,remove.getOrderCode());
            wrapper.eq(Wobom::getBomxh,remove.getBomxh());
            boolean remove1 = this.wobomService.remove(wrapper);
            if(!remove1){
                errorList.add(remove);
            }
        }
        if(!EmptyUtil.isEmpty(errorList)){
            return new Result().toWarr("删除的数据中有部分数据不存在系统中，详情见返回数据的data字段!").setData(errorList);
        }
        return new Result().toSuccess();
    }

    /**
     * 处理 订单修改数据
     * @param woid  订单号
     * @param isUpdate  是否修改
     * @return
     */
    private Result<Long> processingData(String woid,Boolean isUpdate){
        if(EmptyUtil.isEmpty(woid)){
            return new Result<>().toFailure("订单号不能为空!");
        }
        if(!isUpdate){
            //添加方法，直接返回主键
            return new Result<Long>().toSuccess(SnowflakeIdUtils.generate());
        }
        //修改方法，先判订单号对应的订单数据是否存在
        LambdaQueryWrapper<Wo> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(Wo::getWoid,woid);
        wrapper.select(Wo::getWooid,Wo::getZt);
        List<Wo> woList = this.woService.getBaseMapper().selectList(wrapper);
        if(EmptyUtil.isEmpty(woList)){
            return new Result<>().toFailure("订单号有误，当前订单号["+woid+"] 不存在本系统中!");
        }
        if(woList.size()!=1){
            return new Result<>().toFailure("系统异常：当前订单号["+woid+"]存在多条数据!,请联系管理员处理!");
        }
        Wo wo = woList.get(0);
        //订单状态为 I或者F可以修改
        if(WorkOderEnum.CONFIRM.getValue().equals(wo.getZt())||WorkOderEnum.INITAL.getValue().equals(wo.getZt())){
            return new Result<Long>().toSuccess(wo.getWooid());
        }
        Result toFailure = new ResultUfc<>().toFailure(UfcResultCodeEnum.ERPERROR30010);
        toFailure.setMsg(toFailure.getMsg()+" 异常数据：订单号["+woid+"]-状态：["+wo.getZt()+"]").setData(wo.getZt());
        return toFailure;

    }

    /**
     * 处理订单数据
     * @param user 用户数据
     * @param woInitDto 订单数据
     */
    private Result<Wo> disposeWo(WoInitDto woInitDto,User user){
        Wo wo=new Wo();
        if(EmptyUtil.isEmpty(woInitDto)){
            return new Result<>().toFailure("不能传递数据为空");
        }
        //TO-DO 第一步：处理订单生产数据，需要处理的部分如下：
        //1.工厂编码替换为工厂主键
        Long aLong = disposeFactory(woInitDto.getGcCode());
        if(EmptyUtil.isEmpty(aLong)){
            //请推送对应单位之后在同步订单
            return new Result<>().toFailure("请推送对应组织之后在同步订单:对应组织编码["+woInitDto.getGcCode()+"]").setCode(1000690);
        }
        wo.setBFactoryFk(aLong);
        //2.车间编码替换为车间主键
        Long shop = disposeWorkShop(woInitDto.getCjCode(),aLong);
        wo.setBWorkshopFk(shop);
        //3.物料编码替换为物料主键 根据物料编码,工厂编码查询物料主键

        Long wloid =  selectMaterial(woInitDto.getCInvCode(),woInitDto.getGcCode());
        Long disposeMaterial = disposeMaterial(woInitDto.getCInvCode());
        if(EmptyUtil.isEmpty(wloid)){
            //请推送对应单位之后在同步订单
            return new Result<>().toFailure("请推送对应物料之后在同步订单:对应物料编码["+woInitDto.getCInvCode()+"]").setCode(1000687);
        }
        wo.setBMaterialFk(wloid);
        //4.产品工艺路线编码替换为产品工艺路线
        Long process = disposeProcess(woInitDto.getCpgyCode(),aLong);
        wo.setBProductprocessFk(process);
        //TO-DO 第二步：填充数据:源订单号、行号、执行标准、订单金额，ERP修改时间-未处理
        if(EmptyUtil.isEmpty(woInitDto.getOrderCode())){
            return new Result<>().toFailure("订单号必填!");
        }
        wo.setWoid(woInitDto.getOrderCode());
        //订单类型
        wo.setLx(woInitDto.getOrderType());
        if(EmptyUtil.isEmpty(woInitDto.getOrderSL())){
            return new Result<>().toFailure("请指定订单数量!");
        }
        wo.setXqsl(new BigDecimal(woInitDto.getHmjh()));
        //订单状态
        if(!EmptyUtil.isEmpty(woInitDto.getStatus())){
            wo.setZt(woInitDto.getStatus());
        }else {
            wo.setZt(WorkOderEnum.CONFIRM.getValue());
        }
        if(EmptyUtil.isEmpty(woInitDto.getPlanStDate())){
            return new Result<>().toFailure("请指定计划开工日期!");
        }
        wo.setJhkgrq(woInitDto.getPlanStDate());
        if(EmptyUtil.isEmpty(woInitDto.getPlanCpDate())){
            return new Result<>().toFailure("请指定计划完工日期!");
        }
        wo.setJhwgrq(woInitDto.getPlanCpDate());
        wo.setSysCreated(LocalDateTime.now());
        if(!EmptyUtil.isEmpty(woInitDto.getCreateDate())){
            wo.setSysCreated(woInitDto.getCreateDate());
        }
        wo.setZlh(woInitDto.getZlh());
        wo.setSysLastUpdBy(user.getEmployeeOid());
        wo.setSysLastUpd(LocalDateTime.now());
        wo.setSysCreated(LocalDateTime.now());
        wo.setSysCreatedBy(user.getEmployeeOid());
        wo.setDel(IsDeleteEnum.NotDelete.getStatus());
        wo.setQrrq(LocalDate.now());
        wo.setQrr(user.getEmployeeOid());
        wo.setScfs("IM");
        wo.setReleaseControlType("1");
        wo.setBz(woInitDto.getBz());
        return new Result<Wo>().toSuccess(wo);

    }

    /**
     * 查询物料主键
     * @param cInvCode 物料编码
     * @param gcCode  工厂编码
     * @return
     */
    private Long selectMaterial(String cInvCode, String gcCode) {
        //根据工厂编码查询工厂主键
        LambdaQueryWrapper<BFactory> bFactoryLambdaQueryWrapper=new LambdaQueryWrapper<>();
        bFactoryLambdaQueryWrapper.eq(BFactory::getGcid,gcCode);
        bFactoryLambdaQueryWrapper.eq(BFactory::getDel,false);
        BFactory bfactory = null;
        try {
            bfactory = bFactoryService.getBaseMapper().selectOne(bFactoryLambdaQueryWrapper);
        }catch (Exception e){
            return null;
        }
        if(EmptyUtil.isEmpty(bfactory)){
            log.error("工厂编码:["+gcCode+"]-没有查询出值");
            return null;
        }
        //根据物料编码 、 工厂主键 查询物料
        LambdaQueryWrapper<BMaterial> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(BMaterial::getWlid,cInvCode);
        wrapper.eq(BMaterial::getDefaultFactoryFk,bfactory.getBFactoryoid());
        wrapper.select(BMaterial::getBMaterialoid);
        wrapper.last("LIMIT 1");
        BMaterial one = this.bMaterialService.getOne(wrapper);
        if(!EmptyUtil.isEmpty(one)){
            return one.getBMaterialoid();
        }
        log.error("物料编码:["+cInvCode+"]-没有查询出值");
        return null;
    }

    /**
     *  删除订单相关信息：
     *     1.订单工艺路线
     *     2.订单物料清单
     *     3.订单工艺节点
     *     4.订单拓展表
     * @param woList
     * @return
     */
    private void removeWoCorrelation(List<Long> woList){
        if(EmptyUtil.isEmpty(woList)){
            return;
        }
        //1.删除订单物料清单数据
        LambdaQueryWrapper<Wobom> wrapper=new LambdaQueryWrapper<>();
        wrapper.in(Wobom::getWoFk,woList);
        wobomService.remove(wrapper);
        //2.删除订单工艺路线数据
        LambdaQueryWrapper<Wogylx> wogylxWrapper=new LambdaQueryWrapper<>();
        wogylxWrapper.in(Wogylx::getWoFk,woList);
        erpWogylxService.remove(wogylxWrapper);
        //3.删除订单工艺节点数据
        LambdaQueryWrapper<PpTechnologicalWogylx> pWogylxWrapper=new LambdaQueryWrapper<>();
        pWogylxWrapper.in(PpTechnologicalWogylx::getProcessRouteFk,woList);
        ppTechnologicalWogylxService.remove(pWogylxWrapper);
        //4.删除订单拓展表数据
        LambdaQueryWrapper<WoExpand>  woExpandWrapper=new LambdaQueryWrapper<>();
        woExpandWrapper.in(WoExpand::getWooid,woList);
        woExpandService.remove(woExpandWrapper);
    }

    /**
     * 处理订单扩展数据
     * @param woInitDto 参数传递条件
     * @param wooid     订单主键
     * @return
     */
    private WoExpand disposeWoExpand(WoInitDto woInitDto,Long wooid){
        WoExpand expand = new WoExpand();
        expand.setWooid(wooid);
        expand.setWoid(woInitDto.getOrderCode());
        expand.setYdid(woInitDto.getYdid());
        expand.setDdje(woInitDto.getDdje());
        expand.setYdhh(woInitDto.getYdhh());
        expand.setZxbz(woInitDto.getZxbz());
        expand.setSysUpd(woInitDto.getSysUpd());
        expand.setScjhdherId(woInitDto.getScjhdherId());
        expand.setYdhId(woInitDto.getYdhId());
        expand.setYdhhId(woInitDto.getYdhhId());
        expand.setErpjh(woInitDto.getOrderSL().intValue());
        expand.setHth(woInitDto.getHth());
        expand.setWlId(woInitDto.getWlId());
        expand.setHmjh(woInitDto.getHmjh());
        expand.setSysUpd(woInitDto.getSysUpd());
        return expand;
    }

    /**
     * 处理订单工艺路线数据
     * @param wogylxList 订单工艺路线
     * @param user       用户数据
     * @param wod 订单号
     * @return
     */
    private Result<List<Wogylx>> disposeWogylx(List<WogylxErp> wogylxList,User user,Long woId,String wod,Long cpGyFk,List<PpTechnologicalWogylx> pplist){
        Map<String,Long> map = new HashMap<>();
        for (PpTechnologicalWogylx ppTechnologicalWogylx : pplist) {
            map.put(ppTechnologicalWogylx.getNodeCode(),ppTechnologicalWogylx.getTechnologicalProcessOid());
        }
        if(EmptyUtil.isEmpty(wogylxList)){
            return new Result<List<Wogylx>>().toSuccess();
        }
        List<Wogylx> wogylxes=new ArrayList<>();
        for (WogylxErp erp : wogylxList) {
            Result<UfcWogylx> result = disposeWogylxOne(erp, user, cpGyFk);
            if(!result.confirmSuccess()){
                return new Result<>().toFailure(result.getMsg());
            }
            result.getData().setTechnologicalProcessFk(map.get(erp.getSxh().toString()));
            result.getData().setSxh(erp.getSxh());
            result.getData().setSort(erp.getSxh());
            result.getData().setWoFk(woId);
            result.getData().setWoid(wod);
            result.getData().setZt(WorkOderEnum.CONFIRM.getValue());
            Wogylx  wogylx = new Wogylx();
            BeanUtils.copyProperties(result.getData(),wogylx);
            wogylxes.add(wogylx);

        }
        return new Result<List<Wogylx>>().toSuccess(wogylxes);
    }

    private Result<List<PpTechnologicalWogylx>> disposePpTechnologicalWogylx(List<WogylxErp> wogylxErpList,Long woId){
        if(EmptyUtil.isEmpty(wogylxErpList)){
            return new Result<>().toFailure("订单工艺路为空!");
        }
        List<PpTechnologicalWogylx> wogylxList=new ArrayList<>();
        List<UfcErpPpTechnologicalWogylx> ufcErpPpTechnologicalWogylxes=new ArrayList<>();

        //存放nodes数组
        ArrayList<Map<String,Object>> nodesList = new ArrayList<>();
        ArrayList<Map<String,Object>> edgesList = new ArrayList<>();

        // 坐标
        int x=100 , y=100;
        Map<String,Object> opacity = new LinkedHashMap<>();
        opacity.put("opacity",0.9);

        Map<String,Object> style = new LinkedHashMap<>();
        style.put("nodeState:default",opacity);
        style.put("nodeState:hover",opacity);
        style.put("nodeState:selected",opacity);
        style.put("radius",10);

        Map<String,Object> labelCfg = new LinkedHashMap<>();
        labelCfg.put("fontSize",20);



        for (int i=0;i<wogylxErpList.size();i++) {

            UfcErpPpTechnologicalWogylx ufcErpPpTechnologicalWogylx = new UfcErpPpTechnologicalWogylx();
            if(i==0){
                //开始节点
                PpTechnologicalWogylx wogylx=new PpTechnologicalWogylx();
                wogylx.setNodeTypes(1);
                wogylx.setTechnologicalProcessPid(topPid);
                wogylx.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                wogylx.setNodeCode("start");
                wogylx.setNodeName("开始节点");
                wogylx.setProcessRouteFk(woId);
                wogylx.setTransferMode("A");
                wogylxList.add(wogylx);

                Map<String,Object> startArray = new LinkedHashMap<>();
                startArray.put("text","node");
                startArray.put("label","开始");
                startArray.put("nodeCode","start");
                startArray.put("nodeName","开始节点");
                startArray.put("transferMode","A");
                startArray.put("bgroupCode","");
                startArray.put("bgroupFk","");
                startArray.put("bgroupName","");
                startArray.put("processRouteFk",String.valueOf(woId));
                startArray.put("technologicalProcessPid","");
                startArray.put("nodeTypes","1");
                startArray.put("id",String.valueOf(wogylx.getTechnologicalProcessOid()));
                startArray.put("technologicalProcessOid",String.valueOf(wogylx.getTechnologicalProcessOid()));
                startArray.put("type","circle-node");
                startArray.put("x",x);
                startArray.put("y",y);
                startArray.put("style",style);
                startArray.put("labelCfg",labelCfg);

                nodesList.add(startArray);

                //第1个节点数据
                PpTechnologicalWogylx node1=new PpTechnologicalWogylx();
                node1.setNodeTypes(2);
                node1.setTechnologicalProcessPid(wogylx.getTechnologicalProcessOid());
                node1.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                node1.setNodeCode(String.valueOf(wogylxErpList.get(i).getSxh()));
                node1.setNodeName(wogylxErpList.get(i).getGxmc());
                node1.setProcessRouteFk(woId);
                node1.setTransferMode("A");
                wogylxList.add(node1);
                ufcErpPpTechnologicalWogylx.setPpTechnologicalWogylxFk(node1.getTechnologicalProcessOid());

                Map<String,Object> node1Array = new LinkedHashMap<>();
                node1Array.put("text","node");
                node1Array.put("label",node1.getNodeName());
                node1Array.put("nodeCode",node1.getNodeCode());
                node1Array.put("nodeName",node1.getNodeName());
                node1Array.put("transferMode","A");
                node1Array.put("bgroupCode","");
                node1Array.put("bgroupFk","");
                node1Array.put("bgroupName","");
                node1Array.put("technologicalProcessPid","");
                node1Array.put("processRouteFk",String.valueOf(woId));
                node1Array.put("nodeTypes","2");
                node1Array.put("id",String.valueOf(node1.getTechnologicalProcessOid()));
                node1Array.put("technologicalProcessOid",String.valueOf(node1.getTechnologicalProcessOid()));
                node1Array.put("type","rect-node");
                node1Array.put("x",x+(i+1)*100);
                node1Array.put("y",y+(i+1)*100);
                style.put("width",96);
                node1Array.put("style",style);
                node1Array.put("labelCfg",labelCfg);

                //第一个节点线条
                Map<String,Object> edges = new LinkedHashMap<>();
                edges.put("id",String.valueOf(System.currentTimeMillis()));
                edges.put("source",String.valueOf(wogylx.getTechnologicalProcessOid()));
                edges.put("target",String.valueOf(node1.getTechnologicalProcessOid()));
                edges.put("sourceAnchor",1);
                edges.put("targetAnchor",3);
                edges.put("type","polyline-edge");

                edgesList.add(edges);
                nodesList.add(node1Array);


            }else {
                PpTechnologicalWogylx wogylx=new PpTechnologicalWogylx();
                wogylx.setNodeTypes(2);
                wogylx.setTechnologicalProcessPid(wogylxList.get(i).getTechnologicalProcessOid());
                wogylx.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                wogylx.setNodeCode(String.valueOf(wogylxErpList.get(i).getSxh()));
                wogylx.setNodeName(wogylxErpList.get(i).getGxmc());
                wogylx.setProcessRouteFk(woId);
                wogylx.setTransferMode("A");
                wogylxList.add(wogylx);
                ufcErpPpTechnologicalWogylx.setPpTechnologicalWogylxFk(wogylx.getTechnologicalProcessOid());

                Map<String,Object> nodeArray = new LinkedHashMap<>();
                nodeArray.put("text","node");
                nodeArray.put("label",wogylx.getNodeName());
                nodeArray.put("nodeCode",wogylx.getNodeCode());
                nodeArray.put("nodeName",wogylx.getNodeName());
                nodeArray.put("transferMode","A");
                nodeArray.put("bgroupCode","");
                nodeArray.put("bgroupFk","");
                nodeArray.put("bgroupName","");
                nodeArray.put("technologicalProcessPid","");
                nodeArray.put("processRouteFk",String.valueOf(woId));
                nodeArray.put("nodeTypes","2");
                nodeArray.put("id",String.valueOf(wogylx.getTechnologicalProcessOid()));
                nodeArray.put("technologicalProcessOid",String.valueOf(wogylx.getTechnologicalProcessOid()));
                nodeArray.put("type","rect-node");
                nodeArray.put("x",x+(i+1)*100);
                nodeArray.put("y",y+(i+1)*100);
                style.put("width",96);
                nodeArray.put("style",style);
                nodeArray.put("labelCfg",labelCfg);

                nodesList.add(nodeArray);
                //节点线条
                Map<String,Object> edges = new LinkedHashMap<>();
                edges.put("id",String.valueOf(System.currentTimeMillis()));
                edges.put("source",String.valueOf(wogylxList.get(i).getTechnologicalProcessOid()));
                edges.put("target",String.valueOf(wogylx.getTechnologicalProcessOid()));
                edges.put("sourceAnchor",1);
                edges.put("targetAnchor",3);
                edges.put("type","polyline-edge");

                edgesList.add(edges);


                //当前节点为最后一个节点
                if(i==(wogylxErpList.size()-1)){
                    //结束节点
                    PpTechnologicalWogylx endWogylx=new PpTechnologicalWogylx();
                    endWogylx.setNodeTypes(3);
                    endWogylx.setTechnologicalProcessPid(topPid);
                    endWogylx.setTechnologicalProcessOid(SnowflakeIdUtils.generate());
                    endWogylx.setNodeCode("end");
                    endWogylx.setNodeName("结束节点");
                    endWogylx.setProcessRouteFk(woId);
                    endWogylx.setTransferMode("A");

                    Map<String,Object> endArray = new LinkedHashMap<>();
                    endArray.put("text","node");
                    endArray.put("label","结束");
                    endArray.put("nodeCode","end");
                    endArray.put("nodeName","结束节点");
                    endArray.put("transferMode","A");
                    endArray.put("bgroupCode","");
                    endArray.put("bgroupFk","");
                    endArray.put("bgroupName","");
                    endArray.put("processRouteFk",String.valueOf(woId));
                    endArray.put("technologicalProcessPid","");
                    endArray.put("nodeTypes","3");
                    endArray.put("id",String.valueOf(endWogylx.getTechnologicalProcessOid()));
                    endArray.put("technologicalProcessOid",String.valueOf(endWogylx.getTechnologicalProcessOid()));
                    endArray.put("type","ellipse-node");
                    endArray.put("x",x+(i+2)*100);
                    endArray.put("y",y+(i+2)*100);
                    endArray.put("style",style);
                    endArray.put("labelCfg",labelCfg);

                    wogylxList.add(endWogylx);
                    nodesList.add(endArray);

                    //结束线条
                    Map<String,Object> endEdges = new LinkedHashMap<>();
                    endEdges.put("id",String.valueOf(System.currentTimeMillis()));
                    endEdges.put("source",String.valueOf(wogylx.getTechnologicalProcessOid()));
                    endEdges.put("target",String.valueOf(endWogylx.getTechnologicalProcessOid()));
                    endEdges.put("sourceAnchor",1);
                    endEdges.put("targetAnchor",3);
                    endEdges.put("type","polyline-edge");
                    edgesList.add(endEdges);
                }
            }
            ufcErpPpTechnologicalWogylx.setUfcErpPpTechnologicalWogylxOid(SnowflakeIdUtils.generate());
            ufcErpPpTechnologicalWogylx.setGzzx(wogylxErpList.get(i).getGzzx());

            ufcErpPpTechnologicalWogylx.setGxxlid(wogylxErpList.get(i).getGxxlid());
            ufcErpPpTechnologicalWogylx.setDwid(wogylxErpList.get(i).getDwid());
            ufcErpPpTechnologicalWogylx.setGxOid(wogylxErpList.get(i).getId());
            ufcErpPpTechnologicalWogylx.setXh(wogylxErpList.get(i).getXh());
            ufcErpPpTechnologicalWogylx.setSxh(wogylxErpList.get(i).getSxh());
            ufcErpPpTechnologicalWogylxes.add(ufcErpPpTechnologicalWogylx);
        }
        if(!EmptyUtil.isEmpty(ufcErpPpTechnologicalWogylxes)){
            ufcErpPpTechnologicalWogylxService.saveBatch(ufcErpPpTechnologicalWogylxes);
        }
        Map<String,Object> nodes = new LinkedHashMap<>();
        nodes.put("nodes",nodesList);
        nodes.put("edges",edgesList);
        String textJson = JsonUtils.toJson(nodes);
        for (PpTechnologicalWogylx ppTechnologicalWogylx : wogylxList) {
            ppTechnologicalWogylx.setTextJson(textJson);
        }
        //处理Id和pid问题
        /*for (int i = 0; i < wogylxList.size(); i++) {
            if(0==i){
                continue;
            }
            Integer pidIndex=i+1;
            if(pidIndex==wogylxList.size()){
                continue;
            }
            Long processOid = wogylxList.get(i).getTechnologicalProcessOid();
            wogylxList.get(pidIndex).setTechnologicalProcessPid(processOid);
        }*/
        return new Result<List<PpTechnologicalWogylx>>().toSuccess(wogylxList);
    }

    /**
     * 处理订单物料清单数据
     * @param woBomErps 订单物料清单传递值
     * @param user 用户星星
     * @param woId  订单外键
     * @param wod  订单号
     * @param wogylxMap  工艺路线处理数据 key:工序编码 value:订单工艺路线
     * @return
     */
    private Result<List<Wobom>> disposeWoBom(List<WoBomErp> woBomErps, User user, Long woId,String wod, Map<String,Wogylx> wogylxMap){
        if(EmptyUtil.isEmpty(woBomErps)){
            return new Result<List<Wobom>>().toSuccess();
        }
        List<Wobom> wobomList=new ArrayList<>();
        for (WoBomErp bomErp : woBomErps) {
            Result<Wobom> result = disposeWoBomOne(bomErp, user, wogylxMap);
            if(!result.confirmSuccess()){
                return new Result<>().toFailure(result.getMsg());
            }
            result.getData().setWobomoid(SnowflakeIdUtils.generate());
            result.getData().setWoFk(woId);
            result.getData().setWoid(wod);
            result.getData().setZt(WorkOderEnum.CONFIRM.getValue());
            wobomList.add(result.getData());
        }
        return new Result<List<Wobom>>().toSuccess(wobomList);

    }

    /**
     * 订单工艺路线数据处理
     * @param wogylxErp  订单工艺路线
     * @param cpGylxFk   产品工艺路线外键
     * @return
     */
    private Result<UfcWogylx> disposeWogylxOne(WogylxErp wogylxErp,User user,Long cpGylxFk){
        if(EmptyUtil.isEmpty(wogylxErp)){
            return new Result<>().toFailure("请传递数据!");
        }
        if(EmptyUtil.isEmpty(wogylxErp.getGxid())){
            return new Result<>().toFailure("工序编码必传!");
        }
        UfcWogylx wogylx = new UfcWogylx();
        BeanUtils.copyProperties(wogylxErp,wogylx);
        //处理产品工艺路线明细数据
        Long detail = disProcessDetail(wogylxErp.getGxid(), cpGylxFk);
        wogylx.setBProductionlineFk(detail);
        //处理基础工序数据
        Long aLong = disStandardProcess(wogylxErp.getGxid());
        wogylx.setBStandardprocessFk(aLong);
        wogylx.setWogylxoid(SnowflakeIdUtils.generate());
        wogylx.setSysCreated(LocalDateTime.now());
        wogylx.setSysCreatedBy(user.getEmployeeOid());
        wogylx.setSysLastUpd(LocalDateTime.now());
        wogylx.setSysLastUpdBy(user.getEmployeeOid());
        wogylx.setDel(IsDeleteEnum.NotDelete.getStatus());
        wogylx.setZbgx(wogylxErp.getZbgx());
        if(wogylxErp.getJgbgx()==40){
            //不汇报
            wogylx.setJgbgx(false);
        }else{
            wogylx.setJgbgx(true);
        }
        wogylx.setSfsj(wogylxErp.getFirstInspectionProcess());
        wogylx.setSfjygx(wogylxErp.getSfjygx());
        return new Result<UfcWogylx>().toSuccess(wogylx);
    }

    /**
     * 处理物料清单数据
     * @param bomErp 参数传递对象
     * @param user   用户信息
     * @param wogylxMap 当前订单要生成工艺路线
     * @return
     */
    private Result<Wobom> disposeWoBomOne(WoBomErp bomErp,User user,Map<String,Wogylx> wogylxMap){
        if(EmptyUtil.isEmpty(bomErp)){
            return new Result<>().toFailure("请传递数据!");
        }
        Wobom wobom = new Wobom();
        wobom.setBomxh(bomErp.getBomxh());
        wobom.setFfyz(bomErp.getFfyz());
        wobom.setFcp(bomErp.getFcp());
        wobom.setShlz(bomErp.getShlz());
        wobom.setWlph(bomErp.getWlph());
        wobom.setShz(bomErp.getShz());
        wobom.setYcp(bomErp.getYcp());
        wobom.setBz(bomErp.getBz());
        if(EmptyUtil.isEmpty(bomErp.getXqsl())){
            return new Result<>().toFailure("请指定订单物料清单的需求数量!");
        }
        wobom.setXqsl(bomErp.getXqsl());
        //处理-物料编码-替换成主键
        if(EmptyUtil.isEmpty(bomErp.getCInvCode())){
            return new Result<>().toFailure("订单物料清单的物料编码必填!");
        }
        Long aLong = disposeMaterial(bomErp.getCInvCode());
        if(EmptyUtil.isEmpty(aLong)){
            return new Result<>().toFailure("物料编码：["+bomErp.getCInvCode()+"]在系统中不存在!");
        }
        wobom.setBMaterialFk(aLong);
        wobom.setSysLastUpd(LocalDateTime.now());
        wobom.setSysCreated(LocalDateTime.now());
        wobom.setSysLastUpdBy(user.getEmployeeOid());
        wobom.setSysCreatedBy(user.getEmployeeOid());
        wobom.setFlrq(LocalDate.now());
        //通过工序编码查询出订单工艺数据
        String gxid = bomErp.getGxid();
        if(!EmptyUtil.isEmpty(wogylxMap)){
            Wogylx wogylx = wogylxMap.get(gxid);
            if(!EmptyUtil.isEmpty(wogylx)){
                wobom.setBStandardprocessFk(wogylx.getBStandardprocessFk());
                wobom.setBProductprocessdetailFk(wogylx.getWogylxoid());
            }
        }
        return new Result<Wobom>().toSuccess(wobom);
    }


    /**
     * 处理产品工艺路线：将产品工艺路线编码替换为主键
     * @param cpgyCode  产品工艺路线编码
     * @param factoryFk  工厂主键
     * @return 主键
     */
    private Long disposeProcess(String cpgyCode,Long factoryFk){
        if(!EmptyUtil.isEmpty(cpgyCode)){
            LambdaQueryWrapper<BProductprocess> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(BProductprocess::getCpgyid,cpgyCode);
            if(!EmptyUtil.isEmpty(factoryFk)){
                wrapper.eq(BProductprocess::getBFactoryFk,factoryFk);
            }
            wrapper.select(BProductprocess::getBProductprocessoid);
            wrapper.last("LIMIT 1");
            BProductprocess one = this.bProductprocessService.getOne(wrapper);
            if(!EmptyUtil.isEmpty(one)){
                return one.getBProductprocessoid();
            }
            log.error("产品工艺路线编码:["+cpgyCode+"]-没有查询出值");
        }
        return null;

    }

    /**
     * 处理标准工序数据
     * @param gxid  工序编码
     * @return
     */
    private Long disStandardProcess(String gxid){
        if(!EmptyUtil.isEmpty(gxid)){
            LambdaQueryWrapper<BStandardprocess> wrapper=new LambdaQueryWrapper<>();
            wrapper.select(BStandardprocess::getBStandardprocessoid);
            wrapper.eq(BStandardprocess::getBzgxid,gxid);
            wrapper.last("LIMIT 1");
            BStandardprocess one = this.bStandardprocessService.getOne(wrapper);
            if(!EmptyUtil.isEmpty(one)){
                return one.getBStandardprocessoid();
            }
            log.error("标准工艺路线编码:["+gxid+"]-没有查询出值");
        }
        return null;
    }

    /**
     * 处理产品工艺路线明细主键数据
     * @param gxid  工序编码
     * @return
     */
    private Long disProcessDetail(String gxid,Long cpGylxFk){
        if(!EmptyUtil.isEmpty(gxid)&&!EmptyUtil.isEmpty(cpGylxFk)){
            LambdaQueryWrapper<BProductprocessdetail> wrapper=new LambdaQueryWrapper<>();
            wrapper.select(BProductprocessdetail::getBProductprocessdetailoid);
            wrapper.eq(BProductprocessdetail::getGxid,gxid);
            wrapper.eq(BProductprocessdetail::getBProductprocessFk,cpGylxFk);
            wrapper.last("LIMIT 1");
            BProductprocessdetail one = this.bProductprocessdetailService.getOne(wrapper);
            if(!EmptyUtil.isEmpty(one)){
                return one.getBProductprocessdetailoid();
            }
            log.error("产品工艺路线明细编码:["+gxid+"]-没有查询出值");
        }
        return null;
    }

    /**
     * 处理工厂：将工厂编码替换为主键
     * @param factoryCode  工厂编码
     * @return 主键
     */
    private Long disposeFactory(String factoryCode){
        if(!EmptyUtil.isEmpty(factoryCode)){
            LambdaQueryWrapper<BFactory> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(BFactory::getGcid,factoryCode);
            wrapper.select(BFactory::getBFactoryoid);
            wrapper.last("LIMIT 1");
            BFactory one = this.bFactoryService.getOne(wrapper);
            if(!EmptyUtil.isEmpty(one)){
                return one.getBFactoryoid();
            }
            log.error("工厂编码:["+factoryCode+"]-没有查询出值");
        }
        return null;
    }

    /**
     * 处理车间：将车间编码替换为主键
     * @param workShopCode  车间编码
     * @param factoryId  工厂主键：需要校验工厂的时候传递
     * @return 主键
     */
    private Long disposeWorkShop(String workShopCode,Long factoryId){
        if(!EmptyUtil.isEmpty(workShopCode)){
            LambdaQueryWrapper<BWorkshop> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(BWorkshop::getCjid,workShopCode);
            if(!EmptyUtil.isEmpty(factoryId)){
                wrapper.eq(BWorkshop::getFactoryFk,factoryId);
            }
            wrapper.select(BWorkshop::getBWorkshopoid);
            wrapper.last("LIMIT 1");
            BWorkshop one = this.bWorkshopService.getOne(wrapper);
            if(!EmptyUtil.isEmpty(one)){
                return one.getBWorkshopoid();
            }
            log.info("车间编码:["+workShopCode+"]-没查询出值");
        }
        return null;
    }

    /**
     * 处理物料：将物料编码替换为主键
     * @param wlId  物料编码
     * @return 主键
     */
    private Long disposeMaterial(String wlId){
        if(!EmptyUtil.isEmpty(wlId)){
            LambdaQueryWrapper<BMaterial> wrapper=new LambdaQueryWrapper<>();
            wrapper.eq(BMaterial::getWlid,wlId);
            wrapper.select(BMaterial::getBMaterialoid);
            wrapper.last("LIMIT 1");
            BMaterial one = this.bMaterialService.getOne(wrapper);
            if(!EmptyUtil.isEmpty(one)){
                return one.getBMaterialoid();
            }
            log.error("物料编码:["+wlId+"]-没有查询出值");
        }
        return null;
    }

    /**
     * 查询辅助属性(质量等级 / 精度)
     */
    public Result<List<FAuxPropNameVo>> getFzsx(String type){
        ERPParam params = new ERPParam();
        //后台限制
        params.setFieldKeys("FEntryID,FNumber,FDataValue,FDescription");
        params.setFormId("BOS_ASSISTANTDATA_DETAIL");
        params.setTopRowCount(0);
        String erpParam = null;
        if(FzsxType.JD.getKey().equals(type)){
            erpParam = "FID.FName='精度' and FFORBIDSTATUS='A'";
        }else if(FzsxType.ZLDJ.getKey().equals(type)){
            erpParam = "FID.FName='精度' and FFORBIDSTATUS='A'";
        }else {
            return new Result<>().toFailure("查询类型输入错误");
        }
        params.setFilterString(erpParam);
        params.setStartRow(0);
        params.setOrderString("FNumber");
        return ERPHttpUtils.other(params, FAuxPropNameVo.class);
    }

    @Override
    public Result saveWo(WoDto wo, User user) {
        Result result = woService.saveWo(wo, user);
        if (!result.confirmSuccess()) {
            return new Result().toFailure(result.getMsg());
        }

        // 新增wo_expand
        WoExpand woExpand = new WoExpand();
        BeanUtils.copyProperties(wo, woExpand);
        woExpand.setWooid(wo.getWooid());
        // 根据wooid查询
        WoExpand byId = woExpandService.getById(wo.getWooid());
        if (EmptyUtil.isEmpty(byId)) {
            woExpandService.save(woExpand);
        } else {
            woExpandService.update(woExpand, new QueryWrapper<WoExpand>().eq("wooid", woExpand.getWooid()));
        }

        return new Result().toSuccess(wo.getWooid());
    }

    @Override
    public Boolean getErpWoInfo(List<String> woid) {
        //查询订单信息
        LambdaQueryWrapper<Wo> wrapper = new LambdaQueryWrapper<>();
        wrapper.in(Wo::getWoid,woid);
        wrapper.eq(Wo::getDel,false);
        List<Wo> wo = woService.getBaseMapper().selectList(wrapper);
        if(EmptyUtil.isEmpty(wo)){
            return true;
        }
        List<Long> wooids = wo.stream().map(p -> p.getWooid()).collect(Collectors.toList());
        //查询工单排程数据
        LambdaQueryWrapper<PsWs> psWsLambdaQueryWrapper = new LambdaQueryWrapper<>();
        psWsLambdaQueryWrapper.in(PsWs::getWoFk,wooids);
        psWsLambdaQueryWrapper.eq(PsWs::getDel,false);
        Integer row = psWsService.getBaseMapper().selectCount(psWsLambdaQueryWrapper);
        if(row==0){
            return true;
        }else {
            return false;
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result erpDelWo(List<String> list) {
        if(EmptyUtil.isEmpty(list)){
            return new Result().toFailure("订单编码为空！");
        }
        if(!this.getErpWoInfo(list)){
            return new Result().toFailure("生产订单已排程 不允许删除！");
        }
        for (String woid : list) {
            LambdaQueryWrapper<Wo> woQueryWrapper = new LambdaQueryWrapper<>();
            woQueryWrapper.eq(Wo::getWoid,woid);
            woQueryWrapper.eq(Wo::getDel,false);
            Wo checkWo = woService.getBaseMapper().selectOne(woQueryWrapper);
            if(!EmptyUtil.isEmpty(checkWo)){
                try {
                    //删除订单扩展表 wo_expand 数据
                    LambdaUpdateWrapper<WoExpand> woExpandQueryWrapper = new LambdaUpdateWrapper<>();
                    woExpandQueryWrapper.eq(WoExpand::getWoid,woid);
                    woExpandService.getBaseMapper().delete(woExpandQueryWrapper);

                    //删除订单扩展表 ufc_erp_wo 数据
                    LambdaUpdateWrapper<UfcErpWo> ufcErpWoQueryWrapper = new LambdaUpdateWrapper<>();
                    ufcErpWoQueryWrapper.eq(UfcErpWo::getWoFk,checkWo.getWooid());
                    ufcErpWoService.getBaseMapper().delete(ufcErpWoQueryWrapper);

                    //删除订单物料清单 wobom 数据
                    int i = ufcErpPpTechnologicalWogylxService.delWoBom(checkWo.getWooid());

                    //根据订单外键查询工序节点数据
                    LambdaQueryWrapper<PpTechnologicalWogylx> ppTechnologicalWogylxWrapper=new LambdaQueryWrapper<>();
                    ppTechnologicalWogylxWrapper.eq(PpTechnologicalWogylx::getProcessRouteFk,checkWo.getWooid());
                    List<PpTechnologicalWogylx> listWogylx = ppTechnologicalWogylxService.getBaseMapper().selectList(ppTechnologicalWogylxWrapper);
                    //从list集合中，取出字段technologicalProcessOid的列表
                    List<Long> technologicalProcessOid = listWogylx.stream().map(p -> p.getTechnologicalProcessOid()).collect(Collectors.toList());
                    //删除工序节点 pp_technological_wogylx 数据
                    ppTechnologicalWogylxService.getBaseMapper().deleteBatchIds(technologicalProcessOid);

                    //删除工序扩展表 ufc_erp_pp_technological_wogylx 数据
                    ufcErpPpTechnologicalWogylxService.del(technologicalProcessOid);

                    //删除工序 wogylx 数据
                    ufcErpPpTechnologicalWogylxService.delWogylx(checkWo.getWooid());

                    //删除订单 wo  数据
                    ufcErpPpTechnologicalWogylxService.delWo(checkWo.getWooid());
                }catch (Exception e){
                    throw new CustomException(-1, "数据删除失败！");
                }
            }
        }
        return new Result().toSuccess();
    }

}

