package com.jln.system.web.action.mes.organize.mapper;

import com.jln.system.web.action.erp.organization.jopo.dto.OrganizeErpWorkshop;
import com.jln.system.web.action.mes.organize.entity.SysOrganizeErp;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author
 * @since 2021-10-26
 */
public interface SysOrganizeErpMapper extends BaseMapper<SysOrganizeErp> {
    /**
     * 根据编码获取存在的组织信息
     * ERP的组织机构 哪些存在，哪些不存在
     *
     * @param bms
     * @return
     */
    List<SysOrganizeErp> queryOrganizationsByCodes(@Param("bms") List<Long> bms);

    /**
     * 根据ERP的组织机构主键获取存在的组织信息
     *
     * @param ids
     * @return
     */
    List<SysOrganizeErp> queryOrganizationsByOrgIds(@Param("ids") Collection<Long> ids);

    SysOrganizeErp getByFOrgId(@Param("orgId") Long orgId);

    List<OrganizeErpWorkshop> selectOrganizeErpWorkshop();
}
