package com.jln.system.web.action.mes.production.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.enums.*;
import com.jln.common.exception.CustomException;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.erp.ufcpswb.mapper.UfcPsWbMapper;
import com.jln.system.web.action.erp.ufcpswb.service.UfcPsWbService;
import com.jln.system.web.action.mes.production.service.UfcWorkOrderStartService;
import com.jln.system.web.action.ps.gwj.entity.PsWt;
import com.jln.system.web.action.ps.gwj.service.AutomaticFeedbackService;
import com.jln.system.web.action.ps.gwj.service.PsWtService;
import com.jln.system.web.action.ps.production.entity.PsWb;
import com.jln.system.web.action.ps.production.entity.PsWbout;
import com.jln.system.web.action.ps.production.entity.PsWs;
import com.jln.system.web.action.ps.production.mapper.PsWbMapper;
import com.jln.system.web.action.ps.production.pojo.vo.ProcessNodeVO;
import com.jln.system.web.action.ps.production.pojo.vo.WbOutVo;
import com.jln.system.web.action.ps.production.service.PsTechnologicalProcessService;
import com.jln.system.web.action.ps.production.service.PsWbBomInitService;
import com.jln.system.web.action.ps.production.service.PsWbService;
import com.jln.system.web.action.ps.production.service.PsWsService;
import com.jln.ufc.web.action.ufc.ps.pojo.vo.UfcPsWb;
import com.jln.ufc.web.action.ufc.qc.entity.UfcHmQcBill;
import com.jln.ufc.web.action.ufc.qc.service.UfcHmBillService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @ClassName:
 * @Description:
 * @Author:三刀 Date:2020/2/10 20:24
 * Version:1.0
 **/
@Service
public class UfcWorkOrderStartImpl implements UfcWorkOrderStartService {
    /**
     * 工单开工的时候是否自动生成反馈记录数据
     */
    @Autowired
    private AutomaticFeedbackService automaticFeedbackService;

    @Autowired
    private PsWbService psWbService;

    @Autowired
    private PsWbMapper psWbMapper;

    @Autowired
    private PsWsService psWsService;

    /**
     * 工单开工之后是否自动生成投料数据
     */
    @Autowired
    private PsWbBomInitService psWbBomInitService;

    @Autowired
    private UfcPsWbMapper ufcPsWbMapper;

    @Autowired
    private PsWtService psWtService;

    @Autowired
    private UfcHmBillService ufcHmBillService;

    @Transactional
    @Override
    public Result startWorking(Long wbId, String bz, User user, Long startOne) {

        //获取上一道工序
        PsWb nextpswb = ufcPsWbMapper.selectNextGx(wbId);
        if(!EmptyUtil.isEmpty(nextpswb) && !"C".equals(nextpswb.getZt())){
            throw new CustomException(-1, "上一道工序未完工！");
        }
        if(!EmptyUtil.isEmpty(nextpswb)){
            //获取上一道工序工票数据
            LambdaQueryWrapper<PsWt> psWtLambdaQueryWrapper = new LambdaQueryWrapper<>();
            psWtLambdaQueryWrapper.eq(PsWt::getPsWbFk,nextpswb.getPsWboid());
            PsWt nextpswt = psWtService.getOne(psWtLambdaQueryWrapper);
            if(EmptyUtil.isEmpty(nextpswt)){
                throw new CustomException(-1, "上一道工序未开工！");
            }
            if(EmptyUtil.isEmpty(nextpswb.getSjkgrq())){
                return new Result().toFailure("上一道工序未开工！");
            }
            /*//判断是否需要专检
            if(nextpswt.getSfzj()){
                *//*if(!nextpswt.getZjwc()){
                    throw new CustomException(-1, "上一道工序未完成专检！");
                }*//*
                LambdaQueryWrapper<UfcHmQcBill> lambdaQueryWrapper = new LambdaQueryWrapper<>();
                lambdaQueryWrapper.eq(UfcHmQcBill::getPsWbFk,nextpswb.getPsWboid());
                lambdaQueryWrapper.eq(UfcHmQcBill::getSfzj,false);
                lambdaQueryWrapper.eq(UfcHmQcBill::getGxJyfs,'Z');
                int count = ufcHmBillService.count(lambdaQueryWrapper);
                if(count>0){
                    return new Result().toFailure("未完成专检");
                }
            }*/
        }

        if(EmptyUtil.isEmpty(wbId)){
            return new Result().toFailure(ResultCodeEnum.MISS_PARAM);
        }

        //增加暂停不能操作的逻辑
        Result result = psWbService.haltedState(wbId);

        if(!result.confirmSuccess()){
            return result;
        }
        //1.第一步查询出当前生产物料是单件还是批次的
        WbOutVo outVo = psWbMapper.getWbOutVo(wbId);
        if(EmptyUtil.isEmpty(outVo)){
            return new Result().toFailure(ResultCodeEnum.PSERROR116);
        }
        if(!WorkOderEnum.ISSUED.getValue().equals(outVo.getZt())){
            return new Result().toFailure("非下达状态不允许开工!");
        }
        if(!EmptyUtil.isEmpty(outVo.getSjkgrq())){
            return new Result().toFailure("已开工");
        }
        LocalDateTime startTime = LocalDateTime.now();
        PsWb wb = new PsWb();
        wb.setSjkgrq(LocalDate.now());
        wb.setKgrId(user.getEmployeeOid());
        if(!EmptyUtil.isEmpty(startOne)&&0!=startOne){
            wb.setKgrId(startOne);
        }
        wb.setPsWboid(wbId);
        wb.setSysCreatedBy(user.getEmployeeOid());
        wb.setSysCreated(startTime);
        wb.setBz(bz);
        int id = psWbMapper.updateById(wb);
        if (0 == id) {
            throw new CustomException(ResultCodeEnum.PSERROR1112);
        }
        //增加逻辑：作业计划开工之后，判断当前排程记录是否存在实际开工日期，如果不存在 修改当前作业计划的实际开工日期
        Long ws = this.psWbMapper.getNotInServiceWs(wb.getPsWboid());
        if(!EmptyUtil.isEmpty(ws)){
            LambdaUpdateWrapper<PsWs> wrapper=new LambdaUpdateWrapper<>();
            wrapper.set(PsWs::getSjkgrq,LocalDate.now());
            wrapper.set(PsWs::getSysCreated,LocalDateTime.now());
            wrapper.set(PsWs::getSysLastUpdBy,user.getEmployeeOid());
            wrapper.eq(PsWs::getPsWsoid,ws);
            psWsService.update(wrapper);
        }
        //调整产出物料生成逻辑
        Result<List<PsWbout>> material = psWbBomInitService.outputMaterial(outVo, user, wbId);
        if(!material.confirmSuccess()){
            throw new CustomException(material.getCode(),material.getMsg());
        }
        //新增自动生成反馈记录逻辑
        Result feedback = automaticFeedbackService.createFeedback(wbId, material.getData(), user);
        if(!feedback.confirmSuccess()){
            throw new CustomException(feedback.getCode(),feedback.getMsg());
        }
        return material;
    }

}
