package com.jln.system.web.action.mes.qc.controller;

import com.jln.common.annotation.IgnoreUserLoginToken;
import com.jln.common.annotation.LoginUser;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.system.web.action.mes.qc.entity.StorageNotice;
import com.jln.system.web.action.mes.qc.entity.vo.StorageNoticeVO;
import com.jln.system.web.action.mes.qc.service.StorageNoticesService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value = "/erp.qc/ufcStorageNotice")
@Api(value = "入库通知",tags = "入库通知API")
public class NoticesController {

    @Autowired
    private StorageNoticesService noticesService;

    @PostMapping(value = "/saveNotice")
    @ApiOperation(value = "添加/编辑 入库信息", notes = "添加/编辑 入库信息")
    public Result saveNotice(@RequestBody StorageNotice storageNotice,@LoginUser User user){
        return noticesService.saveNotice(storageNotice,user);
    }

    @PostMapping(value = "/delNotice")
    @ApiOperation(value = "删除入库信息", notes = "删除入库信息")
    public Result delNotice(@RequestBody List<Long> ids,@LoginUser User user){
        return noticesService.delNotice(ids,user);
    }

    @PostMapping(value = "/modifyNotice")
    @ApiOperation(value = "修改入库信息状态", notes = "信息状态（未修改）——>（修改）")
    public Result modifyNotice(@RequestBody List<Long> ids,@LoginUser User user){
        return noticesService.modifyNotice(ids,user);
    }

    @GetMapping(value = "/reNotice")
    @ApiOperation(value = "撤回入库信息状态", notes = "信息状态（修改）——>（未修改）")
    public Result reNotice(@RequestParam Long id,@LoginUser User user){
        return noticesService.reNotice(id,user);
    }

    @PostMapping(value = "/getNotices")
    @ApiOperation(value = "查询所有入库信息", notes = "获取入库信息")
    public Result getNotices(@RequestBody PageParameter<StorageNoticeVO> parameter, @LoginUser User user){
        return noticesService.getNotices(parameter,user);
    }

    @GetMapping(value = "/getFactoryWork")
    @ApiOperation(value = "获取当前用户所负责车间/工厂编码", notes = "获取信息")
    public Result getFactoryWork(@LoginUser User user){
        return noticesService.getFactoryWork(user);
    }

}
