package com.jln.system.web.action.mes.qc.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.jln.common.entity.Result;
import com.jln.common.entity.User;
import com.jln.common.utils.PageParameter;
import com.jln.system.web.action.mes.qc.entity.StorageNotice;
import com.jln.system.web.action.mes.qc.entity.vo.StorageNoticeVO;

import java.util.List;

public interface StorageNoticesService extends IService<StorageNotice> {

    /**
     * 新增/编辑 入库通知
     * @return
     */
    public Result saveNotice(StorageNotice storageNoticeVo,User user);

    /**
     * 删除入库通知
     * @return
     */
    public Result delNotice(List<Long> ids,User user);

    /**
     * 处理入库通知
     * @return
     */
    public Result modifyNotice(List<Long> ids,User user);

    /**
     * 撤回入库通知
     * @return
     */
    public Result reNotice(Long id,User user);

    /**
     * 分页查询
     * @return
     */
    public Result getNotices(PageParameter<StorageNoticeVO> parameter, User user);


    /**
     * 根据当前用户获取车间信息和工厂信息
     * @param user
     * @return
     */
    public Result getFactoryWork(User user);

}
