package com.jln.system.web.action.mes.user.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 岗位表
 * </p>
 *
 * @author 
 * @since 2021-10-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SysPost extends Model<SysPost> {

    private static final long serialVersionUID = 1L;

    /**
     * 岗位主键
     */
    @TableId
    private Long sysPostId;

    /**
     * 岗位编码
     */
    private String postCode;

    /**
     * 岗位名称
     */
    private String postName;

    /**
     * 父级岗位
     */
    private Long postPid;

    /**
     * 备注
     */
    private String remark;

    /**
     * 部门表外键
     */
    private Long organizeFk;

    /**
     * 岗位分类外键
     */
    private Long postClassFk;

    /**
     * 是否删除，0没有，1删除
     */
    @TableLogic
    private Integer del;

    /**
     * 是否三员岗位
     */
    private Boolean partThreeJobs;

    /**
     * 维护人
     */
    private Long sysLastUpdBy;

    /**
     * 维护时间
     */
    private LocalDateTime sysLastUpd;

    /**
     * 维护人名称
     */
    private String sysLastName;


    @Override
    protected Serializable pkVal() {
        return this.sysPostId;
    }

}
