package com.jln.system.web.action.mes.user.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 用户岗位关联表
 * </p>
 *
 * @author 
 * @since 2021-10-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SysPostEmployee extends Model<SysPostEmployee> {

    private static final long serialVersionUID = 1L;

    /**
     * 用户绑定岗位表主键
     */
    @TableId
    private Long sysPostEmployeeId;

    /**
     * 员工表外键
     */
    private Long employeeFk;

    /**
     * 是否主岗位，0不是，1是
     */
    private Boolean flsMasterPost;

    /**
     * 岗位外键
     */
    private Long postFk;

    /**
     * 是否岗位负责人
     */
    private Boolean principal;


    @Override
    protected Serializable pkVal() {
        return this.sysPostEmployeeId;
    }

}
