package com.jln.system.web.action.mes.user.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 用户登录表
 * </p>
 *
 * @author 
 * @since 2021-10-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SysUser extends Model<SysUser> {

    private static final long serialVersionUID = 1L;

    /**
     * 用户主键
     */
    @TableId
    private Long userId;

    /**
     * 用户名，不能重复
     */
    private String userName;

    /**
     * 密码
     */
    private String password;

    /**
     * 手机号码，冗余字段，方便手机登录
     */
    private String phone;

    /**
     * 登录ip
     */
    private String clientIp;

    /**
     * 登录次数
     */
    private Integer loginTimes;

    /**
     * 历史密码
     */
    private String hisoryPwds;

    /**
     * 微信开发ID
     */
    private String openId;

    /**
     * 是否登录，Y登录，N没有登录
     */
    private String isLogin;

    /**
     * 最后登录时间
     */
    private LocalDateTime usrPwLastUpd;

    /**
     * 密码盐值
     */
    private String salt;

    /**
     * 是否删除，0存在，1删除
     */
    @TableLogic
    private Integer del;

    /**
     * 用户密码策略外键
     */
    private Long paspolFk;

    /**
     * 员工姓名---20200922增加冗余字段
     */
    private String userEmployeeName;

    /**
     * 密级  1|内部 2|一般 3|重要 4|核心
     */
    private String mj;

    /**
     * 申请日期
     */
    private LocalDateTime sqrq;

    /**
     * 申请人
     */
    private String sqr;

    /**
     * 变更
     */
    private Boolean bg;

    /**
     * 变更内容
     */
    private String bgnr;

    /**
     * 审批标志
     */
    private Boolean spbz;

    /**
     * 审批日期
     */
    private LocalDateTime sprq;

    /**
     * 审批人
     */
    private String spr;

    /**
     * 审批意见
     */
    private String spyj;

    /**
     * 退回标志
     */
    private Boolean thbz;

    /**
     * 状态 I|初始 F|待审 C|完成
     */
    private String zt;

    /**
     * 客户端限定
     */
    private String clientQualification;

    /**
     * 是否绑定Ukey
     */
    @TableField("is_Ukey")
    private Boolean isUkey;

    /**
     * Ukey密钥
     */
    @TableField("Ukeys")
    private String Ukeys;

    /**
     * 是否是三员用户
     */
    private Boolean isPartThree;


    @Override
    protected Serializable pkVal() {
        return this.userId;
    }

}
