package com.jln.system.web.action.mes.user.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 用户详情表
 * </p>
 *
 * @author
 * @since 2021-10-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SystemEmployee extends Model<SystemEmployee> {

    private static final long serialVersionUID = 1L;
    @TableId
    private Long sysEmployeeOid;

    /**
     * 员工编码，工号
     */
    private String employeeCode;

    /**
     * 员工名称
     */
    private String employeeName;

    /**
     * 工作电话
     */
    private String workPhoneNumber;

    /**
     * 移动电话
     */
    private String phone;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 身份证号
     */
    private String idCard;

    /**
     * 籍贯
     */
    private String thePlace;

    /**
     * 性别，0男，1女
     */
    private Integer sex;

    /**
     * 出生日期
     */
    private String birthday;

    /**
     * 用户外键
     */
    private Long userFk;

    /**
     * 入职日期
     */
    private LocalDateTime dataOfEntry;

    /**
     * 婚姻状况，0已婚，1未婚
     */
    private Integer mamageSta;

    /**
     * 银行账号
     */
    private String bankNumber;

    /**
     * 照片，放URL地址
     */
    private String photo;

    /**
     * 是否删除，0没有，1删除
     */
    @TableLogic
    private Integer del;

    /**
     * 备注
     */
    private String bz;

    /**
     * 部门外键
     */
    private Long organiceFk;

    /**
     * 主岗位冗余字段---方便后面数据权限处理，查询还是走中间表
     */
    private Long mianPostFk;

    /**
     * 部门外键------这个字段修改了注意20200922
     */
    private Long divisionFk;

    /**
     * 0不启用，1为启用
     */
    private Boolean blockUp;


    @Override
    protected Serializable pkVal() {
        return this.sysEmployeeOid;
    }

}
