package com.jln.system.web.action.mes.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mes.user.entity.SysEmployee;
import com.jln.system.web.action.mes.user.entity.SysUser;
import com.jln.system.web.action.mes.user.entity.SystemEmployee;
import com.jln.system.web.action.mes.user.mapper.SysEmployeeMapper1;
import com.jln.system.web.action.mes.user.service.SysEmployeeService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 员工表（MES） 服务实现类
 * </p>
 *
 * @author
 * @since 2021-10-26
 */
@Service("erpEmployeeService")
public class SysEmployeeServiceImpl extends ServiceImpl<SysEmployeeMapper1, SysEmployee> implements SysEmployeeService {

    @Override
    public Result<List<SysEmployee>> queryByCodes(List<String> codes) {
        if (EmptyUtil.isEmpty(codes)) {
            return new Result<>().toFailure("编码不能没有");
        }
        LambdaQueryWrapper<SysEmployee> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.in(SysEmployee::getCodeing, codes);
        List<SysEmployee> list = list(queryWrapper);
        return new Result<List<SysEmployee>>().toSuccess(list);
    }

    @Override
    public int updateBatch(List<SysEmployee> sysEmployeesUpdate) {
        return this.baseMapper.updateBatch(sysEmployeesUpdate);
    }

    @Override
    public int updateBatchSystemEmployees(List<SystemEmployee> systemEmployeesUpdate) {
        return this.baseMapper.updateBatchSystemEmployees(systemEmployeesUpdate);
    }

    @Override
    public int updateBatchSysUser(List<SysUser> sysUsersUpdate) {
        return this.baseMapper.updateBatchSysUser(sysUsersUpdate);
    }

    @Override
    public List<SysEmployee> selectAll() {
        return this.baseMapper.selectAll();
    }

    @Override
    public int delSysUser(Long userId) {
        return this.baseMapper.delSysUser(userId);
    }

    @Override
    public int delSystemEmployees(Long userId) {
        return this.baseMapper.delSystemEmployees(userId);
    }

    @Override
    public int delSysEmployees(Long userId) {
        return this.baseMapper.delSysEmployees(userId);
    }

    @Override
    public int delEmployeesOrganize(Long userId) {
        return this.baseMapper.delEmployeesOrganize(userId);
    }
}
