package com.jln.system.web.action.mes.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.system.web.action.mes.user.entity.SysPostEmployee;
import com.jln.system.web.action.mes.user.mapper.SysPostEmployeeMapper;
import com.jln.system.web.action.mes.user.service.SysPostEmployeeService;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 用户岗位关联表 服务实现类
 * </p>
 *
 * @author
 * @since 2021-10-26
 */
@Service("erpPostEmployeeService")
public class SysPostEmployeeServiceImpl extends ServiceImpl<SysPostEmployeeMapper, SysPostEmployee> implements SysPostEmployeeService {
    /**
     * 判断当前用户是否已经添加过当前岗位了
     *
     * @param uid    员工主键
     * @param postId 岗位主键
     * @return
     */
    public Result judgeUserExistPost(Long uid, Long postId) {
        LambdaQueryWrapper<SysPostEmployee> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(SysPostEmployee::getEmployeeFk, uid);
        wrapper.eq(SysPostEmployee::getPostFk, postId);
        Integer count = baseMapper.selectCount(wrapper);
        if (0 == count) {
            return new Result().toSuccess();
        }
        return new Result().toFailure("当前用户已分配当前岗位").setCode(1075);
    }
}
