package com.jln.system.web.action.mes.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mes.user.entity.SysUser;
import com.jln.system.web.action.mes.user.mapper.SysUserMapper;
import com.jln.system.web.action.mes.user.service.SysUserService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 用户登录表 服务实现类
 * </p>
 *
 * @author 
 * @since 2021-10-26
 */
@Service("erpUserService")
public class SysUserServiceImpl extends ServiceImpl<SysUserMapper, SysUser> implements SysUserService {

    @Override
    public Result<List<SysUser>> queryByCodes(List<String> codes) {
        if (EmptyUtil.isEmpty(codes)) {
            return new Result<>().toFailure("编码不能没有");
        }
        LambdaQueryWrapper<SysUser> queryWrapper = new LambdaQueryWrapper<>();
//        queryWrapper.in(SysUser::get, codes);
        List<SysUser> list = list(queryWrapper);
        return new Result<List<SysUser>>().toSuccess(list);
    }

}
