package com.jln.system.web.action.mes.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mes.user.entity.SystemEmployee;
import com.jln.system.web.action.mes.user.mapper.SystemEmployeeMapper;
import com.jln.system.web.action.mes.user.service.SystemEmployeeService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 用户详情表 服务实现类
 * </p>
 *
 * @author
 * @since 2021-10-26
 */
@Service("erpSystemEmployeeService")
public class SystemEmployeeServiceImpl extends ServiceImpl<SystemEmployeeMapper, SystemEmployee> implements SystemEmployeeService {

    @Override
    public Result<List<SystemEmployee>> queryByCodes(List<String> codes) {
        if (EmptyUtil.isEmpty(codes)) {
            return new Result<>().toFailure("编码不能没有");
        }
        LambdaQueryWrapper<SystemEmployee> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.in(SystemEmployee::getEmployeeCode, codes);
        List<SystemEmployee> list = list(queryWrapper);
        return new Result<List<SystemEmployee>>().toSuccess(list);
    }
}
