package com.jln.system.web.action.plm.controller;


import com.jln.common.entity.Result;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.plm.util.WebService;
import com.jln.system.web.action.plm.util.WebServiceSoap;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.util.Arrays;

@Api(tags = "获取物料的plm文件")
@RestController
@RequestMapping("/plm/file")
public class PLMController {

    @ApiOperation(value = "获取物料的plm文件", notes = "获取物料的plm文件")
    @GetMapping("/get")
    public Result get(@RequestParam String wlid, HttpServletRequest request, HttpServletResponse response,String lckh) throws IOException {
        response.setHeader("Access-Control-Expose-Headers", "FileName,code,message");
        Boolean bool = Boolean.TRUE;
        WebService webService = new WebService();
        WebServiceSoap webServiceSoap = webService.getWebServiceSoap();
        byte[] file = webServiceSoap.getFile(wlid,lckh);
        if (EmptyUtil.isEmpty(file)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("PLM中未维护相关数据，请联系工艺人员核实","utf-8"));
        }

        String split = new String(file,"UTF-8");
        if ("0".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("未能创建缓存文件夹","utf-8"));
            return new Result().toFailure("未能创建缓存文件夹： D:\\PLM2MES");
        }
        if ("1".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("未能成功登录PLM","utf-8"));
            return new Result().toFailure("未能成功登录 PLM。");
        }
        if ("2".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("没有搜索到文件","utf-8"));
            return new Result().toFailure("没有搜索到文件");
        }
        if ("3".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("搜索到多个结果","utf-8"));
            return new Result().toFailure("搜索到多个结果");
        }

        if ("4".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("文件未获取最新版。解决办法:管理员根据所示路径在服务器(192.168.1.221)手动获取最新版。","utf-8"));
            return new Result().toFailure("文件未获取最新版。解决办法：管理员根据所示路径在服务\n" +
                    "器（192.168.1.221）手动获取最新版。");
        }
        if ("5".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message",URLEncoder.encode("异常信息超过两条","utf-8"));
            return new Result().toFailure("异常信息超过两条");
        }
        if ("6".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message", URLEncoder.encode("HMPLM2MES.exe未按预期运行，需要接口开发人员调试","utf-8"));
            return new Result().toFailure("HMPLM2MES.exe未按预期运行，需要接口开发人员调试");
        }
        if ("7".equals(split)){
            bool = Boolean.FALSE;
            response.setHeader("code","-1");
            response.setHeader("message","未知的异常信息，需要接口开发人员调试");
            return new Result().toFailure("未知的异常信息，需要接口开发人员调试");
        }
        String fileName = webServiceSoap.getFileName();
        response.setHeader("Content-Disposition", "attachment;filename*=utf-8'zh_cn'" + fileName);
        response.setHeader("FileName",fileName);
        if (bool){
            response.setHeader("code","0");
            response.setHeader("message", URLEncoder.encode("正常","utf-8"));
        }
        //response.addHeader("Content-Length", "" + fi.length());
        response.setContentType("application/octet-stream");
        InputStream in =  new ByteArrayInputStream(file);
        int len = 0;
        //创建数据缓冲区
        byte[] buffer = new byte[1024];
        //通过response对象获取OutputStream流
        OutputStream out = response.getOutputStream();
        //将FileInputStream流写入到buffer缓冲区
        while ((len = in.read(buffer)) > 0) {
            //sendError
            out.write(buffer, 0, len);
        }
        in.close();
        return new Result().toSuccess();
    }

}
