package com.jln.system.web.action.plm.test;

import com.jln.system.web.action.plm.util.WebService;
import com.jln.system.web.action.plm.util.WebServiceSoap;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 * <p>
 * 获取plm文件测试
 * </p>
 *
 * @author 龙明普
 * @version 1.0
 * @date 2021-11-03 11:35
 */
public class WebserviceTest
{
    public static void main(String[] args) {
        //也可以使用new WeatherWebService(url)此方法可重新设置请求的地址 URL url=new URL("http://www.webxml.com.cn/WebServices/WeatherWebService.asmx?wsdl")
        WebService factory = new WebService();
        WebServiceSoap weatherWebServiceSoap = factory.getWebServiceSoap(); //WeatherWebServiceSoap为调用的实现类
        byte[] file = weatherWebServiceSoap.getFile("000","000");
        String fileName = weatherWebServiceSoap.getFileName();
        System.out.println(fileName);
        fileToBytes(file,"D://test/",fileName);
    }


    /**
     * 将Byte数组转换成文件
     * @param bytes byte数组
     * @param filePath 文件路径  如 D://test/ 最后“/”结尾
     * @param fileName  文件名
     */
    public static void fileToBytes(byte[] bytes, String filePath, String fileName) {
        BufferedOutputStream bos = null;
        FileOutputStream fos = null;
        File file = null;
        try {

            file = new File(filePath + fileName);
            if (!file.getParentFile().exists()){
                //文件夹不存在 生成
                file.getParentFile().mkdirs();
            }
            fos = new FileOutputStream(file);
            bos = new BufferedOutputStream(fos);
            bos.write(bytes);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (bos != null) {
                try {
                    bos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (fos != null) {
                try {
                    fos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
