package com.jln.system.web.action.util;

public enum ERPMsgCode {
    DEFAULT(0, "默认"),
    CONTEXT_LOSS(1, "上下文丢失"),
    NO_PERMISSION(2, "没有权限"),
    OPERATION_ID_IS_EMPTY(3, "操作标识为空"),
    ABNORMAL(4, "异常"),
    THE_DOCUMENT_ID_IS_EMPTY(5, "单据标识为空"),
    DATABASE_OPERATION_FAILED(6, "数据库操作失败"),
    LICENSE_ERROR(7, "许可错误"),
    PARAMETER_ERROR(8, "参数错误"),
    FIELD_OR_VALUE_NOT_EXIST(9, "指定字段/值不存在"),
    CORRESPONDING_DATA_NOT_FOUND(10, "未找到对应数据"),
    VALIDATION_FAILED(11, "验证失败"),
    INOPERABLE(12, "不可操作"),
    NETWORK_CONTROL_CONFLICT(13, "网控冲突"),
    ;
    private int code;
    private String msg;

    ERPMsgCode(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public int getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }

    public String getMsgByCode(int code) {
        for (ERPMsgCode value : values()) {
            if (code == value.getCode()) {

                return msg;
            }
        }
        return "";
    }
}
