package com.jln.system.web.action.util;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
@ApiModel("ERP单据查询接口参数")
public class ERPParams {

    /**
     * 查询表单元数据唯一标识，每个接口都不一样
     */
    @ApiModelProperty(value = "查询表单元数据唯一标识，每个接口都不一样", example = "ORG_Organizations")
    private String FormId;

    /**
     * 最多允许查询的数量，0或者不要此属性表示不限制
     */

    @ApiModelProperty(value = "最多允许查询的数量，0或者不要此属性表示不限制", example = "0")
    private Integer TopRowCount;

    /**
     * 分页取数每页允许获取的数据，最大不能超过2000
     */
    @ApiModelProperty(value = "分页取数每页允许获取的数据，最大不能超过2000", example = "10")
    private Integer Limit;

    /**
     * 分页取数开始行索引，从0开始，例如每页10行数据，第2页开始是10，第3页开始是20
     */
    @ApiModelProperty(value = "分页取数开始行索引，从0开始，例如每页10行数据，第2页开始是10，第3页开始是20", example = "0")
    private Integer StartRow;

    /**
     * 查过滤条件
     */
    @ApiModelProperty(value = "查过滤条件", example = " ")
    private List<ERPFilterString> FilterString;

    /**
     * 排序条件
     */
    @ApiModelProperty(value = "排序条件", example = " ")
    private String OrderString;

    /**
     * 待查询的字段列表(具体字段由开发自行整理需要的字段，到微信群里找金蝶负责人员要对应的字段)
     */
    @ApiModelProperty(value = "待查询的字段列表(具体字段由开发自行整理需要的字段，到微信群里找金蝶负责人员要对应的字段)", example = "FFORBIDSTATUS,FDocumentStatus,FNUMBER,FNAME,FTEL,FOrgID,FORGFORMID,FModifyDate")
    private String FieldKeys;
}
