package com.jln.system.web.action.util;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import java.time.LocalDateTime;

/**
 * EPR分页更新
 */
@Data
public class ERPQueryDTO {


    @ApiModelProperty(value = "开始时间", dataType = "java.lang.String", example = "2021-04-01 11:11:11")
    private LocalDateTime startTime;

    /**
     * 分页取数每页允许获取的数据，最大不能超过2000
     */
    @ApiModelProperty(value = "分页取数每页允许获取的数据，最大不能超过2000", example = "10")
    @Max(value = 2000, message = "分页取数最大不能超过2000")
    private Integer Limit;

    /**
     * 分页取数开始行索引，从0开始，例如每页10行数据，第2页开始是10，第3页开始是20
     */
    @ApiModelProperty(value = "分页页码", example = "1")
    @Min(value = 1, message = "分页取数最小不能低于1")
    private Integer page;

}
