package com.jln.system.web.action.util;

import com.alibaba.fastjson.JSONObject;
import com.jln.common.utils.HttpClientUtil;
import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@ConfigurationProperties(prefix = "erp")
@Component
@Data
public class ErpLoginUtil {

    /**
     * HTTP协议
     */
    //@Value("${httperpurl}")
    public  String httperpurl ;
    //@Value("${httperploginurl}")
    public   String httperploginurl ;
    //@Value("${httpusername}")
    public   String httpusername;
    //@Value("${httppassword}")
    public   String httppassword;
    //@Value("${httpacctid}")
    public   String httpacctid;
    //@Value("${httplcid}")
    public   String httplcid;

    public CookieData Login(){

        Map<String,String> map = new HashMap<>();
        map.put("username",httpusername);
        map.put("password",httppassword);
        map.put("acctID",httpacctid);
        map.put("lcid",httplcid);
        String s = HttpClientUtil.doPost(httperploginurl, map);
        Integer loginResultType = JSONObject.parseObject(s).getInteger("LoginResultType");


        JSONObject jsonObject = JSONObject.parseObject(JSONObject.parseObject(s).getString("Context"));
        String sessionId = jsonObject.getString("SessionId");
        String kdsvcSessionId = JSONObject.parseObject(s).getString("KDSVCSessionId");
        CookieData cookieData = new CookieData();
        cookieData.setKdsvcSessionId(kdsvcSessionId);
        cookieData.setLoginResultType(loginResultType);
        cookieData.setSessionId(sessionId);
        return cookieData;

    }

    public static void main(String[] args) {
        Map<String,String> map = new HashMap<>();
        map.put("username","Administrator");
        map.put("password","kingdee@123");
        map.put("acctID","6134840740b7ab");
        map.put("lcid","2052");
        String s = HttpClientUtil.doPost("http://10.41.1.87/k3cloud/Kingdee.BOS.WebApi.ServicesStub.AuthService.ValidateUser.common.kdsvc", map);
        Integer loginResultType = JSONObject.parseObject(s).getInteger("LoginResultType");

    }

}
