CREATE TABLE `ufc_qc_ty_rule` (
  `ufc_qc_ty_ruleoid` bigint(20) NOT NULL COMMENT '通用规程主键',
  `kzfs` char(1) DEFAULT '' COMMENT '控制方式',
  `djjy` char(1) DEFAULT '' COMMENT '单件检验',
  `qyrq` date DEFAULT NULL COMMENT '启动日期',
  `tyrq` date DEFAULT NULL COMMENT '停用日期',
  `tybz` bit(1) DEFAULT b'0' COMMENT '停用标志',
  `bz` varchar(250) DEFAULT '' COMMENT '备注',
  `zt` char(1) DEFAULT 'I' COMMENT '状态',
  `sys_created_by` bigint(20) NOT NULL COMMENT '创建人oid',
  `sys_last_upd_by` bigint(20) NOT NULL COMMENT '最后修改人oid',
  `sys_created` datetime DEFAULT NULL COMMENT '创建日期',
  `qc_type_fk` bigint(20) DEFAULT NULL COMMENT '检验类型外键',
  `qc_std_fk` bigint(20) DEFAULT NULL COMMENT '检验标准外键',
  `b_material_fk` bigint(20) DEFAULT NULL COMMENT '物料外键',
  `b_productionline_fk` bigint(20) DEFAULT NULL COMMENT '生产线外键',
  `b_supplier_fk` bigint(20) DEFAULT NULL COMMENT '供应商外键',
  `b_standardprocess_fk` bigint(20) DEFAULT NULL COMMENT '标准工序外键',
  `sys_last_upd` datetime DEFAULT NULL COMMENT '最后一次修改时间',
  `del` bit(1) DEFAULT b'0' COMMENT '删除标记',
  `cessory_name` varchar(50) DEFAULT NULL COMMENT '文档附件名称',
  `accessory_url` varchar(255) DEFAULT NULL COMMENT '文档地址',
  `ty_rule_bz` bit(1) DEFAULT NULL COMMENT '通用标志',
  PRIMARY KEY (`ufc_qc_ty_ruleoid`) USING BTREE,
  KEY `qc_ruleAllFk` (`zt`,`del`,`sys_created_by`,`sys_last_upd_by`,`qc_type_fk`,`qc_std_fk`,`b_material_fk`,`b_productionline_fk`,`b_supplier_fk`,`b_standardprocess_fk`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='通用规程';

CREATE TABLE `ufc_qc_ty_rule_bill` (
  `ufc_bill_rule` bigint(20) NOT NULL COMMENT '检验单-通用规程中间表主键',
  `qc_bill_oid` bigint(20) DEFAULT NULL COMMENT '检验单外键',
  `ufc_qc_ty_ruleoid` bigint(20) DEFAULT NULL COMMENT '通用规程外键',
  PRIMARY KEY (`ufc_bill_rule`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='检验单-通用规程中间表';