CREATE TABLE `ufc_erp_b_material`  (
  `ufc_erp_b_material_oid` bigint(20) NOT NULL COMMENT 'erp物料扩展表主键',
  `b_material_fk` bigint(20) NULL DEFAULT NULL COMMENT '物料外键',
  `wl_plm_zxbz` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物料.PLM执行标准',
  `wl_plm_ysgf` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物料.PLM验收规范',
  `wl_plm_cgbz` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `wl_plm_xmbh` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物料.PLM项目编号',
  `wl_plm_xh` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物料.PLM型号',
  `wl_xmbh` int(32) NULL DEFAULT NULL COMMENT '物料.项目编号',
  `wl_xm_funmber` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '项目.Fnumber',
  `wl_hm_zxbz` int(32) NULL DEFAULT NULL COMMENT '物料.HM执行标准',
  `wl_hm_zxbz_fnumber` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '执行标准.Fnumber',
  `wl_hm_ysgf` int(32) NULL DEFAULT NULL COMMENT '物料.HM验收规范',
  `wl_hm_ysgf_fname` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '验收规范.Fname',
  `wl_hm_cgbz` int(32) NULL DEFAULT NULL COMMENT '物料.HM采购标准',
  `wl_hm_cgbz_fname` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '采购标准.Fname',
  `wl_cgbzbm` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物料.采购标准编码',
  `wl_hm_cgbz_fnumber` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '采购标准.Fnumber',
  `wl_ysgfbm` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物料.验收规范编码',
  `wl_hm_ysgf_fnumber` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '验收规范.Fnumber',
  PRIMARY KEY (`ufc_erp_b_material_oid`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = DYNAMIC;

CREATE TABLE `ufc_erp_wo`  (
  `ufc_erp_wo_oid` bigint(20) NOT NULL COMMENT '生产订单扩展表主键',
  `wo_fk` bigint(20) NULL DEFAULT NULL COMMENT '生产订单外键',
  `djt_djrq` datetime NULL DEFAULT NULL COMMENT '单据头.单据日期',
  `djt_shr` int(32) NULL DEFAULT NULL COMMENT '单据头.审核人',
  `djt_shrq` datetime NULL DEFAULT NULL COMMENT '单据头.审核日期',
  `djt_khmc` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '单据头.客户名称',
  `djt_lzkh` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '单据头.流转卡号',
  `djt_xslx_id` int(32) NULL DEFAULT NULL COMMENT '单据头.销售类型ID',
  `xslxmc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '销售类型名称',
  `mx_xqzz` int(32) NULL DEFAULT NULL COMMENT '明细.需求组织',
  `mx_wlbm_id` int(32) NULL DEFAULT NULL COMMENT '明细.物料编码ID',
  `mx_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.ID号',
  `mx_fzsx_id` int(32) NULL DEFAULT NULL COMMENT '明细.辅助属性ID',
  `mx_fzsxmc_zldj` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.辅助属性名称（质量等级）',
  `mx_fzsxmc_jd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.辅助属性名称（精度）',
  `mx_wdxszb` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.温度系数组别',
  `mx_ptsj` datetime NULL DEFAULT NULL COMMENT '明细.配套时间',
  `mx_ptsl` decimal(23, 10) NULL DEFAULT NULL COMMENT '明细.配套数量',
  `mx_jd` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.阶段（技术状态）',
  `mx_hth` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.合同号',
  `mx_jjlx` int(32) NULL DEFAULT NULL COMMENT '明细.军检类型ID',
  `mx_jjmc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '军检类型名称',
  `mx_dj` decimal(30, 10) NULL DEFAULT NULL COMMENT '明细.单价',
  `mx_bz` varchar(4000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.备注',
  `mx_bz_sc` varchar(4000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.备注（生产）',
  `mx_xsddyhrq` datetime NULL DEFAULT NULL COMMENT '明细.销售订单要货日期',
  `mx_sfxcys` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.是否下场验收',
  `mx_hnzxbz_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.HM执行标准编码',
  `mx_zxbz_id` int(32) NULL DEFAULT NULL COMMENT '明细.执行标准ID',
  `mx_khwl_id` varchar(36) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.客户物料编码',
  `mx_khwlmc` varchar(80) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.客户物料名称',
  `mx_hmxmbh` int(11) NULL DEFAULT NULL COMMENT '明细.HM项目编号ID',
  `mx_hmxmbm_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.HM项目编码',
  `mx_bom_id` int(32) NULL DEFAULT NULL COMMENT '明细.BOM ID',
  `bom_bb` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'BOM版本',
  `mx_ph_id` int(32) NULL DEFAULT NULL COMMENT '明细.批号ID',
  `mx_ph` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.批号',
  `mx_rkzz` int(32) NULL DEFAULT NULL COMMENT '明细.入库组织（传名称）',
  `mx_ydlx` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.源单类型',
  `mx_ydbm_id` varchar(80) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '明细.源单编号',
  `mx_ydflhh` int(32) NULL DEFAULT NULL COMMENT '明细.源单分录行号',
  `custom_text_one` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '预留文本字段',
  `custom_text_two` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `custom_text_three` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `custom_text_four` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `custom_text_five` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `custom_datetime_one` datetime NULL DEFAULT NULL COMMENT '预留日期时间字段',
  `custom_datetime_two` datetime NULL DEFAULT NULL,
  PRIMARY KEY (`ufc_erp_wo_oid`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '生产订单扩展表' ROW_FORMAT = DYNAMIC;

CREATE TABLE `ufc_lm_orders` (
  `ufc_lm_orders_oid` bigint(20) NOT NULL COMMENT '主键',
  `ufc_lm_orders_number` varchar(50) DEFAULT NULL COMMENT '单据编号',
  `ufc_lm_orders_type` varchar(20) DEFAULT NULL COMMENT '单据类型',
  `ufc_lm_orders_inspection_type` varchar(20) DEFAULT NULL COMMENT '检验类别',
  `ufc_lm_orders_sales_type` varchar(20) DEFAULT NULL COMMENT '销售类型',
  `ufc_lm_orders_consignee_type` varchar(20) DEFAULT NULL COMMENT '合同类型',
  `ufc_lm_orders_contract` varchar(50) DEFAULT NULL COMMENT '合同号',
  `ufc_lm_orders_department` varchar(50) DEFAULT NULL COMMENT '销售部门',
  `ufc_lm_orders_salesman` varchar(50) DEFAULT NULL COMMENT '销售员',
  `ufc_lm_orders_send_people_fk` bigint(20) DEFAULT NULL COMMENT '送试人外键',
  `ufc_lm_orders_consignee` varchar(50) DEFAULT NULL COMMENT '收货方',
  `ufc_lm_orders_date` datetime DEFAULT NULL COMMENT '日期',
  `ufc_lm_orders_remarks` varchar(255) DEFAULT NULL COMMENT '备注',
  `b_custome_fk` bigint(20) DEFAULT NULL COMMENT '客户外键',
  `ufc_lm_orders_state` char(1) DEFAULT NULL COMMENT '状态(I:初始 F:确认)',
  PRIMARY KEY (`ufc_lm_orders_oid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='委托单';

CREATE TABLE `ufc_lm_orders_detail` (
  `ufc_lm_orders_detai_oid` bigint(20) NOT NULL COMMENT '主键',
  `ufc_lm_orders_detail_ssdh` varchar(50) DEFAULT NULL COMMENT '送试单号',
  `ufc_lm_orders_detail_scph` varchar(50) DEFAULT NULL COMMENT '生产批号',
  `ufc_lm_orders_detail_wl_fk` bigint(20) DEFAULT NULL COMMENT '物料外键',
  `ufc_lm_orders_detail_ggxh` varchar(600) DEFAULT NULL COMMENT '规格型号',
  `ufc_lm_orders_detail_wlcz` varchar(30) DEFAULT NULL COMMENT '物料材质',
  `ufc_lm_orders_detail_th` varchar(50) DEFAULT NULL COMMENT '图号',
  `ufc_lm_orders_detail_jldw` varchar(100) DEFAULT NULL COMMENT '计量单位',
  `ufc_lm_orders_detail_sssj` datetime DEFAULT NULL COMMENT '送试时间',
  `ufc_lm_orders_detail_sssl` int(18) DEFAULT NULL COMMENT '送试数量',
  `ufc_lm_orders_detail_dj` decimal(18,2) DEFAULT NULL COMMENT '单价',
  `ufc_lm_orders_detail_hsdj` decimal(18,2) DEFAULT NULL COMMENT '含税单价',
  `ufc_lm_orders_detail_zxsybz_fk` bigint(20) DEFAULT NULL COMMENT '执行试验标准外键',
  `ufc_lm_orders_detail_jczxsybz_fk` bigint(20) DEFAULT NULL COMMENT '检测中心试验标准外键',
  `ufc_lm_orders_detail_khhth` varchar(50) DEFAULT NULL COMMENT '客户合同号',
  `ufc_lm_orders_detail_dsfkhdh` varchar(50) DEFAULT NULL COMMENT '第三方客户单号',
  `ufc_lm_orders_detail_yqwcsj` datetime DEFAULT NULL COMMENT '要求完成时间',
  `ufc_lm_orders_detail_bz` varchar(255) DEFAULT NULL COMMENT '备注',
  `ufc_lm_orders_fk` bigint(20) DEFAULT NULL COMMENT '主表外键',
  `lm_test_category_fk` bigint(20) DEFAULT NULL COMMENT '实验分类',
  PRIMARY KEY (`ufc_lm_orders_detai_oid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='委托单明细';

-- 添加委托单菜单
INSERT INTO `sys_resources`(`sys_resources_id`, `resources_code`, `resources_name`, `resources_pid`, `icon`, `resources_type`, `sort_num`, `open_mode`, `url`, `del`, `button_fk`, `allowediting`, `configurable`, `system_type`, `see_type`, `workstation`, `workflow_resources`, `bus_table_en_name`, `bus_table_pk_field`) VALUES (900000000000000001, 'ufcLM0207', '委托单', 1000001400009, '', 0, 40, '0', '/ufcLM0207', 0, NULL, b'0', b'0', 1, 0, b'0', NULL, NULL, NULL);